%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Interface to the CLP(FD) solver library of Sicstus-Prolog
%
% The clauses in this file are added to each compiled Curry program
% if finite domains constraints are used

:- use_module(library(clpfd)).

?- block 'prim_CLPFD.domain'(?,?,?,?,-,?).
'prim_CLPFD.domain'(L,A,B,success,E0,E) :- domain(L,A,B), E0=E.

?- block 'prim_CLPFD.all_different'(?,?,-,?).
'prim_CLPFD.all_different'(L,success,E0,E) :- all_different(L), E0=E.

?- block 'prim_CLPFD.labeling'(?,?,-,?).
'prim_CLPFD.labeling'(L,success,E0,E) :- labeling([],L), E0=E.

?- block 'prim_CLPFD.+#'(?,?,?,-,?).
'prim_CLPFD.+#'(A,B,R,E0,E) :- R #= A+B, E0=E.

?- block 'prim_CLPFD.-#'(?,?,?,-,?).
'prim_CLPFD.-#'(A,B,R,E0,E) :- R #= A-B, E0=E.

?- block 'prim_CLPFD.*#'(?,?,?,-,?).
'prim_CLPFD.*#'(A,B,R,E0,E) :- R #= A*B, E0=E.

?- block 'prim_CLPFD.=#'(?,?,?,-,?).
'prim_CLPFD.=#'(A,B,success,E0,E) :- A #= B, E0=E.

?- block 'prim_CLPFD./=#'(?,?,?,-,?).
'prim_CLPFD./=#'(A,B,success,E0,E) :- A #\= B, E0=E.

?- block 'prim_CLPFD.>#'(?,?,?,-,?).
'prim_CLPFD.>#'(A,B,success,E0,E) :- A #> B, E0=E.

?- block 'prim_CLPFD.>=#'(?,?,?,-,?).
'prim_CLPFD.>=#'(A,B,success,E0,E) :- A #>= B, E0=E.

?- block 'prim_CLPFD.<#'(?,?,?,-,?).
'prim_CLPFD.<#'(A,B,success,E0,E) :- A #< B, E0=E.

?- block 'prim_CLPFD.<=#'(?,?,?,-,?).
'prim_CLPFD.<=#'(A,B,success,E0,E) :- A #=< B, E0=E.

