%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Definitions of builtins of module Directory:
%

:- use_module(library(system)).

?- block 'prim_Directory.doesFileExist'(?,?,?,-,?).
'prim_Directory.doesFileExist'(FileName,_,'$io'(Exists),E0,E) :-
	string2Atom(FileName,FName),
	((file_exists(FName), file_property(FName,type(regular)))
	 -> Exists='True'
	  ; Exists='False'), E0=E.

?- block 'prim_Directory.doesDirectoryExist'(?,?,?,-,?).
'prim_Directory.doesDirectoryExist'(DirName,_,'$io'(Exists),E0,E) :-
	string2Atom(DirName,Dir),
	((file_exists(Dir), file_property(Dir,type(directory)))
	 -> Exists='True'
	  ; Exists='False'), E0=E.

?- block 'prim_Directory.getModificationTime'(?,?,?,-,?).
'prim_Directory.getModificationTime'(FileName,_,'$io'(Time),E0,E) :-
	string2Atom(FileName,FName),
	file_property(FName,mod_time(Time)), E0=E.

?- block 'prim_Directory.fileSize'(?,?,?,-,?).
'prim_Directory.fileSize'(FileName,_,'$io'(Size),E0,E) :-
	string2Atom(FileName,FName),
	file_property(FName,size(Size)), E0=E.

?- block 'prim_Directory.getDirectoryContents'(?,?,?,-,?).
'prim_Directory.getDirectoryContents'(DirName,_,'$io'(EntryNames),E0,E) :-
	string2Atom(DirName,Dir),
	directory_files(Dir,Entries),
	map2(atom2String,Entries,EntryNames), E0=E.
