%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Implementation of library Float

?- block 'prim_Float.+.'(-,?,?,?,?), 'prim_Float.+.'(?,-,?,?,?),
         'prim_Float.+.'(?,?,?,-,?).
'prim_Float.+.'(A,B,R,E0,E) :- R is A+B, E0=E.

?- block 'prim_Float.-.'(-,?,?,?,?), 'prim_Float.-.'(?,-,?,?,?),
         'prim_Float.-.'(?,?,?,-,?).
'prim_Float.-.'(A,B,R,E0,E) :- R is A-B, E0=E.

?- block 'prim_Float.*.'(-,?,?,?,?), 'prim_Float.*.'(?,-,?,?,?),
         'prim_Float.*.'(?,?,?,-,?).
'prim_Float.*.'(A,B,R,E0,E) :- R is A*B, E0=E.

?- block 'prim_Float./.'(-,?,?,?,?), 'prim_Float./.'(?,-,?,?,?),
         'prim_Float./.'(?,?,?,-,?).
'prim_Float./.'(A,B,R,E0,E) :- R is A/B, E0=E.

?- block 'prim_Float.<.'(-,?,?,?,?), 'prim_Float.<.'(?,-,?,?,?),
         'prim_Float.<.'(?,?,?,-,?).
'prim_Float.<.'(A,B,R,E0,E) :- (A<B -> R='True' ; R='False'), E0=E.

?- block 'prim_Float.<=.'(-,?,?,?,?), 'prim_Float.<=.'(?,-,?,?,?),
         'prim_Float.<=.'(?,?,?,-,?).
'prim_Float.<=.'(A,B,R,E0,E) :- (A=<B -> R='True' ; R='False'), E0=E.

?- block 'prim_Float.>.'(-,?,?,?,?), 'prim_Float.>.'(?,-,?,?,?),
         'prim_Float.>.'(?,?,?,-,?).
'prim_Float.>.'(A,B,R,E0,E) :- (A>B -> R='True' ; R='False'), E0=E.

?- block 'prim_Float.>=.'(-,?,?,?,?), 'prim_Float.>=.'(?,-,?,?,?),
         'prim_Float.>=.'(?,?,?,-,?).
'prim_Float.>=.'(A,B,R,E0,E) :- (A>=B -> R='True' ; R='False'), E0=E.

% transform an integer into a float:
?- block 'prim_Float.i2f'(-,?,?,?), 'prim_Float.i2f'(?,?,-,?).
'prim_Float.i2f'(A,R,E0,E) :- R is A*1.0, E0=E.

% transform a float to an integer:
?- block 'prim_Float.truncate'(-,?,?,?), 'prim_Float.truncate'(?,?,-,?).
'prim_Float.truncate'(A,R,E0,E) :- R is integer(A), E0=E.

% round a float to an integer:
?- block 'prim_Float.round'(-,?,?,?), 'prim_Float.round'(?,?,-,?).
'prim_Float.round'(A,R,E0,E) :- R is integer(round(A)), E0=E.

?- block 'prim_Float.sqrt'(-,?,?,?), 'prim_Float.sqrt'(?,?,-,?).
'prim_Float.sqrt'(A,R,E0,E) :- R is sqrt(A), E0=E.

?- block 'prim_Float.log'(-,?,?,?), 'prim_Float.log'(?,?,-,?).
'prim_Float.log'(A,R,E0,E) :- R is log(A), E0=E.

?- block 'prim_Float.exp'(-,?,?,?), 'prim_Float.exp'(?,?,-,?).
'prim_Float.exp'(A,R,E0,E) :- R is exp(A), E0=E.

?- block 'prim_Float.sin'(-,?,?,?), 'prim_Float.sin'(?,?,-,?).
'prim_Float.sin'(A,R,E0,E) :- R is sin(A), E0=E.

?- block 'prim_Float.cos'(-,?,?,?), 'prim_Float.cos'(?,?,-,?).
'prim_Float.cos'(A,R,E0,E) :- R is cos(A), E0=E.

?- block 'prim_Float.tan'(-,?,?,?), 'prim_Float.tan'(?,?,-,?).
'prim_Float.tan'(A,R,E0,E) :- R is tan(A), E0=E.

