%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Definitions of builtins of module IOExts:
%

:- dynamic globalAssoc/2.

?- block 'prim_IOExts.setAssoc'(-,?,?,?,?,?),
         'prim_IOExts.setAssoc'(?,-,?,?,?,?),
         'prim_IOExts.setAssoc'(?,?,?,?,-,?).
'prim_IOExts.setAssoc'(Key,Val,_,'$io'('()'),E0,E) :-
        string2Atom(Key,KeyA),
	(retract(globalAssoc(KeyA,_)) -> true ; true),
	assertz(globalAssoc(KeyA,Val)),
	!, E0=E.

?- block 'prim_IOExts.getAssoc'(-,?,?,?,?),
         'prim_IOExts.getAssoc'(?,?,?,-,?).
'prim_IOExts.getAssoc'(Key,_,'$io'(R),E0,E) :-
        string2Atom(Key,KeyA),
	(globalAssoc(KeyA,Val) -> R='Just'(Val) ; R='Nothing'),
	!, E0=E.

% shell command execution:
?- block 'prim_IOExts.execCmd'(-,?,?,?,?),
         'prim_IOExts.execCmd'(?,?,?,-,?).
'prim_IOExts.execCmd'(CmdString,_,'$io'('(,,)'(StdIn,StdOut,StdErr)),E0,E) :-
	string2Atom(CmdString,Cmd),
	exec(Cmd,[pipe(StdIn),pipe(StdOut),pipe(StdErr)],_), E0=E.


% open a connection to a Unix socket:
?- block 'prim_IOExts.connectToSocket'(-,?,?,?,?,?),
         'prim_IOExts.connectToSocket'(?,-,?,?,?,?),
         'prim_IOExts.connectToSocket'(?,?,?,?,-,?).
'prim_IOExts.connectToSocket'(SHst,SNr,_,
	  '$io'(SocketStream),E0,E) :-
	string2Atom(SHst,Host), !,
	socket('AF_INET',Socket),
	socket_connect(Socket,'AF_INET'(Host,SNr),SocketStream), E0=E.

