-- A simple program implementing the kernel of the Unix "talk"
-- to enable a conversation between two partners on different machines

import Ports

-- talk between your_port and my_port
talk :: String -> String -> IO ()
talk your_port my_port =
  do incoming   <- openNamedPort my_port
     ttyport    <- openStdIn
     targetPort <- connectPort your_port
     talkloop targetPort ttyport incoming

--talkloop :: Port String -> [String] -> [String] -> IO ()
talkloop eval choice
talkloop port ttyport (msg:msgs) =
  if msg=="." then done
              else putStrLn ('*':msg) >>
                   talkloop port ttyport msgs
talkloop port (msg:msgs) incoming =
  doSend msg port >>
  if msg=="." then done
              else talkloop port msgs incoming


-- start "talk1" on margaux:
talk1 = talk "34004@agamemnon.informatik.rwth-aachen.de" "34005"
--talk1 = talk "34004@localhost" "34005"

-- start "talk2" on agamemnon:
talk2 = talk "34005@margaux.informatik.rwth-aachen.de" "34004"
--talk2 = talk "34005@localhost" "34004"
