--- Library for accessing the directory structure of the
--- underlying operating system.
---
--- @author Michael Hanus
--- @version January 2004

module Directory(doesFileExist,doesDirectoryExist,fileSize,
                 getModificationTime,getDirectoryContents) where


--- Returns true if the argument is the name of an existing file.
doesFileExist :: String -> IO Bool
doesFileExist external

--- Returns true if the argument is the name of an existing directory.
doesDirectoryExist :: String -> IO Bool
doesDirectoryExist external

--- Returns the size of the file.
fileSize :: String -> IO Int
fileSize external

--- Returns the modification time of the file.
getModificationTime :: String -> IO Int
getModificationTime external

--- Returns the list of all entries in a directory.
getDirectoryContents :: String -> IO [String]
getDirectoryContents external

