%PAKCS1.5.2V4

:-prolog_flag(single_var_warnings,A,off).
:-prolog_flag(redefine_warnings,A,off).

modulename('OptFlat').

opFixity(seq,0,right).
opFixity(==,4,non).
opFixity(+,6,left).
opFixity(-,6,left).
opFixity(*,7,left).
opFixity(div,7,left).
opFixity(mod,7,left).
opFixity(<,4,non).
opFixity(>,4,non).
opFixity(<=,4,non).
opFixity(>=,4,non).
opFixity(=:=,4,non).
opFixity(&,0,right).
opFixity(>>=,1,left).
opFixity('.',9,right).
opFixity($,0,right).
opFixity('$!',0,right).
opFixity(&&,3,right).
opFixity('||',2,right).
opFixity(/=,4,non).
opFixity(++,5,right).
opFixity('!!',9,left).
opFixity(elem,4,non).
opFixity(notElem,4,non).
opFixity(&>,0,right).
opFixity(>>,1,left).

:- block 'OptFlat.optimizeFlatCurry'(?,?,?,?,?,?,-,?).
'OptFlat.optimizeFlatCurry'(A,B,C,D,E,F,G,H):-makeShare(A,I),hnf(apply(>>=('OptFlat.tryReadFlatCurry'(B,I),'OptFlat.lambdafun_9660'(I,D,C)),E),F,G,H).

:- block 'OptFlat.getStartingState'(?,?,?,?,?,-,?).
'OptFlat.getStartingState'(A,B,C,D,E,F,G):-makeShare(A,H),makeShare(B,I),if_then_else(elem('\'m',C),'(,)'('OptFlat.makeOneFuncProg'(H,D),'OptFlat.mergeFlatProgList'([H|I])),'(,)'(H,'OptFlat.mergeFlatProgList'(I)),E,F,G).

:- block 'OptFlat.makeOneFuncProg'(?,?,?,-,?).
'OptFlat.makeOneFuncProg'(A,B,C,D,E):-hnf(A,F,D,G),'OptFlat.makeOneFuncProg_1'(F,B,C,G,E).

:- block 'OptFlat.makeOneFuncProg_1'(?,?,?,-,?).
'OptFlat.makeOneFuncProg_1'('Flat.Prog'(A,B,C,D,E,F),G,H,I,J):-'OptFlat.optFlat_lambda2_9663'(A,C,D,E,'OptFlat.getTrans'(G,F),H,I,J).

:- block 'OptFlat.getFunc'(?,?,?,-,?).
'OptFlat.getFunc'(A,B,C,D,E):-hnf(B,F,D,G),'OptFlat.getFunc_2'(F,A,C,G,E).

:- block 'OptFlat.getFunc_2'(?,?,?,-,?).
'OptFlat.getFunc_2'([],A,B,C,D):-hnf(error(['\'C','\'a','\'n','\'n','\'o','\'t','\' ','\'f','\'i','\'n','\'d','\' ','\'m','\'a','\'i','\'n','\' ','\'f','\'u','\'n','\'c','\'t','\'i','\'o','\'n','\' ','\'i','\'n','\' ','\'m','\'o','\'d','\'u','\'l','\'e','\'.']),B,C,D).
'OptFlat.getFunc_2'([A|B],C,D,E,F):-makeShare(C,G),makeShare(A,H),if_then_else(G=='OptFlat.getFuncName'(H),H,'OptFlat.getFunc'(G,B),D,E,F).

:- block 'OptFlat.getTrans'(?,?,?,-,?).
'OptFlat.getTrans'(A,B,C,D,E):-hnf(B,F,D,G),'OptFlat.getTrans_2'(F,A,C,G,E).

:- block 'OptFlat.getTrans_2'(?,?,?,-,?).
'OptFlat.getTrans_2'([],A,B,C,D):-hnf(error(['\'C','\'a','\'n','\'n','\'o','\'t','\' ','\'f','\'i','\'n','\'d','\' ','\'e','\'n','\'t','\'r','\'y','\' ','\'o','\'f','\' ','\'m','\'a','\'i','\'n','\' ','\'f','\'u','\'n','\'c','\'t','\'i','\'o','\'n','\' ','\'i','\'n','\' ','\'t','\'r','\'a','\'n','\'s','\'l','\'a','\'t','\'i','\'o','\'n','\' ','\'t','\'a','\'b','\'l','\'e']),B,C,D).
'OptFlat.getTrans_2'([A|B],C,D,E,F):-makeShare(C,G),makeShare(A,H),if_then_else(G=='OptFlat.getTransName'(H),'(,)'('OptFlat.getInternalName'(H),H),'OptFlat.getTrans'(G,B),D,E,F).

:- block 'OptFlat.makeOptimizedFlatProg'(?,?,?,?,-,?).
'OptFlat.makeOptimizedFlatProg'(A,B,C,D,E,F):-hnf(A,G,E,H),'OptFlat.makeOptimizedFlatProg_1'(G,B,C,D,H,F).

:- block 'OptFlat.makeOptimizedFlatProg_1'(?,?,?,?,-,?).
'OptFlat.makeOptimizedFlatProg_1'('Flat.Prog'(A,B,C,D,E,F),G,H,I,J,K):-hnf(G,L,J,M),'OptFlat.makeOptimizedFlatProg_1_Flat.Prog_7'(L,A,B,C,D,E,F,H,I,M,K).

:- block 'OptFlat.makeOptimizedFlatProg_1_Flat.Prog_7'(?,?,?,?,?,?,?,?,?,-,?).
'OptFlat.makeOptimizedFlatProg_1_Flat.Prog_7'('Flat.Prog'(A,B,C,D,E,F),G,H,I,J,K,L,M,'Flat.Prog'(G,[],++(I,C),'OptFlat.optFuncDecls'(J,D),++(K,E),L),N,N).

:- block 'OptFlat.optFuncDecls'(?,?,?,-,?).
'OptFlat.optFuncDecls'(A,B,C,D,E):-makeShare(A,F),'OptFlat.optFlat_lambda3_9664'(F,B,'OptFlat.list2SetRBT'('OptFlat.leString',map('OptFlat.getFuncName',F)),C,D,E).

:- block 'OptFlat.optFuncDecls\''(?,?,?,?,-,?).
'OptFlat.optFuncDecls\''(A,B,C,D,E,F):-hnf(A,G,E,H),'OptFlat.optFuncDecls\'_1'(G,B,C,D,H,F).

:- block 'OptFlat.optFuncDecls\'_1'(?,?,?,?,-,?).
'OptFlat.optFuncDecls\'_1'([],A,B,[],C,C).
'OptFlat.optFuncDecls\'_1'([A|B],C,D,E,F,G):-makeShare(A,H),'OptFlat.optFlat_lambda4_9666'(H,D,B,C,'OptFlat.getAllFuncCalls'(H),E,F,G).

:- block 'OptFlat.lookupFuncCalls'(?,?,?,?,?,-,?).
'OptFlat.lookupFuncCalls'(A,B,C,D,E,F,G):-hnf(A,H,F,I),'OptFlat.lookupFuncCalls_1'(H,B,C,D,E,I,G).

:- block 'OptFlat.lookupFuncCalls_1'(?,?,?,?,?,-,?).
'OptFlat.lookupFuncCalls_1'([],A,B,C,'(,)'(A,B),D,D).
'OptFlat.lookupFuncCalls_1'([A|B],C,D,E,F,G,H):-makeShare(A,I),makeShare(D,J),makeShare(B,K),makeShare(C,L),makeShare(E,M),if_then_else('SetRBT2.elemRBT'(I,J),'OptFlat.lookupFuncCalls'(K,L,J,M),'OptFlat.lookupFuncCalls'(K,++(L,'OptFlat.lookupFuncDeclInRest'(I,M)),'SetRBT2.insertRBT'(I,J),M),F,G,H).

:- block 'OptFlat.lookupFuncDeclInRest'(?,?,?,-,?).
'OptFlat.lookupFuncDeclInRest'(A,B,C,D,E):-hnf(B,F,D,G),'OptFlat.lookupFuncDeclInRest_2'(F,A,C,G,E).

:- block 'OptFlat.lookupFuncDeclInRest_2'(?,?,?,-,?).
'OptFlat.lookupFuncDeclInRest_2'([],A,[],B,B).
'OptFlat.lookupFuncDeclInRest_2'([A|B],C,D,E,F):-makeShare(C,G),makeShare(A,H),if_then_else(G=='OptFlat.getFuncName'(H),[H],'OptFlat.lookupFuncDeclInRest'(G,B),D,E,F).

:- block 'OptFlat.getAllFuncCalls'(?,?,-,?).
'OptFlat.getAllFuncCalls'(A,B,C,D):-hnf(A,E,C,F),'OptFlat.getAllFuncCalls_1'(E,B,F,D).

:- block 'OptFlat.getAllFuncCalls_1'(?,?,-,?).
'OptFlat.getAllFuncCalls_1'('Flat.Func'(A,B,C,D),E,F,G):-hnf(D,H,F,I),'OptFlat.getAllFuncCalls_1_Flat.Func_4'(H,A,B,C,E,I,G).

:- block 'OptFlat.getAllFuncCalls_1_Flat.Func_4'(?,?,?,?,?,-,?).
'OptFlat.getAllFuncCalls_1_Flat.Func_4'('Flat.External'(A),B,C,D,[],E,E).
'OptFlat.getAllFuncCalls_1_Flat.Func_4'('Flat.Rule'(A,B),C,D,E,F,G,H):-'List.nub'('OptFlat.getAllFuncCallsOfExpr'(B),F,G,H).

:- block 'OptFlat.getAllFuncCallsOfExpr'(?,?,-,?).
'OptFlat.getAllFuncCallsOfExpr'(A,B,C,D):-hnf(A,E,C,F),'OptFlat.getAllFuncCallsOfExpr_1'(E,B,F,D).

:- block 'OptFlat.getAllFuncCallsOfExpr_1'(?,?,-,?).
'OptFlat.getAllFuncCallsOfExpr_1'('Flat.Var'(A),[],B,B).
'OptFlat.getAllFuncCallsOfExpr_1'('Flat.Lit'(A),[],B,B).
'OptFlat.getAllFuncCallsOfExpr_1'('Flat.Comb'(A,B,C),[B|concatMap('OptFlat.getAllFuncCallsOfExpr',C)],D,D).
'OptFlat.getAllFuncCallsOfExpr_1'('Flat.Apply'(A,B),C,D,E):- ++('OptFlat.getAllFuncCallsOfExpr'(A),'OptFlat.getAllFuncCallsOfExpr'(B),C,D,E).
'OptFlat.getAllFuncCallsOfExpr_1'('Flat.Constr'(A,B),C,D,E):-'OptFlat.getAllFuncCallsOfExpr'(B,C,D,E).
'OptFlat.getAllFuncCallsOfExpr_1'('Flat.Or'(A,B),C,D,E):- ++('OptFlat.getAllFuncCallsOfExpr'(A),'OptFlat.getAllFuncCallsOfExpr'(B),C,D,E).
'OptFlat.getAllFuncCallsOfExpr_1'('Flat.Case'(A,B,C),D,E,F):- ++('OptFlat.getAllFuncCallsOfExpr'(B),concatMap('OptFlat.getAllFuncCallsOfBranchExpr',C),D,E,F).
'OptFlat.getAllFuncCallsOfExpr_1'('Flat.Choice'(A),B,C,D):-'OptFlat.getAllFuncCallsOfExpr'(A,B,C,D).
'OptFlat.getAllFuncCallsOfExpr_1'('Flat.GuardedExpr'(A,B,C),D,E,F):- ++('OptFlat.getAllFuncCallsOfExpr'(B),'OptFlat.getAllFuncCallsOfExpr'(C),D,E,F).

:- block 'OptFlat.getAllFuncCallsOfBranchExpr'(?,?,-,?).
'OptFlat.getAllFuncCallsOfBranchExpr'(A,B,C,D):-hnf(A,E,C,F),'OptFlat.getAllFuncCallsOfBranchExpr_1'(E,B,F,D).

:- block 'OptFlat.getAllFuncCallsOfBranchExpr_1'(?,?,-,?).
'OptFlat.getAllFuncCallsOfBranchExpr_1'('Flat.Branch'(A,B),C,D,E):-'OptFlat.getAllFuncCallsOfExpr'(B,C,D,E).

:- block 'OptFlat.readAllImportedFlatProgs'(?,?,?,?,-,?).
'OptFlat.readAllImportedFlatProgs'(A,B,C,D,E,F):-hnf(apply(putStr(['\'L','\'o','\'a','\'d','\'i','\'n','\'g','\' ','\'i','\'m','\'p','\'o','\'r','\'t','\'e','\'d','\' ','\'m','\'o','\'d','\'u','\'l','\'e','\'s','\'.','\'.','\'.','\'\n'])>> >>=('OptFlat.readAllImportedFlatProgs\''('OptFlat.getImports'(A),B,'SetRBT2.emptySetRBT'('OptFlat.leString')),'OptFlat.lambdafun_9667'),C),D,E,F).

:- block 'OptFlat.readAllImportedFlatProgs\''(?,?,?,?,?,-,?).
'OptFlat.readAllImportedFlatProgs\''(A,B,C,D,E,F,G):-hnf(A,H,F,I),'OptFlat.readAllImportedFlatProgs\'_1'(H,B,C,D,E,I,G).

:- block 'OptFlat.readAllImportedFlatProgs\'_1'(-,?,?,?,?,?,?),'OptFlat.readAllImportedFlatProgs\'_1'(?,?,?,?,?,-,?).
'OptFlat.readAllImportedFlatProgs\'_1'([],A,B,C,D,E,F):-hnf(apply(return([]),C),D,E,F).
'OptFlat.readAllImportedFlatProgs\'_1'([A|B],C,D,E,F,G,H):-makeShare(A,I),makeShare(D,J),makeShare(B,K),makeShare(C,L),hnf(apply(if_then_else('SetRBT2.elemRBT'(I,J),>>=('OptFlat.readAllImportedFlatProgs\''(K,L,J),'OptFlat.lambdafun_9668'),>>=('OptFlat.tryReadFlatCurry'(I,L),'OptFlat.lambdafun_9670'(I,K,L,J))),E),F,G,H).

:- block 'OptFlat.tryReadFlatCurry'(?,?,?,?,-,?).
'OptFlat.tryReadFlatCurry'(A,B,C,D,E,F):-makeShare(A,G),hnf(apply(if_then_else(elem('\'r',B),'Flat.readFlatCurryFile'(++(G,['\'.','\'f','\'l','\'c'])),'Flat.readFlatCurry'(G)),C),D,E,F).

:- block 'OptFlat.getModname'(?,?,-,?).
'OptFlat.getModname'(A,B,C,D):-hnf(A,E,C,F),'OptFlat.getModname_1'(E,B,F,D).

:- block 'OptFlat.getModname_1'(?,?,-,?).
'OptFlat.getModname_1'('Flat.Prog'(A,B,C,D,E,F),G,H,I):-hnf(A,G,H,I).

:- block 'OptFlat.getImports'(?,?,-,?).
'OptFlat.getImports'(A,B,C,D):-hnf(A,E,C,F),'OptFlat.getImports_1'(E,B,F,D).

:- block 'OptFlat.getImports_1'(?,?,-,?).
'OptFlat.getImports_1'('Flat.Prog'(A,B,C,D,E,F),G,H,I):-hnf(B,G,H,I).

:- block 'OptFlat.getFuncDecls'(?,?,-,?).
'OptFlat.getFuncDecls'(A,B,C,D):-hnf(A,E,C,F),'OptFlat.getFuncDecls_1'(E,B,F,D).

:- block 'OptFlat.getFuncDecls_1'(?,?,-,?).
'OptFlat.getFuncDecls_1'('Flat.Prog'(A,B,C,D,E,F),G,H,I):-hnf(D,G,H,I).

:- block 'OptFlat.getFuncName'(?,?,-,?).
'OptFlat.getFuncName'(A,B,C,D):-hnf(A,E,C,F),'OptFlat.getFuncName_1'(E,B,F,D).

:- block 'OptFlat.getFuncName_1'(?,?,-,?).
'OptFlat.getFuncName_1'('Flat.Func'(A,B,C,D),E,F,G):-hnf(A,E,F,G).

:- block 'OptFlat.getTransName'(?,?,-,?).
'OptFlat.getTransName'(A,B,C,D):-hnf(A,E,C,F),'OptFlat.getTransName_1'(E,B,F,D).

:- block 'OptFlat.getTransName_1'(?,?,-,?).
'OptFlat.getTransName_1'('Flat.Trans'(A,B),C,D,E):-hnf(A,C,D,E).

:- block 'OptFlat.getInternalName'(?,?,-,?).
'OptFlat.getInternalName'(A,B,C,D):-hnf(A,E,C,F),'OptFlat.getInternalName_1'(E,B,F,D).

:- block 'OptFlat.getInternalName_1'(?,?,-,?).
'OptFlat.getInternalName_1'('Flat.Trans'(A,B),C,D,E):-hnf(B,C,D,E).

:- block 'OptFlat.mergeFlatProgList'(?,?,-,?).
'OptFlat.mergeFlatProgList'(A,B,C,D):-foldl1('OptFlat.mergeFlatProgs',A,B,C,D).

:- block 'OptFlat.mergeFlatProgs'(?,?,?,-,?).
'OptFlat.mergeFlatProgs'(A,B,C,D,E):-hnf(A,F,D,G),'OptFlat.mergeFlatProgs_1'(F,B,C,G,E).

:- block 'OptFlat.mergeFlatProgs_1'(?,?,?,-,?).
'OptFlat.mergeFlatProgs_1'('Flat.Prog'(A,B,C,D,E,F),G,H,I,J):-hnf(G,K,I,L),'OptFlat.mergeFlatProgs_1_Flat.Prog_7'(K,A,B,C,D,E,F,H,L,J).

:- block 'OptFlat.mergeFlatProgs_1_Flat.Prog_7'(?,?,?,?,?,?,?,?,-,?).
'OptFlat.mergeFlatProgs_1_Flat.Prog_7'('Flat.Prog'(A,B,C,D,E,F),G,H,I,J,K,L,'Flat.Prog'(G,'List.nub'(++(H,B)),++(I,C),++(J,D),++(K,E),++(L,F)),M,M).

:- block 'OptFlat.leString'(?,?,?,-,?).
'OptFlat.leString'(A,B,C,D,E):-hnf(apply(apply('OptFlat.leList'('OptFlat.leChar'),A),B),C,D,E).

:- block 'OptFlat.leChar'(?,?,?,-,?).
'OptFlat.leChar'(A,B,C,D,E):-hnf(ord(A)<ord(B),C,D,E).

:- block 'OptFlat.leList'(?,?,?,?,-,?).
'OptFlat.leList'(A,B,C,D,E,F):-hnf(B,G,E,H),'OptFlat.leList_2'(G,A,C,D,H,F).

:- block 'OptFlat.leList_2'(?,?,?,?,-,?).
'OptFlat.leList_2'([],A,B,C,D,E):-hnf(B,F,D,G),'OptFlat.leList_2_[]_2'(F,A,C,G,E).

:- block 'OptFlat.leList_2_[]_2'(?,?,?,-,?).
'OptFlat.leList_2_[]_2'([],A,'False',B,B).
'OptFlat.leList_2_[]_2'([A|B],C,'True',D,D).
'OptFlat.leList_2'([A|B],C,D,E,F,G):-hnf(D,H,F,I),'OptFlat.leList_2_._4'(H,A,B,C,E,I,G).

:- block 'OptFlat.leList_2_._4'(?,?,?,?,?,-,?).
'OptFlat.leList_2_._4'([],A,B,C,'False',D,D).
'OptFlat.leList_2_._4'([A|B],C,D,E,F,G,H):-makeShare(E,I),makeShare(C,J),makeShare(A,K),'||'(apply(apply(I,J),K),&&(J==K,'OptFlat.leList'(I,D,B)),F,G,H).

:- block 'OptFlat.leFuncDecl'(?,?,?,-,?).
'OptFlat.leFuncDecl'(A,B,C,D,E):-hnf(apply(apply('OptFlat.leString','OptFlat.getFuncName'(A)),'OptFlat.getFuncName'(B)),C,D,E).

:- block 'OptFlat.list2SetRBT'(?,?,?,-,?).
'OptFlat.list2SetRBT'(A,B,C,D,E):-foldr('SetRBT2.insertRBT','SetRBT2.emptySetRBT'(A),B,C,D,E).

:- block 'OptFlat.lambdafun_9659'(?,?,?,?,?,?,?,-,?).
'OptFlat.lambdafun_9659'(A,B,C,D,E,F,G,H,I):-makeShare(B,J),hnf(apply(putStr(['\'O','\'p','\'t','\'i','\'m','\'i','\'z','\'i','\'n','\'g','\'.','\'.','\'.','\'\n'])>>'OptFlat.optFlat_lambda0_9662'(D,J,'OptFlat.getStartingState'(A,E,J,C)),F),G,H,I).

:- block 'OptFlat.optFlat_lambda1_9661'(?,?,?,?,-,?).
'OptFlat.optFlat_lambda1_9661'(A,B,C,D,E,F):-makeShare(A,G),hnf(apply('FlatTools.writeFLC'(++(G,['\'.','\'f','\'l','\'c']),B)>>(putStr(++(G,['\'.','\'f','\'l','\'c','\' ','\'w','\'r','\'i','\'t','\'t','\'e','\'n','\'.','\'\n']))>>done),C),D,E,F).

:- block 'OptFlat.optFlat_lambda0_9662'(?,?,?,?,?,-,?).
'OptFlat.optFlat_lambda0_9662'(A,B,C,D,E,F,G):-hnf(C,H,F,I),'OptFlat.optFlat_lambda0_9662_3'(H,A,B,D,E,I,G).

:- block 'OptFlat.optFlat_lambda0_9662_3'(-,?,?,?,?,?,?),'OptFlat.optFlat_lambda0_9662_3'(?,?,?,?,?,-,?).
'OptFlat.optFlat_lambda0_9662_3'('(,)'(A,B),C,D,E,F,G,H):-hnf(apply('OptFlat.optFlat_lambda1_9661'(C,'OptFlat.makeOptimizedFlatProg'(A,B,D)),E),F,G,H).

:- block 'OptFlat.lambdafun_9660'(?,?,?,?,?,?,-,?).
'OptFlat.lambdafun_9660'(A,B,C,D,E,F,G,H):-makeShare(D,I),makeShare(A,J),hnf(apply(>>=('OptFlat.readAllImportedFlatProgs'(I,J),'OptFlat.lambdafun_9659'(I,J,B,C)),E),F,G,H).

:- block 'OptFlat.optFlat_lambda2_9663'(?,?,?,?,?,?,-,?).
'OptFlat.optFlat_lambda2_9663'(A,B,C,D,E,F,G,H):-hnf(E,I,G,J),'OptFlat.optFlat_lambda2_9663_5'(I,A,B,C,D,F,J,H).

:- block 'OptFlat.optFlat_lambda2_9663_5'(?,?,?,?,?,?,-,?).
'OptFlat.optFlat_lambda2_9663_5'('(,)'(A,B),C,D,E,F,'Flat.Prog'(C,[],D,['OptFlat.getFunc'(A,E)],F,[B]),G,G).

:- block 'OptFlat.optFlat_lambda3_9664'(?,?,?,?,-,?).
'OptFlat.optFlat_lambda3_9664'(A,B,C,D,E,F):-'OptFlat.optFuncDecls\''(A,C,B,D,E,F).

:- block 'OptFlat.optFlat_lambda5_9665'(?,?,?,?,-,?).
'OptFlat.optFlat_lambda5_9665'(A,B,C,D,E,F):-hnf(C,G,E,H),'OptFlat.optFlat_lambda5_9665_3'(G,A,B,D,H,F).

:- block 'OptFlat.optFlat_lambda5_9665_3'(?,?,?,?,-,?).
'OptFlat.optFlat_lambda5_9665_3'('(,)'(A,B),C,D,[C|'OptFlat.optFuncDecls\''(A,B,D)],E,E).

:- block 'OptFlat.optFlat_lambda4_9666'(?,?,?,?,?,?,-,?).
'OptFlat.optFlat_lambda4_9666'(A,B,C,D,E,F,G,H):-makeShare(B,I),'OptFlat.optFlat_lambda5_9665'(A,I,'OptFlat.lookupFuncCalls'(E,C,D,I),F,G,H).

:- block 'OptFlat.lambdafun_9667'(?,?,?,-,?).
'OptFlat.lambdafun_9667'(A,B,C,D,E):-hnf(apply(putStr(['\'A','\'l','\'l','\' ','\'m','\'o','\'d','\'u','\'l','\'e','\'s','\' ','\'i','\'m','\'p','\'o','\'r','\'t','\'e','\'d','\'.','\'\n'])>>return(A),B),C,D,E).

:- block 'OptFlat.lambdafun_9668'(?,?,?,-,?).
'OptFlat.lambdafun_9668'(A,B,C,D,E):-hnf(apply(return(A),B),C,D,E).

:- block 'OptFlat.lambdafun_9669'(?,?,?,?,-,?).
'OptFlat.lambdafun_9669'(A,B,C,D,E,F):-hnf(apply(return([A|B]),C),D,E,F).

:- block 'OptFlat.lambdafun_9670'(?,?,?,?,?,?,?,-,?).
'OptFlat.lambdafun_9670'(A,B,C,D,E,F,G,H,I):-makeShare(A,J),makeShare(E,K),hnf(apply(putStr(++(['\'I','\'m','\'p','\'o','\'r','\'t','\'e','\'d','\' ','\'m','\'o','\'d','\'u','\'l','\'e','\' '],++(J,['\'.','\'\n'])))>> >>=('OptFlat.readAllImportedFlatProgs\''(++(B,'OptFlat.getImports'(K)),C,'SetRBT2.insertRBT'(J,D)),'OptFlat.lambdafun_9669'(K)),F),G,H,I).

:- block 'prelude..'(?,?,?,?,-,?).
'prelude..'(A,B,C,D,E,F):-hnf(apply(prelude_lambda0_1997(A,B),C),D,E,F).

:- block id(?,?,-,?).
id(A,B,C,D):-hnf(A,B,C,D).

:- block const(?,?,?,-,?).
const(A,B,C,D,E):-hnf(A,C,D,E).

:- block curry(?,?,?,?,-,?).
curry(A,B,C,D,E,F):-hnf(apply(A,'(,)'(B,C)),D,E,F).

:- block uncurry(?,?,?,-,?).
uncurry(A,B,C,D,E):-hnf(B,F,D,G),uncurry_2(F,A,C,G,E).

:- block uncurry_2(?,?,?,-,?).
uncurry_2('(,)'(A,B),C,D,E,F):-hnf(apply(apply(C,A),B),D,E,F).

:- block flip(?,?,?,?,-,?).
flip(A,B,C,D,E,F):-hnf(apply(apply(A,C),B),D,E,F).

:- block until(?,?,?,?,-,?).
until(A,B,C,D,E,F):-makeShare(A,G),makeShare(C,H),makeShare(B,I),if_then_else(apply(G,H),H,until(G,I,apply(I,H)),D,E,F).

:- block $(?,?,?,-,?).
$(A,B,C,D,E):-hnf(apply(A,B),C,D,E).

:- block '$!'(?,?,?,-,?).
'$!'(A,B,C,D,E):-makeShare(B,F),hnf(seq(F,apply(A,F)),C,D,E).

:- block failed(?,-,?).
failed(A,B,C):-hnf(guardedexpr(1=:=2,D),A,B,C).

:- block &&(?,?,?,-,?).
&&(A,B,C,D,E):-hnf(A,F,D,G),'&&_1'(F,B,C,G,E).

:- block '&&_1'(?,?,?,-,?).
'&&_1'('True',A,B,C,D):-hnf(A,B,C,D).
'&&_1'('False',A,'False',B,B).

:- block '||'(?,?,?,-,?).
'||'(A,B,C,D,E):-hnf(A,F,D,G),'||_1'(F,B,C,G,E).

:- block '||_1'(?,?,?,-,?).
'||_1'('True',A,'True',B,B).
'||_1'('False',A,B,C,D):-hnf(A,B,C,D).

:- block not(?,?,-,?).
not(A,B,C,D):-hnf(A,E,C,F),not_1(E,B,F,D).

:- block not_1(?,?,-,?).
not_1('True','False',A,A).
not_1('False','True',A,A).

:- block otherwise(?,-,?).
otherwise('True',A,A).

:- block if_then_else(?,?,?,?,-,?).
if_then_else(A,B,C,D,E,F):-hnf(A,G,E,H),if_then_else_1(G,B,C,D,H,F).

:- block if_then_else_1(-,?,?,?,?,?),if_then_else_1(?,?,?,?,-,?).
if_then_else_1('True',A,B,C,D,E):-hnf(A,C,D,E).
if_then_else_1('False',A,B,C,D,E):-hnf(B,C,D,E).

:- block /=(?,?,?,-,?).
/=(A,B,C,D,E):-not(A==B,C,D,E).

:- block fst(?,?,-,?).
fst(A,B,C,D):-hnf(A,E,C,F),fst_1(E,B,F,D).

:- block fst_1(?,?,-,?).
fst_1('(,)'(A,B),C,D,E):-hnf(A,C,D,E).

:- block snd(?,?,-,?).
snd(A,B,C,D):-hnf(A,E,C,F),snd_1(E,B,F,D).

:- block snd_1(?,?,-,?).
snd_1('(,)'(A,B),C,D,E):-hnf(B,C,D,E).

:- block head(?,?,-,?).
head(A,B,C,D):-hnf(A,E,C,F),head_1(E,B,F,D).

:- block head_1(?,?,-,?).
head_1([A|B],C,D,E):-hnf(A,C,D,E).

:- block tail(?,?,-,?).
tail(A,B,C,D):-hnf(A,E,C,F),tail_1(E,B,F,D).

:- block tail_1(?,?,-,?).
tail_1([A|B],C,D,E):-hnf(B,C,D,E).

:- block null(?,?,-,?).
null(A,B,C,D):-hnf(A,E,C,F),null_1(E,B,F,D).

:- block null_1(?,?,-,?).
null_1([],'True',A,A).
null_1([A|B],'False',C,C).

:- block ++(?,?,?,-,?).
++(A,B,C,D,E):-hnf(A,F,D,G),'++_1'(F,B,C,G,E).

:- block '++_1'(?,?,?,-,?).
'++_1'([],A,B,C,D):-hnf(A,B,C,D).
'++_1'([A|B],C,[A|++(B,C)],D,D).

:- block length(?,?,-,?).
length(A,B,C,D):-hnf(A,E,C,F),length_1(E,B,F,D).

:- block length_1(?,?,-,?).
length_1([],0,A,A).
length_1([A|B],C,D,E):-hnf(1+length(B),C,D,E).

:- block '!!'(?,?,?,-,?).
'!!'(A,B,C,D,E):-hnf(A,F,D,G),'!!_1'(F,B,C,G,E).

:- block '!!_1'(?,?,?,-,?).
'!!_1'([A|B],C,D,E,F):-makeShare(C,G),if_then_else(G==0,A,if_then_else(G>0,'!!'(B,G-1),failed),D,E,F).

:- block map(?,?,?,-,?).
map(A,B,C,D,E):-hnf(B,F,D,G),map_2(F,A,C,G,E).

:- block map_2(?,?,?,-,?).
map_2([],A,[],B,B).
map_2([A|B],C,[apply(D,A)|map(D,B)],E,E):-makeShare(C,D).

:- block foldl(?,?,?,?,-,?).
foldl(A,B,C,D,E,F):-hnf(C,G,E,H),foldl_3(G,A,B,D,H,F).

:- block foldl_3(?,?,?,?,-,?).
foldl_3([],A,B,C,D,E):-hnf(B,C,D,E).
foldl_3([A|B],C,D,E,F,G):-makeShare(C,H),foldl(H,apply(apply(H,D),A),B,E,F,G).

:- block foldl1(?,?,?,-,?).
foldl1(A,B,C,D,E):-hnf(B,F,D,G),foldl1_2(F,A,C,G,E).

:- block foldl1_2(?,?,?,-,?).
foldl1_2([A|B],C,D,E,F):-foldl(C,A,B,D,E,F).

:- block foldr(?,?,?,?,-,?).
foldr(A,B,C,D,E,F):-hnf(C,G,E,H),foldr_3(G,A,B,D,H,F).

:- block foldr_3(?,?,?,?,-,?).
foldr_3([],A,B,C,D,E):-hnf(B,C,D,E).
foldr_3([A|B],C,D,E,F,G):-makeShare(C,H),hnf(apply(apply(H,A),foldr(H,D,B)),E,F,G).

:- block foldr1(?,?,?,-,?).
foldr1(A,B,C,D,E):-hnf(B,F,D,G),foldr1_2(F,A,C,G,E).

:- block foldr1_2(?,?,?,-,?).
foldr1_2([A|B],C,D,E,F):-hnf(B,G,E,H),'foldr1_2_._2'(G,A,C,D,H,F).

:- block 'foldr1_2_._2'(?,?,?,?,-,?).
'foldr1_2_._2'([],A,B,C,D,E):-hnf(A,C,D,E).
'foldr1_2_._2'([A|B],C,D,E,F,G):-makeShare(D,H),hnf(apply(apply(H,C),foldr1(H,[A|B])),E,F,G).

:- block filter(?,?,?,-,?).
filter(A,B,C,D,E):-hnf(B,F,D,G),filter_2(F,A,C,G,E).

:- block filter_2(?,?,?,-,?).
filter_2([],A,[],B,B).
filter_2([A|B],C,D,E,F):-makeShare(C,G),makeShare(A,H),makeShare(B,I),if_then_else(apply(G,H),[H|filter(G,I)],filter(G,I),D,E,F).

:- block zip(?,?,?,-,?).
zip(A,B,C,D,E):-hnf(A,F,D,G),zip_1(F,B,C,G,E).

:- block zip_1(?,?,?,-,?).
zip_1([],A,[],B,B).
zip_1([A|B],C,D,E,F):-hnf(C,G,E,H),'zip_1_._3'(G,A,B,D,H,F).

:- block 'zip_1_._3'(?,?,?,?,-,?).
'zip_1_._3'([],A,B,[],C,C).
'zip_1_._3'([A|B],C,D,['(,)'(C,A)|zip(D,B)],E,E).

:- block zip3(?,?,?,?,-,?).
zip3(A,B,C,D,E,F):-hnf(A,G,E,H),zip3_1(G,B,C,D,H,F).

:- block zip3_1(?,?,?,?,-,?).
zip3_1([],A,B,[],C,C).
zip3_1([A|B],C,D,E,F,G):-hnf(C,H,F,I),'zip3_1_._3'(H,A,B,D,E,I,G).

:- block 'zip3_1_._3'(?,?,?,?,?,-,?).
'zip3_1_._3'([],A,B,C,[],D,D).
'zip3_1_._3'([A|B],C,D,E,F,G,H):-hnf(E,I,G,J),'zip3_1_._3_._5'(I,A,B,C,D,F,J,H).

:- block 'zip3_1_._3_._5'(?,?,?,?,?,?,-,?).
'zip3_1_._3_._5'([],A,B,C,D,[],E,E).
'zip3_1_._3_._5'([A|B],C,D,E,F,['(,,)'(E,C,A)|zip3(F,D,B)],G,G).

:- block zipWith(?,?,?,?,-,?).
zipWith(A,B,C,D,E,F):-hnf(B,G,E,H),zipWith_2(G,A,C,D,H,F).

:- block zipWith_2(?,?,?,?,-,?).
zipWith_2([],A,B,[],C,C).
zipWith_2([A|B],C,D,E,F,G):-hnf(D,H,F,I),'zipWith_2_._4'(H,A,B,C,E,I,G).

:- block 'zipWith_2_._4'(?,?,?,?,?,-,?).
'zipWith_2_._4'([],A,B,C,[],D,D).
'zipWith_2_._4'([A|B],C,D,E,[apply(apply(F,C),A)|zipWith(F,D,B)],G,G):-makeShare(E,F).

:- block zipWith3(?,?,?,?,?,-,?).
zipWith3(A,B,C,D,E,F,G):-hnf(B,H,F,I),zipWith3_2(H,A,C,D,E,I,G).

:- block zipWith3_2(?,?,?,?,?,-,?).
zipWith3_2([],A,B,C,[],D,D).
zipWith3_2([A|B],C,D,E,F,G,H):-hnf(D,I,G,J),'zipWith3_2_._4'(I,A,B,C,E,F,J,H).

:- block 'zipWith3_2_._4'(?,?,?,?,?,?,-,?).
'zipWith3_2_._4'([],A,B,C,D,[],E,E).
'zipWith3_2_._4'([A|B],C,D,E,F,G,H,I):-hnf(F,J,H,K),'zipWith3_2_._4_._6'(J,A,B,C,D,E,G,K,I).

:- block 'zipWith3_2_._4_._6'(?,?,?,?,?,?,?,-,?).
'zipWith3_2_._4_._6'([],A,B,C,D,E,[],F,F).
'zipWith3_2_._4_._6'([A|B],C,D,E,F,G,[apply(apply(apply(H,E),C),A)|zipWith3(H,F,D,B)],I,I):-makeShare(G,H).

:- block unzip(?,?,-,?).
unzip(A,B,C,D):-hnf(A,E,C,F),unzip_1(E,B,F,D).

:- block unzip_1(?,?,-,?).
unzip_1([],'(,)'([],[]),A,A).
unzip_1([A|B],C,D,E):-hnf(A,F,D,G),'unzip_1_._1'(F,B,C,G,E).

:- block 'unzip_1_._1'(?,?,?,-,?).
'unzip_1_._1'('(,)'(A,B),C,D,E,F):-prelude_lambda1_1998(A,B,unzip(C),D,E,F).

:- block unzip3(?,?,-,?).
unzip3(A,B,C,D):-hnf(A,E,C,F),unzip3_1(E,B,F,D).

:- block unzip3_1(?,?,-,?).
unzip3_1([],'(,,)'([],[],[]),A,A).
unzip3_1([A|B],C,D,E):-hnf(A,F,D,G),'unzip3_1_._1'(F,B,C,G,E).

:- block 'unzip3_1_._1'(?,?,?,-,?).
'unzip3_1_._1'('(,,)'(A,B,C),D,E,F,G):-prelude_lambda2_1999(A,B,C,unzip3(D),E,F,G).

:- block concat(?,?,-,?).
concat(A,B,C,D):-foldr(++,[],A,B,C,D).

:- block concatMap(?,?,?,-,?).
concatMap(A,B,C,D,E):-hnf(apply('prelude..'(concat,map(A)),B),C,D,E).

:- block iterate(?,?,?,-,?).
iterate(A,B,[C|iterate(D,apply(D,C))],E,E):-makeShare(B,C),makeShare(A,D).

:- block repeat(?,?,-,?).
repeat(A,[B|repeat(B)],C,C):-makeShare(A,B).

:- block replicate(?,?,?,-,?).
replicate(A,B,C,D,E):-take(A,repeat(B),C,D,E).

:- block take(?,?,?,-,?).
take(A,B,C,D,E):-makeShare(A,F),if_then_else(<=(F,0),[],takep_452(F,B),C,D,E).

:- block drop(?,?,?,-,?).
drop(A,B,C,D,E):-makeShare(A,F),makeShare(B,G),if_then_else(<=(F,0),G,dropp_459(F,G),C,D,E).

:- block splitAt(?,?,?,-,?).
splitAt(A,B,C,D,E):-makeShare(A,F),makeShare(B,G),if_then_else(<=(F,0),'(,)'([],G),splitAtp_466(F,G),C,D,E).

:- block takeWhile(?,?,?,-,?).
takeWhile(A,B,C,D,E):-hnf(B,F,D,G),takeWhile_2(F,A,C,G,E).

:- block takeWhile_2(?,?,?,-,?).
takeWhile_2([],A,[],B,B).
takeWhile_2([A|B],C,D,E,F):-makeShare(C,G),makeShare(A,H),if_then_else(apply(G,H),[H|takeWhile(G,B)],[],D,E,F).

:- block dropWhile(?,?,?,-,?).
dropWhile(A,B,C,D,E):-hnf(B,F,D,G),dropWhile_2(F,A,C,G,E).

:- block dropWhile_2(?,?,?,-,?).
dropWhile_2([],A,[],B,B).
dropWhile_2([A|B],C,D,E,F):-makeShare(C,G),makeShare(A,H),makeShare(B,I),if_then_else(apply(G,H),dropWhile(G,I),[H|I],D,E,F).

:- block span(?,?,?,-,?).
span(A,B,C,D,E):-hnf(B,F,D,G),span_2(F,A,C,G,E).

:- block span_2(?,?,?,-,?).
span_2([],A,'(,)'([],[]),B,B).
span_2([A|B],C,D,E,F):-makeShare(C,G),makeShare(A,H),makeShare(B,I),if_then_else(apply(G,H),prelude_lambda4_2001(H,span(G,I)),'(,)'([],[H|I]),D,E,F).

:- block break(?,?,?,-,?).
break(A,B,C,D,E):-hnf(apply(span('prelude..'(not,A)),B),C,D,E).

:- block lines(?,?,-,?).
lines(A,B,C,D):-hnf(A,E,C,F),lines_1(E,B,F,D).

:- block lines_1(?,?,-,?).
lines_1([],[],A,A).
lines_1([A|B],C,D,E):-prelude_lambda6_2003(splitline_490([A|B]),C,D,E).

:- block unlines(?,?,-,?).
unlines(A,B,C,D):-hnf(apply(concatMap(prelude_lambda7_2004),A),B,C,D).

:- block words(?,?,-,?).
words(A,B,C,D):-prelude_lambda8_2006(dropWhile(isSpace_500,A),B,C,D).

:- block unwords(?,?,-,?).
unwords(A,B,C,D):-makeShare(A,E),if_then_else(E==[],[],foldr1(prelude_lambda10_2007,E),B,C,D).

:- block reverse(?,?,-,?).
reverse(A,B,C,D):-hnf(apply(foldl(flip('.'),[]),A),B,C,D).

:- block and(?,?,-,?).
and(A,B,C,D):-hnf(apply(foldr(&&,'True'),A),B,C,D).

:- block or(?,?,-,?).
or(A,B,C,D):-hnf(apply(foldr('||','False'),A),B,C,D).

:- block any(?,?,?,-,?).
any(A,B,C,D,E):-hnf(apply('prelude..'(or,map(A)),B),C,D,E).

:- block all(?,?,?,-,?).
all(A,B,C,D,E):-hnf(apply('prelude..'(and,map(A)),B),C,D,E).

:- block elem(?,?,?,-,?).
elem(A,B,C,D,E):-hnf(apply(any(prelude_lambda11_2008(A)),B),C,D,E).

:- block notElem(?,?,?,-,?).
notElem(A,B,C,D,E):-hnf(apply(all(prelude_lambda12_2009(A)),B),C,D,E).

:- block lookup(?,?,?,-,?).
lookup(A,B,C,D,E):-hnf(B,F,D,G),lookup_2(F,A,C,G,E).

:- block lookup_2(?,?,?,-,?).
lookup_2([],A,'Nothing',B,B).
lookup_2([A|B],C,D,E,F):-hnf(A,G,E,H),'lookup_2_._1'(G,B,C,D,H,F).

:- block 'lookup_2_._1'(?,?,?,?,-,?).
'lookup_2_._1'('(,)'(A,B),C,D,E,F,G):-makeShare(D,H),if_then_else(H==A,'Just'(B),lookup(H,C),E,F,G).

:- block enumFrom(?,?,-,?).
enumFrom(A,[B|enumFrom(B+1)],C,C):-makeShare(A,B).

:- block enumFromThen(?,?,?,-,?).
enumFromThen(A,B,C,D,E):-makeShare(A,F),iterate(prelude_lambda13_2010(B,F),F,C,D,E).

:- block enumFromTo(?,?,?,-,?).
enumFromTo(A,B,C,D,E):-makeShare(A,F),makeShare(B,G),if_then_else(F>G,[],[F|enumFromTo(F+1,G)],C,D,E).

:- block enumFromThenTo(?,?,?,?,-,?).
enumFromThenTo(A,B,C,D,E,F):-makeShare(B,G),makeShare(A,H),takeWhile(p_528(G,H,C),enumFromThen(H,G),D,E,F).

:- block &>(?,?,?,-,?).
&>(A,B,C,D,E):-hnf(guardedexpr(A,B),C,D,E).

:- block maybe(?,?,?,?,-,?).
maybe(A,B,C,D,E,F):-hnf(C,G,E,H),maybe_3(G,A,B,D,H,F).

:- block maybe_3(?,?,?,?,-,?).
maybe_3('Nothing',A,B,C,D,E):-hnf(A,C,D,E).
maybe_3('Just'(A),B,C,D,E,F):-hnf(apply(C,A),D,E,F).

:- block either(?,?,?,?,-,?).
either(A,B,C,D,E,F):-hnf(C,G,E,H),either_3(G,A,B,D,H,F).

:- block either_3(?,?,?,?,-,?).
either_3('Left'(A),B,C,D,E,F):-hnf(apply(B,A),D,E,F).
either_3('Right'(A),B,C,D,E,F):-hnf(apply(C,A),D,E,F).

:- block done(?,?,-,?).
done(A,B,C,D):-hnf(apply(return('()'),A),B,C,D).

:- block putStr(?,?,?,-,?).
putStr(A,B,C,D,E):-hnf(A,F,D,G),putStr_1(F,B,C,G,E).

:- block putStr_1(-,?,?,?,?),putStr_1(?,?,?,-,?).
putStr_1([],A,B,C,D):-hnf(apply(done,A),B,C,D).
putStr_1([A|B],C,D,E,F):-hnf(apply(putChar(A)>>putStr(B),C),D,E,F).

:- block putStrLn(?,?,?,-,?).
putStrLn(A,B,C,D,E):-hnf(apply(putStr(A)>>putChar('\'\n'),B),C,D,E).

:- block getLine(?,?,-,?).
getLine(A,B,C,D):-hnf(apply(>>=(getChar,lambdafun_2012),A),B,C,D).

:- block print(?,?,?,-,?).
print(A,B,C,D,E):-hnf(apply(putStrLn(show(A)),B),C,D,E).

:- block doSolve(?,?,?,-,?).
doSolve(A,B,C,D,E):-hnf(guardedexpr(A,apply(done,B)),C,D,E).

:- block sequenceIO(?,?,?,-,?).
sequenceIO(A,B,C,D,E):-hnf(A,F,D,G),sequenceIO_1(F,B,C,G,E).

:- block sequenceIO_1(-,?,?,?,?),sequenceIO_1(?,?,?,-,?).
sequenceIO_1([],A,B,C,D):-hnf(apply(return([]),A),B,C,D).
sequenceIO_1([A|B],C,D,E,F):-hnf(apply(>>=(A,lambdafun_2015(B)),C),D,E,F).

:- block sequenceIO_(?,?,?,-,?).
sequenceIO_(A,B,C,D,E):-hnf(apply(apply(foldr(>>,done),A),B),C,D,E).

:- block mapIO(?,?,?,?,-,?).
mapIO(A,B,C,D,E,F):-hnf(apply(apply('prelude..'(sequenceIO,map(A)),B),C),D,E,F).

:- block mapIO_(?,?,?,?,-,?).
mapIO_(A,B,C,D,E,F):-hnf(apply(apply('prelude..'(sequenceIO_,map(A)),B),C),D,E,F).

:- block inject(?,?,?,?,-,?).
inject(A,B,C,D,E,F):-hnf(apply(prelude_lambda15_2016(B,A),C),D,E,F).

:- block solveAll(?,?,-,?).
solveAll(A,B,C,D):-evalall_563(try(A),B,C,D).

:- block solveAll2(?,?,-,?).
solveAll2(A,B,C,D):-evalResult_580(try(A),B,C,D).

:- block once(?,?,?,-,?).
once(A,B,C,D,E):-hnf(apply(head(solveAll(A)),B),C,D,E).

:- block one(?,?,-,?).
one(A,B,C,D):-solveAll(prelude_lambda16_2017(A),B,C,D).

:- block condSearch(?,?,?,-,?).
condSearch(A,B,C,D,E):-one(prelude_lambda17_2018(A,B),C,D,E).

:- block best(?,?,?,-,?).
best(A,B,C,D,E):-bestHelp_595(B,[],try(A),[],C,D,E).

:- block browse(?,?,?,-,?).
browse(A,B,C,D,E):-hnf(apply(putStr(show(unpack(A))),B),C,D,E).

:- block browseList(?,?,?,-,?).
browseList(A,B,C,D,E):-hnf(A,F,D,G),browseList_1(F,B,C,G,E).

:- block browseList_1(-,?,?,?,?),browseList_1(?,?,?,-,?).
browseList_1([],A,B,C,D):-hnf(apply(done,A),B,C,D).
browseList_1([A|B],C,D,E,F):-hnf(apply(browse(A)>>putChar('\'\n')>>browseList(B),C),D,E,F).

:- block unpack(?,?,-,?).
unpack(A,B,C,D):-makeShare(E,F),hnf(guardedexpr(apply(A,F),F),B,C,D).

:- block 'PEVAL'(?,?,-,?).
'PEVAL'(A,B,C,D):-hnf(A,B,C,D).

:- block prelude_lambda0_1997(?,?,?,?,-,?).
prelude_lambda0_1997(A,B,C,D,E,F):-hnf(apply(A,apply(B,C)),D,E,F).

:- block prelude_lambda1_1998(?,?,?,?,-,?).
prelude_lambda1_1998(A,B,C,D,E,F):-hnf(C,G,E,H),prelude_lambda1_1998_3(G,A,B,D,H,F).

:- block prelude_lambda1_1998_3(?,?,?,?,-,?).
prelude_lambda1_1998_3('(,)'(A,B),C,D,'(,)'([C|A],[D|B]),E,E).

:- block prelude_lambda2_1999(?,?,?,?,?,-,?).
prelude_lambda2_1999(A,B,C,D,E,F,G):-hnf(D,H,F,I),prelude_lambda2_1999_4(H,A,B,C,E,I,G).

:- block prelude_lambda2_1999_4(?,?,?,?,?,-,?).
prelude_lambda2_1999_4('(,,)'(A,B,C),D,E,F,'(,,)'([D|A],[E|B],[F|C]),G,G).

:- block takep_452(?,?,?,-,?).
takep_452(A,B,C,D,E):-hnf(B,F,D,G),takep_452_2(F,A,C,G,E).

:- block takep_452_2(?,?,?,-,?).
takep_452_2([],A,[],B,B).
takep_452_2([A|B],C,[A|take(C-1,B)],D,D).

:- block dropp_459(?,?,?,-,?).
dropp_459(A,B,C,D,E):-hnf(B,F,D,G),dropp_459_2(F,A,C,G,E).

:- block dropp_459_2(?,?,?,-,?).
dropp_459_2([],A,[],B,B).
dropp_459_2([A|B],C,D,E,F):-drop(C-1,B,D,E,F).

:- block splitAtp_466(?,?,?,-,?).
splitAtp_466(A,B,C,D,E):-hnf(B,F,D,G),splitAtp_466_2(F,A,C,G,E).

:- block splitAtp_466_2(?,?,?,-,?).
splitAtp_466_2([],A,'(,)'([],[]),B,B).
splitAtp_466_2([A|B],C,D,E,F):-prelude_lambda3_2000(A,splitAt(C-1,B),D,E,F).

:- block prelude_lambda3_2000(?,?,?,-,?).
prelude_lambda3_2000(A,B,C,D,E):-hnf(B,F,D,G),prelude_lambda3_2000_2(F,A,C,G,E).

:- block prelude_lambda3_2000_2(?,?,?,-,?).
prelude_lambda3_2000_2('(,)'(A,B),C,'(,)'([C|A],B),D,D).

:- block prelude_lambda4_2001(?,?,?,-,?).
prelude_lambda4_2001(A,B,C,D,E):-hnf(B,F,D,G),prelude_lambda4_2001_2(F,A,C,G,E).

:- block prelude_lambda4_2001_2(?,?,?,-,?).
prelude_lambda4_2001_2('(,)'(A,B),C,'(,)'([C|A],B),D,D).

:- block splitline_490(?,?,-,?).
splitline_490(A,B,C,D):-hnf(A,E,C,F),splitline_490_1(E,B,F,D).

:- block splitline_490_1(?,?,-,?).
splitline_490_1([],'(,)'([],[]),A,A).
splitline_490_1([A|B],C,D,E):-makeShare(A,F),makeShare(B,G),if_then_else(F=='\'\n','(,)'([],G),prelude_lambda5_2002(F,splitline_490(G)),C,D,E).

:- block prelude_lambda5_2002(?,?,?,-,?).
prelude_lambda5_2002(A,B,C,D,E):-hnf(B,F,D,G),prelude_lambda5_2002_2(F,A,C,G,E).

:- block prelude_lambda5_2002_2(?,?,?,-,?).
prelude_lambda5_2002_2('(,)'(A,B),C,'(,)'([C|A],B),D,D).

:- block prelude_lambda6_2003(?,?,-,?).
prelude_lambda6_2003(A,B,C,D):-hnf(A,E,C,F),prelude_lambda6_2003_1(E,B,F,D).

:- block prelude_lambda6_2003_1(?,?,-,?).
prelude_lambda6_2003_1('(,)'(A,B),[A|lines(B)],C,C).

:- block prelude_lambda7_2004(?,?,-,?).
prelude_lambda7_2004(A,B,C,D):- ++(A,['\'\n'],B,C,D).

:- block isSpace_500(?,?,-,?).
isSpace_500(A,B,C,D):-makeShare(A,E),'||'(E=='\' ','||'(E=='\'\t','||'(E=='\'\n',E=='\'\r')),B,C,D).

:- block prelude_lambda9_2005(?,?,-,?).
prelude_lambda9_2005(A,B,C,D):-hnf(A,E,C,F),prelude_lambda9_2005_1(E,B,F,D).

:- block prelude_lambda9_2005_1(?,?,-,?).
prelude_lambda9_2005_1('(,)'(A,B),[A|words(B)],C,C).

:- block prelude_lambda8_2006(?,?,-,?).
prelude_lambda8_2006(A,B,C,D):-makeShare(A,E),if_then_else(E==[],[],prelude_lambda9_2005(apply(break(isSpace_500),E)),B,C,D).

:- block prelude_lambda10_2007(?,?,?,-,?).
prelude_lambda10_2007(A,B,C,D,E):- ++(A,['\' '|B],C,D,E).

:- block prelude_lambda11_2008(?,?,?,-,?).
prelude_lambda11_2008(A,B,C,D,E):-hnf(A==B,C,D,E).

:- block prelude_lambda12_2009(?,?,?,-,?).
prelude_lambda12_2009(A,B,C,D,E):- /=(A,B,C,D,E).

:- block prelude_lambda13_2010(?,?,?,?,-,?).
prelude_lambda13_2010(A,B,C,D,E,F):-hnf(A-B+C,D,E,F).

:- block p_528(?,?,?,?,?,-,?).
p_528(A,B,C,D,E,F,G):-makeShare(D,H),makeShare(C,I),if_then_else(A>=B,<=(H,I),H>=I,E,F,G).

:- block prelude_lambda14_2011(?,?,?,?,-,?).
prelude_lambda14_2011(A,B,C,D,E,F):-hnf(apply(A,C),D,E,F).

:- block lambdafun_2012(?,?,?,-,?).
lambdafun_2012(A,B,C,D,E):-makeShare(A,F),hnf(apply(if_then_else(F=='\'\n',return([]),>>=(getLine,lambdafun_2013(F))),B),C,D,E).

:- block lambdafun_2013(?,?,?,?,-,?).
lambdafun_2013(A,B,C,D,E,F):-hnf(apply(return([A|B]),C),D,E,F).

:- block lambdafun_2014(?,?,?,?,-,?).
lambdafun_2014(A,B,C,D,E,F):-hnf(apply(return([A|B]),C),D,E,F).

:- block lambdafun_2015(?,?,?,?,-,?).
lambdafun_2015(A,B,C,D,E,F):-hnf(apply(>>=(sequenceIO(A),lambdafun_2014(B)),C),D,E,F).

:- block prelude_lambda15_2016(?,?,?,?,-,?).
prelude_lambda15_2016(A,B,C,D,E,F):-makeShare(C,G),hnf(&(apply(A,G),apply(B,G)),D,E,F).

:- block evalall_563(?,?,-,?).
evalall_563(A,B,C,D):-hnf(A,E,C,F),evalall_563_1(E,B,F,D).

:- block evalall_563_1(?,?,-,?).
evalall_563_1([],[],A,A).
evalall_563_1([A|B],C,D,E):-hnf(B,F,D,G),'evalall_563_1_._2'(F,A,C,G,E).

:- block 'evalall_563_1_._2'(?,?,?,-,?).
'evalall_563_1_._2'([],A,[A],B,B).
'evalall_563_1_._2'([A|B],C,D,E,F):-evalall3_565(try(C),[A|B],D,E,F).

:- block evalall2_564(?,?,-,?).
evalall2_564(A,B,C,D):-hnf(A,E,C,F),evalall2_564_1(E,B,F,D).

:- block evalall2_564_1(?,?,-,?).
evalall2_564_1([],[],A,A).
evalall2_564_1([A|B],C,D,E):-evalall3_565(try(A),B,C,D,E).

:- block evalall3_565(?,?,?,-,?).
evalall3_565(A,B,C,D,E):-hnf(A,F,D,G),evalall3_565_1(F,B,C,G,E).

:- block evalall3_565_1(?,?,?,-,?).
evalall3_565_1([],A,B,C,D):-evalall2_564(A,B,C,D).
evalall3_565_1([A|B],C,D,E,F):-hnf(B,G,E,H),'evalall3_565_1_._2'(G,A,C,D,H,F).

:- block 'evalall3_565_1_._2'(?,?,?,?,-,?).
'evalall3_565_1_._2'([],A,B,[A|evalall2_564(B)],C,C).
'evalall3_565_1_._2'([A|B],C,D,E,F,G):-evalall3_565(try(C),[A|++(B,D)],E,F,G).

:- block evalResult_580(?,?,-,?).
evalResult_580(A,B,C,D):-hnf(A,E,C,F),evalResult_580_1(E,B,F,D).

:- block evalResult_580_1(?,?,-,?).
evalResult_580_1([],[],A,A).
evalResult_580_1([A|B],C,D,E):-hnf(B,F,D,G),'evalResult_580_1_._2'(F,A,C,G,E).

:- block 'evalResult_580_1_._2'(?,?,?,-,?).
'evalResult_580_1_._2'([],A,[A],B,B).
'evalResult_580_1_._2'([A|B],C,D,E,F):-hnf(apply(concatMap(solveAll2),[C,A|B]),D,E,F).

:- block prelude_lambda16_2017(?,?,?,-,?).
prelude_lambda16_2017(A,B,C,D,E):-hnf(B=:=tryone(A),C,D,E).

:- block prelude_lambda17_2018(?,?,?,?,-,?).
prelude_lambda17_2018(A,B,C,D,E,F):-makeShare(C,G),hnf(&(apply(A,G),apply(B,G)=:='True'),D,E,F).

:- block bestHelp_595(?,?,?,?,?,-,?).
bestHelp_595(A,B,C,D,E,F,G):-hnf(B,H,F,I),bestHelp_595_2(H,A,C,D,E,I,G).

:- block bestHelp_595_2(?,?,?,?,?,-,?).
bestHelp_595_2([],A,B,C,D,E,F):-hnf(B,G,E,H),'bestHelp_595_2_[]_2'(G,A,C,D,H,F).

:- block 'bestHelp_595_2_[]_2'(?,?,?,?,-,?).
'bestHelp_595_2_[]_2'([],A,B,C,D,E):-hnf(B,C,D,E).
'bestHelp_595_2_[]_2'([A|B],C,D,E,F,G):-makeShare(C,H),makeShare(D,I),evalY_596(H,try(constrain_599(H,A,I)),B,I,E,F,G).
bestHelp_595_2([A|B],C,D,E,F,G,H):-evalX_597(C,try(A),B,D,E,F,G,H).

:- block evalY_596(?,?,?,?,?,-,?).
evalY_596(A,B,C,D,E,F,G):-hnf(B,H,F,I),evalY_596_2(H,A,C,D,E,I,G).

:- block evalY_596_2(?,?,?,?,?,-,?).
evalY_596_2([],A,B,C,D,E,F):-bestHelp_595(A,[],B,C,D,E,F).
evalY_596_2([A|B],C,D,E,F,G,H):-hnf(B,I,G,J),'evalY_596_2_._2'(I,A,C,D,E,F,J,H).

:- block 'evalY_596_2_._2'(?,?,?,?,?,?,-,?).
'evalY_596_2_._2'([],A,B,C,D,E,F,G):-bestHelp_595(B,[],C,[A],E,F,G).
'evalY_596_2_._2'([A|B],C,D,E,F,G,H,I):-bestHelp_595(D,[C,A|B],E,F,G,H,I).

:- block evalX_597(?,?,?,?,?,?,-,?).
evalX_597(A,B,C,D,E,F,G,H):-hnf(B,I,G,J),evalX_597_2(I,A,C,D,E,F,J,H).

:- block evalX_597_2(?,?,?,?,?,?,-,?).
evalX_597_2([],A,B,C,D,E,F,G):-bestHelp_595(A,B,C,D,E,F,G).
evalX_597_2([A|B],C,D,E,F,G,H,I):-hnf(B,J,H,K),'evalX_597_2_._2'(J,A,C,D,E,F,G,K,I).

:- block 'evalX_597_2_._2'(?,?,?,?,?,?,?,-,?).
'evalX_597_2_._2'([],A,B,C,D,E,F,G,H):-bestHelp_595(B,[],++(C,D),[A],F,G,H).

:- block evalA_598(?,?,?,?,?,?,-,?).
evalA_598(A,B,C,D,E,F,G,H):-hnf(B,I,G,J),evalA_598_2(I,A,C,D,E,F,J,H).

:- block evalA_598_2(?,?,?,?,?,?,-,?).
evalA_598_2([A|B],C,D,E,F,G,H,I):-hnf(B,J,H,K),'evalA_598_2_._2'(J,A,C,D,E,F,G,K,I).

:- block 'evalA_598_2_._2'(?,?,?,?,?,?,?,-,?).
'evalA_598_2_._2'([A|B],C,D,E,F,G,H,I,J):-bestHelp_595(D,++([C,A|B],E),F,G,H,I,J).

:- block constrain_599(?,?,?,?,?,-,?).
constrain_599(A,B,C,D,E,F,G):-hnf(C,H,F,I),constrain_599_3(H,A,B,D,E,I,G).

:- block constrain_599_3(?,?,?,?,?,-,?).
constrain_599_3([],A,B,C,D,E,F):-hnf(apply(B,C),D,E,F).
constrain_599_3([A|B],C,D,E,F,G,H):-hnf(B,I,G,J),'constrain_599_3_._2'(I,A,C,D,E,F,J,H).

:- block 'constrain_599_3_._2'(?,?,?,?,?,?,-,?).
'constrain_599_3_._2'([],A,B,C,D,E,F,G):-hnf(apply(inject(C,prelude_lambda18_2019(A,B)),D),E,F,G).

:- block prelude_lambda18_2019(?,?,?,?,-,?).
prelude_lambda18_2019(A,B,C,D,E,F):-makeShare(G,H),hnf(&(apply(A,H),apply(apply(B,C),H)=:='True'),D,E,F).

:- block 'Flat.readFlatCurry'(?,?,?,-,?).
'Flat.readFlatCurry'(A,B,C,D,E):-hnf(apply('Flat.readFlatCurryWithParseOptions'(A,['\'-','\'q','\'u','\'i','\'e','\'t']),B),C,D,E).

:- block 'Flat.readFlatCurryWithParseOptions'(?,?,?,?,-,?).
'Flat.readFlatCurryWithParseOptions'(A,B,C,D,E,F):-makeShare(A,G),hnf(apply(>>=('Directory.doesFileExist'(++(G,['\'.','\'c','\'u','\'r','\'r','\'y'])),'Flat.lambdafun_2844'(B,G)),C),D,E,F).

:- block 'Flat.splitFlatModName'(?,?,-,?).
'Flat.splitFlatModName'(A,B,C,D):-makeShare(A,E),if_then_else('Char.isAlpha'(head(E)),'Flat.flat_lambda0_2846'(E,break('Flat.flat_lambda1_2847',E)),'(,)'(['\'p','\'r','\'e','\'l','\'u','\'d','\'e'],E),B,C,D).

:- block 'Flat.lambdafun_2843'(?,?,?,?,?,?,-,?).
'Flat.lambdafun_2843'(A,B,C,D,E,F,G,H):-makeShare(C,I),hnf(apply(if_then_else('||'(A,D),>>=('System.getEnviron'(['\'P','\'A','\'K','\'C','\'S','\'H','\'O','\'M','\'E']),'Flat.lambdafun_2845'(B,I)),done)>>'Flat.readFlatCurryFile'(++(I,['\'.','\'f','\'l','\'c'])),E),F,G,H).

:- block 'Flat.lambdafun_2845'(?,?,?,?,?,-,?).
'Flat.lambdafun_2845'(A,B,C,D,E,F,G):-hnf(apply('System.system'(++(C,++(['\'/','\'b','\'i','\'n','\'/','\'p','\'a','\'r','\'s','\'e','\'c','\'u','\'r','\'r','\'y','\' ','\'-','\'f','\'l','\'c','\' '],++(A,++(['\' '],B)))))>>done,D),E,F,G).

:- block 'Flat.lambdafun_2844'(?,?,?,?,?,-,?).
'Flat.lambdafun_2844'(A,B,C,D,E,F,G):-makeShare(B,H),hnf(apply(>>=('Directory.doesFileExist'(++(H,['\'.','\'l','\'c','\'u','\'r','\'r','\'y'])),'Flat.lambdafun_2843'(C,A,H)),D),E,F,G).

:- block 'Flat.flat_lambda0_2846'(?,?,?,-,?).
'Flat.flat_lambda0_2846'(A,B,C,D,E):-hnf(B,F,D,G),'Flat.flat_lambda0_2846_2'(F,A,C,G,E).

:- block 'Flat.flat_lambda0_2846_2'(?,?,?,-,?).
'Flat.flat_lambda0_2846_2'('(,)'(A,B),C,D,E,F):-makeShare(B,G),if_then_else(G==[],'(,)'(['\'p','\'r','\'e','\'l','\'u','\'d','\'e'],C),'(,)'(A,tail(G)),D,E,F).

:- block 'Flat.flat_lambda1_2847'(?,?,-,?).
'Flat.flat_lambda1_2847'(A,B,C,D):-hnf(A=='\'.',B,C,D).

:- block 'FlatTools.showFlatProg'(?,?,-,?).
'FlatTools.showFlatProg'(A,B,C,D):-hnf(A,E,C,F),'FlatTools.showFlatProg_1'(E,B,F,D).

:- block 'FlatTools.showFlatProg_1'(?,?,-,?).
'FlatTools.showFlatProg_1'('Flat.Prog'(A,B,C,D,E,F),G,H,I):-makeShare(B,J),makeShare(C,K),++(['\' ','\'(','\'P','\'r','\'o','\'g','\' '],++('FlatTools.flatShowString'(A),++(if_then_else(J==[],['\'\n','\' ','\' ','\'[','\']'],++(['\'\n','\' ','\' ','\'['],++('FlatTools.flatShowListElems'('FlatTools.flatShowString',J),['\']']))),++(if_then_else(K==[],['\'\n','\' ','\' ','\'[','\']'],++(['\'\n','\' ','\' ','\'['],++('FlatTools.flatShowListElems'('FlatTools.flatShowType',K),['\'\n','\' ','\']']))),++(['\'\n','\' ','\' ','\'['],++('FlatTools.flatShowListElems'('FlatTools.flatShowFunc',D),++(['\'\n','\' ','\' ','\']'],++(['\'\n','\' '],++('FlatTools.flatShowList'('FlatTools.flatShowOp',E),++(['\'\n','\' ','\' ','\'['],++('FlatTools.flatShowListElems'('FlatTools.flatShowTrans',F),['\'\n','\' ','\' ','\']','\'\n','\' ','\')','\'\n'])))))))))),G,H,I).

:- block 'FlatTools.flatShowFixity'(?,?,-,?).
'FlatTools.flatShowFixity'(A,B,C,D):-hnf(A,E,C,F),'FlatTools.flatShowFixity_1'(E,B,F,D).

:- block 'FlatTools.flatShowFixity_1'(?,?,-,?).
'FlatTools.flatShowFixity_1'('Flat.InfixOp',['\' ','\'I','\'n','\'f','\'i','\'x','\'O','\'p','\' '],A,A).
'FlatTools.flatShowFixity_1'('Flat.InfixlOp',['\' ','\'I','\'n','\'f','\'i','\'x','\'l','\'O','\'p','\' '],A,A).
'FlatTools.flatShowFixity_1'('Flat.InfixrOp',['\' ','\'I','\'n','\'f','\'i','\'x','\'r','\'O','\'p','\' '],A,A).

:- block 'FlatTools.flatShowOp'(?,?,-,?).
'FlatTools.flatShowOp'(A,B,C,D):-hnf(A,E,C,F),'FlatTools.flatShowOp_1'(E,B,F,D).

:- block 'FlatTools.flatShowOp_1'(?,?,-,?).
'FlatTools.flatShowOp_1'('Flat.Op'(A,B,C),D,E,F):- ++(['\'(','\'O','\'p','\' '],++('FlatTools.flatShowString'(A),++('FlatTools.flatShowFixity'(B),++(show(C),['\')']))),D,E,F).

:- block 'FlatTools.flatShowType'(?,?,-,?).
'FlatTools.flatShowType'(A,B,C,D):-hnf(A,E,C,F),'FlatTools.flatShowType_1'(E,B,F,D).

:- block 'FlatTools.flatShowType_1'(?,?,-,?).
'FlatTools.flatShowType_1'('Flat.Type'(A,B,C),D,E,F):- ++(['\'\n','\' ','\' ','\'(','\'T','\'y','\'p','\'e','\' '],++('FlatTools.flatShowString'(A),++('FlatTools.flatShowList'(show,B),++('FlatTools.flatShowList'('FlatTools.flatShowCons',C),['\')']))),D,E,F).

:- block 'FlatTools.flatShowCons'(?,?,-,?).
'FlatTools.flatShowCons'(A,B,C,D):-hnf(A,E,C,F),'FlatTools.flatShowCons_1'(E,B,F,D).

:- block 'FlatTools.flatShowCons_1'(?,?,-,?).
'FlatTools.flatShowCons_1'('Flat.Cons'(A,B,C),D,E,F):- ++(['\'(','\'C','\'o','\'n','\'s','\' '],++('FlatTools.flatShowString'(A),++(['\' '],++(show(B),++('FlatTools.flatShowList'('FlatTools.flatShowTypeExpr',C),['\')'])))),D,E,F).

:- block 'FlatTools.flatShowFunc'(?,?,-,?).
'FlatTools.flatShowFunc'(A,B,C,D):-hnf(A,E,C,F),'FlatTools.flatShowFunc_1'(E,B,F,D).

:- block 'FlatTools.flatShowFunc_1'(?,?,-,?).
'FlatTools.flatShowFunc_1'('Flat.Func'(A,B,C,D),E,F,G):- ++(['\'\n','\' ','\' ','\'(','\'F','\'u','\'n','\'c','\' '],++('FlatTools.flatShowString'(A),++(['\' '],++(show(B),++(['\' '],++('FlatTools.flatShowTypeExpr'(C),++('FlatTools.flatShowRule'(D),['\')'])))))),E,F,G).

:- block 'FlatTools.flatShowRule'(?,?,-,?).
'FlatTools.flatShowRule'(A,B,C,D):-hnf(A,E,C,F),'FlatTools.flatShowRule_1'(E,B,F,D).

:- block 'FlatTools.flatShowRule_1'(?,?,-,?).
'FlatTools.flatShowRule_1'('Flat.Rule'(A,B),C,D,E):- ++(['\' ','\'(','\'R','\'u','\'l','\'e','\' '],++('FlatTools.flatShowList'(show,A),++('FlatTools.flatShowExpr'(B),['\')'])),C,D,E).
'FlatTools.flatShowRule_1'('Flat.External'(A),B,C,D):- ++(['\' ','\'(','\'E','\'x','\'t','\'e','\'r','\'n','\'a','\'l','\' '],++('FlatTools.flatShowString'(A),['\')']),B,C,D).

:- block 'FlatTools.flatShowTypeExpr'(?,?,-,?).
'FlatTools.flatShowTypeExpr'(A,B,C,D):-hnf(A,E,C,F),'FlatTools.flatShowTypeExpr_1'(E,B,F,D).

:- block 'FlatTools.flatShowTypeExpr_1'(?,?,-,?).
'FlatTools.flatShowTypeExpr_1'('Flat.FuncType'(A,B),C,D,E):- ++(['\'(','\'F','\'u','\'n','\'c','\'T','\'y','\'p','\'e','\' '],++('FlatTools.flatShowTypeExpr'(A),++(['\' '],++('FlatTools.flatShowTypeExpr'(B),['\')']))),C,D,E).
'FlatTools.flatShowTypeExpr_1'('Flat.TCons'(A,B),C,D,E):- ++(['\'(','\'T','\'C','\'o','\'n','\'s','\' '],++('FlatTools.flatShowString'(A),++('FlatTools.flatShowList'('FlatTools.flatShowTypeExpr',B),['\')'])),C,D,E).
'FlatTools.flatShowTypeExpr_1'('Flat.TVar'(A),B,C,D):- ++(['\'(','\'T','\'V','\'a','\'r','\' '],++(show(A),['\')']),B,C,D).

:- block 'FlatTools.flatShowExpr'(?,?,-,?).
'FlatTools.flatShowExpr'(A,B,C,D):-hnf(A,E,C,F),'FlatTools.flatShowExpr_1'(E,B,F,D).

:- block 'FlatTools.flatShowExpr_1'(?,?,-,?).
'FlatTools.flatShowExpr_1'('Flat.Var'(A),B,C,D):- ++(['\'(','\'V','\'a','\'r','\' '],++(show(A),['\')']),B,C,D).
'FlatTools.flatShowExpr_1'('Flat.Lit'(A),B,C,D):- ++(['\'(','\'L','\'i','\'t','\' '],++('FlatTools.flatShowLit'(A),['\')']),B,C,D).
'FlatTools.flatShowExpr_1'('Flat.Comb'(A,B,C),D,E,F):- ++(['\'(','\'C','\'o','\'m','\'b','\' '],++(show(A),++(['\' '],++('FlatTools.flatShowString'(B),++('FlatTools.flatShowList'('FlatTools.flatShowExpr',C),['\')'])))),D,E,F).
'FlatTools.flatShowExpr_1'('Flat.Apply'(A,B),C,D,E):- ++(['\'(','\'A','\'p','\'p','\'l','\'y','\' '],++('FlatTools.flatShowExpr'(A),++(['\' '],++('FlatTools.flatShowExpr'(B),['\')']))),C,D,E).
'FlatTools.flatShowExpr_1'('Flat.Constr'(A,B),C,D,E):- ++(['\'(','\'C','\'o','\'n','\'s','\'t','\'r','\' '],++('FlatTools.flatShowList'(show,A),++('FlatTools.flatShowExpr'(B),['\')'])),C,D,E).
'FlatTools.flatShowExpr_1'('Flat.Or'(A,B),C,D,E):- ++(['\'(','\'O','\'r','\' '],++('FlatTools.flatShowExpr'(A),++(['\' '],++('FlatTools.flatShowExpr'(B),['\')']))),C,D,E).
'FlatTools.flatShowExpr_1'('Flat.Case'(A,B,C),D,E,F):-hnf(A,G,E,H),'FlatTools.flatShowExpr_1_Flat.Case_1'(G,B,C,D,H,F).

:- block 'FlatTools.flatShowExpr_1_Flat.Case_1'(?,?,?,?,-,?).
'FlatTools.flatShowExpr_1_Flat.Case_1'('Flat.Rigid',A,B,C,D,E):- ++(['\'(','\'C','\'a','\'s','\'e','\' ','\'R','\'i','\'g','\'i','\'d','\' '],++('FlatTools.flatShowExpr'(A),++('FlatTools.flatShowList'('FlatTools.flatShowBranch',B),['\')'])),C,D,E).
'FlatTools.flatShowExpr_1_Flat.Case_1'('Flat.Flex',A,B,C,D,E):- ++(['\'(','\'C','\'a','\'s','\'e','\' ','\'F','\'l','\'e','\'x','\' '],++('FlatTools.flatShowExpr'(A),++('FlatTools.flatShowList'('FlatTools.flatShowBranch',B),['\')'])),C,D,E).
'FlatTools.flatShowExpr_1'('Flat.GuardedExpr'(A,B,C),D,E,F):- ++(['\'(','\'G','\'u','\'a','\'r','\'d','\'e','\'d','\'E','\'x','\'p','\'r','\' '],++('FlatTools.flatShowList'(show,A),++('FlatTools.flatShowExpr'(B),++(['\' '],++('FlatTools.flatShowExpr'(C),['\')'])))),D,E,F).
'FlatTools.flatShowExpr_1'('Flat.Choice'(A),B,C,D):- ++(['\'(','\'C','\'h','\'o','\'i','\'c','\'e','\' '],++('FlatTools.flatShowExpr'(A),['\')']),B,C,D).

:- block 'FlatTools.flatShowLit'(?,?,-,?).
'FlatTools.flatShowLit'(A,B,C,D):-hnf(A,E,C,F),'FlatTools.flatShowLit_1'(E,B,F,D).

:- block 'FlatTools.flatShowLit_1'(?,?,-,?).
'FlatTools.flatShowLit_1'('Flat.Intc'(A),B,C,D):- ++(['\'(','\'I','\'n','\'t','\'c','\' '],++(show(A),['\')']),B,C,D).
'FlatTools.flatShowLit_1'('Flat.Floatc'(A),B,C,D):- ++(['\'(','\'F','\'l','\'o','\'a','\'t','\'c','\' '],++(show(A),['\')']),B,C,D).
'FlatTools.flatShowLit_1'('Flat.Charc'(A),B,C,D):-makeShare(A,E),if_then_else(&&(ord(E)>=32,ord(E)<127),++(['\'(','\'C','\'h','\'a','\'r','\'c','\' ','\'\''],++([E],['\'\'','\')'])),++(['\'(','\'C','\'h','\'a','\'r','\'c','\' ','\'(','\'c','\'h','\'r','\' '],++(show(ord(E)),['\')','\')'])),B,C,D).

:- block 'FlatTools.flatShowBranch'(?,?,-,?).
'FlatTools.flatShowBranch'(A,B,C,D):-hnf(A,E,C,F),'FlatTools.flatShowBranch_1'(E,B,F,D).

:- block 'FlatTools.flatShowBranch_1'(?,?,-,?).
'FlatTools.flatShowBranch_1'('Flat.Branch'(A,B),C,D,E):- ++(['\'(','\'B','\'r','\'a','\'n','\'c','\'h','\' '],++('FlatTools.flatShowPattern'(A),++('FlatTools.flatShowExpr'(B),['\')'])),C,D,E).

:- block 'FlatTools.flatShowPattern'(?,?,-,?).
'FlatTools.flatShowPattern'(A,B,C,D):-hnf(A,E,C,F),'FlatTools.flatShowPattern_1'(E,B,F,D).

:- block 'FlatTools.flatShowPattern_1'(?,?,-,?).
'FlatTools.flatShowPattern_1'('Flat.Pattern'(A,B),C,D,E):- ++(['\'(','\'P','\'a','\'t','\'t','\'e','\'r','\'n','\' '],++('FlatTools.flatShowString'(A),++('FlatTools.flatShowList'(show,B),['\')'])),C,D,E).
'FlatTools.flatShowPattern_1'('Flat.LPattern'(A),B,C,D):- ++(['\'(','\'L','\'P','\'a','\'t','\'t','\'e','\'r','\'n','\' '],++('FlatTools.flatShowLit'(A),['\')']),B,C,D).

:- block 'FlatTools.flatShowTrans'(?,?,-,?).
'FlatTools.flatShowTrans'(A,B,C,D):-hnf(A,E,C,F),'FlatTools.flatShowTrans_1'(E,B,F,D).

:- block 'FlatTools.flatShowTrans_1'(?,?,-,?).
'FlatTools.flatShowTrans_1'('Flat.Trans'(A,B),C,D,E):- ++(['\'\n','\' ','\' ','\'(','\'T','\'r','\'a','\'n','\'s','\' '],++('FlatTools.flatShowString'(A),++(['\' '],++('FlatTools.flatShowString'(B),['\')']))),C,D,E).

:- block 'FlatTools.flatShowList'(?,?,?,-,?).
'FlatTools.flatShowList'(A,B,C,D,E):- ++(['\' ','\'['],++('FlatTools.flatShowListElems'(A,B),['\']','\' ']),C,D,E).

:- block 'FlatTools.flatShowListElems'(?,?,?,-,?).
'FlatTools.flatShowListElems'(A,B,C,D,E):-concat('List.intersperse'(['\','],map(A,B)),C,D,E).

:- block 'FlatTools.flatShowString'(?,?,-,?).
'FlatTools.flatShowString'(A,B,C,D):- ++(['\'"'],++(A,['\'"']),B,C,D).

:- block 'FlatTools.showCurryType'(?,?,?,?,-,?).
'FlatTools.showCurryType'(A,B,C,D,E,F):-hnf(C,G,E,H),'FlatTools.showCurryType_3'(G,A,B,D,H,F).

:- block 'FlatTools.showCurryType_3'(?,?,?,?,-,?).
'FlatTools.showCurryType_3'('Flat.TVar'(A),B,C,[chr(97+A)],D,D).
'FlatTools.showCurryType_3'('Flat.FuncType'(A,B),C,D,E,F,G):-makeShare(D,H),makeShare(C,I),makeShare(A,J),++(if_then_else(H,['\'('],[]),++('FlatTools.showCurryType'(I,'FlatTools.isFuncType'(J),J),++(['\' ','\'-','\'>','\' '],++('FlatTools.showCurryType'(I,'False',B),if_then_else(H,['\')'],[])))),E,F,G).
'FlatTools.showCurryType_3'('Flat.TCons'(A,B),C,D,E,F,G):-makeShare(B,H),makeShare(C,I),makeShare(A,J),makeShare(D,K),if_then_else(H==[],apply(I,J),if_then_else(&&(J==['\'[','\']'],head(H)=='Flat.TCons'(['\'C','\'h','\'a','\'r'],[])),['\'S','\'t','\'r','\'i','\'n','\'g'],if_then_else(J==['\'[','\']'],++(['\'['],++('FlatTools.showCurryType'(I,'False',head(H)),['\']'])),if_then_else(take(2,J)==['\'(','\','],++(['\'('],++(concat('List.intersperse'(['\','],map('FlatTools.showCurryType'(I,'False'),H))),['\')'])),++(if_then_else(K,['\'('],[]),++(apply(I,J),++(['\' '],++(concat('List.intersperse'(['\' '],map('FlatTools.showCurryType'(I,'True'),H))),if_then_else(K,['\')'],[])))))))),E,F,G).

:- block 'FlatTools.isFuncType'(?,?,-,?).
'FlatTools.isFuncType'(A,B,C,D):-hnf(A,E,C,F),'FlatTools.isFuncType_1'(E,B,F,D).

:- block 'FlatTools.isFuncType_1'(?,?,-,?).
'FlatTools.isFuncType_1'('Flat.TVar'(A),'False',B,B).
'FlatTools.isFuncType_1'('Flat.FuncType'(A,B),'True',C,C).
'FlatTools.isFuncType_1'('Flat.TCons'(A,B),'False',C,C).

:- block 'FlatTools.showCurryExpr'(?,?,?,?,?,-,?).
'FlatTools.showCurryExpr'(A,B,C,D,E,F,G):-hnf(D,H,F,I),'FlatTools.showCurryExpr_4'(H,A,B,C,E,I,G).

:- block 'FlatTools.showCurryExpr_4'(?,?,?,?,?,-,?).
'FlatTools.showCurryExpr_4'('Flat.Var'(A),B,C,D,E,F,G):-'FlatTools.showCurryVar'(A,E,F,G).
'FlatTools.showCurryExpr_4'('Flat.Lit'(A),B,C,D,E,F,G):-'FlatTools.showCurryLit'(A,E,F,G).
'FlatTools.showCurryExpr_4'('Flat.Comb'(A,B,C),D,E,F,G,H,I):-hnf(C,J,H,K),'FlatTools.showCurryExpr_4_Flat.Comb_3'(J,A,B,D,E,F,G,K,I).

:- block 'FlatTools.showCurryExpr_4_Flat.Comb_3'(?,?,?,?,?,?,?,-,?).
'FlatTools.showCurryExpr_4_Flat.Comb_3'([],A,B,C,D,E,F,G,H):-hnf(apply(C,B),F,G,H).
'FlatTools.showCurryExpr_4_Flat.Comb_3'([A|B],C,D,E,F,G,H,I,J):-hnf(B,K,I,L),'FlatTools.showCurryExpr_4_Flat.Comb_3_._2'(K,A,C,D,E,F,G,H,L,J).

:- block 'FlatTools.showCurryExpr_4_Flat.Comb_3_._2'(?,?,?,?,?,?,?,?,-,?).
'FlatTools.showCurryExpr_4_Flat.Comb_3_._2'([],A,B,C,D,E,F,G,H,I):-makeShare(D,J),'FlatTools.maybeShowBrackets'(E,++(apply(J,C),++(['\' '],'FlatTools.showCurryExpr'(J,'True',F,A))),G,H,I).
'FlatTools.showCurryExpr_4_Flat.Comb_3_._2'([A|B],C,D,E,F,G,H,I,J,K):-hnf(B,L,J,M),'FlatTools.showCurryExpr_4_Flat.Comb_3_._2_._2'(L,A,C,D,E,F,G,H,I,M,K).

:- block 'FlatTools.showCurryExpr_4_Flat.Comb_3_._2_._2'(?,?,?,?,?,?,?,?,?,-,?).
'FlatTools.showCurryExpr_4_Flat.Comb_3_._2_._2'([],A,B,C,D,E,F,G,H,I,J):-makeShare(E,K),makeShare(D,L),makeShare(F,M),makeShare(G,N),makeShare(B,O),makeShare(A,P),makeShare(C,Q),if_then_else('Char.isAlpha'(head(apply(K,L))),'FlatTools.maybeShowBrackets'(M,++(apply(K,L),++(['\' '],'FlatTools.showCurryElems'('FlatTools.showCurryExpr'(K,'True',N),[O,P])))),if_then_else('FlatTools.isFiniteList'('Flat.Comb'(Q,L,[O,P])),++(['\'['],++(concat('List.intersperse'(['\','],'FlatTools.showCurryFiniteList'(K,N,'Flat.Comb'(Q,L,[O,P])))),['\']'])),if_then_else(L==['\'(','\',','\')'],++(['\'('],++('FlatTools.showCurryExpr'(K,'False',N,O),++(['\','],++('FlatTools.showCurryExpr'(K,'False',N,P),['\')'])))),'FlatTools.maybeShowBrackets'(M,++('FlatTools.showCurryExpr'(K,'True',N,O),++(['\' '],++(apply(K,L),++(['\' '],'FlatTools.showCurryExpr'(K,'True',N,P)))))))),H,I,J).
'FlatTools.showCurryExpr_4_Flat.Comb_3_._2_._2'([A|B],C,D,E,F,G,H,I,J,K,L):-makeShare(F,M),makeShare(B,N),makeShare(H,O),makeShare(I,P),makeShare(G,Q),makeShare(D,R),makeShare(C,S),makeShare(A,T),if_then_else(&&(M==['\'i','\'f','\'_','\'t','\'h','\'e','\'n','\'_','\'e','\'l','\'s','\'e'],N==[]),'FlatTools.maybeShowBrackets'(O,++(['\'\n'],++('FlatTools.sceBlanks'(P),++(['\' ','\'i','\'f','\' '],++('FlatTools.showCurryExpr'(Q,'False',P+2,R),++(['\'\n'],++('FlatTools.sceBlanks'(P),++(['\' ','\'t','\'h','\'e','\'n','\' '],++('FlatTools.showCurryExpr'(Q,'False',P+2,S),++(['\'\n'],++('FlatTools.sceBlanks'(P),++(['\' ','\'e','\'l','\'s','\'e','\' '],'FlatTools.showCurryExpr'(Q,'False',P+2,T))))))))))))),if_then_else(take(2,M)==['\'(','\','],++(['\'('],++(concat('List.intersperse'(['\','],map('FlatTools.showCurryExpr'(Q,'False',P),[R,S,T|N]))),['\')'])),'FlatTools.maybeShowBrackets'(O,++(apply(Q,M),++(['\' '],'FlatTools.showCurryElems'('FlatTools.showCurryExpr'(Q,'True',P),[R,S,T|N]))))),J,K,L).
'FlatTools.showCurryExpr_4'('Flat.Apply'(A,B),C,D,E,F,G,H):-makeShare(C,I),makeShare(E,J),'FlatTools.maybeShowBrackets'(D,++('FlatTools.showCurryExpr'(I,'True',J,A),++(['\' '],'FlatTools.showCurryExpr'(I,'True',J,B))),F,G,H).
'FlatTools.showCurryExpr_4'('Flat.Constr'(A,B),C,D,E,F,G,H):-hnf(A,I,G,J),'FlatTools.showCurryExpr_4_Flat.Constr_1'(I,B,C,D,E,F,J,H).

:- block 'FlatTools.showCurryExpr_4_Flat.Constr_1'(?,?,?,?,?,?,-,?).
'FlatTools.showCurryExpr_4_Flat.Constr_1'([],A,B,C,D,E,F,G):-'FlatTools.showCurryExpr'(B,C,D,A,E,F,G).
'FlatTools.showCurryExpr_4_Flat.Constr_1'([A|B],C,D,E,F,G,H,I):-'FlatTools.maybeShowBrackets'(E,++(['\'l','\'e','\'t','\' '],++(concat('List.intersperse'(['\','],map('FlatTools.showCurryVar',[A|B]))),++(['\' ','\'f','\'r','\'e','\'e','\' ','\'i','\'n','\' '],'FlatTools.showCurryExpr'(D,'False',F,C)))),G,H,I).
'FlatTools.showCurryExpr_4'('Flat.Or'(A,B),C,D,E,F,G,H):-makeShare(C,I),makeShare(E,J),'FlatTools.maybeShowBrackets'(D,++('FlatTools.showCurryExpr'(I,'True',J,A),++(['\' ','\'!','\' '],'FlatTools.showCurryExpr'(I,'True',J,B))),F,G,H).
'FlatTools.showCurryExpr_4'('Flat.Case'(A,B,C),D,E,F,G,H,I):-makeShare(D,J),makeShare(F,K),'FlatTools.maybeShowBrackets'(E,++(if_then_else(A=='Flat.Rigid',['\'c','\'a','\'s','\'e','\' '],['\'f','\'c','\'a','\'s','\'e','\' ']),++('FlatTools.showCurryExpr'(J,'True',K,B),++(['\' ','\'o','\'f','\'\n','\' '],++('FlatTools.showCurryElems'('FlatTools.showCurryCase'(J,K+2),C),'FlatTools.sceBlanks'(K))))),G,H,I).
'FlatTools.showCurryExpr_4'('Flat.GuardedExpr'(A,B,C),D,E,F,G,H,I):-hnf(A,J,H,K),'FlatTools.showCurryExpr_4_Flat.GuardedExpr_1'(J,B,C,D,E,F,G,K,I).

:- block 'FlatTools.showCurryExpr_4_Flat.GuardedExpr_1'(?,?,?,?,?,?,?,-,?).
'FlatTools.showCurryExpr_4_Flat.GuardedExpr_1'([],A,B,C,D,E,F,G,H):-makeShare(C,I),makeShare(E,J),'FlatTools.maybeShowBrackets'(D,++('FlatTools.showCurryExpr'(I,'False',J,A),++(['\' ','\'=','\'>','\' '],'FlatTools.showCurryExpr'(I,'False',J,B))),F,G,H).
'FlatTools.showCurryExpr_4_Flat.GuardedExpr_1'([A|B],C,D,E,F,G,H,I,J):-makeShare(E,K),makeShare(G,L),'FlatTools.maybeShowBrackets'(F,++('FlatTools.showCurryExpr'(K,'False',L,C),++(['\' ','\'=','\'>','\' '],++('FlatTools.showCurryExpr'(K,'False',L,D),++(['\' ','\' ','\'w','\'h','\'e','\'r','\'e','\' '],++(concat('List.intersperse'(['\','],map('FlatTools.showCurryVar',[A|B]))),['\' ','\'f','\'r','\'e','\'e']))))),H,I,J).
'FlatTools.showCurryExpr_4'('Flat.Choice'(A),B,C,D,E,F,G):-'FlatTools.maybeShowBrackets'(C,++(['\'C','\'h','\'o','\'i','\'c','\'e','\' '],'FlatTools.showCurryExpr'(B,'True',D,A)),E,F,G).

:- block 'FlatTools.showCurryVar'(?,?,-,?).
'FlatTools.showCurryVar'(A,B,C,D):- ++(['\'v'],show(A),B,C,D).

:- block 'FlatTools.showCurryLit'(?,?,-,?).
'FlatTools.showCurryLit'(A,B,C,D):-hnf(A,E,C,F),'FlatTools.showCurryLit_1'(E,B,F,D).

:- block 'FlatTools.showCurryLit_1'(?,?,-,?).
'FlatTools.showCurryLit_1'('Flat.Intc'(A),B,C,D):-hnf(show(A),B,C,D).
'FlatTools.showCurryLit_1'('Flat.Floatc'(A),B,C,D):-hnf(show(A),B,C,D).
'FlatTools.showCurryLit_1'('Flat.Charc'(A),B,C,D):- ++(['\'\''],++([A],['\'\'']),B,C,D).

:- block 'FlatTools.showCurryCase'(?,?,?,?,-,?).
'FlatTools.showCurryCase'(A,B,C,D,E,F):-hnf(C,G,E,H),'FlatTools.showCurryCase_3'(G,A,B,D,H,F).

:- block 'FlatTools.showCurryCase_3'(?,?,?,?,-,?).
'FlatTools.showCurryCase_3'('Flat.Branch'(A,B),C,D,E,F,G):-hnf(A,H,F,I),'FlatTools.showCurryCase_3_Flat.Branch_1'(H,B,C,D,E,I,G).

:- block 'FlatTools.showCurryCase_3_Flat.Branch_1'(?,?,?,?,?,-,?).
'FlatTools.showCurryCase_3_Flat.Branch_1'('Flat.Pattern'(A,B),C,D,E,F,G,H):-makeShare(E,I),makeShare(D,J),++('FlatTools.sceBlanks'(I),++('FlatTools.showPattern_3583'(apply(J,A),B),++(['\' ','\'-','\'>','\' '],++('FlatTools.showCurryExpr'(J,'False',I,C),['\'\n']))),F,G,H).
'FlatTools.showCurryCase_3_Flat.Branch_1'('Flat.LPattern'(A),B,C,D,E,F,G):-makeShare(D,H),++('FlatTools.sceBlanks'(H),++('FlatTools.showCurryLit'(A),++(['\' '],++(['\' ','\'-','\'>','\' '],++('FlatTools.showCurryExpr'(C,'False',H,B),['\'\n'])))),E,F,G).

:- block 'FlatTools.showCurryFiniteList'(?,?,?,?,-,?).
'FlatTools.showCurryFiniteList'(A,B,C,D,E,F):-hnf(C,G,E,H),'FlatTools.showCurryFiniteList_3'(G,A,B,D,H,F).

:- block 'FlatTools.showCurryFiniteList_3'(?,?,?,?,-,?).
'FlatTools.showCurryFiniteList_3'('Flat.Comb'(A,B,C),D,E,F,G,H):-hnf(B,I,G,J),'FlatTools.showCurryFiniteList_3_Flat.Comb_2'(I,A,C,D,E,F,J,H).

:- block 'FlatTools.showCurryFiniteList_3_Flat.Comb_2'(?,?,?,?,?,?,-,?).
'FlatTools.showCurryFiniteList_3_Flat.Comb_2'([A|B],C,D,E,F,G,H,I):-hnf(A,J,H,K),'FlatTools.showCurryFiniteList_3_Flat.Comb_2_._1'(J,B,C,D,E,F,G,K,I).

:- block 'FlatTools.showCurryFiniteList_3_Flat.Comb_2_._1'(?,?,?,?,?,?,?,-,?).
'FlatTools.showCurryFiniteList_3_Flat.Comb_2_._1'('\'[',A,B,C,D,E,F,G,H):-hnf(A,I,G,J),'FlatTools.showCurryFiniteList_3_Flat.Comb_2_._1_\'[_1'(I,B,C,D,E,F,J,H).

:- block 'FlatTools.showCurryFiniteList_3_Flat.Comb_2_._1_\'[_1'(?,?,?,?,?,?,-,?).
'FlatTools.showCurryFiniteList_3_Flat.Comb_2_._1_\'[_1'([A|B],C,D,E,F,G,H,I):-hnf(A,J,H,K),'FlatTools.showCurryFiniteList_3_Flat.Comb_2_._1_\'[_1_._1'(J,B,C,D,E,F,G,K,I).

:- block 'FlatTools.showCurryFiniteList_3_Flat.Comb_2_._1_\'[_1_._1'(?,?,?,?,?,?,?,-,?).
'FlatTools.showCurryFiniteList_3_Flat.Comb_2_._1_\'[_1_._1'('\']',A,B,C,D,E,F,G,H):-hnf(A,I,G,J),'FlatTools.showCurryFiniteList_3_Flat.Comb_2_._1_\'[_1_._1_\']_1'(I,B,C,D,E,F,J,H).

:- block 'FlatTools.showCurryFiniteList_3_Flat.Comb_2_._1_\'[_1_._1_\']_1'(?,?,?,?,?,?,-,?).
'FlatTools.showCurryFiniteList_3_Flat.Comb_2_._1_\'[_1_._1_\']_1'([],A,B,C,D,E,F,G):-hnf(B,H,F,I),'FlatTools.showCurryFiniteList_3_Flat.Comb_2_._1_\'[_1_._1_\']_1_[]_2'(H,A,C,D,E,I,G).

:- block 'FlatTools.showCurryFiniteList_3_Flat.Comb_2_._1_\'[_1_._1_\']_1_[]_2'(?,?,?,?,?,-,?).
'FlatTools.showCurryFiniteList_3_Flat.Comb_2_._1_\'[_1_._1_\']_1_[]_2'([],A,B,C,[],D,D).
'FlatTools.showCurryFiniteList_3_Flat.Comb_2_._1'('\':',A,B,C,D,E,F,G,H):-hnf(A,I,G,J),'FlatTools.showCurryFiniteList_3_Flat.Comb_2_._1_\':_1'(I,B,C,D,E,F,J,H).

:- block 'FlatTools.showCurryFiniteList_3_Flat.Comb_2_._1_\':_1'(?,?,?,?,?,?,-,?).
'FlatTools.showCurryFiniteList_3_Flat.Comb_2_._1_\':_1'([],A,B,C,D,E,F,G):-hnf(B,H,F,I),'FlatTools.showCurryFiniteList_3_Flat.Comb_2_._1_\':_1_[]_2'(H,A,C,D,E,I,G).

:- block 'FlatTools.showCurryFiniteList_3_Flat.Comb_2_._1_\':_1_[]_2'(?,?,?,?,?,-,?).
'FlatTools.showCurryFiniteList_3_Flat.Comb_2_._1_\':_1_[]_2'([A|B],C,D,E,F,G,H):-hnf(B,I,G,J),'FlatTools.showCurryFiniteList_3_Flat.Comb_2_._1_\':_1_[]_2_._2'(I,A,C,D,E,F,J,H).

:- block 'FlatTools.showCurryFiniteList_3_Flat.Comb_2_._1_\':_1_[]_2_._2'(?,?,?,?,?,?,-,?).
'FlatTools.showCurryFiniteList_3_Flat.Comb_2_._1_\':_1_[]_2_._2'([A|B],C,D,E,F,G,H,I):-hnf(B,J,H,K),'FlatTools.showCurryFiniteList_3_Flat.Comb_2_._1_\':_1_[]_2_._2_._2'(J,A,C,D,E,F,G,K,I).

:- block 'FlatTools.showCurryFiniteList_3_Flat.Comb_2_._1_\':_1_[]_2_._2_._2'(?,?,?,?,?,?,?,-,?).
'FlatTools.showCurryFiniteList_3_Flat.Comb_2_._1_\':_1_[]_2_._2_._2'([],A,B,C,D,E,['FlatTools.showCurryExpr'(F,'False',G,B)|'FlatTools.showCurryFiniteList'(F,G,A)],H,H):-makeShare(D,F),makeShare(E,G).

:- block 'FlatTools.showCurryElems'(?,?,?,-,?).
'FlatTools.showCurryElems'(A,B,C,D,E):-concat('List.intersperse'(['\' '],map(A,B)),C,D,E).

:- block 'FlatTools.maybeShowBrackets'(?,?,?,-,?).
'FlatTools.maybeShowBrackets'(A,B,C,D,E):-makeShare(A,F),++(if_then_else(F,['\'('],[]),++(B,if_then_else(F,['\')'],[])),C,D,E).

:- block 'FlatTools.sceBlanks'(?,?,-,?).
'FlatTools.sceBlanks'(A,B,C,D):-take(A,repeat('\' '),B,C,D).

:- block 'FlatTools.isFiniteList'(?,?,-,?).
'FlatTools.isFiniteList'(A,B,C,D):-hnf(A,E,C,F),'FlatTools.isFiniteList_1'(E,B,F,D).

:- block 'FlatTools.isFiniteList_1'(?,?,-,?).
'FlatTools.isFiniteList_1'('Flat.Var'(A),'False',B,B).
'FlatTools.isFiniteList_1'('Flat.Lit'(A),'False',B,B).
'FlatTools.isFiniteList_1'('Flat.Comb'(A,B,C),D,E,F):-makeShare(B,G),makeShare(C,H),if_then_else(&&(G==['\'[','\']'],H==[]),'True',if_then_else(&&(G==['\':'],length(H)==2),'FlatTools.isFiniteList'('!!'(H,1)),'False'),D,E,F).
'FlatTools.isFiniteList_1'('Flat.Apply'(A,B),'False',C,C).
'FlatTools.isFiniteList_1'('Flat.Constr'(A,B),'False',C,C).
'FlatTools.isFiniteList_1'('Flat.Or'(A,B),'False',C,C).
'FlatTools.isFiniteList_1'('Flat.Case'(A,B,C),'False',D,D).
'FlatTools.isFiniteList_1'('Flat.Choice'(A),'False',B,B).
'FlatTools.isFiniteList_1'('Flat.GuardedExpr'(A,B,C),'False',D,D).

:- block 'FlatTools.writeFLC'(?,?,?,?,-,?).
'FlatTools.writeFLC'(A,B,C,D,E,F):-hnf(apply(writeFile(A,'FlatTools.showFlcProg'(B)),C),D,E,F).

:- block 'FlatTools.showFlcProg'(?,?,-,?).
'FlatTools.showFlcProg'(A,B,C,D):-hnf(A,E,C,F),'FlatTools.showFlcProg_1'(E,B,F,D).

:- block 'FlatTools.showFlcProg_1'(?,?,-,?).
'FlatTools.showFlcProg_1'('Flat.Prog'(A,B,C,D,E,F),G,H,I):-makeShare(C,J),++(['\'\'','\'P','\'r','\'o','\'g','\'\'','\'('],++('FlatTools.flcShowString'(A),++(['\',','\'\n','\' ','\'['],++('FlatTools.flcShowListElems'('FlatTools.flcShowString',B),++(['\']','\',','\'\n'],++(if_then_else(J==[],['\' ','\'[','\']','\',','\'\n','\' '],++(['\' ','\'['],++('FlatTools.flcShowListElems'('FlatTools.flcShowType',J),['\'\n','\' ','\']','\',','\'\n']))),++(['\' ','\'['],++('FlatTools.flcShowListElems'('FlatTools.flcShowFunc',D),++(['\'\n','\' ','\']','\',','\'\n','\' '],++('FlatTools.flcShowList'('FlatTools.flcShowOp',E),++(['\',','\'\n','\' ','\'['],++('FlatTools.flcShowListElems'('FlatTools.flcShowTrans',F),['\'\n','\' ','\']','\')','\'.','\'\n']))))))))))),G,H,I).

:- block 'FlatTools.flcShowOp'(?,?,-,?).
'FlatTools.flcShowOp'(A,B,C,D):-hnf(A,E,C,F),'FlatTools.flcShowOp_1'(E,B,F,D).

:- block 'FlatTools.flcShowOp_1'(?,?,-,?).
'FlatTools.flcShowOp_1'('Flat.Op'(A,B,C),D,E,F):- ++(['\'\'','\'O','\'p','\'\'','\'('],++('FlatTools.flcShowString'(A),++(['\',','\'\''],++('FlatTools.flcShowFixity'(B),++(['\'\'','\','],++(show(C),['\')']))))),D,E,F).

:- block 'FlatTools.flcShowFixity'(?,?,-,?).
'FlatTools.flcShowFixity'(A,B,C,D):-hnf(A,E,C,F),'FlatTools.flcShowFixity_1'(E,B,F,D).

:- block 'FlatTools.flcShowFixity_1'(?,?,-,?).
'FlatTools.flcShowFixity_1'('Flat.InfixOp',['\'I','\'n','\'f','\'i','\'x','\'O','\'p'],A,A).
'FlatTools.flcShowFixity_1'('Flat.InfixlOp',['\'I','\'n','\'f','\'i','\'x','\'l','\'O','\'p'],A,A).
'FlatTools.flcShowFixity_1'('Flat.InfixrOp',['\'I','\'n','\'f','\'i','\'x','\'r','\'O','\'p'],A,A).

:- block 'FlatTools.flcShowType'(?,?,-,?).
'FlatTools.flcShowType'(A,B,C,D):-hnf(A,E,C,F),'FlatTools.flcShowType_1'(E,B,F,D).

:- block 'FlatTools.flcShowType_1'(?,?,-,?).
'FlatTools.flcShowType_1'('Flat.Type'(A,B,C),D,E,F):- ++(['\'\n','\' ','\' ','\'\'','\'T','\'y','\'p','\'e','\'\'','\'('],++('FlatTools.flcShowString'(A),++(['\','],++('FlatTools.flcShowList'(show,B),++(['\','],++('FlatTools.flcShowList'('FlatTools.flcShowCons',C),['\')']))))),D,E,F).

:- block 'FlatTools.flcShowCons'(?,?,-,?).
'FlatTools.flcShowCons'(A,B,C,D):-hnf(A,E,C,F),'FlatTools.flcShowCons_1'(E,B,F,D).

:- block 'FlatTools.flcShowCons_1'(?,?,-,?).
'FlatTools.flcShowCons_1'('Flat.Cons'(A,B,C),D,E,F):- ++(['\'\'','\'C','\'o','\'n','\'s','\'\'','\'('],++('FlatTools.flcShowString'(A),++(['\','],++(show(B),++(['\','],++('FlatTools.flcShowList'('FlatTools.flcShowTypeExpr',C),['\')']))))),D,E,F).

:- block 'FlatTools.flcShowFunc'(?,?,-,?).
'FlatTools.flcShowFunc'(A,B,C,D):-hnf(A,E,C,F),'FlatTools.flcShowFunc_1'(E,B,F,D).

:- block 'FlatTools.flcShowFunc_1'(?,?,-,?).
'FlatTools.flcShowFunc_1'('Flat.Func'(A,B,C,D),E,F,G):- ++(['\'\n','\' ','\' ','\'\'','\'F','\'u','\'n','\'c','\'\'','\'('],++('FlatTools.flcShowString'(A),++(['\','],++(show(B),++(['\',','\'\n','\' ','\' ','\' ','\' '],++('FlatTools.flcShowTypeExpr'(C),++(['\',','\'\n','\' ','\' ','\' ','\' '],++('FlatTools.flcShowRule'(D),['\')']))))))),E,F,G).

:- block 'FlatTools.flcShowRule'(?,?,-,?).
'FlatTools.flcShowRule'(A,B,C,D):-hnf(A,E,C,F),'FlatTools.flcShowRule_1'(E,B,F,D).

:- block 'FlatTools.flcShowRule_1'(?,?,-,?).
'FlatTools.flcShowRule_1'('Flat.Rule'(A,B),C,D,E):- ++(['\'\'','\'R','\'u','\'l','\'e','\'\'','\'('],++('FlatTools.flcShowList'(show,A),++(['\','],++('FlatTools.flcShowExpr'(B),['\')']))),C,D,E).
'FlatTools.flcShowRule_1'('Flat.External'(A),B,C,D):- ++(['\'\'','\'E','\'x','\'t','\'e','\'r','\'n','\'a','\'l','\'\'','\'('],++('FlatTools.flcShowString'(A),['\')']),B,C,D).

:- block 'FlatTools.flcShowTypeExpr'(?,?,-,?).
'FlatTools.flcShowTypeExpr'(A,B,C,D):-hnf(A,E,C,F),'FlatTools.flcShowTypeExpr_1'(E,B,F,D).

:- block 'FlatTools.flcShowTypeExpr_1'(?,?,-,?).
'FlatTools.flcShowTypeExpr_1'('Flat.FuncType'(A,B),C,D,E):- ++(['\'\'','\'F','\'u','\'n','\'c','\'T','\'y','\'p','\'e','\'\'','\'('],++('FlatTools.flcShowTypeExpr'(A),++(['\','],++('FlatTools.flcShowTypeExpr'(B),['\')']))),C,D,E).
'FlatTools.flcShowTypeExpr_1'('Flat.TCons'(A,B),C,D,E):- ++(['\'\'','\'T','\'C','\'o','\'n','\'s','\'\'','\'('],++('FlatTools.flcShowString'(A),++(['\','],++('FlatTools.flcShowList'('FlatTools.flcShowTypeExpr',B),['\')']))),C,D,E).
'FlatTools.flcShowTypeExpr_1'('Flat.TVar'(A),B,C,D):- ++(['\'\'','\'T','\'V','\'a','\'r','\'\'','\'('],++(show(A),['\')']),B,C,D).

:- block 'FlatTools.flcShowCombType'(?,?,-,?).
'FlatTools.flcShowCombType'(A,B,C,D):-hnf(A,E,C,F),'FlatTools.flcShowCombType_1'(E,B,F,D).

:- block 'FlatTools.flcShowCombType_1'(?,?,-,?).
'FlatTools.flcShowCombType_1'('Flat.FuncCall',['\'F','\'u','\'n','\'c','\'C','\'a','\'l','\'l'],A,A).
'FlatTools.flcShowCombType_1'('Flat.ConsCall',['\'C','\'o','\'n','\'s','\'C','\'a','\'l','\'l'],A,A).
'FlatTools.flcShowCombType_1'('Flat.PartCall',['\'P','\'a','\'r','\'t','\'C','\'a','\'l','\'l'],A,A).

:- block 'FlatTools.flcShowExpr'(?,?,-,?).
'FlatTools.flcShowExpr'(A,B,C,D):-hnf(A,E,C,F),'FlatTools.flcShowExpr_1'(E,B,F,D).

:- block 'FlatTools.flcShowExpr_1'(?,?,-,?).
'FlatTools.flcShowExpr_1'('Flat.Var'(A),B,C,D):- ++(['\'\'','\'V','\'a','\'r','\'\'','\'('],++(show(A),['\')']),B,C,D).
'FlatTools.flcShowExpr_1'('Flat.Lit'(A),B,C,D):- ++(['\'\'','\'L','\'i','\'t','\'\'','\'('],++('FlatTools.flcShowLit'(A),['\')']),B,C,D).
'FlatTools.flcShowExpr_1'('Flat.Comb'(A,B,C),D,E,F):- ++(['\'\'','\'C','\'o','\'m','\'b','\'\'','\'(','\'\''],++('FlatTools.flcShowCombType'(A),++(['\'\'','\','],++('FlatTools.flcShowString'(B),++(['\','],++('FlatTools.flcShowList'('FlatTools.flcShowExpr',C),['\')']))))),D,E,F).
'FlatTools.flcShowExpr_1'('Flat.Apply'(A,B),C,D,E):- ++(['\'\'','\'A','\'p','\'p','\'l','\'y','\'\'','\'('],++('FlatTools.flcShowExpr'(A),++(['\','],++('FlatTools.flcShowExpr'(B),['\')']))),C,D,E).
'FlatTools.flcShowExpr_1'('Flat.Constr'(A,B),C,D,E):- ++(['\'\'','\'C','\'o','\'n','\'s','\'t','\'r','\'\'','\'('],++('FlatTools.flcShowList'(show,A),++(['\','],++('FlatTools.flcShowExpr'(B),['\')']))),C,D,E).
'FlatTools.flcShowExpr_1'('Flat.Or'(A,B),C,D,E):- ++(['\'\'','\'O','\'r','\'\'','\'('],++('FlatTools.flcShowExpr'(A),++(['\','],++('FlatTools.flcShowExpr'(B),['\')']))),C,D,E).
'FlatTools.flcShowExpr_1'('Flat.Case'(A,B,C),D,E,F):-hnf(A,G,E,H),'FlatTools.flcShowExpr_1_Flat.Case_1'(G,B,C,D,H,F).

:- block 'FlatTools.flcShowExpr_1_Flat.Case_1'(?,?,?,?,-,?).
'FlatTools.flcShowExpr_1_Flat.Case_1'('Flat.Rigid',A,B,C,D,E):- ++(['\'\'','\'C','\'a','\'s','\'e','\'\'','\'(','\'\'','\'R','\'i','\'g','\'i','\'d','\'\'','\','],++('FlatTools.flcShowExpr'(A),++(['\','],++('FlatTools.flcShowList'('FlatTools.flcShowBranch',B),['\')']))),C,D,E).
'FlatTools.flcShowExpr_1_Flat.Case_1'('Flat.Flex',A,B,C,D,E):- ++(['\'\'','\'C','\'a','\'s','\'e','\'\'','\'(','\'\'','\'F','\'l','\'e','\'x','\'\'','\','],++('FlatTools.flcShowExpr'(A),++(['\','],++('FlatTools.flcShowList'('FlatTools.flcShowBranch',B),['\')']))),C,D,E).
'FlatTools.flcShowExpr_1'('Flat.GuardedExpr'(A,B,C),D,E,F):- ++(['\'\'','\'G','\'u','\'a','\'r','\'d','\'e','\'d','\'E','\'x','\'p','\'r','\'\'','\'('],++('FlatTools.flcShowList'(show,A),++(['\','],++('FlatTools.flcShowExpr'(B),++(['\','],++('FlatTools.flcShowExpr'(C),['\')']))))),D,E,F).
'FlatTools.flcShowExpr_1'('Flat.Choice'(A),B,C,D):- ++(['\'\'','\'C','\'h','\'o','\'i','\'c','\'e','\'\'','\'('],++('FlatTools.flcShowExpr'(A),['\')']),B,C,D).

:- block 'FlatTools.flcShowLit'(?,?,-,?).
'FlatTools.flcShowLit'(A,B,C,D):-hnf(A,E,C,F),'FlatTools.flcShowLit_1'(E,B,F,D).

:- block 'FlatTools.flcShowLit_1'(?,?,-,?).
'FlatTools.flcShowLit_1'('Flat.Intc'(A),B,C,D):- ++(['\'\'','\'I','\'n','\'t','\'c','\'\'','\'('],++(show(A),['\')']),B,C,D).
'FlatTools.flcShowLit_1'('Flat.Floatc'(A),B,C,D):- ++(['\'\'','\'F','\'l','\'o','\'a','\'t','\'c','\'\'','\'('],++(show(A),['\')']),B,C,D).
'FlatTools.flcShowLit_1'('Flat.Charc'(A),B,C,D):- ++(['\'\'','\'C','\'h','\'a','\'r','\'c','\'\'','\'('],++(show(ord(A)),['\')']),B,C,D).

:- block 'FlatTools.flcShowBranch'(?,?,-,?).
'FlatTools.flcShowBranch'(A,B,C,D):-hnf(A,E,C,F),'FlatTools.flcShowBranch_1'(E,B,F,D).

:- block 'FlatTools.flcShowBranch_1'(?,?,-,?).
'FlatTools.flcShowBranch_1'('Flat.Branch'(A,B),C,D,E):-hnf(A,F,D,G),'FlatTools.flcShowBranch_1_Flat.Branch_1'(F,B,C,G,E).

:- block 'FlatTools.flcShowBranch_1_Flat.Branch_1'(?,?,?,-,?).
'FlatTools.flcShowBranch_1_Flat.Branch_1'('Flat.Pattern'(A,B),C,D,E,F):- ++(['\'\'','\'B','\'r','\'a','\'n','\'c','\'h','\'\'','\'(','\'\'','\'P','\'a','\'t','\'t','\'e','\'r','\'n','\'\'','\'('],++('FlatTools.flcShowString'(A),++(['\','],++('FlatTools.flcShowList'(show,B),++(['\')','\','],++('FlatTools.flcShowExpr'(C),['\')']))))),D,E,F).
'FlatTools.flcShowBranch_1_Flat.Branch_1'('Flat.LPattern'(A),B,C,D,E):- ++(['\'\'','\'B','\'r','\'a','\'n','\'c','\'h','\'\'','\'(','\'\'','\'L','\'P','\'a','\'t','\'t','\'e','\'r','\'n','\'\'','\'('],++('FlatTools.flcShowLit'(A),++(['\')','\','],++('FlatTools.flcShowExpr'(B),['\')']))),C,D,E).

:- block 'FlatTools.flcShowTrans'(?,?,-,?).
'FlatTools.flcShowTrans'(A,B,C,D):-hnf(A,E,C,F),'FlatTools.flcShowTrans_1'(E,B,F,D).

:- block 'FlatTools.flcShowTrans_1'(?,?,-,?).
'FlatTools.flcShowTrans_1'('Flat.Trans'(A,B),C,D,E):- ++(['\'\n','\' ','\' ','\'\'','\'T','\'r','\'a','\'n','\'s','\'\'','\'('],++('FlatTools.flcShowString'(A),++(['\','],++('FlatTools.flcShowString'(B),['\')']))),C,D,E).

:- block 'FlatTools.flcShowList'(?,?,?,-,?).
'FlatTools.flcShowList'(A,B,C,D,E):- ++(['\'['],++('FlatTools.flcShowListElems'(A,B),['\']']),C,D,E).

:- block 'FlatTools.flcShowListElems'(?,?,?,-,?).
'FlatTools.flcShowListElems'(A,B,C,D,E):-hnf(B,F,D,G),'FlatTools.flcShowListElems_2'(F,A,C,G,E).

:- block 'FlatTools.flcShowListElems_2'(?,?,?,-,?).
'FlatTools.flcShowListElems_2'([],A,[],B,B).
'FlatTools.flcShowListElems_2'([A|B],C,D,E,F):-hnf(B,G,E,H),'FlatTools.flcShowListElems_2_._2'(G,A,C,D,H,F).

:- block 'FlatTools.flcShowListElems_2_._2'(?,?,?,?,-,?).
'FlatTools.flcShowListElems_2_._2'([],A,B,C,D,E):-hnf(apply(B,A),C,D,E).
'FlatTools.flcShowListElems_2_._2'([A|B],C,D,E,F,G):-makeShare(D,H),++(apply(H,C),++(['\','],'FlatTools.flcShowListElems'(H,[A|B])),E,F,G).

:- block 'FlatTools.flcShowString'(?,?,-,?).
'FlatTools.flcShowString'(A,B,C,D):-'FlatTools.flcShowList'('prelude..'(show,ord),A,B,C,D).

:- block 'FlatTools.ppshow'(?,?,?,-,?).
'FlatTools.ppshow'(A,B,C,D,E):-hnf(apply(>>=('Flat.readFlatCurry'(A),'prelude..'(putStrLn,'FlatTools.showFlatProg')),B),C,D,E).

:- block 'FlatTools.pptest'(?,?,?,-,?).
'FlatTools.pptest'(A,B,C,D,E):-hnf(apply(>>=('Flat.readFlatCurry'(A),'FlatTools.lambdafun_6063'),B),C,D,E).

:- block 'FlatTools.flcshow'(?,?,?,-,?).
'FlatTools.flcshow'(A,B,C,D,E):-hnf(apply(>>=('Flat.readFlatCurry'(A),'prelude..'(putStrLn,'FlatTools.showFlcProg')),B),C,D,E).

:- block 'FlatTools.flctest'(?,?,?,-,?).
'FlatTools.flctest'(A,B,C,D,E):-hnf(apply(>>=('Flat.readFlatCurry'(A),'FlatTools.lambdafun_6064'),B),C,D,E).

:- block 'FlatTools.showPattern_3583'(?,?,?,-,?).
'FlatTools.showPattern_3583'(A,B,C,D,E):-hnf(B,F,D,G),'FlatTools.showPattern_3583_2'(F,A,C,G,E).

:- block 'FlatTools.showPattern_3583_2'(?,?,?,-,?).
'FlatTools.showPattern_3583_2'([],A,B,C,D):-hnf(A,B,C,D).
'FlatTools.showPattern_3583_2'([A|B],C,D,E,F):-hnf(B,G,E,H),'FlatTools.showPattern_3583_2_._2'(G,A,C,D,H,F).

:- block 'FlatTools.showPattern_3583_2_._2'(?,?,?,?,-,?).
'FlatTools.showPattern_3583_2_._2'([],A,B,C,D,E):- ++(B,++(['\' '],'FlatTools.showCurryVar'(A)),C,D,E).
'FlatTools.showPattern_3583_2_._2'([A|B],C,D,E,F,G):-hnf(B,H,F,I),'FlatTools.showPattern_3583_2_._2_._2'(H,A,C,D,E,I,G).

:- block 'FlatTools.showPattern_3583_2_._2_._2'(?,?,?,?,?,-,?).
'FlatTools.showPattern_3583_2_._2_._2'([],A,B,C,D,E,F):-makeShare(C,G),makeShare(B,H),makeShare(A,I),if_then_else('Char.isAlpha'(head(G)),++(G,++(['\' '],++('FlatTools.showCurryVar'(H),++(['\' '],'FlatTools.showCurryVar'(I))))),if_then_else(G==['\'(','\',','\')'],++(['\'('],++('FlatTools.showCurryVar'(H),++(['\','],++('FlatTools.showCurryVar'(I),['\')'])))),++('FlatTools.showCurryVar'(H),++(['\' '],++(G,++(['\' '],'FlatTools.showCurryVar'(I)))))),D,E,F).
'FlatTools.showPattern_3583_2_._2_._2'([A|B],C,D,E,F,G,H):-makeShare(E,I),makeShare(D,J),makeShare(C,K),makeShare(A,L),makeShare(B,M),if_then_else(take(2,I)==['\'(','\','],++(['\'('],++(concat('List.intersperse'(['\','],map('FlatTools.showCurryVar',[J,K,L|M]))),['\')'])),++(I,++(['\' '],'FlatTools.showCurryElems'('FlatTools.showCurryVar',[J,K,L|M]))),F,G,H).

:- block 'FlatTools.lambdafun_6063'(?,?,?,-,?).
'FlatTools.lambdafun_6063'(A,B,C,D,E):-hnf(apply(writeFile(['\'t','\'m','\'p','\'.','\'c','\'u','\'r','\'r','\'y'],++(['\'-','\'-','\'i','\'m','\'p','\'o','\'r','\'t','\' ','\'F','\'l','\'a','\'t','\'\n','\'m','\'a','\'i','\'n','\' ','\'=','\'\n'],'FlatTools.showFlatProg'(A))),B),C,D,E).

:- block 'FlatTools.lambdafun_6064'(?,?,?,-,?).
'FlatTools.lambdafun_6064'(A,B,C,D,E):-hnf(apply('FlatTools.writeFLC'(['\'t','\'m','\'p','\'.','\'f','\'l','\'c'],A),B),C,D,E).

:- block 'SetRBT2.emptySetRBT'(?,?,-,?).
'SetRBT2.emptySetRBT'(A,'SetRBT2.SetRBT'(A,'SetRBT2.RBSEmpty'),B,B).

:- block 'SetRBT2.elemRBT'(?,?,?,-,?).
'SetRBT2.elemRBT'(A,B,C,D,E):-hnf(B,F,D,G),'SetRBT2.elemRBT_2'(F,A,C,G,E).

:- block 'SetRBT2.elemRBT_2'(?,?,?,-,?).
'SetRBT2.elemRBT_2'('SetRBT2.SetRBT'(A,B),C,D,E,F):-'SetRBT2.elemRBTree'(A,C,B,D,E,F).

:- block 'SetRBT2.elemRBTree'(?,?,?,?,-,?).
'SetRBT2.elemRBTree'(A,B,C,D,E,F):-hnf(C,G,E,H),'SetRBT2.elemRBTree_3'(G,A,B,D,H,F).

:- block 'SetRBT2.elemRBTree_3'(?,?,?,?,-,?).
'SetRBT2.elemRBTree_3'('SetRBT2.RBSEmpty',A,B,'False',C,C).
'SetRBT2.elemRBTree_3'('SetRBT2.RBS'(A,B,C,D),E,F,G,H,I):-makeShare(B,J),makeShare(F,K),makeShare(E,L),if_then_else(J==K,'True',if_then_else(apply(apply(L,K),J),'SetRBT2.elemRBTree'(L,K,C),'SetRBT2.elemRBTree'(L,K,D)),G,H,I).

:- block 'SetRBT2.insertRBT'(?,?,?,-,?).
'SetRBT2.insertRBT'(A,B,C,D,E):-hnf(B,F,D,G),'SetRBT2.insertRBT_2'(F,A,C,G,E).

:- block 'SetRBT2.insertRBT_2'(?,?,?,-,?).
'SetRBT2.insertRBT_2'('SetRBT2.SetRBT'(A,B),C,'SetRBT2.SetRBT'(D,'SetRBT2.insertRBTree'(D,C,B)),E,E):-makeShare(A,D).

:- block 'SetRBT2.insertRBTree'(?,?,?,?,-,?).
'SetRBT2.insertRBTree'(A,B,C,D,E,F):-'SetRBT2.setRBT2_lambda0_7386'('SetRBT2.ins_6383'(B,A,C),D,E,F).

:- block 'SetRBT2.insertMultiRBT'(?,?,?,-,?).
'SetRBT2.insertMultiRBT'(A,B,C,D,E):-hnf(B,F,D,G),'SetRBT2.insertMultiRBT_2'(F,A,C,G,E).

:- block 'SetRBT2.insertMultiRBT_2'(?,?,?,-,?).
'SetRBT2.insertMultiRBT_2'('SetRBT2.SetRBT'(A,B),C,'SetRBT2.SetRBT'(D,'SetRBT2.insertMultiRBTree'(D,C,B)),E,E):-makeShare(A,D).

:- block 'SetRBT2.insertMultiRBTree'(?,?,?,?,-,?).
'SetRBT2.insertMultiRBTree'(A,B,C,D,E,F):-'SetRBT2.setRBT2_lambda1_7387'('SetRBT2.ins_6398'(B,A,C),D,E,F).

:- block 'SetRBT2.setRBT2list'(?,?,-,?).
'SetRBT2.setRBT2list'(A,B,C,D):-hnf(A,E,C,F),'SetRBT2.setRBT2list_1'(E,B,F,D).

:- block 'SetRBT2.setRBT2list_1'(?,?,-,?).
'SetRBT2.setRBT2list_1'('SetRBT2.SetRBT'(A,B),C,D,E):-'SetRBT2.s2l_6409'(B,[],C,D,E).

:- block 'SetRBT2.unionRBT'(?,?,?,-,?).
'SetRBT2.unionRBT'(A,B,C,D,E):-foldr('SetRBT2.insertRBT',B,'SetRBT2.setRBT2list'(A),C,D,E).

:- block 'SetRBT2.intersectRBT'(?,?,?,-,?).
'SetRBT2.intersectRBT'(A,B,C,D,E):-makeShare(A,F),'SetRBT2.setRBT2_lambda2_7389'(B,F,F,C,D,E).

:- block 'SetRBT2.sortRBT'(?,?,?,-,?).
'SetRBT2.sortRBT'(A,B,C,D,E):-'SetRBT2.setRBT2list'(foldr('SetRBT2.insertMultiRBT','SetRBT2.emptySetRBT'(A),B),C,D,E).

:- block 'SetRBT2.rbsBalance'(?,?,-,?).
'SetRBT2.rbsBalance'(A,B,C,D):-hnf(A,E,C,F),'SetRBT2.rbsBalance_1'(E,B,F,D).

:- block 'SetRBT2.rbsBalance_1'(?,?,-,?).
'SetRBT2.rbsBalance_1'('SetRBT2.RBSEmpty','SetRBT2.RBSEmpty',A,A).
'SetRBT2.rbsBalance_1'('SetRBT2.RBS'(A,B,C,D),E,F,G):-makeShare(A,H),makeShare(B,I),makeShare(C,J),makeShare(D,K),'SetRBT2.setRBT2_lambda4_7390'(H,I,J,K,'SetRBT2.rbsBalanceL'('SetRBT2.RBS'(H,I,J,K)),E,F,G).

:- block 'SetRBT2.rbsBalanceL'(?,?,-,?).
'SetRBT2.rbsBalanceL'(A,B,C,D):-hnf(A,E,C,F),'SetRBT2.rbsBalanceL_1'(E,B,F,D).

:- block 'SetRBT2.rbsBalanceL_1'(?,?,-,?).
'SetRBT2.rbsBalanceL_1'('SetRBT2.RBS'(A,B,C,D),E,F,G):-hnf(C,H,F,I),'SetRBT2.rbsBalanceL_1_SetRBT2.RBS_3'(H,A,B,D,E,I,G).

:- block 'SetRBT2.rbsBalanceL_1_SetRBT2.RBS_3'(?,?,?,?,?,-,?).
'SetRBT2.rbsBalanceL_1_SetRBT2.RBS_3'('SetRBT2.RBSEmpty',A,B,C,'SetRBT2.RBS'(A,B,'SetRBT2.RBSEmpty',C),D,D).
'SetRBT2.rbsBalanceL_1_SetRBT2.RBS_3'('SetRBT2.RBS'(A,B,C,D),E,F,G,H,I,J):-hnf(C,K,I,L),'SetRBT2.rbsBalanceL_1_SetRBT2.RBS_3_SetRBT2.RBS_3'(K,A,B,D,E,F,G,H,L,J).

:- block 'SetRBT2.rbsBalanceL_1_SetRBT2.RBS_3_SetRBT2.RBS_3'(?,?,?,?,?,?,?,?,-,?).
'SetRBT2.rbsBalanceL_1_SetRBT2.RBS_3_SetRBT2.RBS_3'('SetRBT2.RBSEmpty',A,B,C,D,E,F,G,H,I):-hnf(C,J,H,K),'SetRBT2.rbsBalanceL_1_SetRBT2.RBS_3_SetRBT2.RBS_3_SetRBT2.RBSEmpty_3'(J,A,B,D,E,F,G,K,I).

:- block 'SetRBT2.rbsBalanceL_1_SetRBT2.RBS_3_SetRBT2.RBS_3_SetRBT2.RBSEmpty_3'(?,?,?,?,?,?,?,-,?).
'SetRBT2.rbsBalanceL_1_SetRBT2.RBS_3_SetRBT2.RBS_3_SetRBT2.RBSEmpty_3'('SetRBT2.RBSEmpty',A,B,C,D,E,'SetRBT2.RBS'(C,D,'SetRBT2.RBS'(A,B,'SetRBT2.RBSEmpty','SetRBT2.RBSEmpty'),E),F,F).
'SetRBT2.rbsBalanceL_1_SetRBT2.RBS_3_SetRBT2.RBS_3_SetRBT2.RBSEmpty_3'('SetRBT2.RBS'(A,B,C,D),E,F,G,H,I,J,K,L):-makeShare(E,M),makeShare(A,N),makeShare(B,O),makeShare(F,P),makeShare(C,Q),makeShare(H,R),makeShare(D,S),makeShare(I,T),if_then_else(&&(M=='SetRBT2.RBSRed',N=='SetRBT2.RBSRed'),'SetRBT2.RBS'('SetRBT2.RBSRed',O,'SetRBT2.RBS'('SetRBT2.RBSBlack',P,'SetRBT2.RBSEmpty',Q),'SetRBT2.RBS'('SetRBT2.RBSBlack',R,S,T)),'SetRBT2.RBS'(G,R,'SetRBT2.RBS'(M,P,'SetRBT2.RBSEmpty','SetRBT2.RBS'(N,O,Q,S)),T),J,K,L).
'SetRBT2.rbsBalanceL_1_SetRBT2.RBS_3_SetRBT2.RBS_3'('SetRBT2.RBS'(A,B,C,D),E,F,G,H,I,J,K,L,M):-hnf(G,N,L,O),'SetRBT2.rbsBalanceL_1_SetRBT2.RBS_3_SetRBT2.RBS_3_SetRBT2.RBS_7'(N,A,B,C,D,E,F,H,I,J,K,O,M).

:- block 'SetRBT2.rbsBalanceL_1_SetRBT2.RBS_3_SetRBT2.RBS_3_SetRBT2.RBS_7'(?,?,?,?,?,?,?,?,?,?,?,-,?).
'SetRBT2.rbsBalanceL_1_SetRBT2.RBS_3_SetRBT2.RBS_3_SetRBT2.RBS_7'('SetRBT2.RBSEmpty',A,B,C,D,E,F,G,H,I,J,K,L):-makeShare(E,M),makeShare(A,N),makeShare(F,O),makeShare(B,P),makeShare(C,Q),makeShare(D,R),makeShare(H,S),makeShare(I,T),if_then_else(&&(M=='SetRBT2.RBSRed',N=='SetRBT2.RBSRed'),'SetRBT2.RBS'('SetRBT2.RBSRed',O,'SetRBT2.RBS'('SetRBT2.RBSBlack',P,Q,R),'SetRBT2.RBS'('SetRBT2.RBSBlack',S,'SetRBT2.RBSEmpty',T)),'SetRBT2.RBS'(G,S,'SetRBT2.RBS'(M,O,'SetRBT2.RBS'(N,P,Q,R),'SetRBT2.RBSEmpty'),T),J,K,L).
'SetRBT2.rbsBalanceL_1_SetRBT2.RBS_3_SetRBT2.RBS_3_SetRBT2.RBS_7'('SetRBT2.RBS'(A,B,C,D),E,F,G,H,I,J,K,L,M,N,O,P):-makeShare(I,Q),makeShare(E,R),makeShare(J,S),makeShare(F,T),makeShare(G,U),makeShare(H,V),makeShare(L,W),makeShare(A,X),makeShare(B,Y),makeShare(C,Z),makeShare(D,A1),makeShare(M,B1),if_then_else(&&(Q=='SetRBT2.RBSRed',R=='SetRBT2.RBSRed'),'SetRBT2.RBS'('SetRBT2.RBSRed',S,'SetRBT2.RBS'('SetRBT2.RBSBlack',T,U,V),'SetRBT2.RBS'('SetRBT2.RBSBlack',W,'SetRBT2.RBS'(X,Y,Z,A1),B1)),if_then_else(&&(Q=='SetRBT2.RBSRed',X=='SetRBT2.RBSRed'),'SetRBT2.RBS'('SetRBT2.RBSRed',Y,'SetRBT2.RBS'('SetRBT2.RBSBlack',S,'SetRBT2.RBS'(R,T,U,V),Z),'SetRBT2.RBS'('SetRBT2.RBSBlack',W,A1,B1)),'SetRBT2.RBS'(K,W,'SetRBT2.RBS'(Q,S,'SetRBT2.RBS'(R,T,U,V),'SetRBT2.RBS'(X,Y,Z,A1)),B1)),N,O,P).

:- block 'SetRBT2.rbsBalanceR'(?,?,-,?).
'SetRBT2.rbsBalanceR'(A,B,C,D):-hnf(A,E,C,F),'SetRBT2.rbsBalanceR_1'(E,B,F,D).

:- block 'SetRBT2.rbsBalanceR_1'(?,?,-,?).
'SetRBT2.rbsBalanceR_1'('SetRBT2.RBS'(A,B,C,D),E,F,G):-hnf(D,H,F,I),'SetRBT2.rbsBalanceR_1_SetRBT2.RBS_4'(H,A,B,C,E,I,G).

:- block 'SetRBT2.rbsBalanceR_1_SetRBT2.RBS_4'(?,?,?,?,?,-,?).
'SetRBT2.rbsBalanceR_1_SetRBT2.RBS_4'('SetRBT2.RBSEmpty',A,B,C,'SetRBT2.RBS'(A,B,C,'SetRBT2.RBSEmpty'),D,D).
'SetRBT2.rbsBalanceR_1_SetRBT2.RBS_4'('SetRBT2.RBS'(A,B,C,D),E,F,G,H,I,J):-hnf(C,K,I,L),'SetRBT2.rbsBalanceR_1_SetRBT2.RBS_4_SetRBT2.RBS_3'(K,A,B,D,E,F,G,H,L,J).

:- block 'SetRBT2.rbsBalanceR_1_SetRBT2.RBS_4_SetRBT2.RBS_3'(?,?,?,?,?,?,?,?,-,?).
'SetRBT2.rbsBalanceR_1_SetRBT2.RBS_4_SetRBT2.RBS_3'('SetRBT2.RBSEmpty',A,B,C,D,E,F,G,H,I):-hnf(C,J,H,K),'SetRBT2.rbsBalanceR_1_SetRBT2.RBS_4_SetRBT2.RBS_3_SetRBT2.RBSEmpty_3'(J,A,B,D,E,F,G,K,I).

:- block 'SetRBT2.rbsBalanceR_1_SetRBT2.RBS_4_SetRBT2.RBS_3_SetRBT2.RBSEmpty_3'(?,?,?,?,?,?,?,-,?).
'SetRBT2.rbsBalanceR_1_SetRBT2.RBS_4_SetRBT2.RBS_3_SetRBT2.RBSEmpty_3'('SetRBT2.RBSEmpty',A,B,C,D,E,'SetRBT2.RBS'(C,D,E,'SetRBT2.RBS'(A,B,'SetRBT2.RBSEmpty','SetRBT2.RBSEmpty')),F,F).
'SetRBT2.rbsBalanceR_1_SetRBT2.RBS_4_SetRBT2.RBS_3_SetRBT2.RBSEmpty_3'('SetRBT2.RBS'(A,B,C,D),E,F,G,H,I,J,K,L):-makeShare(E,M),makeShare(A,N),makeShare(F,O),makeShare(H,P),makeShare(I,Q),makeShare(B,R),makeShare(C,S),makeShare(D,T),if_then_else(&&(M=='SetRBT2.RBSRed',N=='SetRBT2.RBSRed'),'SetRBT2.RBS'('SetRBT2.RBSRed',O,'SetRBT2.RBS'('SetRBT2.RBSBlack',P,Q,'SetRBT2.RBSEmpty'),'SetRBT2.RBS'('SetRBT2.RBSBlack',R,S,T)),'SetRBT2.RBS'(G,P,Q,'SetRBT2.RBS'(M,O,'SetRBT2.RBSEmpty','SetRBT2.RBS'(N,R,S,T))),J,K,L).
'SetRBT2.rbsBalanceR_1_SetRBT2.RBS_4_SetRBT2.RBS_3'('SetRBT2.RBS'(A,B,C,D),E,F,G,H,I,J,K,L,M):-hnf(G,N,L,O),'SetRBT2.rbsBalanceR_1_SetRBT2.RBS_4_SetRBT2.RBS_3_SetRBT2.RBS_7'(N,A,B,C,D,E,F,H,I,J,K,O,M).

:- block 'SetRBT2.rbsBalanceR_1_SetRBT2.RBS_4_SetRBT2.RBS_3_SetRBT2.RBS_7'(?,?,?,?,?,?,?,?,?,?,?,-,?).
'SetRBT2.rbsBalanceR_1_SetRBT2.RBS_4_SetRBT2.RBS_3_SetRBT2.RBS_7'('SetRBT2.RBSEmpty',A,B,C,D,E,F,G,H,I,J,K,L):-makeShare(E,M),makeShare(A,N),makeShare(B,O),makeShare(H,P),makeShare(I,Q),makeShare(C,R),makeShare(F,S),makeShare(D,T),if_then_else(&&(M=='SetRBT2.RBSRed',N=='SetRBT2.RBSRed'),'SetRBT2.RBS'('SetRBT2.RBSRed',O,'SetRBT2.RBS'('SetRBT2.RBSBlack',P,Q,R),'SetRBT2.RBS'('SetRBT2.RBSBlack',S,T,'SetRBT2.RBSEmpty')),'SetRBT2.RBS'(G,P,Q,'SetRBT2.RBS'(M,S,'SetRBT2.RBS'(N,O,R,T),'SetRBT2.RBSEmpty')),J,K,L).
'SetRBT2.rbsBalanceR_1_SetRBT2.RBS_4_SetRBT2.RBS_3_SetRBT2.RBS_7'('SetRBT2.RBS'(A,B,C,D),E,F,G,H,I,J,K,L,M,N,O,P):-makeShare(I,Q),makeShare(E,R),makeShare(F,S),makeShare(L,T),makeShare(M,U),makeShare(G,V),makeShare(J,W),makeShare(H,X),makeShare(A,Y),makeShare(B,Z),makeShare(C,A1),makeShare(D,B1),if_then_else(&&(Q=='SetRBT2.RBSRed',R=='SetRBT2.RBSRed'),'SetRBT2.RBS'('SetRBT2.RBSRed',S,'SetRBT2.RBS'('SetRBT2.RBSBlack',T,U,V),'SetRBT2.RBS'('SetRBT2.RBSBlack',W,X,'SetRBT2.RBS'(Y,Z,A1,B1))),if_then_else(&&(Q=='SetRBT2.RBSRed',Y=='SetRBT2.RBSRed'),'SetRBT2.RBS'('SetRBT2.RBSRed',W,'SetRBT2.RBS'('SetRBT2.RBSBlack',T,U,'SetRBT2.RBS'(R,S,V,X)),'SetRBT2.RBS'('SetRBT2.RBSBlack',Z,A1,B1)),'SetRBT2.RBS'(K,T,U,'SetRBT2.RBS'(Q,W,'SetRBT2.RBS'(R,S,V,X),'SetRBT2.RBS'(Y,Z,A1,B1)))),N,O,P).

:- block 'SetRBT2.ins_6383'(?,?,?,?,-,?).
'SetRBT2.ins_6383'(A,B,C,D,E,F):-hnf(C,G,E,H),'SetRBT2.ins_6383_3'(G,A,B,D,H,F).

:- block 'SetRBT2.ins_6383_3'(?,?,?,?,-,?).
'SetRBT2.ins_6383_3'('SetRBT2.RBSEmpty',A,B,'SetRBT2.RBS'('SetRBT2.RBSRed',A,'SetRBT2.RBSEmpty','SetRBT2.RBSEmpty'),C,C).
'SetRBT2.ins_6383_3'('SetRBT2.RBS'(A,B,C,D),E,F,G,H,I):-makeShare(E,J),makeShare(B,K),makeShare(A,L),makeShare(C,M),makeShare(D,N),makeShare(F,O),if_then_else(J==K,'SetRBT2.RBS'(L,K,M,N),if_then_else(apply(apply(O,J),K),'SetRBT2.rbsBalanceL'('SetRBT2.RBS'(L,K,'SetRBT2.ins_6383'(J,O,M),N)),'SetRBT2.rbsBalanceR'('SetRBT2.RBS'(L,K,M,'SetRBT2.ins_6383'(J,O,N)))),G,H,I).

:- block 'SetRBT2.setRBT2_lambda0_7386'(?,?,-,?).
'SetRBT2.setRBT2_lambda0_7386'(A,B,C,D):-hnf(A,E,C,F),'SetRBT2.setRBT2_lambda0_7386_1'(E,B,F,D).

:- block 'SetRBT2.setRBT2_lambda0_7386_1'(?,?,-,?).
'SetRBT2.setRBT2_lambda0_7386_1'('SetRBT2.RBS'(A,B,C,D),'SetRBT2.RBS'('SetRBT2.RBSBlack',B,C,D),E,E).

:- block 'SetRBT2.ins_6398'(?,?,?,?,-,?).
'SetRBT2.ins_6398'(A,B,C,D,E,F):-hnf(C,G,E,H),'SetRBT2.ins_6398_3'(G,A,B,D,H,F).

:- block 'SetRBT2.ins_6398_3'(?,?,?,?,-,?).
'SetRBT2.ins_6398_3'('SetRBT2.RBSEmpty',A,B,'SetRBT2.RBS'('SetRBT2.RBSRed',A,'SetRBT2.RBSEmpty','SetRBT2.RBSEmpty'),C,C).
'SetRBT2.ins_6398_3'('SetRBT2.RBS'(A,B,C,D),E,F,G,H,I):-makeShare(F,J),makeShare(E,K),makeShare(B,L),makeShare(A,M),makeShare(C,N),makeShare(D,O),if_then_else(apply(apply(J,K),L),'SetRBT2.rbsBalanceL'('SetRBT2.RBS'(M,L,'SetRBT2.ins_6398'(K,J,N),O)),'SetRBT2.rbsBalanceR'('SetRBT2.RBS'(M,L,N,'SetRBT2.ins_6398'(K,J,O))),G,H,I).

:- block 'SetRBT2.setRBT2_lambda1_7387'(?,?,-,?).
'SetRBT2.setRBT2_lambda1_7387'(A,B,C,D):-hnf(A,E,C,F),'SetRBT2.setRBT2_lambda1_7387_1'(E,B,F,D).

:- block 'SetRBT2.setRBT2_lambda1_7387_1'(?,?,-,?).
'SetRBT2.setRBT2_lambda1_7387_1'('SetRBT2.RBS'(A,B,C,D),'SetRBT2.RBS'('SetRBT2.RBSBlack',B,C,D),E,E).

:- block 'SetRBT2.s2l_6409'(?,?,?,-,?).
'SetRBT2.s2l_6409'(A,B,C,D,E):-hnf(A,F,D,G),'SetRBT2.s2l_6409_1'(F,B,C,G,E).

:- block 'SetRBT2.s2l_6409_1'(?,?,?,-,?).
'SetRBT2.s2l_6409_1'('SetRBT2.RBSEmpty',A,B,C,D):-hnf(A,B,C,D).
'SetRBT2.s2l_6409_1'('SetRBT2.RBS'(A,B,C,D),E,F,G,H):-'SetRBT2.s2l_6409'(C,[B|'SetRBT2.s2l_6409'(D,E)],F,G,H).

:- block 'SetRBT2.setRBT2_lambda3_7388'(?,?,?,-,?).
'SetRBT2.setRBT2_lambda3_7388'(A,B,C,D,E):-'SetRBT2.elemRBT'(B,A,C,D,E).

:- block 'SetRBT2.setRBT2_lambda2_7389'(?,?,?,?,-,?).
'SetRBT2.setRBT2_lambda2_7389'(A,B,C,D,E,F):-hnf(C,G,E,H),'SetRBT2.setRBT2_lambda2_7389_3'(G,A,B,D,H,F).

:- block 'SetRBT2.setRBT2_lambda2_7389_3'(?,?,?,?,-,?).
'SetRBT2.setRBT2_lambda2_7389_3'('SetRBT2.SetRBT'(A,B),C,D,E,F,G):-foldr('SetRBT2.insertRBT','SetRBT2.emptySetRBT'(A),filter('SetRBT2.setRBT2_lambda3_7388'(C),'SetRBT2.setRBT2list'(D)),E,F,G).

:- block 'SetRBT2.setRBT2_lambda4_7390'(?,?,?,?,?,?,-,?).
'SetRBT2.setRBT2_lambda4_7390'(A,B,C,D,E,F,G,H):-hnf(E,I,G,J),'SetRBT2.setRBT2_lambda4_7390_5'(I,A,B,C,D,F,J,H).

:- block 'SetRBT2.setRBT2_lambda4_7390_5'(?,?,?,?,?,?,-,?).
'SetRBT2.setRBT2_lambda4_7390_5'('SetRBT2.RBS'(A,B,C,D),E,F,G,H,I,J,K):-makeShare(E,L),makeShare(F,M),makeShare(G,N),makeShare(H,O),makeShare(A,P),if_then_else(/=(L,'SetRBT2.RBSBlack'),'SetRBT2.RBS'(L,M,N,O),if_then_else(P=='SetRBT2.RBSRed','SetRBT2.RBS'(P,B,C,D),'SetRBT2.rbsBalanceR'('SetRBT2.RBS'(L,M,N,O))),I,J,K).

:- block 'TableRBT2.emptyTableRBT'(?,?,-,?).
'TableRBT2.emptyTableRBT'(A,'TableRBT2.TableRBT'(A,'TableRBT2.RBTEmpty'),B,B).

:- block 'TableRBT2.lookupRBT'(?,?,?,-,?).
'TableRBT2.lookupRBT'(A,B,C,D,E):-hnf(B,F,D,G),'TableRBT2.lookupRBT_2'(F,A,C,G,E).

:- block 'TableRBT2.lookupRBT_2'(?,?,?,-,?).
'TableRBT2.lookupRBT_2'('TableRBT2.TableRBT'(A,B),C,D,E,F):-'TableRBT2.lookupRBTree'(A,C,B,D,E,F).

:- block 'TableRBT2.lookupRBTree'(?,?,?,?,-,?).
'TableRBT2.lookupRBTree'(A,B,C,D,E,F):-hnf(C,G,E,H),'TableRBT2.lookupRBTree_3'(G,A,B,D,H,F).

:- block 'TableRBT2.lookupRBTree_3'(?,?,?,?,-,?).
'TableRBT2.lookupRBTree_3'('TableRBT2.RBTEmpty',A,B,'Nothing',C,C).
'TableRBT2.lookupRBTree_3'('TableRBT2.RBT'(A,B,C,D,E),F,G,H,I,J):-makeShare(B,K),makeShare(G,L),makeShare(F,M),if_then_else(K==L,'Just'(C),if_then_else(apply(apply(M,L),K),'TableRBT2.lookupRBTree'(M,L,D),'TableRBT2.lookupRBTree'(M,L,E)),H,I,J).

:- block 'TableRBT2.updateRBT'(?,?,?,?,-,?).
'TableRBT2.updateRBT'(A,B,C,D,E,F):-hnf(C,G,E,H),'TableRBT2.updateRBT_3'(G,A,B,D,H,F).

:- block 'TableRBT2.updateRBT_3'(?,?,?,?,-,?).
'TableRBT2.updateRBT_3'('TableRBT2.TableRBT'(A,B),C,D,E,F,G):-makeShare(A,H),$('TableRBT2.TableRBT'(H),'TableRBT2.updateRBTree'(H,C,D,B),E,F,G).

:- block 'TableRBT2.updateRBTree'(?,?,?,?,?,-,?).
'TableRBT2.updateRBTree'(A,B,C,D,E,F,G):-'TableRBT2.tableRBT2_lambda0_8750'('TableRBT2.ins_7577'(B,C,A,D),E,F,G).

:- block 'TableRBT2.tableRBT2list'(?,?,-,?).
'TableRBT2.tableRBT2list'(A,B,C,D):-hnf(A,E,C,F),'TableRBT2.tableRBT2list_1'(E,B,F,D).

:- block 'TableRBT2.tableRBT2list_1'(?,?,-,?).
'TableRBT2.tableRBT2list_1'('TableRBT2.TableRBT'(A,B),C,D,E):-'TableRBT2.t2l_7590'(B,[],C,D,E).

:- block 'TableRBT2.rbtBalance'(?,?,-,?).
'TableRBT2.rbtBalance'(A,B,C,D):-hnf(A,E,C,F),'TableRBT2.rbtBalance_1'(E,B,F,D).

:- block 'TableRBT2.rbtBalance_1'(?,?,-,?).
'TableRBT2.rbtBalance_1'('TableRBT2.RBTEmpty','TableRBT2.RBTEmpty',A,A).
'TableRBT2.rbtBalance_1'('TableRBT2.RBT'(A,B,C,D,E),F,G,H):-makeShare(A,I),makeShare(B,J),makeShare(C,K),makeShare(D,L),makeShare(E,M),'TableRBT2.tableRBT2_lambda1_8751'(I,J,K,L,M,'TableRBT2.rbtBalanceL'('TableRBT2.RBT'(I,J,K,L,M)),F,G,H).

:- block 'TableRBT2.rbtBalanceL'(?,?,-,?).
'TableRBT2.rbtBalanceL'(A,B,C,D):-hnf(A,E,C,F),'TableRBT2.rbtBalanceL_1'(E,B,F,D).

:- block 'TableRBT2.rbtBalanceL_1'(?,?,-,?).
'TableRBT2.rbtBalanceL_1'('TableRBT2.RBT'(A,B,C,D,E),F,G,H):-hnf(D,I,G,J),'TableRBT2.rbtBalanceL_1_TableRBT2.RBT_4'(I,A,B,C,E,F,J,H).

:- block 'TableRBT2.rbtBalanceL_1_TableRBT2.RBT_4'(?,?,?,?,?,?,-,?).
'TableRBT2.rbtBalanceL_1_TableRBT2.RBT_4'('TableRBT2.RBTEmpty',A,B,C,D,'TableRBT2.RBT'(A,B,C,'TableRBT2.RBTEmpty',D),E,E).
'TableRBT2.rbtBalanceL_1_TableRBT2.RBT_4'('TableRBT2.RBT'(A,B,C,D,E),F,G,H,I,J,K,L):-hnf(D,M,K,N),'TableRBT2.rbtBalanceL_1_TableRBT2.RBT_4_TableRBT2.RBT_4'(M,A,B,C,E,F,G,H,I,J,N,L).

:- block 'TableRBT2.rbtBalanceL_1_TableRBT2.RBT_4_TableRBT2.RBT_4'(?,?,?,?,?,?,?,?,?,?,-,?).
'TableRBT2.rbtBalanceL_1_TableRBT2.RBT_4_TableRBT2.RBT_4'('TableRBT2.RBTEmpty',A,B,C,D,E,F,G,H,I,J,K):-hnf(D,L,J,M),'TableRBT2.rbtBalanceL_1_TableRBT2.RBT_4_TableRBT2.RBT_4_TableRBT2.RBTEmpty_4'(L,A,B,C,E,F,G,H,I,M,K).

:- block 'TableRBT2.rbtBalanceL_1_TableRBT2.RBT_4_TableRBT2.RBT_4_TableRBT2.RBTEmpty_4'(?,?,?,?,?,?,?,?,?,-,?).
'TableRBT2.rbtBalanceL_1_TableRBT2.RBT_4_TableRBT2.RBT_4_TableRBT2.RBTEmpty_4'('TableRBT2.RBTEmpty',A,B,C,D,E,F,G,'TableRBT2.RBT'(D,E,F,'TableRBT2.RBT'(A,B,C,'TableRBT2.RBTEmpty','TableRBT2.RBTEmpty'),G),H,H).
'TableRBT2.rbtBalanceL_1_TableRBT2.RBT_4_TableRBT2.RBT_4_TableRBT2.RBTEmpty_4'('TableRBT2.RBT'(A,B,C,D,E),F,G,H,I,J,K,L,M,N,O):-makeShare(F,P),makeShare(A,Q),makeShare(B,R),makeShare(C,S),makeShare(G,T),makeShare(H,U),makeShare(D,V),makeShare(J,W),makeShare(K,X),makeShare(E,Y),makeShare(L,Z),if_then_else(&&(P=='TableRBT2.RBTRed',Q=='TableRBT2.RBTRed'),'TableRBT2.RBT'('TableRBT2.RBTRed',R,S,'TableRBT2.RBT'('TableRBT2.RBTBlack',T,U,'TableRBT2.RBTEmpty',V),'TableRBT2.RBT'('TableRBT2.RBTBlack',W,X,Y,Z)),'TableRBT2.RBT'(I,W,X,'TableRBT2.RBT'(P,T,U,'TableRBT2.RBTEmpty','TableRBT2.RBT'(Q,R,S,V,Y)),Z),M,N,O).
'TableRBT2.rbtBalanceL_1_TableRBT2.RBT_4_TableRBT2.RBT_4'('TableRBT2.RBT'(A,B,C,D,E),F,G,H,I,J,K,L,M,N,O,P):-hnf(I,Q,O,R),'TableRBT2.rbtBalanceL_1_TableRBT2.RBT_4_TableRBT2.RBT_4_TableRBT2.RBT_9'(Q,A,B,C,D,E,F,G,H,J,K,L,M,N,R,P).

:- block 'TableRBT2.rbtBalanceL_1_TableRBT2.RBT_4_TableRBT2.RBT_4_TableRBT2.RBT_9'(?,?,?,?,?,?,?,?,?,?,?,?,?,?,-,?).
'TableRBT2.rbtBalanceL_1_TableRBT2.RBT_4_TableRBT2.RBT_4_TableRBT2.RBT_9'('TableRBT2.RBTEmpty',A,B,C,D,E,F,G,H,I,J,K,L,M,N,O):-makeShare(F,P),makeShare(A,Q),makeShare(G,R),makeShare(H,S),makeShare(B,T),makeShare(C,U),makeShare(D,V),makeShare(E,W),makeShare(J,X),makeShare(K,Y),makeShare(L,Z),if_then_else(&&(P=='TableRBT2.RBTRed',Q=='TableRBT2.RBTRed'),'TableRBT2.RBT'('TableRBT2.RBTRed',R,S,'TableRBT2.RBT'('TableRBT2.RBTBlack',T,U,V,W),'TableRBT2.RBT'('TableRBT2.RBTBlack',X,Y,'TableRBT2.RBTEmpty',Z)),'TableRBT2.RBT'(I,X,Y,'TableRBT2.RBT'(P,R,S,'TableRBT2.RBT'(Q,T,U,V,W),'TableRBT2.RBTEmpty'),Z),M,N,O).
'TableRBT2.rbtBalanceL_1_TableRBT2.RBT_4_TableRBT2.RBT_4_TableRBT2.RBT_9'('TableRBT2.RBT'(A,B,C,D,E),F,G,H,I,J,K,L,M,N,O,P,Q,R,S,T):-makeShare(K,U),makeShare(F,V),makeShare(L,W),makeShare(M,X),makeShare(G,Y),makeShare(H,Z),makeShare(I,A1),makeShare(J,B1),makeShare(O,C1),makeShare(P,D1),makeShare(A,E1),makeShare(B,F1),makeShare(C,G1),makeShare(D,H1),makeShare(E,I1),makeShare(Q,J1),if_then_else(&&(U=='TableRBT2.RBTRed',V=='TableRBT2.RBTRed'),'TableRBT2.RBT'('TableRBT2.RBTRed',W,X,'TableRBT2.RBT'('TableRBT2.RBTBlack',Y,Z,A1,B1),'TableRBT2.RBT'('TableRBT2.RBTBlack',C1,D1,'TableRBT2.RBT'(E1,F1,G1,H1,I1),J1)),if_then_else(&&(U=='TableRBT2.RBTRed',E1=='TableRBT2.RBTRed'),'TableRBT2.RBT'('TableRBT2.RBTRed',F1,G1,'TableRBT2.RBT'('TableRBT2.RBTBlack',W,X,'TableRBT2.RBT'(V,Y,Z,A1,B1),H1),'TableRBT2.RBT'('TableRBT2.RBTBlack',C1,D1,I1,J1)),'TableRBT2.RBT'(N,C1,D1,'TableRBT2.RBT'(U,W,X,'TableRBT2.RBT'(V,Y,Z,A1,B1),'TableRBT2.RBT'(E1,F1,G1,H1,I1)),J1)),R,S,T).

:- block 'TableRBT2.rbtBalanceR'(?,?,-,?).
'TableRBT2.rbtBalanceR'(A,B,C,D):-hnf(A,E,C,F),'TableRBT2.rbtBalanceR_1'(E,B,F,D).

:- block 'TableRBT2.rbtBalanceR_1'(?,?,-,?).
'TableRBT2.rbtBalanceR_1'('TableRBT2.RBT'(A,B,C,D,E),F,G,H):-hnf(E,I,G,J),'TableRBT2.rbtBalanceR_1_TableRBT2.RBT_5'(I,A,B,C,D,F,J,H).

:- block 'TableRBT2.rbtBalanceR_1_TableRBT2.RBT_5'(?,?,?,?,?,?,-,?).
'TableRBT2.rbtBalanceR_1_TableRBT2.RBT_5'('TableRBT2.RBTEmpty',A,B,C,D,'TableRBT2.RBT'(A,B,C,D,'TableRBT2.RBTEmpty'),E,E).
'TableRBT2.rbtBalanceR_1_TableRBT2.RBT_5'('TableRBT2.RBT'(A,B,C,D,E),F,G,H,I,J,K,L):-hnf(D,M,K,N),'TableRBT2.rbtBalanceR_1_TableRBT2.RBT_5_TableRBT2.RBT_4'(M,A,B,C,E,F,G,H,I,J,N,L).

:- block 'TableRBT2.rbtBalanceR_1_TableRBT2.RBT_5_TableRBT2.RBT_4'(?,?,?,?,?,?,?,?,?,?,-,?).
'TableRBT2.rbtBalanceR_1_TableRBT2.RBT_5_TableRBT2.RBT_4'('TableRBT2.RBTEmpty',A,B,C,D,E,F,G,H,I,J,K):-hnf(D,L,J,M),'TableRBT2.rbtBalanceR_1_TableRBT2.RBT_5_TableRBT2.RBT_4_TableRBT2.RBTEmpty_4'(L,A,B,C,E,F,G,H,I,M,K).

:- block 'TableRBT2.rbtBalanceR_1_TableRBT2.RBT_5_TableRBT2.RBT_4_TableRBT2.RBTEmpty_4'(?,?,?,?,?,?,?,?,?,-,?).
'TableRBT2.rbtBalanceR_1_TableRBT2.RBT_5_TableRBT2.RBT_4_TableRBT2.RBTEmpty_4'('TableRBT2.RBTEmpty',A,B,C,D,E,F,G,'TableRBT2.RBT'(D,E,F,G,'TableRBT2.RBT'(A,B,C,'TableRBT2.RBTEmpty','TableRBT2.RBTEmpty')),H,H).
'TableRBT2.rbtBalanceR_1_TableRBT2.RBT_5_TableRBT2.RBT_4_TableRBT2.RBTEmpty_4'('TableRBT2.RBT'(A,B,C,D,E),F,G,H,I,J,K,L,M,N,O):-makeShare(F,P),makeShare(A,Q),makeShare(G,R),makeShare(H,S),makeShare(J,T),makeShare(K,U),makeShare(L,V),makeShare(B,W),makeShare(C,X),makeShare(D,Y),makeShare(E,Z),if_then_else(&&(P=='TableRBT2.RBTRed',Q=='TableRBT2.RBTRed'),'TableRBT2.RBT'('TableRBT2.RBTRed',R,S,'TableRBT2.RBT'('TableRBT2.RBTBlack',T,U,V,'TableRBT2.RBTEmpty'),'TableRBT2.RBT'('TableRBT2.RBTBlack',W,X,Y,Z)),'TableRBT2.RBT'(I,T,U,V,'TableRBT2.RBT'(P,R,S,'TableRBT2.RBTEmpty','TableRBT2.RBT'(Q,W,X,Y,Z))),M,N,O).
'TableRBT2.rbtBalanceR_1_TableRBT2.RBT_5_TableRBT2.RBT_4'('TableRBT2.RBT'(A,B,C,D,E),F,G,H,I,J,K,L,M,N,O,P):-hnf(I,Q,O,R),'TableRBT2.rbtBalanceR_1_TableRBT2.RBT_5_TableRBT2.RBT_4_TableRBT2.RBT_9'(Q,A,B,C,D,E,F,G,H,J,K,L,M,N,R,P).

:- block 'TableRBT2.rbtBalanceR_1_TableRBT2.RBT_5_TableRBT2.RBT_4_TableRBT2.RBT_9'(?,?,?,?,?,?,?,?,?,?,?,?,?,?,-,?).
'TableRBT2.rbtBalanceR_1_TableRBT2.RBT_5_TableRBT2.RBT_4_TableRBT2.RBT_9'('TableRBT2.RBTEmpty',A,B,C,D,E,F,G,H,I,J,K,L,M,N,O):-makeShare(F,P),makeShare(A,Q),makeShare(B,R),makeShare(C,S),makeShare(J,T),makeShare(K,U),makeShare(L,V),makeShare(D,W),makeShare(G,X),makeShare(H,Y),makeShare(E,Z),if_then_else(&&(P=='TableRBT2.RBTRed',Q=='TableRBT2.RBTRed'),'TableRBT2.RBT'('TableRBT2.RBTRed',R,S,'TableRBT2.RBT'('TableRBT2.RBTBlack',T,U,V,W),'TableRBT2.RBT'('TableRBT2.RBTBlack',X,Y,Z,'TableRBT2.RBTEmpty')),'TableRBT2.RBT'(I,T,U,V,'TableRBT2.RBT'(P,X,Y,'TableRBT2.RBT'(Q,R,S,W,Z),'TableRBT2.RBTEmpty')),M,N,O).
'TableRBT2.rbtBalanceR_1_TableRBT2.RBT_5_TableRBT2.RBT_4_TableRBT2.RBT_9'('TableRBT2.RBT'(A,B,C,D,E),F,G,H,I,J,K,L,M,N,O,P,Q,R,S,T):-makeShare(K,U),makeShare(F,V),makeShare(G,W),makeShare(H,X),makeShare(O,Y),makeShare(P,Z),makeShare(Q,A1),makeShare(I,B1),makeShare(L,C1),makeShare(M,D1),makeShare(J,E1),makeShare(A,F1),makeShare(B,G1),makeShare(C,H1),makeShare(D,I1),makeShare(E,J1),if_then_else(&&(U=='TableRBT2.RBTRed',V=='TableRBT2.RBTRed'),'TableRBT2.RBT'('TableRBT2.RBTRed',W,X,'TableRBT2.RBT'('TableRBT2.RBTBlack',Y,Z,A1,B1),'TableRBT2.RBT'('TableRBT2.RBTBlack',C1,D1,E1,'TableRBT2.RBT'(F1,G1,H1,I1,J1))),if_then_else(&&(U=='TableRBT2.RBTRed',F1=='TableRBT2.RBTRed'),'TableRBT2.RBT'('TableRBT2.RBTRed',C1,D1,'TableRBT2.RBT'('TableRBT2.RBTBlack',Y,Z,A1,'TableRBT2.RBT'(V,W,X,B1,E1)),'TableRBT2.RBT'('TableRBT2.RBTBlack',G1,H1,I1,J1)),'TableRBT2.RBT'(N,Y,Z,A1,'TableRBT2.RBT'(U,C1,D1,'TableRBT2.RBT'(V,W,X,B1,E1),'TableRBT2.RBT'(F1,G1,H1,I1,J1)))),R,S,T).

:- block 'TableRBT2.ins_7577'(?,?,?,?,?,-,?).
'TableRBT2.ins_7577'(A,B,C,D,E,F,G):-hnf(D,H,F,I),'TableRBT2.ins_7577_4'(H,A,B,C,E,I,G).

:- block 'TableRBT2.ins_7577_4'(?,?,?,?,?,-,?).
'TableRBT2.ins_7577_4'('TableRBT2.RBTEmpty',A,B,C,'TableRBT2.RBT'('TableRBT2.RBTRed',A,B,'TableRBT2.RBTEmpty','TableRBT2.RBTEmpty'),D,D).
'TableRBT2.ins_7577_4'('TableRBT2.RBT'(A,B,C,D,E),F,G,H,I,J,K):-makeShare(F,L),makeShare(B,M),makeShare(A,N),makeShare(G,O),makeShare(D,P),makeShare(E,Q),makeShare(H,R),makeShare(C,S),if_then_else(L==M,'TableRBT2.RBT'(N,M,O,P,Q),if_then_else(apply(apply(R,L),M),'TableRBT2.rbtBalanceL'('TableRBT2.RBT'(N,M,S,'TableRBT2.ins_7577'(L,O,R,P),Q)),'TableRBT2.rbtBalanceR'('TableRBT2.RBT'(N,M,S,P,'TableRBT2.ins_7577'(L,O,R,Q)))),I,J,K).

:- block 'TableRBT2.tableRBT2_lambda0_8750'(?,?,-,?).
'TableRBT2.tableRBT2_lambda0_8750'(A,B,C,D):-hnf(A,E,C,F),'TableRBT2.tableRBT2_lambda0_8750_1'(E,B,F,D).

:- block 'TableRBT2.tableRBT2_lambda0_8750_1'(?,?,-,?).
'TableRBT2.tableRBT2_lambda0_8750_1'('TableRBT2.RBT'(A,B,C,D,E),'TableRBT2.RBT'('TableRBT2.RBTBlack',B,C,D,E),F,F).

:- block 'TableRBT2.t2l_7590'(?,?,?,-,?).
'TableRBT2.t2l_7590'(A,B,C,D,E):-hnf(A,F,D,G),'TableRBT2.t2l_7590_1'(F,B,C,G,E).

:- block 'TableRBT2.t2l_7590_1'(?,?,?,-,?).
'TableRBT2.t2l_7590_1'('TableRBT2.RBTEmpty',A,B,C,D):-hnf(A,B,C,D).
'TableRBT2.t2l_7590_1'('TableRBT2.RBT'(A,B,C,D,E),F,G,H,I):-'TableRBT2.t2l_7590'(D,['(,)'(B,C)|'TableRBT2.t2l_7590'(E,F)],G,H,I).

:- block 'TableRBT2.tableRBT2_lambda1_8751'(?,?,?,?,?,?,?,-,?).
'TableRBT2.tableRBT2_lambda1_8751'(A,B,C,D,E,F,G,H,I):-hnf(F,J,H,K),'TableRBT2.tableRBT2_lambda1_8751_6'(J,A,B,C,D,E,G,K,I).

:- block 'TableRBT2.tableRBT2_lambda1_8751_6'(?,?,?,?,?,?,?,-,?).
'TableRBT2.tableRBT2_lambda1_8751_6'('TableRBT2.RBT'(A,B,C,D,E),F,G,H,I,J,K,L,M):-makeShare(F,N),makeShare(G,O),makeShare(H,P),makeShare(I,Q),makeShare(J,R),makeShare(A,S),if_then_else(/=(N,'TableRBT2.RBTBlack'),'TableRBT2.RBT'(N,O,P,Q,R),if_then_else(S=='TableRBT2.RBTRed','TableRBT2.RBT'(S,B,C,D,E),'TableRBT2.rbtBalanceR'('TableRBT2.RBT'(N,O,P,Q,R))),K,L,M).

:- block 'System.showDate'(?,?,-,?).
'System.showDate'(A,B,C,D):-hnf(A,E,C,F),'System.showDate_1'(E,B,F,D).

:- block 'System.showDate_1'(?,?,-,?).
'System.showDate_1'('System.Date'(A,B,C,D,E,F),G,H,I):- ++('System.digit2_2404'(B),++(['\'/'],++('System.digit2_2404'(C),++(['\'/'],++(show(A),++(['\' '],++('System.digit2_2404'(D),++(['\':'],++('System.digit2_2404'(E),++(['\':'],'System.digit2_2404'(F)))))))))),G,H,I).

:- block 'System.digit2_2404'(?,?,-,?).
'System.digit2_2404'(A,B,C,D):-makeShare(A,E),if_then_else(E<10,['\'0',chr(ord('\'0')+E)],show(E),B,C,D).

:- block 'List.nub'(?,?,-,?).
'List.nub'(A,B,C,D):-'List.nubBy'(==,A,B,C,D).

:- block 'List.nubBy'(?,?,?,-,?).
'List.nubBy'(A,B,C,D,E):-hnf(B,F,D,G),'List.nubBy_2'(F,A,C,G,E).

:- block 'List.nubBy_2'(?,?,?,-,?).
'List.nubBy_2'([],A,[],B,B).
'List.nubBy_2'([A|B],C,[D|'List.nubBy'(E,filter('List.list_lambda0_3110'(E,D),B))],F,F):-makeShare(A,D),makeShare(C,E).

:- block 'List.delete'(?,?,?,-,?).
'List.delete'(A,B,C,D,E):-hnf(B,F,D,G),'List.delete_2'(F,A,C,G,E).

:- block 'List.delete_2'(?,?,?,-,?).
'List.delete_2'([],A,[],B,B).
'List.delete_2'([A|B],C,D,E,F):-makeShare(C,G),makeShare(A,H),makeShare(B,I),if_then_else(G==H,I,[H|'List.delete'(G,I)],D,E,F).

:- block 'List.union'(?,?,?,-,?).
'List.union'(A,B,C,D,E):-hnf(A,F,D,G),'List.union_1'(F,B,C,G,E).

:- block 'List.union_1'(?,?,?,-,?).
'List.union_1'([],A,B,C,D):-hnf(A,B,C,D).
'List.union_1'([A|B],C,D,E,F):-makeShare(A,G),makeShare(C,H),makeShare(B,I),if_then_else(elem(G,H),'List.union'(I,H),[G|'List.union'(I,H)],D,E,F).

:- block 'List.intersect'(?,?,?,-,?).
'List.intersect'(A,B,C,D,E):-hnf(A,F,D,G),'List.intersect_1'(F,B,C,G,E).

:- block 'List.intersect_1'(?,?,?,-,?).
'List.intersect_1'([],A,[],B,B).
'List.intersect_1'([A|B],C,D,E,F):-makeShare(A,G),makeShare(C,H),makeShare(B,I),if_then_else(elem(G,H),[G|'List.intersect'(I,H)],'List.intersect'(I,H),D,E,F).

:- block 'List.intersperse'(?,?,?,-,?).
'List.intersperse'(A,B,C,D,E):-hnf(B,F,D,G),'List.intersperse_2'(F,A,C,G,E).

:- block 'List.intersperse_2'(?,?,?,-,?).
'List.intersperse_2'([],A,[],B,B).
'List.intersperse_2'([A|B],C,D,E,F):-hnf(B,G,E,H),'List.intersperse_2_._2'(G,A,C,D,H,F).

:- block 'List.intersperse_2_._2'(?,?,?,?,-,?).
'List.intersperse_2_._2'([],A,B,[A],C,C).
'List.intersperse_2_._2'([A|B],C,D,[C,E|'List.intersperse'(E,[A|B])],F,F):-makeShare(D,E).

:- block 'List.transpose'(?,?,-,?).
'List.transpose'(A,B,C,D):-hnf(A,E,C,F),'List.transpose_1'(E,B,F,D).

:- block 'List.transpose_1'(?,?,-,?).
'List.transpose_1'([],[],A,A).
'List.transpose_1'([A|B],C,D,E):-hnf(A,F,D,G),'List.transpose_1_._1'(F,B,C,G,E).

:- block 'List.transpose_1_._1'(?,?,?,-,?).
'List.transpose_1_._1'([],A,B,C,D):-'List.transpose'(A,B,C,D).
'List.transpose_1_._1'([A|B],C,[[A|map(head,D)]|'List.transpose'([B|map(tail,D)])],E,E):-makeShare(C,D).

:- block 'List.partition'(?,?,?,-,?).
'List.partition'(A,B,C,D,E):-foldr('List.select_2741'(A),'(,)'([],[]),B,C,D,E).

:- block 'List.group'(?,?,-,?).
'List.group'(A,B,C,D):-hnf(apply('List.groupBy'(==),A),B,C,D).

:- block 'List.groupBy'(?,?,?,-,?).
'List.groupBy'(A,B,C,D,E):-hnf(B,F,D,G),'List.groupBy_2'(F,A,C,G,E).

:- block 'List.groupBy_2'(?,?,?,-,?).
'List.groupBy_2'([],A,[],B,B).
'List.groupBy_2'([A|B],C,D,E,F):-makeShare(A,G),makeShare(C,H),'List.list_lambda1_3111'(G,H,span(apply(H,G),B),D,E,F).

:- block 'List.replace'(?,?,?,?,-,?).
'List.replace'(A,B,C,D,E,F):-hnf(C,G,E,H),'List.replace_3'(G,A,B,D,H,F).

:- block 'List.replace_3'(?,?,?,?,-,?).
'List.replace_3'([],A,B,[],C,C).
'List.replace_3'([A|B],C,D,E,F,G):-makeShare(D,H),makeShare(C,I),makeShare(B,J),if_then_else(H==0,[I|J],[A|'List.replace'(I,H-1,J)],E,F,G).

:- block 'List.isPrefixOf'(?,?,?,-,?).
'List.isPrefixOf'(A,B,C,D,E):-hnf(A,F,D,G),'List.isPrefixOf_1'(F,B,C,G,E).

:- block 'List.isPrefixOf_1'(?,?,?,-,?).
'List.isPrefixOf_1'([],A,'True',B,B).
'List.isPrefixOf_1'([A|B],C,D,E,F):-hnf(C,G,E,H),'List.isPrefixOf_1_._3'(G,A,B,D,H,F).

:- block 'List.isPrefixOf_1_._3'(?,?,?,?,-,?).
'List.isPrefixOf_1_._3'([],A,B,'False',C,C).
'List.isPrefixOf_1_._3'([A|B],C,D,E,F,G):- &&(C==A,'List.isPrefixOf'(D,B),E,F,G).

:- block 'List.sortBy'(?,?,?,-,?).
'List.sortBy'(A,B,C,D,E):-hnf(apply(foldr('List.insertBy'(A),[]),B),C,D,E).

:- block 'List.insertBy'(?,?,?,?,-,?).
'List.insertBy'(A,B,C,D,E,F):-hnf(C,G,E,H),'List.insertBy_3'(G,A,B,D,H,F).

:- block 'List.insertBy_3'(?,?,?,?,-,?).
'List.insertBy_3'([],A,B,[B],C,C).
'List.insertBy_3'([A|B],C,D,E,F,G):-makeShare(C,H),makeShare(D,I),makeShare(A,J),makeShare(B,K),if_then_else(apply(apply(H,I),J),[I,J|K],[J|'List.insertBy'(H,I,K)],E,F,G).

:- block 'List.last'(?,?,-,?).
'List.last'(A,B,C,D):-hnf(A,E,C,F),'List.last_1'(E,B,F,D).

:- block 'List.last_1'(?,?,-,?).
'List.last_1'([A|B],C,D,E):-hnf(B,F,D,G),'List.last_1_._2'(F,A,C,G,E).

:- block 'List.last_1_._2'(?,?,?,-,?).
'List.last_1_._2'([],A,B,C,D):-hnf(A,B,C,D).
'List.last_1_._2'([A|B],C,D,E,F):-'List.last'([A|B],D,E,F).

:- block 'List.list_lambda0_3110'(?,?,?,?,-,?).
'List.list_lambda0_3110'(A,B,C,D,E,F):-not(apply(apply(A,B),C),D,E,F).

:- block 'List.select_2741'(?,?,?,?,-,?).
'List.select_2741'(A,B,C,D,E,F):-hnf(C,G,E,H),'List.select_2741_3'(G,A,B,D,H,F).

:- block 'List.select_2741_3'(?,?,?,?,-,?).
'List.select_2741_3'('(,)'(A,B),C,D,E,F,G):-makeShare(D,H),makeShare(A,I),makeShare(B,J),if_then_else(apply(C,H),'(,)'([H|I],J),'(,)'(I,[H|J]),E,F,G).

:- block 'List.list_lambda1_3111'(?,?,?,?,-,?).
'List.list_lambda1_3111'(A,B,C,D,E,F):-hnf(C,G,E,H),'List.list_lambda1_3111_3'(G,A,B,D,H,F).

:- block 'List.list_lambda1_3111_3'(?,?,?,?,-,?).
'List.list_lambda1_3111_3'('(,)'(A,B),C,D,[[C|A]|'List.groupBy'(D,B)],E,E).

:- block 'Char.isUpper'(?,?,-,?).
'Char.isUpper'(A,B,C,D):-makeShare(A,E),&&(ord(E)>=ord('\'A'),<=(ord(E),ord('\'Z')),B,C,D).

:- block 'Char.isLower'(?,?,-,?).
'Char.isLower'(A,B,C,D):-makeShare(A,E),&&(ord(E)>=ord('\'a'),<=(ord(E),ord('\'z')),B,C,D).

:- block 'Char.isAlpha'(?,?,-,?).
'Char.isAlpha'(A,B,C,D):-makeShare(A,E),'||'('Char.isUpper'(E),'Char.isLower'(E),B,C,D).

:- block 'Char.isDigit'(?,?,-,?).
'Char.isDigit'(A,B,C,D):-makeShare(A,E),&&(<=(ord('\'0'),ord(E)),<=(ord(E),ord('\'9')),B,C,D).

:- block 'Char.isAlphaNum'(?,?,-,?).
'Char.isAlphaNum'(A,B,C,D):-makeShare(A,E),'||'('Char.isAlpha'(E),'Char.isDigit'(E),B,C,D).

:- block 'Char.isOctDigit'(?,?,-,?).
'Char.isOctDigit'(A,B,C,D):-makeShare(A,E),&&(ord(E)>=ord('\'0'),<=(ord(E),ord('\'7')),B,C,D).

:- block 'Char.isHexDigit'(?,?,-,?).
'Char.isHexDigit'(A,B,C,D):-makeShare(A,E),'||'('Char.isDigit'(E),'||'(&&(ord(E)>=ord('\'A'),<=(ord(E),ord('\'F'))),&&(ord(E)>=ord('\'a'),<=(ord(E),ord('\'f')))),B,C,D).

:- block 'Char.isSpace'(?,?,-,?).
'Char.isSpace'(A,B,C,D):-makeShare(A,E),'||'(E=='\' ','||'(E=='\'\t','||'(E=='\'\n','||'(E=='\'\r',ord(E)==12))),B,C,D).

:- block 'Char.toUpper'(?,?,-,?).
'Char.toUpper'(A,B,C,D):-makeShare(A,E),if_then_else('Char.isLower'(E),chr(ord(E)-ord('\'a')+ord('\'A')),E,B,C,D).

:- block 'Char.toLower'(?,?,-,?).
'Char.toLower'(A,B,C,D):-makeShare(A,E),if_then_else('Char.isUpper'(E),chr(ord(E)-ord('\'A')+ord('\'a')),E,B,C,D).

:- block 'Char.digitToInt'(?,?,-,?).
'Char.digitToInt'(A,B,C,D):-makeShare(A,E),if_then_else('Char.isDigit'(E),ord(E)-ord('\'0'),if_then_else(&&(ord(E)>=ord('\'A'),<=(ord(E),ord('\'F'))),ord(E)-ord('\'A')+10,if_then_else(&&(ord(E)>=ord('\'a'),<=(ord(E),ord('\'f'))),ord(E)-ord('\'a')+10,error(['\'C','\'h','\'a','\'r','\'.','\'d','\'i','\'g','\'i','\'t','\'T','\'o','\'I','\'n','\'t','\':','\' ','\'a','\'r','\'g','\'u','\'m','\'e','\'n','\'t','\' ','\'i','\'s','\' ','\'n','\'o','\'t','\' ','\'a','\' ','\'d','\'i','\'g','\'i','\'t']))),B,C,D).

:- block 'Char.intToDigit'(?,?,-,?).
'Char.intToDigit'(A,B,C,D):-makeShare(A,E),if_then_else(&&(E>=0,<=(E,9)),chr(ord('\'0')+E),if_then_else(&&(E>=10,<=(E,15)),chr(ord('\'A')+E-10),error(['\'C','\'h','\'a','\'r','\'.','\'i','\'n','\'t','\'T','\'o','\'D','\'i','\'g','\'i','\'t','\':','\' ','\'a','\'r','\'g','\'u','\'m','\'e','\'n','\'t','\' ','\'n','\'o','\'t','\' ','\'a','\' ','\'d','\'i','\'g','\'i','\'t','\' ','\'v','\'a','\'l','\'u','\'e'])),B,C,D).

:-block hnf(?,?,-,?).
hnf(A,B,C,C):-var(A),!,B=A.
hnf(share(A),B,C,D):-!,get_mutable(E,A),(E='$eval'(F)->B=F,C=D;hnf(E,G,C,D),(nonvar(G),(functor(G,'$io',1);functor(G,success,0))->B=G;propagateShare(G,B)),update_mutable('$eval'(B),A)).
hnf('OptFlat.optimizeFlatCurry'(A,B,C,D,E),F,G,H):-!,'OptFlat.optimizeFlatCurry'(A,B,C,D,E,F,G,H).
hnf('OptFlat.getStartingState'(A,B,C,D),E,F,G):-!,'OptFlat.getStartingState'(A,B,C,D,E,F,G).
hnf('OptFlat.makeOneFuncProg'(A,B),C,D,E):-!,'OptFlat.makeOneFuncProg'(A,B,C,D,E).
hnf('OptFlat.getFunc'(A,B),C,D,E):-!,'OptFlat.getFunc'(A,B,C,D,E).
hnf('OptFlat.getTrans'(A,B),C,D,E):-!,'OptFlat.getTrans'(A,B,C,D,E).
hnf('OptFlat.makeOptimizedFlatProg'(A,B,C),D,E,F):-!,'OptFlat.makeOptimizedFlatProg'(A,B,C,D,E,F).
hnf('OptFlat.optFuncDecls'(A,B),C,D,E):-!,'OptFlat.optFuncDecls'(A,B,C,D,E).
hnf('OptFlat.optFuncDecls\''(A,B,C),D,E,F):-!,'OptFlat.optFuncDecls\''(A,B,C,D,E,F).
hnf('OptFlat.lookupFuncCalls'(A,B,C,D),E,F,G):-!,'OptFlat.lookupFuncCalls'(A,B,C,D,E,F,G).
hnf('OptFlat.lookupFuncDeclInRest'(A,B),C,D,E):-!,'OptFlat.lookupFuncDeclInRest'(A,B,C,D,E).
hnf('OptFlat.getAllFuncCalls'(A),B,C,D):-!,'OptFlat.getAllFuncCalls'(A,B,C,D).
hnf('OptFlat.getAllFuncCallsOfExpr'(A),B,C,D):-!,'OptFlat.getAllFuncCallsOfExpr'(A,B,C,D).
hnf('OptFlat.getAllFuncCallsOfBranchExpr'(A),B,C,D):-!,'OptFlat.getAllFuncCallsOfBranchExpr'(A,B,C,D).
hnf('OptFlat.readAllImportedFlatProgs'(A,B,C),D,E,F):-!,'OptFlat.readAllImportedFlatProgs'(A,B,C,D,E,F).
hnf('OptFlat.readAllImportedFlatProgs\''(A,B,C,D),E,F,G):-!,'OptFlat.readAllImportedFlatProgs\''(A,B,C,D,E,F,G).
hnf('OptFlat.tryReadFlatCurry'(A,B,C),D,E,F):-!,'OptFlat.tryReadFlatCurry'(A,B,C,D,E,F).
hnf('OptFlat.getModname'(A),B,C,D):-!,'OptFlat.getModname'(A,B,C,D).
hnf('OptFlat.getImports'(A),B,C,D):-!,'OptFlat.getImports'(A,B,C,D).
hnf('OptFlat.getFuncDecls'(A),B,C,D):-!,'OptFlat.getFuncDecls'(A,B,C,D).
hnf('OptFlat.getFuncName'(A),B,C,D):-!,'OptFlat.getFuncName'(A,B,C,D).
hnf('OptFlat.getTransName'(A),B,C,D):-!,'OptFlat.getTransName'(A,B,C,D).
hnf('OptFlat.getInternalName'(A),B,C,D):-!,'OptFlat.getInternalName'(A,B,C,D).
hnf('OptFlat.mergeFlatProgList'(A),B,C,D):-!,'OptFlat.mergeFlatProgList'(A,B,C,D).
hnf('OptFlat.mergeFlatProgs'(A,B),C,D,E):-!,'OptFlat.mergeFlatProgs'(A,B,C,D,E).
hnf('OptFlat.leString'(A,B),C,D,E):-!,'OptFlat.leString'(A,B,C,D,E).
hnf('OptFlat.leChar'(A,B),C,D,E):-!,'OptFlat.leChar'(A,B,C,D,E).
hnf('OptFlat.leList'(A,B,C),D,E,F):-!,'OptFlat.leList'(A,B,C,D,E,F).
hnf('OptFlat.leFuncDecl'(A,B),C,D,E):-!,'OptFlat.leFuncDecl'(A,B,C,D,E).
hnf('OptFlat.list2SetRBT'(A,B),C,D,E):-!,'OptFlat.list2SetRBT'(A,B,C,D,E).
hnf('OptFlat.lambdafun_9659'(A,B,C,D,E,F),G,H,I):-!,'OptFlat.lambdafun_9659'(A,B,C,D,E,F,G,H,I).
hnf('OptFlat.optFlat_lambda1_9661'(A,B,C),D,E,F):-!,'OptFlat.optFlat_lambda1_9661'(A,B,C,D,E,F).
hnf('OptFlat.optFlat_lambda0_9662'(A,B,C,D),E,F,G):-!,'OptFlat.optFlat_lambda0_9662'(A,B,C,D,E,F,G).
hnf('OptFlat.lambdafun_9660'(A,B,C,D,E),F,G,H):-!,'OptFlat.lambdafun_9660'(A,B,C,D,E,F,G,H).
hnf('OptFlat.optFlat_lambda2_9663'(A,B,C,D,E),F,G,H):-!,'OptFlat.optFlat_lambda2_9663'(A,B,C,D,E,F,G,H).
hnf('OptFlat.optFlat_lambda3_9664'(A,B,C),D,E,F):-!,'OptFlat.optFlat_lambda3_9664'(A,B,C,D,E,F).
hnf('OptFlat.optFlat_lambda5_9665'(A,B,C),D,E,F):-!,'OptFlat.optFlat_lambda5_9665'(A,B,C,D,E,F).
hnf('OptFlat.optFlat_lambda4_9666'(A,B,C,D,E),F,G,H):-!,'OptFlat.optFlat_lambda4_9666'(A,B,C,D,E,F,G,H).
hnf('OptFlat.lambdafun_9667'(A,B),C,D,E):-!,'OptFlat.lambdafun_9667'(A,B,C,D,E).
hnf('OptFlat.lambdafun_9668'(A,B),C,D,E):-!,'OptFlat.lambdafun_9668'(A,B,C,D,E).
hnf('OptFlat.lambdafun_9669'(A,B,C),D,E,F):-!,'OptFlat.lambdafun_9669'(A,B,C,D,E,F).
hnf('OptFlat.lambdafun_9670'(A,B,C,D,E,F),G,H,I):-!,'OptFlat.lambdafun_9670'(A,B,C,D,E,F,G,H,I).
hnf('prelude..'(A,B,C),D,E,F):-!,'prelude..'(A,B,C,D,E,F).
hnf(id(A),B,C,D):-!,id(A,B,C,D).
hnf(const(A,B),C,D,E):-!,const(A,B,C,D,E).
hnf(curry(A,B,C),D,E,F):-!,curry(A,B,C,D,E,F).
hnf(uncurry(A,B),C,D,E):-!,uncurry(A,B,C,D,E).
hnf(flip(A,B,C),D,E,F):-!,flip(A,B,C,D,E,F).
hnf(until(A,B,C),D,E,F):-!,until(A,B,C,D,E,F).
hnf($(A,B),C,D,E):-!,$(A,B,C,D,E).
hnf('$!'(A,B),C,D,E):-!,'$!'(A,B,C,D,E).
hnf(failed,A,B,C):-!,failed(A,B,C).
hnf(&&(A,B),C,D,E):-!,&&(A,B,C,D,E).
hnf('||'(A,B),C,D,E):-!,'||'(A,B,C,D,E).
hnf(not(A),B,C,D):-!,not(A,B,C,D).
hnf(otherwise,A,B,C):-!,otherwise(A,B,C).
hnf(if_then_else(A,B,C),D,E,F):-!,if_then_else(A,B,C,D,E,F).
hnf(/=(A,B),C,D,E):-!,/=(A,B,C,D,E).
hnf(fst(A),B,C,D):-!,fst(A,B,C,D).
hnf(snd(A),B,C,D):-!,snd(A,B,C,D).
hnf(head(A),B,C,D):-!,head(A,B,C,D).
hnf(tail(A),B,C,D):-!,tail(A,B,C,D).
hnf(null(A),B,C,D):-!,null(A,B,C,D).
hnf(++(A,B),C,D,E):-!,++(A,B,C,D,E).
hnf(length(A),B,C,D):-!,length(A,B,C,D).
hnf('!!'(A,B),C,D,E):-!,'!!'(A,B,C,D,E).
hnf(map(A,B),C,D,E):-!,map(A,B,C,D,E).
hnf(foldl(A,B,C),D,E,F):-!,foldl(A,B,C,D,E,F).
hnf(foldl1(A,B),C,D,E):-!,foldl1(A,B,C,D,E).
hnf(foldr(A,B,C),D,E,F):-!,foldr(A,B,C,D,E,F).
hnf(foldr1(A,B),C,D,E):-!,foldr1(A,B,C,D,E).
hnf(filter(A,B),C,D,E):-!,filter(A,B,C,D,E).
hnf(zip(A,B),C,D,E):-!,zip(A,B,C,D,E).
hnf(zip3(A,B,C),D,E,F):-!,zip3(A,B,C,D,E,F).
hnf(zipWith(A,B,C),D,E,F):-!,zipWith(A,B,C,D,E,F).
hnf(zipWith3(A,B,C,D),E,F,G):-!,zipWith3(A,B,C,D,E,F,G).
hnf(unzip(A),B,C,D):-!,unzip(A,B,C,D).
hnf(unzip3(A),B,C,D):-!,unzip3(A,B,C,D).
hnf(concat(A),B,C,D):-!,concat(A,B,C,D).
hnf(concatMap(A,B),C,D,E):-!,concatMap(A,B,C,D,E).
hnf(iterate(A,B),C,D,E):-!,iterate(A,B,C,D,E).
hnf(repeat(A),B,C,D):-!,repeat(A,B,C,D).
hnf(replicate(A,B),C,D,E):-!,replicate(A,B,C,D,E).
hnf(take(A,B),C,D,E):-!,take(A,B,C,D,E).
hnf(drop(A,B),C,D,E):-!,drop(A,B,C,D,E).
hnf(splitAt(A,B),C,D,E):-!,splitAt(A,B,C,D,E).
hnf(takeWhile(A,B),C,D,E):-!,takeWhile(A,B,C,D,E).
hnf(dropWhile(A,B),C,D,E):-!,dropWhile(A,B,C,D,E).
hnf(span(A,B),C,D,E):-!,span(A,B,C,D,E).
hnf(break(A,B),C,D,E):-!,break(A,B,C,D,E).
hnf(lines(A),B,C,D):-!,lines(A,B,C,D).
hnf(unlines(A),B,C,D):-!,unlines(A,B,C,D).
hnf(words(A),B,C,D):-!,words(A,B,C,D).
hnf(unwords(A),B,C,D):-!,unwords(A,B,C,D).
hnf(reverse(A),B,C,D):-!,reverse(A,B,C,D).
hnf(and(A),B,C,D):-!,and(A,B,C,D).
hnf(or(A),B,C,D):-!,or(A,B,C,D).
hnf(any(A,B),C,D,E):-!,any(A,B,C,D,E).
hnf(all(A,B),C,D,E):-!,all(A,B,C,D,E).
hnf(elem(A,B),C,D,E):-!,elem(A,B,C,D,E).
hnf(notElem(A,B),C,D,E):-!,notElem(A,B,C,D,E).
hnf(lookup(A,B),C,D,E):-!,lookup(A,B,C,D,E).
hnf(enumFrom(A),B,C,D):-!,enumFrom(A,B,C,D).
hnf(enumFromThen(A,B),C,D,E):-!,enumFromThen(A,B,C,D,E).
hnf(enumFromTo(A,B),C,D,E):-!,enumFromTo(A,B,C,D,E).
hnf(enumFromThenTo(A,B,C),D,E,F):-!,enumFromThenTo(A,B,C,D,E,F).
hnf(&>(A,B),C,D,E):-!,&>(A,B,C,D,E).
hnf(maybe(A,B,C),D,E,F):-!,maybe(A,B,C,D,E,F).
hnf(either(A,B,C),D,E,F):-!,either(A,B,C,D,E,F).
hnf(done(A),B,C,D):-!,done(A,B,C,D).
hnf(putStr(A,B),C,D,E):-!,putStr(A,B,C,D,E).
hnf(putStrLn(A,B),C,D,E):-!,putStrLn(A,B,C,D,E).
hnf(getLine(A),B,C,D):-!,getLine(A,B,C,D).
hnf(print(A,B),C,D,E):-!,print(A,B,C,D,E).
hnf(doSolve(A,B),C,D,E):-!,doSolve(A,B,C,D,E).
hnf(sequenceIO(A,B),C,D,E):-!,sequenceIO(A,B,C,D,E).
hnf(sequenceIO_(A,B),C,D,E):-!,sequenceIO_(A,B,C,D,E).
hnf(mapIO(A,B,C),D,E,F):-!,mapIO(A,B,C,D,E,F).
hnf(mapIO_(A,B,C),D,E,F):-!,mapIO_(A,B,C,D,E,F).
hnf(inject(A,B,C),D,E,F):-!,inject(A,B,C,D,E,F).
hnf(solveAll(A),B,C,D):-!,solveAll(A,B,C,D).
hnf(solveAll2(A),B,C,D):-!,solveAll2(A,B,C,D).
hnf(once(A,B),C,D,E):-!,once(A,B,C,D,E).
hnf(one(A),B,C,D):-!,one(A,B,C,D).
hnf(condSearch(A,B),C,D,E):-!,condSearch(A,B,C,D,E).
hnf(best(A,B),C,D,E):-!,best(A,B,C,D,E).
hnf(browse(A,B),C,D,E):-!,browse(A,B,C,D,E).
hnf(browseList(A,B),C,D,E):-!,browseList(A,B,C,D,E).
hnf(unpack(A),B,C,D):-!,unpack(A,B,C,D).
hnf('PEVAL'(A),B,C,D):-!,'PEVAL'(A,B,C,D).
hnf(prelude_lambda0_1997(A,B,C),D,E,F):-!,prelude_lambda0_1997(A,B,C,D,E,F).
hnf(prelude_lambda1_1998(A,B,C),D,E,F):-!,prelude_lambda1_1998(A,B,C,D,E,F).
hnf(prelude_lambda2_1999(A,B,C,D),E,F,G):-!,prelude_lambda2_1999(A,B,C,D,E,F,G).
hnf(takep_452(A,B),C,D,E):-!,takep_452(A,B,C,D,E).
hnf(dropp_459(A,B),C,D,E):-!,dropp_459(A,B,C,D,E).
hnf(splitAtp_466(A,B),C,D,E):-!,splitAtp_466(A,B,C,D,E).
hnf(prelude_lambda3_2000(A,B),C,D,E):-!,prelude_lambda3_2000(A,B,C,D,E).
hnf(prelude_lambda4_2001(A,B),C,D,E):-!,prelude_lambda4_2001(A,B,C,D,E).
hnf(splitline_490(A),B,C,D):-!,splitline_490(A,B,C,D).
hnf(prelude_lambda5_2002(A,B),C,D,E):-!,prelude_lambda5_2002(A,B,C,D,E).
hnf(prelude_lambda6_2003(A),B,C,D):-!,prelude_lambda6_2003(A,B,C,D).
hnf(prelude_lambda7_2004(A),B,C,D):-!,prelude_lambda7_2004(A,B,C,D).
hnf(isSpace_500(A),B,C,D):-!,isSpace_500(A,B,C,D).
hnf(prelude_lambda9_2005(A),B,C,D):-!,prelude_lambda9_2005(A,B,C,D).
hnf(prelude_lambda8_2006(A),B,C,D):-!,prelude_lambda8_2006(A,B,C,D).
hnf(prelude_lambda10_2007(A,B),C,D,E):-!,prelude_lambda10_2007(A,B,C,D,E).
hnf(prelude_lambda11_2008(A,B),C,D,E):-!,prelude_lambda11_2008(A,B,C,D,E).
hnf(prelude_lambda12_2009(A,B),C,D,E):-!,prelude_lambda12_2009(A,B,C,D,E).
hnf(prelude_lambda13_2010(A,B,C),D,E,F):-!,prelude_lambda13_2010(A,B,C,D,E,F).
hnf(p_528(A,B,C,D),E,F,G):-!,p_528(A,B,C,D,E,F,G).
hnf(prelude_lambda14_2011(A,B,C),D,E,F):-!,prelude_lambda14_2011(A,B,C,D,E,F).
hnf(lambdafun_2012(A,B),C,D,E):-!,lambdafun_2012(A,B,C,D,E).
hnf(lambdafun_2013(A,B,C),D,E,F):-!,lambdafun_2013(A,B,C,D,E,F).
hnf(lambdafun_2014(A,B,C),D,E,F):-!,lambdafun_2014(A,B,C,D,E,F).
hnf(lambdafun_2015(A,B,C),D,E,F):-!,lambdafun_2015(A,B,C,D,E,F).
hnf(prelude_lambda15_2016(A,B,C),D,E,F):-!,prelude_lambda15_2016(A,B,C,D,E,F).
hnf(evalall_563(A),B,C,D):-!,evalall_563(A,B,C,D).
hnf(evalall2_564(A),B,C,D):-!,evalall2_564(A,B,C,D).
hnf(evalall3_565(A,B),C,D,E):-!,evalall3_565(A,B,C,D,E).
hnf(evalResult_580(A),B,C,D):-!,evalResult_580(A,B,C,D).
hnf(prelude_lambda16_2017(A,B),C,D,E):-!,prelude_lambda16_2017(A,B,C,D,E).
hnf(prelude_lambda17_2018(A,B,C),D,E,F):-!,prelude_lambda17_2018(A,B,C,D,E,F).
hnf(bestHelp_595(A,B,C,D),E,F,G):-!,bestHelp_595(A,B,C,D,E,F,G).
hnf(evalY_596(A,B,C,D),E,F,G):-!,evalY_596(A,B,C,D,E,F,G).
hnf(evalX_597(A,B,C,D,E),F,G,H):-!,evalX_597(A,B,C,D,E,F,G,H).
hnf(evalA_598(A,B,C,D,E),F,G,H):-!,evalA_598(A,B,C,D,E,F,G,H).
hnf(constrain_599(A,B,C,D),E,F,G):-!,constrain_599(A,B,C,D,E,F,G).
hnf(prelude_lambda18_2019(A,B,C),D,E,F):-!,prelude_lambda18_2019(A,B,C,D,E,F).
hnf('Flat.readFlatCurry'(A,B),C,D,E):-!,'Flat.readFlatCurry'(A,B,C,D,E).
hnf('Flat.readFlatCurryWithParseOptions'(A,B,C),D,E,F):-!,'Flat.readFlatCurryWithParseOptions'(A,B,C,D,E,F).
hnf('Flat.splitFlatModName'(A),B,C,D):-!,'Flat.splitFlatModName'(A,B,C,D).
hnf('Flat.lambdafun_2843'(A,B,C,D,E),F,G,H):-!,'Flat.lambdafun_2843'(A,B,C,D,E,F,G,H).
hnf('Flat.lambdafun_2845'(A,B,C,D),E,F,G):-!,'Flat.lambdafun_2845'(A,B,C,D,E,F,G).
hnf('Flat.lambdafun_2844'(A,B,C,D),E,F,G):-!,'Flat.lambdafun_2844'(A,B,C,D,E,F,G).
hnf('Flat.flat_lambda0_2846'(A,B),C,D,E):-!,'Flat.flat_lambda0_2846'(A,B,C,D,E).
hnf('Flat.flat_lambda1_2847'(A),B,C,D):-!,'Flat.flat_lambda1_2847'(A,B,C,D).
hnf('FlatTools.showFlatProg'(A),B,C,D):-!,'FlatTools.showFlatProg'(A,B,C,D).
hnf('FlatTools.flatShowFixity'(A),B,C,D):-!,'FlatTools.flatShowFixity'(A,B,C,D).
hnf('FlatTools.flatShowOp'(A),B,C,D):-!,'FlatTools.flatShowOp'(A,B,C,D).
hnf('FlatTools.flatShowType'(A),B,C,D):-!,'FlatTools.flatShowType'(A,B,C,D).
hnf('FlatTools.flatShowCons'(A),B,C,D):-!,'FlatTools.flatShowCons'(A,B,C,D).
hnf('FlatTools.flatShowFunc'(A),B,C,D):-!,'FlatTools.flatShowFunc'(A,B,C,D).
hnf('FlatTools.flatShowRule'(A),B,C,D):-!,'FlatTools.flatShowRule'(A,B,C,D).
hnf('FlatTools.flatShowTypeExpr'(A),B,C,D):-!,'FlatTools.flatShowTypeExpr'(A,B,C,D).
hnf('FlatTools.flatShowExpr'(A),B,C,D):-!,'FlatTools.flatShowExpr'(A,B,C,D).
hnf('FlatTools.flatShowLit'(A),B,C,D):-!,'FlatTools.flatShowLit'(A,B,C,D).
hnf('FlatTools.flatShowBranch'(A),B,C,D):-!,'FlatTools.flatShowBranch'(A,B,C,D).
hnf('FlatTools.flatShowPattern'(A),B,C,D):-!,'FlatTools.flatShowPattern'(A,B,C,D).
hnf('FlatTools.flatShowTrans'(A),B,C,D):-!,'FlatTools.flatShowTrans'(A,B,C,D).
hnf('FlatTools.flatShowList'(A,B),C,D,E):-!,'FlatTools.flatShowList'(A,B,C,D,E).
hnf('FlatTools.flatShowListElems'(A,B),C,D,E):-!,'FlatTools.flatShowListElems'(A,B,C,D,E).
hnf('FlatTools.flatShowString'(A),B,C,D):-!,'FlatTools.flatShowString'(A,B,C,D).
hnf('FlatTools.showCurryType'(A,B,C),D,E,F):-!,'FlatTools.showCurryType'(A,B,C,D,E,F).
hnf('FlatTools.isFuncType'(A),B,C,D):-!,'FlatTools.isFuncType'(A,B,C,D).
hnf('FlatTools.showCurryExpr'(A,B,C,D),E,F,G):-!,'FlatTools.showCurryExpr'(A,B,C,D,E,F,G).
hnf('FlatTools.showCurryVar'(A),B,C,D):-!,'FlatTools.showCurryVar'(A,B,C,D).
hnf('FlatTools.showCurryLit'(A),B,C,D):-!,'FlatTools.showCurryLit'(A,B,C,D).
hnf('FlatTools.showCurryCase'(A,B,C),D,E,F):-!,'FlatTools.showCurryCase'(A,B,C,D,E,F).
hnf('FlatTools.showCurryFiniteList'(A,B,C),D,E,F):-!,'FlatTools.showCurryFiniteList'(A,B,C,D,E,F).
hnf('FlatTools.showCurryElems'(A,B),C,D,E):-!,'FlatTools.showCurryElems'(A,B,C,D,E).
hnf('FlatTools.maybeShowBrackets'(A,B),C,D,E):-!,'FlatTools.maybeShowBrackets'(A,B,C,D,E).
hnf('FlatTools.sceBlanks'(A),B,C,D):-!,'FlatTools.sceBlanks'(A,B,C,D).
hnf('FlatTools.isFiniteList'(A),B,C,D):-!,'FlatTools.isFiniteList'(A,B,C,D).
hnf('FlatTools.writeFLC'(A,B,C),D,E,F):-!,'FlatTools.writeFLC'(A,B,C,D,E,F).
hnf('FlatTools.showFlcProg'(A),B,C,D):-!,'FlatTools.showFlcProg'(A,B,C,D).
hnf('FlatTools.flcShowOp'(A),B,C,D):-!,'FlatTools.flcShowOp'(A,B,C,D).
hnf('FlatTools.flcShowFixity'(A),B,C,D):-!,'FlatTools.flcShowFixity'(A,B,C,D).
hnf('FlatTools.flcShowType'(A),B,C,D):-!,'FlatTools.flcShowType'(A,B,C,D).
hnf('FlatTools.flcShowCons'(A),B,C,D):-!,'FlatTools.flcShowCons'(A,B,C,D).
hnf('FlatTools.flcShowFunc'(A),B,C,D):-!,'FlatTools.flcShowFunc'(A,B,C,D).
hnf('FlatTools.flcShowRule'(A),B,C,D):-!,'FlatTools.flcShowRule'(A,B,C,D).
hnf('FlatTools.flcShowTypeExpr'(A),B,C,D):-!,'FlatTools.flcShowTypeExpr'(A,B,C,D).
hnf('FlatTools.flcShowCombType'(A),B,C,D):-!,'FlatTools.flcShowCombType'(A,B,C,D).
hnf('FlatTools.flcShowExpr'(A),B,C,D):-!,'FlatTools.flcShowExpr'(A,B,C,D).
hnf('FlatTools.flcShowLit'(A),B,C,D):-!,'FlatTools.flcShowLit'(A,B,C,D).
hnf('FlatTools.flcShowBranch'(A),B,C,D):-!,'FlatTools.flcShowBranch'(A,B,C,D).
hnf('FlatTools.flcShowTrans'(A),B,C,D):-!,'FlatTools.flcShowTrans'(A,B,C,D).
hnf('FlatTools.flcShowList'(A,B),C,D,E):-!,'FlatTools.flcShowList'(A,B,C,D,E).
hnf('FlatTools.flcShowListElems'(A,B),C,D,E):-!,'FlatTools.flcShowListElems'(A,B,C,D,E).
hnf('FlatTools.flcShowString'(A),B,C,D):-!,'FlatTools.flcShowString'(A,B,C,D).
hnf('FlatTools.ppshow'(A,B),C,D,E):-!,'FlatTools.ppshow'(A,B,C,D,E).
hnf('FlatTools.pptest'(A,B),C,D,E):-!,'FlatTools.pptest'(A,B,C,D,E).
hnf('FlatTools.flcshow'(A,B),C,D,E):-!,'FlatTools.flcshow'(A,B,C,D,E).
hnf('FlatTools.flctest'(A,B),C,D,E):-!,'FlatTools.flctest'(A,B,C,D,E).
hnf('FlatTools.showPattern_3583'(A,B),C,D,E):-!,'FlatTools.showPattern_3583'(A,B,C,D,E).
hnf('FlatTools.lambdafun_6063'(A,B),C,D,E):-!,'FlatTools.lambdafun_6063'(A,B,C,D,E).
hnf('FlatTools.lambdafun_6064'(A,B),C,D,E):-!,'FlatTools.lambdafun_6064'(A,B,C,D,E).
hnf('SetRBT2.emptySetRBT'(A),B,C,D):-!,'SetRBT2.emptySetRBT'(A,B,C,D).
hnf('SetRBT2.elemRBT'(A,B),C,D,E):-!,'SetRBT2.elemRBT'(A,B,C,D,E).
hnf('SetRBT2.elemRBTree'(A,B,C),D,E,F):-!,'SetRBT2.elemRBTree'(A,B,C,D,E,F).
hnf('SetRBT2.insertRBT'(A,B),C,D,E):-!,'SetRBT2.insertRBT'(A,B,C,D,E).
hnf('SetRBT2.insertRBTree'(A,B,C),D,E,F):-!,'SetRBT2.insertRBTree'(A,B,C,D,E,F).
hnf('SetRBT2.insertMultiRBT'(A,B),C,D,E):-!,'SetRBT2.insertMultiRBT'(A,B,C,D,E).
hnf('SetRBT2.insertMultiRBTree'(A,B,C),D,E,F):-!,'SetRBT2.insertMultiRBTree'(A,B,C,D,E,F).
hnf('SetRBT2.setRBT2list'(A),B,C,D):-!,'SetRBT2.setRBT2list'(A,B,C,D).
hnf('SetRBT2.unionRBT'(A,B),C,D,E):-!,'SetRBT2.unionRBT'(A,B,C,D,E).
hnf('SetRBT2.intersectRBT'(A,B),C,D,E):-!,'SetRBT2.intersectRBT'(A,B,C,D,E).
hnf('SetRBT2.sortRBT'(A,B),C,D,E):-!,'SetRBT2.sortRBT'(A,B,C,D,E).
hnf('SetRBT2.rbsBalance'(A),B,C,D):-!,'SetRBT2.rbsBalance'(A,B,C,D).
hnf('SetRBT2.rbsBalanceL'(A),B,C,D):-!,'SetRBT2.rbsBalanceL'(A,B,C,D).
hnf('SetRBT2.rbsBalanceR'(A),B,C,D):-!,'SetRBT2.rbsBalanceR'(A,B,C,D).
hnf('SetRBT2.ins_6383'(A,B,C),D,E,F):-!,'SetRBT2.ins_6383'(A,B,C,D,E,F).
hnf('SetRBT2.setRBT2_lambda0_7386'(A),B,C,D):-!,'SetRBT2.setRBT2_lambda0_7386'(A,B,C,D).
hnf('SetRBT2.ins_6398'(A,B,C),D,E,F):-!,'SetRBT2.ins_6398'(A,B,C,D,E,F).
hnf('SetRBT2.setRBT2_lambda1_7387'(A),B,C,D):-!,'SetRBT2.setRBT2_lambda1_7387'(A,B,C,D).
hnf('SetRBT2.s2l_6409'(A,B),C,D,E):-!,'SetRBT2.s2l_6409'(A,B,C,D,E).
hnf('SetRBT2.setRBT2_lambda3_7388'(A,B),C,D,E):-!,'SetRBT2.setRBT2_lambda3_7388'(A,B,C,D,E).
hnf('SetRBT2.setRBT2_lambda2_7389'(A,B,C),D,E,F):-!,'SetRBT2.setRBT2_lambda2_7389'(A,B,C,D,E,F).
hnf('SetRBT2.setRBT2_lambda4_7390'(A,B,C,D,E),F,G,H):-!,'SetRBT2.setRBT2_lambda4_7390'(A,B,C,D,E,F,G,H).
hnf('TableRBT2.emptyTableRBT'(A),B,C,D):-!,'TableRBT2.emptyTableRBT'(A,B,C,D).
hnf('TableRBT2.lookupRBT'(A,B),C,D,E):-!,'TableRBT2.lookupRBT'(A,B,C,D,E).
hnf('TableRBT2.lookupRBTree'(A,B,C),D,E,F):-!,'TableRBT2.lookupRBTree'(A,B,C,D,E,F).
hnf('TableRBT2.updateRBT'(A,B,C),D,E,F):-!,'TableRBT2.updateRBT'(A,B,C,D,E,F).
hnf('TableRBT2.updateRBTree'(A,B,C,D),E,F,G):-!,'TableRBT2.updateRBTree'(A,B,C,D,E,F,G).
hnf('TableRBT2.tableRBT2list'(A),B,C,D):-!,'TableRBT2.tableRBT2list'(A,B,C,D).
hnf('TableRBT2.rbtBalance'(A),B,C,D):-!,'TableRBT2.rbtBalance'(A,B,C,D).
hnf('TableRBT2.rbtBalanceL'(A),B,C,D):-!,'TableRBT2.rbtBalanceL'(A,B,C,D).
hnf('TableRBT2.rbtBalanceR'(A),B,C,D):-!,'TableRBT2.rbtBalanceR'(A,B,C,D).
hnf('TableRBT2.ins_7577'(A,B,C,D),E,F,G):-!,'TableRBT2.ins_7577'(A,B,C,D,E,F,G).
hnf('TableRBT2.tableRBT2_lambda0_8750'(A),B,C,D):-!,'TableRBT2.tableRBT2_lambda0_8750'(A,B,C,D).
hnf('TableRBT2.t2l_7590'(A,B),C,D,E):-!,'TableRBT2.t2l_7590'(A,B,C,D,E).
hnf('TableRBT2.tableRBT2_lambda1_8751'(A,B,C,D,E,F),G,H,I):-!,'TableRBT2.tableRBT2_lambda1_8751'(A,B,C,D,E,F,G,H,I).
hnf('System.showDate'(A),B,C,D):-!,'System.showDate'(A,B,C,D).
hnf('System.digit2_2404'(A),B,C,D):-!,'System.digit2_2404'(A,B,C,D).
hnf('List.nub'(A),B,C,D):-!,'List.nub'(A,B,C,D).
hnf('List.nubBy'(A,B),C,D,E):-!,'List.nubBy'(A,B,C,D,E).
hnf('List.delete'(A,B),C,D,E):-!,'List.delete'(A,B,C,D,E).
hnf('List.union'(A,B),C,D,E):-!,'List.union'(A,B,C,D,E).
hnf('List.intersect'(A,B),C,D,E):-!,'List.intersect'(A,B,C,D,E).
hnf('List.intersperse'(A,B),C,D,E):-!,'List.intersperse'(A,B,C,D,E).
hnf('List.transpose'(A),B,C,D):-!,'List.transpose'(A,B,C,D).
hnf('List.partition'(A,B),C,D,E):-!,'List.partition'(A,B,C,D,E).
hnf('List.group'(A),B,C,D):-!,'List.group'(A,B,C,D).
hnf('List.groupBy'(A,B),C,D,E):-!,'List.groupBy'(A,B,C,D,E).
hnf('List.replace'(A,B,C),D,E,F):-!,'List.replace'(A,B,C,D,E,F).
hnf('List.isPrefixOf'(A,B),C,D,E):-!,'List.isPrefixOf'(A,B,C,D,E).
hnf('List.sortBy'(A,B),C,D,E):-!,'List.sortBy'(A,B,C,D,E).
hnf('List.insertBy'(A,B,C),D,E,F):-!,'List.insertBy'(A,B,C,D,E,F).
hnf('List.last'(A),B,C,D):-!,'List.last'(A,B,C,D).
hnf('List.list_lambda0_3110'(A,B,C),D,E,F):-!,'List.list_lambda0_3110'(A,B,C,D,E,F).
hnf('List.select_2741'(A,B,C),D,E,F):-!,'List.select_2741'(A,B,C,D,E,F).
hnf('List.list_lambda1_3111'(A,B,C),D,E,F):-!,'List.list_lambda1_3111'(A,B,C,D,E,F).
hnf('Char.isUpper'(A),B,C,D):-!,'Char.isUpper'(A,B,C,D).
hnf('Char.isLower'(A),B,C,D):-!,'Char.isLower'(A,B,C,D).
hnf('Char.isAlpha'(A),B,C,D):-!,'Char.isAlpha'(A,B,C,D).
hnf('Char.isDigit'(A),B,C,D):-!,'Char.isDigit'(A,B,C,D).
hnf('Char.isAlphaNum'(A),B,C,D):-!,'Char.isAlphaNum'(A,B,C,D).
hnf('Char.isOctDigit'(A),B,C,D):-!,'Char.isOctDigit'(A,B,C,D).
hnf('Char.isHexDigit'(A),B,C,D):-!,'Char.isHexDigit'(A,B,C,D).
hnf('Char.isSpace'(A),B,C,D):-!,'Char.isSpace'(A,B,C,D).
hnf('Char.toUpper'(A),B,C,D):-!,'Char.toUpper'(A,B,C,D).
hnf('Char.toLower'(A),B,C,D):-!,'Char.toLower'(A,B,C,D).
hnf('Char.digitToInt'(A),B,C,D):-!,'Char.digitToInt'(A,B,C,D).
hnf('Char.intToDigit'(A),B,C,D):-!,'Char.intToDigit'(A,B,C,D).
hnf(A+B,C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),'prim_+'(F,H,C,I,E).
hnf(A-B,C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),'prim_-'(F,H,C,I,E).
hnf(A*B,C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),'prim_*'(F,H,C,I,E).
hnf(div(A,B),C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),prim_div(F,H,C,I,E).
hnf(A mod B,C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),prim_mod(F,H,C,I,E).
hnf(A<B,C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),'prim_<'(F,H,C,I,E).
hnf(A>B,C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),'prim_>'(F,H,C,I,E).
hnf(<=(A,B),C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),'prim_<='(F,H,C,I,E).
hnf(A>=B,C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),'prim_>='(F,H,C,I,E).
hnf(ord(A),B,C,D):-!,hnf(A,E,C,F),prim_ord(E,B,F,D).
hnf(chr(A),B,C,D):-!,hnf(A,E,C,F),prim_chr(E,B,F,D).
hnf(>>=(A,B,C),D,E,F):-!,hnf(A,G,E,H),'prim_>>='(G,B,C,D,H,F).
hnf(>>(A,B,C),D,E,F):-!,hnf(A,G,E,H),'prim_>>'(G,B,C,D,H,F).
hnf(putChar(A,B),C,D,E):-!,hnf(A,F,D,G),prim_putChar(F,B,C,G,E).
hnf(getChar(A),B,C,D):-!,prim_getChar(A,B,C,D).
hnf(return(A,B),C,D,E):-!,prim_return(A,B,C,D,E).
hnf(readFile(A,B),C,D,E):-!,nf(A,F,D,G),boolEq(F,F,H,G,I),prim_readFile(F,B,C,I,E).
hnf('#readFileContents'(A,B),C,D,E):-!,'prim_#readFileContents'(A,B,C,D,E).
hnf(writeFile(A,B,C),D,E,F):-!,nf(A,G,E,H),boolEq(G,G,I,H,J),prim_writeFile(G,B,C,D,J,F).
hnf(appendFile(A,B,C),D,E,F):-!,nf(A,G,E,H),boolEq(G,G,I,H,J),prim_appendFile(G,B,C,D,J,F).
hnf('#writeFileContents'(A,B,C),D,E,F):-!,hnf(B,G,E,H),'prim_#writeFileContents'(A,G,C,D,H,F).
hnf(catchFail(A,B,C),D,E,F):-!,prim_catchFail(A,B,C,D,E,F).
hnf(findall(A),B,C,D):-!,hnf(A,E,C,F),prim_findall(E,B,F,D).
hnf(findfirst(A),B,C,D):-!,hnf(A,E,C,F),prim_findfirst(E,B,F,D).
hnf(show(A),B,C,D):-!,nf(A,E,C,F),boolEq(E,E,G,F,H),prim_show(E,B,H,D).
hnf(seq(A,B),C,D,E):-!,hnf(A,F,D,G),prim_seq(F,B,C,G,E).
hnf(error(A),B,C,D):-!,nf(A,E,C,F),boolEq(E,E,G,F,H),prim_error(E,B,H,D).
hnf('Unsafe.unsafePerformIO'(A),B,C,D):-!,hnf(A,E,C,F),'prim_Unsafe.unsafePerformIO'(E,B,F,D).
hnf('Unsafe.isVar'(A),B,C,D):-!,hnf(A,E,C,F),'prim_Unsafe.isVar'(E,B,F,D).
hnf('Unsafe.spawnConstraint'(A,B),C,D,E):-!,'prim_Unsafe.spawnConstraint'(A,B,C,D,E).
hnf('AbsCurry.readCurryFile'(A,B),C,D,E):-!,nf(A,F,D,G),boolEq(F,F,H,G,I),'prim_AbsCurry.readCurryFile'(F,B,C,I,E).
hnf('Flat.readFlatCurryFile'(A,B),C,D,E):-!,nf(A,F,D,G),boolEq(F,F,H,G,I),'prim_Flat.readFlatCurryFile'(F,B,C,I,E).
hnf('FlatCurry.readFlatCurryFile'(A,B),C,D,E):-!,nf(A,F,D,G),boolEq(F,F,H,G,I),'prim_FlatCurry.readFlatCurryFile'(F,B,C,I,E).
hnf('System.getCPUTime'(A),B,C,D):-!,'prim_System.getCPUTime'(A,B,C,D).
hnf('System.getElapsedTime'(A),B,C,D):-!,'prim_System.getElapsedTime'(A,B,C,D).
hnf('System.getDate'(A),B,C,D):-!,'prim_System.getDate'(A,B,C,D).
hnf('System.getArgs'(A),B,C,D):-!,'prim_System.getArgs'(A,B,C,D).
hnf('System.getEnviron'(A,B),C,D,E):-!,nf(A,F,D,G),boolEq(F,F,H,G,I),'prim_System.getEnviron'(F,B,C,I,E).
hnf('System.getHostname'(A),B,C,D):-!,'prim_System.getHostname'(A,B,C,D).
hnf('System.getPID'(A),B,C,D):-!,'prim_System.getPID'(A,B,C,D).
hnf('System.system'(A,B),C,D,E):-!,nf(A,F,D,G),boolEq(F,F,H,G,I),'prim_System.system'(F,B,C,I,E).
hnf('System.sleep'(A,B),C,D,E):-!,nf(A,F,D,G),boolEq(F,F,H,G,I),'prim_System.sleep'(F,B,C,I,E).
hnf('System.evalTime'(A),B,C,D):-!,'prim_System.evalTime'(A,B,C,D).
hnf('System.evalSpace'(A),B,C,D):-!,'prim_System.evalSpace'(A,B,C,D).
hnf('IOExts.setAssoc'(A,B,C),D,E,F):-!,nf(A,G,E,H),boolEq(G,G,I,H,J),nf(B,K,J,L),boolEq(K,K,M,L,N),'prim_IOExts.setAssoc'(G,K,C,D,N,F).
hnf('IOExts.getAssoc'(A,B),C,D,E):-!,nf(A,F,D,G),boolEq(F,F,H,G,I),'prim_IOExts.getAssoc'(F,B,C,I,E).
hnf('Time.getClockTime'(A),B,C,D):-!,'prim_Time.getClockTime'(A,B,C,D).
hnf('Directory.doesFileExist'(A,B),C,D,E):-!,nf(A,F,D,G),boolEq(F,F,H,G,I),'prim_Directory.doesFileExist'(F,B,C,I,E).
hnf('Directory.doesDirectoryExist'(A,B),C,D,E):-!,nf(A,F,D,G),boolEq(F,F,H,G,I),'prim_Directory.doesDirectoryExist'(F,B,C,I,E).
hnf('Directory.getModificationTime'(A,B),C,D,E):-!,nf(A,F,D,G),boolEq(F,F,H,G,I),'prim_Directory.getModificationTime'(F,B,C,I,E).
hnf('Directory.getDirectoryContents'(A,B),C,D,E):-!,nf(A,F,D,G),boolEq(F,F,H,G,I),'prim_Directory.getDirectoryContents'(F,B,C,I,E).
hnf('Term.showQTerm'(A),B,C,D):-!,nf(A,E,C,F),boolEq(E,E,G,F,H),'prim_Term.showQTerm'(E,B,H,D).
hnf('Term.showTerm'(A),B,C,D):-!,nf(A,E,C,F),boolEq(E,E,G,F,H),'prim_Term.showTerm'(E,B,H,D).
hnf('Term.readQTerm'(A),B,C,D):-!,nf(A,E,C,F),boolEq(E,E,G,F,H),'prim_Term.readQTerm'(E,B,H,D).
hnf('Term.readTerm'(A),B,C,D):-!,nf(A,E,C,F),boolEq(E,E,G,F,H),'prim_Term.readTerm'(E,B,H,D).
hnf('Ports.openPort'(A,B),C,D,E):-!,nf(A,F,D,G),nf(B,H,G,I),'prim_Ports.openPort'(F,H,C,I,E).
hnf('#basicserverloop'(A,B),C,D,E):-!,'prim_#basicserverloop'(A,B,C,D,E).
hnf('Ports.send'(A,B),C,D,E):-!,nf(A,F,D,G),hnf(B,H,G,I),'prim_Ports.send'(F,H,C,I,E).
hnf('Ports.openProcessPort'(A,B),C,D,E):-!,nf(A,F,D,G),boolEq(F,F,H,G,I),'prim_Ports.openProcessPort'(F,B,C,I,E).
hnf('Ports.openSocketConnectPort'(A,B,C),D,E,F):-!,nf(A,G,E,H),boolEq(G,G,I,H,J),nf(B,K,J,L),boolEq(K,K,M,L,N),'prim_Ports.openSocketConnectPort'(G,K,C,D,N,F).
hnf('Ports.ping'(A,B,C),D,E,F):-!,nf(A,G,E,H),boolEq(G,G,I,H,J),hnf(B,K,J,L),'prim_Ports.ping'(G,K,C,D,L,F).
hnf('Ports.timeoutOnStream'(A,B),C,D,E):-!,nf(A,F,D,G),boolEq(F,F,H,G,I),'prim_Ports.timeoutOnStream'(F,B,C,I,E).
hnf('Ports.openPortOnSocket'(A,B,C),D,E,F):-!,nf(A,G,E,H),nf(B,I,H,J),'prim_Ports.openPortOnSocket'(G,I,C,D,J,F).
hnf('Ports.connectPortAtSocket'(A,B,C,D),E,F,G):-!,nf(A,H,F,I),boolEq(H,H,J,I,K),nf(B,L,K,M),boolEq(L,L,N,M,O),nf(C,P,O,Q),boolEq(P,P,R,Q,S),'prim_Ports.connectPortAtSocket'(H,L,P,D,E,S,G).
hnf('Ports.choiceSPEP'(A,B),C,D,E):-!,hnf(A,F,D,G),'prim_Ports.choiceSPEP'(F,B,C,G,E).
hnf('CLPR.+.'(A,B),C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),'prim_CLPR.+.'(F,H,C,I,E).
hnf('CLPR.-.'(A,B),C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),'prim_CLPR.-.'(F,H,C,I,E).
hnf('CLPR.*.'(A,B),C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),'prim_CLPR.*.'(F,H,C,I,E).
hnf('CLPR./.'(A,B),C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),'prim_CLPR./.'(F,H,C,I,E).
hnf('CLPR.<.'(A,B),C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),'prim_CLPR.<.'(F,H,C,I,E).
hnf('CLPR.>.'(A,B),C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),'prim_CLPR.>.'(F,H,C,I,E).
hnf('CLPR.<=.'(A,B),C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),'prim_CLPR.<=.'(F,H,C,I,E).
hnf('CLPR.>=.'(A,B),C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),'prim_CLPR.>=.'(F,H,C,I,E).
hnf('CLPR.i2f'(A),B,C,D):-!,hnf(A,E,C,F),'prim_CLPR.i2f'(E,B,F,D).
hnf('CLPFD.+#'(A,B),C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),'prim_CLPFD.+#'(F,H,C,I,E).
hnf('CLPFD.-#'(A,B),C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),'prim_CLPFD.-#'(F,H,C,I,E).
hnf('CLPFD.*#'(A,B),C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),'prim_CLPFD.*#'(F,H,C,I,E).
hnf('CLPFD.=#'(A,B),C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),'prim_CLPFD.=#'(F,H,C,I,E).
hnf('CLPFD./=#'(A,B),C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),'prim_CLPFD./=#'(F,H,C,I,E).
hnf('CLPFD.<#'(A,B),C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),'prim_CLPFD.<#'(F,H,C,I,E).
hnf('CLPFD.>#'(A,B),C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),'prim_CLPFD.>#'(F,H,C,I,E).
hnf('CLPFD.<=#'(A,B),C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),'prim_CLPFD.<=#'(F,H,C,I,E).
hnf('CLPFD.>=#'(A,B),C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),'prim_CLPFD.>=#'(F,H,C,I,E).
hnf('CLPFD.domain'(A,B,C),D,E,F):-!,nf(A,G,E,H),hnf(B,I,H,J),hnf(C,K,J,L),'prim_CLPFD.domain'(G,I,K,D,L,F).
hnf('CLPFD.all_different'(A),B,C,D):-!,nf(A,E,C,F),'prim_CLPFD.all_different'(E,B,F,D).
hnf('CLPFD.labeling'(A),B,C,D):-!,nf(A,E,C,F),'prim_CLPFD.labeling'(E,B,F,D).
hnf('TermDB.openDB'(A,B),C,D,E):-!,nf(A,F,D,G),boolEq(F,F,H,G,I),'prim_TermDB.openDB'(F,B,C,I,E).
hnf('TermDB.closeDB'(A,B),C,D,E):-!,nf(A,F,D,G),'prim_TermDB.closeDB'(F,B,C,G,E).
hnf('TermDB.storeDB'(A,B,C),D,E,F):-!,nf(A,G,E,H),boolEq(G,G,I,H,J),nf(B,K,J,L),'prim_TermDB.storeDB'(G,K,C,D,L,F).
hnf('TermDB.eraseDB'(A,B,C),D,E,F):-!,nf(A,G,E,H),nf(B,I,H,J),'prim_TermDB.eraseDB'(G,I,C,D,J,F).
hnf('TermDB.findallDB'(A,B,C),D,E,F):-!,nf(A,G,E,H),nf(B,I,H,J),'prim_TermDB.findallDB'(G,I,C,D,J,F).
hnf(try(A),B,C,D):-!,write('*** '),write(try(A)),write(' currently not supported!'),nl.
hnf(comittedChoice(A),B,C,D):-!,write('*** '),write(comittedChoice(A)),write(' currently not supported!'),nl.
hnf(browse(A),B,C,D):-!,write('*** '),write(browse(A)),write(' currently not supported!'),nl.
hnf(tryone(A),B,C,D):-!,write('*** '),write(tryone(A)),write(' currently not supported!'),nl.
hnf(A=:=B,success,C,D):-!,constrEq(A,B,C,D).
hnf(A==B,C,D,E):-!,boolEq(A,B,C,D,E).
hnf(&(A,B),success,C,D):-!,hnf(A,E,C,F),hnf(B,G,C,H),waitconj(E,G,F,H,D).
hnf(apply(A,B),C,D,E):-!,hnf(A,F,D,G),apply(F,B,C,G,E).
hnf(guardedexpr(A,B),C,D,E):-!,hnf(A,F,D,G),F=success,hnf(B,C,G,E).
hnf(A,A,B,B).

:-block apply(-,?,?,?,?),apply(?,?,?,-,?).
apply('OptFlat.optimizeFlatCurry',A,'OptFlat.optimizeFlatCurry'(A),B,B).
apply('OptFlat.optimizeFlatCurry'(A),B,'OptFlat.optimizeFlatCurry'(A,B),C,C).
apply('OptFlat.optimizeFlatCurry'(A,B),C,'OptFlat.optimizeFlatCurry'(A,B,C),D,D).
apply('OptFlat.optimizeFlatCurry'(A,B,C),D,'OptFlat.optimizeFlatCurry'(A,B,C,D),E,E).
apply('OptFlat.optimizeFlatCurry'(A,B,C,D),E,F,G,H):-hnf('OptFlat.optimizeFlatCurry'(A,B,C,D,E),F,G,H).
apply('OptFlat.getStartingState',A,'OptFlat.getStartingState'(A),B,B).
apply('OptFlat.getStartingState'(A),B,'OptFlat.getStartingState'(A,B),C,C).
apply('OptFlat.getStartingState'(A,B),C,'OptFlat.getStartingState'(A,B,C),D,D).
apply('OptFlat.getStartingState'(A,B,C),D,E,F,G):-hnf('OptFlat.getStartingState'(A,B,C,D),E,F,G).
apply('OptFlat.makeOneFuncProg',A,'OptFlat.makeOneFuncProg'(A),B,B).
apply('OptFlat.makeOneFuncProg'(A),B,C,D,E):-hnf('OptFlat.makeOneFuncProg'(A,B),C,D,E).
apply('OptFlat.getFunc',A,'OptFlat.getFunc'(A),B,B).
apply('OptFlat.getFunc'(A),B,C,D,E):-hnf('OptFlat.getFunc'(A,B),C,D,E).
apply('OptFlat.getTrans',A,'OptFlat.getTrans'(A),B,B).
apply('OptFlat.getTrans'(A),B,C,D,E):-hnf('OptFlat.getTrans'(A,B),C,D,E).
apply('OptFlat.makeOptimizedFlatProg',A,'OptFlat.makeOptimizedFlatProg'(A),B,B).
apply('OptFlat.makeOptimizedFlatProg'(A),B,'OptFlat.makeOptimizedFlatProg'(A,B),C,C).
apply('OptFlat.makeOptimizedFlatProg'(A,B),C,D,E,F):-hnf('OptFlat.makeOptimizedFlatProg'(A,B,C),D,E,F).
apply('OptFlat.optFuncDecls',A,'OptFlat.optFuncDecls'(A),B,B).
apply('OptFlat.optFuncDecls'(A),B,C,D,E):-hnf('OptFlat.optFuncDecls'(A,B),C,D,E).
apply('OptFlat.optFuncDecls\'',A,'OptFlat.optFuncDecls\''(A),B,B).
apply('OptFlat.optFuncDecls\''(A),B,'OptFlat.optFuncDecls\''(A,B),C,C).
apply('OptFlat.optFuncDecls\''(A,B),C,D,E,F):-hnf('OptFlat.optFuncDecls\''(A,B,C),D,E,F).
apply('OptFlat.lookupFuncCalls',A,'OptFlat.lookupFuncCalls'(A),B,B).
apply('OptFlat.lookupFuncCalls'(A),B,'OptFlat.lookupFuncCalls'(A,B),C,C).
apply('OptFlat.lookupFuncCalls'(A,B),C,'OptFlat.lookupFuncCalls'(A,B,C),D,D).
apply('OptFlat.lookupFuncCalls'(A,B,C),D,E,F,G):-hnf('OptFlat.lookupFuncCalls'(A,B,C,D),E,F,G).
apply('OptFlat.lookupFuncDeclInRest',A,'OptFlat.lookupFuncDeclInRest'(A),B,B).
apply('OptFlat.lookupFuncDeclInRest'(A),B,C,D,E):-hnf('OptFlat.lookupFuncDeclInRest'(A,B),C,D,E).
apply('OptFlat.getAllFuncCalls',A,B,C,D):-hnf('OptFlat.getAllFuncCalls'(A),B,C,D).
apply('OptFlat.getAllFuncCallsOfExpr',A,B,C,D):-hnf('OptFlat.getAllFuncCallsOfExpr'(A),B,C,D).
apply('OptFlat.getAllFuncCallsOfBranchExpr',A,B,C,D):-hnf('OptFlat.getAllFuncCallsOfBranchExpr'(A),B,C,D).
apply('OptFlat.readAllImportedFlatProgs',A,'OptFlat.readAllImportedFlatProgs'(A),B,B).
apply('OptFlat.readAllImportedFlatProgs'(A),B,'OptFlat.readAllImportedFlatProgs'(A,B),C,C).
apply('OptFlat.readAllImportedFlatProgs'(A,B),C,D,E,F):-hnf('OptFlat.readAllImportedFlatProgs'(A,B,C),D,E,F).
apply('OptFlat.readAllImportedFlatProgs\'',A,'OptFlat.readAllImportedFlatProgs\''(A),B,B).
apply('OptFlat.readAllImportedFlatProgs\''(A),B,'OptFlat.readAllImportedFlatProgs\''(A,B),C,C).
apply('OptFlat.readAllImportedFlatProgs\''(A,B),C,'OptFlat.readAllImportedFlatProgs\''(A,B,C),D,D).
apply('OptFlat.readAllImportedFlatProgs\''(A,B,C),D,E,F,G):-hnf('OptFlat.readAllImportedFlatProgs\''(A,B,C,D),E,F,G).
apply('OptFlat.tryReadFlatCurry',A,'OptFlat.tryReadFlatCurry'(A),B,B).
apply('OptFlat.tryReadFlatCurry'(A),B,'OptFlat.tryReadFlatCurry'(A,B),C,C).
apply('OptFlat.tryReadFlatCurry'(A,B),C,D,E,F):-hnf('OptFlat.tryReadFlatCurry'(A,B,C),D,E,F).
apply('OptFlat.getModname',A,B,C,D):-hnf('OptFlat.getModname'(A),B,C,D).
apply('OptFlat.getImports',A,B,C,D):-hnf('OptFlat.getImports'(A),B,C,D).
apply('OptFlat.getFuncDecls',A,B,C,D):-hnf('OptFlat.getFuncDecls'(A),B,C,D).
apply('OptFlat.getFuncName',A,B,C,D):-hnf('OptFlat.getFuncName'(A),B,C,D).
apply('OptFlat.getTransName',A,B,C,D):-hnf('OptFlat.getTransName'(A),B,C,D).
apply('OptFlat.getInternalName',A,B,C,D):-hnf('OptFlat.getInternalName'(A),B,C,D).
apply('OptFlat.mergeFlatProgList',A,B,C,D):-hnf('OptFlat.mergeFlatProgList'(A),B,C,D).
apply('OptFlat.mergeFlatProgs',A,'OptFlat.mergeFlatProgs'(A),B,B).
apply('OptFlat.mergeFlatProgs'(A),B,C,D,E):-hnf('OptFlat.mergeFlatProgs'(A,B),C,D,E).
apply('OptFlat.leString',A,'OptFlat.leString'(A),B,B).
apply('OptFlat.leString'(A),B,C,D,E):-hnf('OptFlat.leString'(A,B),C,D,E).
apply('OptFlat.leChar',A,'OptFlat.leChar'(A),B,B).
apply('OptFlat.leChar'(A),B,C,D,E):-hnf('OptFlat.leChar'(A,B),C,D,E).
apply('OptFlat.leList',A,'OptFlat.leList'(A),B,B).
apply('OptFlat.leList'(A),B,'OptFlat.leList'(A,B),C,C).
apply('OptFlat.leList'(A,B),C,D,E,F):-hnf('OptFlat.leList'(A,B,C),D,E,F).
apply('OptFlat.leFuncDecl',A,'OptFlat.leFuncDecl'(A),B,B).
apply('OptFlat.leFuncDecl'(A),B,C,D,E):-hnf('OptFlat.leFuncDecl'(A,B),C,D,E).
apply('OptFlat.list2SetRBT',A,'OptFlat.list2SetRBT'(A),B,B).
apply('OptFlat.list2SetRBT'(A),B,C,D,E):-hnf('OptFlat.list2SetRBT'(A,B),C,D,E).
apply('OptFlat.lambdafun_9659',A,'OptFlat.lambdafun_9659'(A),B,B).
apply('OptFlat.lambdafun_9659'(A),B,'OptFlat.lambdafun_9659'(A,B),C,C).
apply('OptFlat.lambdafun_9659'(A,B),C,'OptFlat.lambdafun_9659'(A,B,C),D,D).
apply('OptFlat.lambdafun_9659'(A,B,C),D,'OptFlat.lambdafun_9659'(A,B,C,D),E,E).
apply('OptFlat.lambdafun_9659'(A,B,C,D),E,'OptFlat.lambdafun_9659'(A,B,C,D,E),F,F).
apply('OptFlat.lambdafun_9659'(A,B,C,D,E),F,G,H,I):-hnf('OptFlat.lambdafun_9659'(A,B,C,D,E,F),G,H,I).
apply('OptFlat.optFlat_lambda1_9661',A,'OptFlat.optFlat_lambda1_9661'(A),B,B).
apply('OptFlat.optFlat_lambda1_9661'(A),B,'OptFlat.optFlat_lambda1_9661'(A,B),C,C).
apply('OptFlat.optFlat_lambda1_9661'(A,B),C,D,E,F):-hnf('OptFlat.optFlat_lambda1_9661'(A,B,C),D,E,F).
apply('OptFlat.optFlat_lambda0_9662',A,'OptFlat.optFlat_lambda0_9662'(A),B,B).
apply('OptFlat.optFlat_lambda0_9662'(A),B,'OptFlat.optFlat_lambda0_9662'(A,B),C,C).
apply('OptFlat.optFlat_lambda0_9662'(A,B),C,'OptFlat.optFlat_lambda0_9662'(A,B,C),D,D).
apply('OptFlat.optFlat_lambda0_9662'(A,B,C),D,E,F,G):-hnf('OptFlat.optFlat_lambda0_9662'(A,B,C,D),E,F,G).
apply('OptFlat.lambdafun_9660',A,'OptFlat.lambdafun_9660'(A),B,B).
apply('OptFlat.lambdafun_9660'(A),B,'OptFlat.lambdafun_9660'(A,B),C,C).
apply('OptFlat.lambdafun_9660'(A,B),C,'OptFlat.lambdafun_9660'(A,B,C),D,D).
apply('OptFlat.lambdafun_9660'(A,B,C),D,'OptFlat.lambdafun_9660'(A,B,C,D),E,E).
apply('OptFlat.lambdafun_9660'(A,B,C,D),E,F,G,H):-hnf('OptFlat.lambdafun_9660'(A,B,C,D,E),F,G,H).
apply('OptFlat.optFlat_lambda2_9663',A,'OptFlat.optFlat_lambda2_9663'(A),B,B).
apply('OptFlat.optFlat_lambda2_9663'(A),B,'OptFlat.optFlat_lambda2_9663'(A,B),C,C).
apply('OptFlat.optFlat_lambda2_9663'(A,B),C,'OptFlat.optFlat_lambda2_9663'(A,B,C),D,D).
apply('OptFlat.optFlat_lambda2_9663'(A,B,C),D,'OptFlat.optFlat_lambda2_9663'(A,B,C,D),E,E).
apply('OptFlat.optFlat_lambda2_9663'(A,B,C,D),E,F,G,H):-hnf('OptFlat.optFlat_lambda2_9663'(A,B,C,D,E),F,G,H).
apply('OptFlat.optFlat_lambda3_9664',A,'OptFlat.optFlat_lambda3_9664'(A),B,B).
apply('OptFlat.optFlat_lambda3_9664'(A),B,'OptFlat.optFlat_lambda3_9664'(A,B),C,C).
apply('OptFlat.optFlat_lambda3_9664'(A,B),C,D,E,F):-hnf('OptFlat.optFlat_lambda3_9664'(A,B,C),D,E,F).
apply('OptFlat.optFlat_lambda5_9665',A,'OptFlat.optFlat_lambda5_9665'(A),B,B).
apply('OptFlat.optFlat_lambda5_9665'(A),B,'OptFlat.optFlat_lambda5_9665'(A,B),C,C).
apply('OptFlat.optFlat_lambda5_9665'(A,B),C,D,E,F):-hnf('OptFlat.optFlat_lambda5_9665'(A,B,C),D,E,F).
apply('OptFlat.optFlat_lambda4_9666',A,'OptFlat.optFlat_lambda4_9666'(A),B,B).
apply('OptFlat.optFlat_lambda4_9666'(A),B,'OptFlat.optFlat_lambda4_9666'(A,B),C,C).
apply('OptFlat.optFlat_lambda4_9666'(A,B),C,'OptFlat.optFlat_lambda4_9666'(A,B,C),D,D).
apply('OptFlat.optFlat_lambda4_9666'(A,B,C),D,'OptFlat.optFlat_lambda4_9666'(A,B,C,D),E,E).
apply('OptFlat.optFlat_lambda4_9666'(A,B,C,D),E,F,G,H):-hnf('OptFlat.optFlat_lambda4_9666'(A,B,C,D,E),F,G,H).
apply('OptFlat.lambdafun_9667',A,'OptFlat.lambdafun_9667'(A),B,B).
apply('OptFlat.lambdafun_9667'(A),B,C,D,E):-hnf('OptFlat.lambdafun_9667'(A,B),C,D,E).
apply('OptFlat.lambdafun_9668',A,'OptFlat.lambdafun_9668'(A),B,B).
apply('OptFlat.lambdafun_9668'(A),B,C,D,E):-hnf('OptFlat.lambdafun_9668'(A,B),C,D,E).
apply('OptFlat.lambdafun_9669',A,'OptFlat.lambdafun_9669'(A),B,B).
apply('OptFlat.lambdafun_9669'(A),B,'OptFlat.lambdafun_9669'(A,B),C,C).
apply('OptFlat.lambdafun_9669'(A,B),C,D,E,F):-hnf('OptFlat.lambdafun_9669'(A,B,C),D,E,F).
apply('OptFlat.lambdafun_9670',A,'OptFlat.lambdafun_9670'(A),B,B).
apply('OptFlat.lambdafun_9670'(A),B,'OptFlat.lambdafun_9670'(A,B),C,C).
apply('OptFlat.lambdafun_9670'(A,B),C,'OptFlat.lambdafun_9670'(A,B,C),D,D).
apply('OptFlat.lambdafun_9670'(A,B,C),D,'OptFlat.lambdafun_9670'(A,B,C,D),E,E).
apply('OptFlat.lambdafun_9670'(A,B,C,D),E,'OptFlat.lambdafun_9670'(A,B,C,D,E),F,F).
apply('OptFlat.lambdafun_9670'(A,B,C,D,E),F,G,H,I):-hnf('OptFlat.lambdafun_9670'(A,B,C,D,E,F),G,H,I).
apply(==,A,==(A),B,B).
apply(==(A),B,C,D,E):-hnf(A==B,C,D,E).
apply(=:=,A,=:=(A),B,B).
apply(=:=(A),B,C,D,E):-hnf(A=:=B,C,D,E).
apply('prelude..',A,'prelude..'(A),B,B).
apply('prelude..'(A),B,'prelude..'(A,B),C,C).
apply('prelude..'(A,B),C,D,E,F):-hnf('prelude..'(A,B,C),D,E,F).
apply(id,A,B,C,D):-hnf(id(A),B,C,D).
apply(const,A,const(A),B,B).
apply(const(A),B,C,D,E):-hnf(const(A,B),C,D,E).
apply(curry,A,curry(A),B,B).
apply(curry(A),B,curry(A,B),C,C).
apply(curry(A,B),C,D,E,F):-hnf(curry(A,B,C),D,E,F).
apply(uncurry,A,uncurry(A),B,B).
apply(uncurry(A),B,C,D,E):-hnf(uncurry(A,B),C,D,E).
apply(flip,A,flip(A),B,B).
apply(flip(A),B,flip(A,B),C,C).
apply(flip(A,B),C,D,E,F):-hnf(flip(A,B,C),D,E,F).
apply(until,A,until(A),B,B).
apply(until(A),B,until(A,B),C,C).
apply(until(A,B),C,D,E,F):-hnf(until(A,B,C),D,E,F).
apply($,A,$(A),B,B).
apply($(A),B,C,D,E):-hnf($(A,B),C,D,E).
apply('$!',A,'$!'(A),B,B).
apply('$!'(A),B,C,D,E):-hnf('$!'(A,B),C,D,E).
apply(&&,A,&&(A),B,B).
apply(&&(A),B,C,D,E):-hnf(&&(A,B),C,D,E).
apply('||',A,'||'(A),B,B).
apply('||'(A),B,C,D,E):-hnf('||'(A,B),C,D,E).
apply(not,A,B,C,D):-hnf(not(A),B,C,D).
apply(if_then_else,A,if_then_else(A),B,B).
apply(if_then_else(A),B,if_then_else(A,B),C,C).
apply(if_then_else(A,B),C,D,E,F):-hnf(if_then_else(A,B,C),D,E,F).
apply(/=,A,/=(A),B,B).
apply(/=(A),B,C,D,E):-hnf(/=(A,B),C,D,E).
apply(fst,A,B,C,D):-hnf(fst(A),B,C,D).
apply(snd,A,B,C,D):-hnf(snd(A),B,C,D).
apply(head,A,B,C,D):-hnf(head(A),B,C,D).
apply(tail,A,B,C,D):-hnf(tail(A),B,C,D).
apply(null,A,B,C,D):-hnf(null(A),B,C,D).
apply(++,A,++(A),B,B).
apply(++(A),B,C,D,E):-hnf(++(A,B),C,D,E).
apply(length,A,B,C,D):-hnf(length(A),B,C,D).
apply('!!',A,'!!'(A),B,B).
apply('!!'(A),B,C,D,E):-hnf('!!'(A,B),C,D,E).
apply(map,A,map(A),B,B).
apply(map(A),B,C,D,E):-hnf(map(A,B),C,D,E).
apply(foldl,A,foldl(A),B,B).
apply(foldl(A),B,foldl(A,B),C,C).
apply(foldl(A,B),C,D,E,F):-hnf(foldl(A,B,C),D,E,F).
apply(foldl1,A,foldl1(A),B,B).
apply(foldl1(A),B,C,D,E):-hnf(foldl1(A,B),C,D,E).
apply(foldr,A,foldr(A),B,B).
apply(foldr(A),B,foldr(A,B),C,C).
apply(foldr(A,B),C,D,E,F):-hnf(foldr(A,B,C),D,E,F).
apply(foldr1,A,foldr1(A),B,B).
apply(foldr1(A),B,C,D,E):-hnf(foldr1(A,B),C,D,E).
apply(filter,A,filter(A),B,B).
apply(filter(A),B,C,D,E):-hnf(filter(A,B),C,D,E).
apply(zip,A,zip(A),B,B).
apply(zip(A),B,C,D,E):-hnf(zip(A,B),C,D,E).
apply(zip3,A,zip3(A),B,B).
apply(zip3(A),B,zip3(A,B),C,C).
apply(zip3(A,B),C,D,E,F):-hnf(zip3(A,B,C),D,E,F).
apply(zipWith,A,zipWith(A),B,B).
apply(zipWith(A),B,zipWith(A,B),C,C).
apply(zipWith(A,B),C,D,E,F):-hnf(zipWith(A,B,C),D,E,F).
apply(zipWith3,A,zipWith3(A),B,B).
apply(zipWith3(A),B,zipWith3(A,B),C,C).
apply(zipWith3(A,B),C,zipWith3(A,B,C),D,D).
apply(zipWith3(A,B,C),D,E,F,G):-hnf(zipWith3(A,B,C,D),E,F,G).
apply(unzip,A,B,C,D):-hnf(unzip(A),B,C,D).
apply(unzip3,A,B,C,D):-hnf(unzip3(A),B,C,D).
apply(concat,A,B,C,D):-hnf(concat(A),B,C,D).
apply(concatMap,A,concatMap(A),B,B).
apply(concatMap(A),B,C,D,E):-hnf(concatMap(A,B),C,D,E).
apply(iterate,A,iterate(A),B,B).
apply(iterate(A),B,C,D,E):-hnf(iterate(A,B),C,D,E).
apply(repeat,A,B,C,D):-hnf(repeat(A),B,C,D).
apply(replicate,A,replicate(A),B,B).
apply(replicate(A),B,C,D,E):-hnf(replicate(A,B),C,D,E).
apply(take,A,take(A),B,B).
apply(take(A),B,C,D,E):-hnf(take(A,B),C,D,E).
apply(drop,A,drop(A),B,B).
apply(drop(A),B,C,D,E):-hnf(drop(A,B),C,D,E).
apply(splitAt,A,splitAt(A),B,B).
apply(splitAt(A),B,C,D,E):-hnf(splitAt(A,B),C,D,E).
apply(takeWhile,A,takeWhile(A),B,B).
apply(takeWhile(A),B,C,D,E):-hnf(takeWhile(A,B),C,D,E).
apply(dropWhile,A,dropWhile(A),B,B).
apply(dropWhile(A),B,C,D,E):-hnf(dropWhile(A,B),C,D,E).
apply(span,A,span(A),B,B).
apply(span(A),B,C,D,E):-hnf(span(A,B),C,D,E).
apply(break,A,break(A),B,B).
apply(break(A),B,C,D,E):-hnf(break(A,B),C,D,E).
apply(lines,A,B,C,D):-hnf(lines(A),B,C,D).
apply(unlines,A,B,C,D):-hnf(unlines(A),B,C,D).
apply(words,A,B,C,D):-hnf(words(A),B,C,D).
apply(unwords,A,B,C,D):-hnf(unwords(A),B,C,D).
apply(reverse,A,B,C,D):-hnf(reverse(A),B,C,D).
apply(and,A,B,C,D):-hnf(and(A),B,C,D).
apply(or,A,B,C,D):-hnf(or(A),B,C,D).
apply(any,A,any(A),B,B).
apply(any(A),B,C,D,E):-hnf(any(A,B),C,D,E).
apply(all,A,all(A),B,B).
apply(all(A),B,C,D,E):-hnf(all(A,B),C,D,E).
apply(elem,A,elem(A),B,B).
apply(elem(A),B,C,D,E):-hnf(elem(A,B),C,D,E).
apply(notElem,A,notElem(A),B,B).
apply(notElem(A),B,C,D,E):-hnf(notElem(A,B),C,D,E).
apply(lookup,A,lookup(A),B,B).
apply(lookup(A),B,C,D,E):-hnf(lookup(A,B),C,D,E).
apply(enumFrom,A,B,C,D):-hnf(enumFrom(A),B,C,D).
apply(enumFromThen,A,enumFromThen(A),B,B).
apply(enumFromThen(A),B,C,D,E):-hnf(enumFromThen(A,B),C,D,E).
apply(enumFromTo,A,enumFromTo(A),B,B).
apply(enumFromTo(A),B,C,D,E):-hnf(enumFromTo(A,B),C,D,E).
apply(enumFromThenTo,A,enumFromThenTo(A),B,B).
apply(enumFromThenTo(A),B,enumFromThenTo(A,B),C,C).
apply(enumFromThenTo(A,B),C,D,E,F):-hnf(enumFromThenTo(A,B,C),D,E,F).
apply(&>,A,&>(A),B,B).
apply(&>(A),B,C,D,E):-hnf(&>(A,B),C,D,E).
apply(maybe,A,maybe(A),B,B).
apply(maybe(A),B,maybe(A,B),C,C).
apply(maybe(A,B),C,D,E,F):-hnf(maybe(A,B,C),D,E,F).
apply(either,A,either(A),B,B).
apply(either(A),B,either(A,B),C,C).
apply(either(A,B),C,D,E,F):-hnf(either(A,B,C),D,E,F).
apply(done,A,B,C,D):-hnf(done(A),B,C,D).
apply(putStr,A,putStr(A),B,B).
apply(putStr(A),B,C,D,E):-hnf(putStr(A,B),C,D,E).
apply(putStrLn,A,putStrLn(A),B,B).
apply(putStrLn(A),B,C,D,E):-hnf(putStrLn(A,B),C,D,E).
apply(getLine,A,B,C,D):-hnf(getLine(A),B,C,D).
apply(print,A,print(A),B,B).
apply(print(A),B,C,D,E):-hnf(print(A,B),C,D,E).
apply(doSolve,A,doSolve(A),B,B).
apply(doSolve(A),B,C,D,E):-hnf(doSolve(A,B),C,D,E).
apply(sequenceIO,A,sequenceIO(A),B,B).
apply(sequenceIO(A),B,C,D,E):-hnf(sequenceIO(A,B),C,D,E).
apply(sequenceIO_,A,sequenceIO_(A),B,B).
apply(sequenceIO_(A),B,C,D,E):-hnf(sequenceIO_(A,B),C,D,E).
apply(mapIO,A,mapIO(A),B,B).
apply(mapIO(A),B,mapIO(A,B),C,C).
apply(mapIO(A,B),C,D,E,F):-hnf(mapIO(A,B,C),D,E,F).
apply(mapIO_,A,mapIO_(A),B,B).
apply(mapIO_(A),B,mapIO_(A,B),C,C).
apply(mapIO_(A,B),C,D,E,F):-hnf(mapIO_(A,B,C),D,E,F).
apply(inject,A,inject(A),B,B).
apply(inject(A),B,inject(A,B),C,C).
apply(inject(A,B),C,D,E,F):-hnf(inject(A,B,C),D,E,F).
apply(solveAll,A,B,C,D):-hnf(solveAll(A),B,C,D).
apply(solveAll2,A,B,C,D):-hnf(solveAll2(A),B,C,D).
apply(once,A,once(A),B,B).
apply(once(A),B,C,D,E):-hnf(once(A,B),C,D,E).
apply(one,A,B,C,D):-hnf(one(A),B,C,D).
apply(condSearch,A,condSearch(A),B,B).
apply(condSearch(A),B,C,D,E):-hnf(condSearch(A,B),C,D,E).
apply(best,A,best(A),B,B).
apply(best(A),B,C,D,E):-hnf(best(A,B),C,D,E).
apply(browse,A,browse(A),B,B).
apply(browse(A),B,C,D,E):-hnf(browse(A,B),C,D,E).
apply(browseList,A,browseList(A),B,B).
apply(browseList(A),B,C,D,E):-hnf(browseList(A,B),C,D,E).
apply(unpack,A,B,C,D):-hnf(unpack(A),B,C,D).
apply('PEVAL',A,B,C,D):-hnf('PEVAL'(A),B,C,D).
apply(prelude_lambda0_1997,A,prelude_lambda0_1997(A),B,B).
apply(prelude_lambda0_1997(A),B,prelude_lambda0_1997(A,B),C,C).
apply(prelude_lambda0_1997(A,B),C,D,E,F):-hnf(prelude_lambda0_1997(A,B,C),D,E,F).
apply(prelude_lambda1_1998,A,prelude_lambda1_1998(A),B,B).
apply(prelude_lambda1_1998(A),B,prelude_lambda1_1998(A,B),C,C).
apply(prelude_lambda1_1998(A,B),C,D,E,F):-hnf(prelude_lambda1_1998(A,B,C),D,E,F).
apply(prelude_lambda2_1999,A,prelude_lambda2_1999(A),B,B).
apply(prelude_lambda2_1999(A),B,prelude_lambda2_1999(A,B),C,C).
apply(prelude_lambda2_1999(A,B),C,prelude_lambda2_1999(A,B,C),D,D).
apply(prelude_lambda2_1999(A,B,C),D,E,F,G):-hnf(prelude_lambda2_1999(A,B,C,D),E,F,G).
apply(takep_452,A,takep_452(A),B,B).
apply(takep_452(A),B,C,D,E):-hnf(takep_452(A,B),C,D,E).
apply(dropp_459,A,dropp_459(A),B,B).
apply(dropp_459(A),B,C,D,E):-hnf(dropp_459(A,B),C,D,E).
apply(splitAtp_466,A,splitAtp_466(A),B,B).
apply(splitAtp_466(A),B,C,D,E):-hnf(splitAtp_466(A,B),C,D,E).
apply(prelude_lambda3_2000,A,prelude_lambda3_2000(A),B,B).
apply(prelude_lambda3_2000(A),B,C,D,E):-hnf(prelude_lambda3_2000(A,B),C,D,E).
apply(prelude_lambda4_2001,A,prelude_lambda4_2001(A),B,B).
apply(prelude_lambda4_2001(A),B,C,D,E):-hnf(prelude_lambda4_2001(A,B),C,D,E).
apply(splitline_490,A,B,C,D):-hnf(splitline_490(A),B,C,D).
apply(prelude_lambda5_2002,A,prelude_lambda5_2002(A),B,B).
apply(prelude_lambda5_2002(A),B,C,D,E):-hnf(prelude_lambda5_2002(A,B),C,D,E).
apply(prelude_lambda6_2003,A,B,C,D):-hnf(prelude_lambda6_2003(A),B,C,D).
apply(prelude_lambda7_2004,A,B,C,D):-hnf(prelude_lambda7_2004(A),B,C,D).
apply(isSpace_500,A,B,C,D):-hnf(isSpace_500(A),B,C,D).
apply(prelude_lambda9_2005,A,B,C,D):-hnf(prelude_lambda9_2005(A),B,C,D).
apply(prelude_lambda8_2006,A,B,C,D):-hnf(prelude_lambda8_2006(A),B,C,D).
apply(prelude_lambda10_2007,A,prelude_lambda10_2007(A),B,B).
apply(prelude_lambda10_2007(A),B,C,D,E):-hnf(prelude_lambda10_2007(A,B),C,D,E).
apply(prelude_lambda11_2008,A,prelude_lambda11_2008(A),B,B).
apply(prelude_lambda11_2008(A),B,C,D,E):-hnf(prelude_lambda11_2008(A,B),C,D,E).
apply(prelude_lambda12_2009,A,prelude_lambda12_2009(A),B,B).
apply(prelude_lambda12_2009(A),B,C,D,E):-hnf(prelude_lambda12_2009(A,B),C,D,E).
apply(prelude_lambda13_2010,A,prelude_lambda13_2010(A),B,B).
apply(prelude_lambda13_2010(A),B,prelude_lambda13_2010(A,B),C,C).
apply(prelude_lambda13_2010(A,B),C,D,E,F):-hnf(prelude_lambda13_2010(A,B,C),D,E,F).
apply(p_528,A,p_528(A),B,B).
apply(p_528(A),B,p_528(A,B),C,C).
apply(p_528(A,B),C,p_528(A,B,C),D,D).
apply(p_528(A,B,C),D,E,F,G):-hnf(p_528(A,B,C,D),E,F,G).
apply(prelude_lambda14_2011,A,prelude_lambda14_2011(A),B,B).
apply(prelude_lambda14_2011(A),B,prelude_lambda14_2011(A,B),C,C).
apply(prelude_lambda14_2011(A,B),C,D,E,F):-hnf(prelude_lambda14_2011(A,B,C),D,E,F).
apply(lambdafun_2012,A,lambdafun_2012(A),B,B).
apply(lambdafun_2012(A),B,C,D,E):-hnf(lambdafun_2012(A,B),C,D,E).
apply(lambdafun_2013,A,lambdafun_2013(A),B,B).
apply(lambdafun_2013(A),B,lambdafun_2013(A,B),C,C).
apply(lambdafun_2013(A,B),C,D,E,F):-hnf(lambdafun_2013(A,B,C),D,E,F).
apply(lambdafun_2014,A,lambdafun_2014(A),B,B).
apply(lambdafun_2014(A),B,lambdafun_2014(A,B),C,C).
apply(lambdafun_2014(A,B),C,D,E,F):-hnf(lambdafun_2014(A,B,C),D,E,F).
apply(lambdafun_2015,A,lambdafun_2015(A),B,B).
apply(lambdafun_2015(A),B,lambdafun_2015(A,B),C,C).
apply(lambdafun_2015(A,B),C,D,E,F):-hnf(lambdafun_2015(A,B,C),D,E,F).
apply(prelude_lambda15_2016,A,prelude_lambda15_2016(A),B,B).
apply(prelude_lambda15_2016(A),B,prelude_lambda15_2016(A,B),C,C).
apply(prelude_lambda15_2016(A,B),C,D,E,F):-hnf(prelude_lambda15_2016(A,B,C),D,E,F).
apply(evalall_563,A,B,C,D):-hnf(evalall_563(A),B,C,D).
apply(evalall2_564,A,B,C,D):-hnf(evalall2_564(A),B,C,D).
apply(evalall3_565,A,evalall3_565(A),B,B).
apply(evalall3_565(A),B,C,D,E):-hnf(evalall3_565(A,B),C,D,E).
apply(evalResult_580,A,B,C,D):-hnf(evalResult_580(A),B,C,D).
apply(prelude_lambda16_2017,A,prelude_lambda16_2017(A),B,B).
apply(prelude_lambda16_2017(A),B,C,D,E):-hnf(prelude_lambda16_2017(A,B),C,D,E).
apply(prelude_lambda17_2018,A,prelude_lambda17_2018(A),B,B).
apply(prelude_lambda17_2018(A),B,prelude_lambda17_2018(A,B),C,C).
apply(prelude_lambda17_2018(A,B),C,D,E,F):-hnf(prelude_lambda17_2018(A,B,C),D,E,F).
apply(bestHelp_595,A,bestHelp_595(A),B,B).
apply(bestHelp_595(A),B,bestHelp_595(A,B),C,C).
apply(bestHelp_595(A,B),C,bestHelp_595(A,B,C),D,D).
apply(bestHelp_595(A,B,C),D,E,F,G):-hnf(bestHelp_595(A,B,C,D),E,F,G).
apply(evalY_596,A,evalY_596(A),B,B).
apply(evalY_596(A),B,evalY_596(A,B),C,C).
apply(evalY_596(A,B),C,evalY_596(A,B,C),D,D).
apply(evalY_596(A,B,C),D,E,F,G):-hnf(evalY_596(A,B,C,D),E,F,G).
apply(evalX_597,A,evalX_597(A),B,B).
apply(evalX_597(A),B,evalX_597(A,B),C,C).
apply(evalX_597(A,B),C,evalX_597(A,B,C),D,D).
apply(evalX_597(A,B,C),D,evalX_597(A,B,C,D),E,E).
apply(evalX_597(A,B,C,D),E,F,G,H):-hnf(evalX_597(A,B,C,D,E),F,G,H).
apply(evalA_598,A,evalA_598(A),B,B).
apply(evalA_598(A),B,evalA_598(A,B),C,C).
apply(evalA_598(A,B),C,evalA_598(A,B,C),D,D).
apply(evalA_598(A,B,C),D,evalA_598(A,B,C,D),E,E).
apply(evalA_598(A,B,C,D),E,F,G,H):-hnf(evalA_598(A,B,C,D,E),F,G,H).
apply(constrain_599,A,constrain_599(A),B,B).
apply(constrain_599(A),B,constrain_599(A,B),C,C).
apply(constrain_599(A,B),C,constrain_599(A,B,C),D,D).
apply(constrain_599(A,B,C),D,E,F,G):-hnf(constrain_599(A,B,C,D),E,F,G).
apply(prelude_lambda18_2019,A,prelude_lambda18_2019(A),B,B).
apply(prelude_lambda18_2019(A),B,prelude_lambda18_2019(A,B),C,C).
apply(prelude_lambda18_2019(A,B),C,D,E,F):-hnf(prelude_lambda18_2019(A,B,C),D,E,F).
apply('Flat.readFlatCurry',A,'Flat.readFlatCurry'(A),B,B).
apply('Flat.readFlatCurry'(A),B,C,D,E):-hnf('Flat.readFlatCurry'(A,B),C,D,E).
apply('Flat.readFlatCurryWithParseOptions',A,'Flat.readFlatCurryWithParseOptions'(A),B,B).
apply('Flat.readFlatCurryWithParseOptions'(A),B,'Flat.readFlatCurryWithParseOptions'(A,B),C,C).
apply('Flat.readFlatCurryWithParseOptions'(A,B),C,D,E,F):-hnf('Flat.readFlatCurryWithParseOptions'(A,B,C),D,E,F).
apply('Flat.splitFlatModName',A,B,C,D):-hnf('Flat.splitFlatModName'(A),B,C,D).
apply('Flat.lambdafun_2843',A,'Flat.lambdafun_2843'(A),B,B).
apply('Flat.lambdafun_2843'(A),B,'Flat.lambdafun_2843'(A,B),C,C).
apply('Flat.lambdafun_2843'(A,B),C,'Flat.lambdafun_2843'(A,B,C),D,D).
apply('Flat.lambdafun_2843'(A,B,C),D,'Flat.lambdafun_2843'(A,B,C,D),E,E).
apply('Flat.lambdafun_2843'(A,B,C,D),E,F,G,H):-hnf('Flat.lambdafun_2843'(A,B,C,D,E),F,G,H).
apply('Flat.lambdafun_2845',A,'Flat.lambdafun_2845'(A),B,B).
apply('Flat.lambdafun_2845'(A),B,'Flat.lambdafun_2845'(A,B),C,C).
apply('Flat.lambdafun_2845'(A,B),C,'Flat.lambdafun_2845'(A,B,C),D,D).
apply('Flat.lambdafun_2845'(A,B,C),D,E,F,G):-hnf('Flat.lambdafun_2845'(A,B,C,D),E,F,G).
apply('Flat.lambdafun_2844',A,'Flat.lambdafun_2844'(A),B,B).
apply('Flat.lambdafun_2844'(A),B,'Flat.lambdafun_2844'(A,B),C,C).
apply('Flat.lambdafun_2844'(A,B),C,'Flat.lambdafun_2844'(A,B,C),D,D).
apply('Flat.lambdafun_2844'(A,B,C),D,E,F,G):-hnf('Flat.lambdafun_2844'(A,B,C,D),E,F,G).
apply('Flat.flat_lambda0_2846',A,'Flat.flat_lambda0_2846'(A),B,B).
apply('Flat.flat_lambda0_2846'(A),B,C,D,E):-hnf('Flat.flat_lambda0_2846'(A,B),C,D,E).
apply('Flat.flat_lambda1_2847',A,B,C,D):-hnf('Flat.flat_lambda1_2847'(A),B,C,D).
apply('FlatTools.showFlatProg',A,B,C,D):-hnf('FlatTools.showFlatProg'(A),B,C,D).
apply('FlatTools.flatShowFixity',A,B,C,D):-hnf('FlatTools.flatShowFixity'(A),B,C,D).
apply('FlatTools.flatShowOp',A,B,C,D):-hnf('FlatTools.flatShowOp'(A),B,C,D).
apply('FlatTools.flatShowType',A,B,C,D):-hnf('FlatTools.flatShowType'(A),B,C,D).
apply('FlatTools.flatShowCons',A,B,C,D):-hnf('FlatTools.flatShowCons'(A),B,C,D).
apply('FlatTools.flatShowFunc',A,B,C,D):-hnf('FlatTools.flatShowFunc'(A),B,C,D).
apply('FlatTools.flatShowRule',A,B,C,D):-hnf('FlatTools.flatShowRule'(A),B,C,D).
apply('FlatTools.flatShowTypeExpr',A,B,C,D):-hnf('FlatTools.flatShowTypeExpr'(A),B,C,D).
apply('FlatTools.flatShowExpr',A,B,C,D):-hnf('FlatTools.flatShowExpr'(A),B,C,D).
apply('FlatTools.flatShowLit',A,B,C,D):-hnf('FlatTools.flatShowLit'(A),B,C,D).
apply('FlatTools.flatShowBranch',A,B,C,D):-hnf('FlatTools.flatShowBranch'(A),B,C,D).
apply('FlatTools.flatShowPattern',A,B,C,D):-hnf('FlatTools.flatShowPattern'(A),B,C,D).
apply('FlatTools.flatShowTrans',A,B,C,D):-hnf('FlatTools.flatShowTrans'(A),B,C,D).
apply('FlatTools.flatShowList',A,'FlatTools.flatShowList'(A),B,B).
apply('FlatTools.flatShowList'(A),B,C,D,E):-hnf('FlatTools.flatShowList'(A,B),C,D,E).
apply('FlatTools.flatShowListElems',A,'FlatTools.flatShowListElems'(A),B,B).
apply('FlatTools.flatShowListElems'(A),B,C,D,E):-hnf('FlatTools.flatShowListElems'(A,B),C,D,E).
apply('FlatTools.flatShowString',A,B,C,D):-hnf('FlatTools.flatShowString'(A),B,C,D).
apply('FlatTools.showCurryType',A,'FlatTools.showCurryType'(A),B,B).
apply('FlatTools.showCurryType'(A),B,'FlatTools.showCurryType'(A,B),C,C).
apply('FlatTools.showCurryType'(A,B),C,D,E,F):-hnf('FlatTools.showCurryType'(A,B,C),D,E,F).
apply('FlatTools.isFuncType',A,B,C,D):-hnf('FlatTools.isFuncType'(A),B,C,D).
apply('FlatTools.showCurryExpr',A,'FlatTools.showCurryExpr'(A),B,B).
apply('FlatTools.showCurryExpr'(A),B,'FlatTools.showCurryExpr'(A,B),C,C).
apply('FlatTools.showCurryExpr'(A,B),C,'FlatTools.showCurryExpr'(A,B,C),D,D).
apply('FlatTools.showCurryExpr'(A,B,C),D,E,F,G):-hnf('FlatTools.showCurryExpr'(A,B,C,D),E,F,G).
apply('FlatTools.showCurryVar',A,B,C,D):-hnf('FlatTools.showCurryVar'(A),B,C,D).
apply('FlatTools.showCurryLit',A,B,C,D):-hnf('FlatTools.showCurryLit'(A),B,C,D).
apply('FlatTools.showCurryCase',A,'FlatTools.showCurryCase'(A),B,B).
apply('FlatTools.showCurryCase'(A),B,'FlatTools.showCurryCase'(A,B),C,C).
apply('FlatTools.showCurryCase'(A,B),C,D,E,F):-hnf('FlatTools.showCurryCase'(A,B,C),D,E,F).
apply('FlatTools.showCurryFiniteList',A,'FlatTools.showCurryFiniteList'(A),B,B).
apply('FlatTools.showCurryFiniteList'(A),B,'FlatTools.showCurryFiniteList'(A,B),C,C).
apply('FlatTools.showCurryFiniteList'(A,B),C,D,E,F):-hnf('FlatTools.showCurryFiniteList'(A,B,C),D,E,F).
apply('FlatTools.showCurryElems',A,'FlatTools.showCurryElems'(A),B,B).
apply('FlatTools.showCurryElems'(A),B,C,D,E):-hnf('FlatTools.showCurryElems'(A,B),C,D,E).
apply('FlatTools.maybeShowBrackets',A,'FlatTools.maybeShowBrackets'(A),B,B).
apply('FlatTools.maybeShowBrackets'(A),B,C,D,E):-hnf('FlatTools.maybeShowBrackets'(A,B),C,D,E).
apply('FlatTools.sceBlanks',A,B,C,D):-hnf('FlatTools.sceBlanks'(A),B,C,D).
apply('FlatTools.isFiniteList',A,B,C,D):-hnf('FlatTools.isFiniteList'(A),B,C,D).
apply('FlatTools.writeFLC',A,'FlatTools.writeFLC'(A),B,B).
apply('FlatTools.writeFLC'(A),B,'FlatTools.writeFLC'(A,B),C,C).
apply('FlatTools.writeFLC'(A,B),C,D,E,F):-hnf('FlatTools.writeFLC'(A,B,C),D,E,F).
apply('FlatTools.showFlcProg',A,B,C,D):-hnf('FlatTools.showFlcProg'(A),B,C,D).
apply('FlatTools.flcShowOp',A,B,C,D):-hnf('FlatTools.flcShowOp'(A),B,C,D).
apply('FlatTools.flcShowFixity',A,B,C,D):-hnf('FlatTools.flcShowFixity'(A),B,C,D).
apply('FlatTools.flcShowType',A,B,C,D):-hnf('FlatTools.flcShowType'(A),B,C,D).
apply('FlatTools.flcShowCons',A,B,C,D):-hnf('FlatTools.flcShowCons'(A),B,C,D).
apply('FlatTools.flcShowFunc',A,B,C,D):-hnf('FlatTools.flcShowFunc'(A),B,C,D).
apply('FlatTools.flcShowRule',A,B,C,D):-hnf('FlatTools.flcShowRule'(A),B,C,D).
apply('FlatTools.flcShowTypeExpr',A,B,C,D):-hnf('FlatTools.flcShowTypeExpr'(A),B,C,D).
apply('FlatTools.flcShowCombType',A,B,C,D):-hnf('FlatTools.flcShowCombType'(A),B,C,D).
apply('FlatTools.flcShowExpr',A,B,C,D):-hnf('FlatTools.flcShowExpr'(A),B,C,D).
apply('FlatTools.flcShowLit',A,B,C,D):-hnf('FlatTools.flcShowLit'(A),B,C,D).
apply('FlatTools.flcShowBranch',A,B,C,D):-hnf('FlatTools.flcShowBranch'(A),B,C,D).
apply('FlatTools.flcShowTrans',A,B,C,D):-hnf('FlatTools.flcShowTrans'(A),B,C,D).
apply('FlatTools.flcShowList',A,'FlatTools.flcShowList'(A),B,B).
apply('FlatTools.flcShowList'(A),B,C,D,E):-hnf('FlatTools.flcShowList'(A,B),C,D,E).
apply('FlatTools.flcShowListElems',A,'FlatTools.flcShowListElems'(A),B,B).
apply('FlatTools.flcShowListElems'(A),B,C,D,E):-hnf('FlatTools.flcShowListElems'(A,B),C,D,E).
apply('FlatTools.flcShowString',A,B,C,D):-hnf('FlatTools.flcShowString'(A),B,C,D).
apply('FlatTools.ppshow',A,'FlatTools.ppshow'(A),B,B).
apply('FlatTools.ppshow'(A),B,C,D,E):-hnf('FlatTools.ppshow'(A,B),C,D,E).
apply('FlatTools.pptest',A,'FlatTools.pptest'(A),B,B).
apply('FlatTools.pptest'(A),B,C,D,E):-hnf('FlatTools.pptest'(A,B),C,D,E).
apply('FlatTools.flcshow',A,'FlatTools.flcshow'(A),B,B).
apply('FlatTools.flcshow'(A),B,C,D,E):-hnf('FlatTools.flcshow'(A,B),C,D,E).
apply('FlatTools.flctest',A,'FlatTools.flctest'(A),B,B).
apply('FlatTools.flctest'(A),B,C,D,E):-hnf('FlatTools.flctest'(A,B),C,D,E).
apply('FlatTools.showPattern_3583',A,'FlatTools.showPattern_3583'(A),B,B).
apply('FlatTools.showPattern_3583'(A),B,C,D,E):-hnf('FlatTools.showPattern_3583'(A,B),C,D,E).
apply('FlatTools.lambdafun_6063',A,'FlatTools.lambdafun_6063'(A),B,B).
apply('FlatTools.lambdafun_6063'(A),B,C,D,E):-hnf('FlatTools.lambdafun_6063'(A,B),C,D,E).
apply('FlatTools.lambdafun_6064',A,'FlatTools.lambdafun_6064'(A),B,B).
apply('FlatTools.lambdafun_6064'(A),B,C,D,E):-hnf('FlatTools.lambdafun_6064'(A,B),C,D,E).
apply('SetRBT2.emptySetRBT',A,B,C,D):-hnf('SetRBT2.emptySetRBT'(A),B,C,D).
apply('SetRBT2.elemRBT',A,'SetRBT2.elemRBT'(A),B,B).
apply('SetRBT2.elemRBT'(A),B,C,D,E):-hnf('SetRBT2.elemRBT'(A,B),C,D,E).
apply('SetRBT2.elemRBTree',A,'SetRBT2.elemRBTree'(A),B,B).
apply('SetRBT2.elemRBTree'(A),B,'SetRBT2.elemRBTree'(A,B),C,C).
apply('SetRBT2.elemRBTree'(A,B),C,D,E,F):-hnf('SetRBT2.elemRBTree'(A,B,C),D,E,F).
apply('SetRBT2.insertRBT',A,'SetRBT2.insertRBT'(A),B,B).
apply('SetRBT2.insertRBT'(A),B,C,D,E):-hnf('SetRBT2.insertRBT'(A,B),C,D,E).
apply('SetRBT2.insertRBTree',A,'SetRBT2.insertRBTree'(A),B,B).
apply('SetRBT2.insertRBTree'(A),B,'SetRBT2.insertRBTree'(A,B),C,C).
apply('SetRBT2.insertRBTree'(A,B),C,D,E,F):-hnf('SetRBT2.insertRBTree'(A,B,C),D,E,F).
apply('SetRBT2.insertMultiRBT',A,'SetRBT2.insertMultiRBT'(A),B,B).
apply('SetRBT2.insertMultiRBT'(A),B,C,D,E):-hnf('SetRBT2.insertMultiRBT'(A,B),C,D,E).
apply('SetRBT2.insertMultiRBTree',A,'SetRBT2.insertMultiRBTree'(A),B,B).
apply('SetRBT2.insertMultiRBTree'(A),B,'SetRBT2.insertMultiRBTree'(A,B),C,C).
apply('SetRBT2.insertMultiRBTree'(A,B),C,D,E,F):-hnf('SetRBT2.insertMultiRBTree'(A,B,C),D,E,F).
apply('SetRBT2.setRBT2list',A,B,C,D):-hnf('SetRBT2.setRBT2list'(A),B,C,D).
apply('SetRBT2.unionRBT',A,'SetRBT2.unionRBT'(A),B,B).
apply('SetRBT2.unionRBT'(A),B,C,D,E):-hnf('SetRBT2.unionRBT'(A,B),C,D,E).
apply('SetRBT2.intersectRBT',A,'SetRBT2.intersectRBT'(A),B,B).
apply('SetRBT2.intersectRBT'(A),B,C,D,E):-hnf('SetRBT2.intersectRBT'(A,B),C,D,E).
apply('SetRBT2.sortRBT',A,'SetRBT2.sortRBT'(A),B,B).
apply('SetRBT2.sortRBT'(A),B,C,D,E):-hnf('SetRBT2.sortRBT'(A,B),C,D,E).
apply('SetRBT2.rbsBalance',A,B,C,D):-hnf('SetRBT2.rbsBalance'(A),B,C,D).
apply('SetRBT2.rbsBalanceL',A,B,C,D):-hnf('SetRBT2.rbsBalanceL'(A),B,C,D).
apply('SetRBT2.rbsBalanceR',A,B,C,D):-hnf('SetRBT2.rbsBalanceR'(A),B,C,D).
apply('SetRBT2.ins_6383',A,'SetRBT2.ins_6383'(A),B,B).
apply('SetRBT2.ins_6383'(A),B,'SetRBT2.ins_6383'(A,B),C,C).
apply('SetRBT2.ins_6383'(A,B),C,D,E,F):-hnf('SetRBT2.ins_6383'(A,B,C),D,E,F).
apply('SetRBT2.setRBT2_lambda0_7386',A,B,C,D):-hnf('SetRBT2.setRBT2_lambda0_7386'(A),B,C,D).
apply('SetRBT2.ins_6398',A,'SetRBT2.ins_6398'(A),B,B).
apply('SetRBT2.ins_6398'(A),B,'SetRBT2.ins_6398'(A,B),C,C).
apply('SetRBT2.ins_6398'(A,B),C,D,E,F):-hnf('SetRBT2.ins_6398'(A,B,C),D,E,F).
apply('SetRBT2.setRBT2_lambda1_7387',A,B,C,D):-hnf('SetRBT2.setRBT2_lambda1_7387'(A),B,C,D).
apply('SetRBT2.s2l_6409',A,'SetRBT2.s2l_6409'(A),B,B).
apply('SetRBT2.s2l_6409'(A),B,C,D,E):-hnf('SetRBT2.s2l_6409'(A,B),C,D,E).
apply('SetRBT2.setRBT2_lambda3_7388',A,'SetRBT2.setRBT2_lambda3_7388'(A),B,B).
apply('SetRBT2.setRBT2_lambda3_7388'(A),B,C,D,E):-hnf('SetRBT2.setRBT2_lambda3_7388'(A,B),C,D,E).
apply('SetRBT2.setRBT2_lambda2_7389',A,'SetRBT2.setRBT2_lambda2_7389'(A),B,B).
apply('SetRBT2.setRBT2_lambda2_7389'(A),B,'SetRBT2.setRBT2_lambda2_7389'(A,B),C,C).
apply('SetRBT2.setRBT2_lambda2_7389'(A,B),C,D,E,F):-hnf('SetRBT2.setRBT2_lambda2_7389'(A,B,C),D,E,F).
apply('SetRBT2.setRBT2_lambda4_7390',A,'SetRBT2.setRBT2_lambda4_7390'(A),B,B).
apply('SetRBT2.setRBT2_lambda4_7390'(A),B,'SetRBT2.setRBT2_lambda4_7390'(A,B),C,C).
apply('SetRBT2.setRBT2_lambda4_7390'(A,B),C,'SetRBT2.setRBT2_lambda4_7390'(A,B,C),D,D).
apply('SetRBT2.setRBT2_lambda4_7390'(A,B,C),D,'SetRBT2.setRBT2_lambda4_7390'(A,B,C,D),E,E).
apply('SetRBT2.setRBT2_lambda4_7390'(A,B,C,D),E,F,G,H):-hnf('SetRBT2.setRBT2_lambda4_7390'(A,B,C,D,E),F,G,H).
apply('TableRBT2.emptyTableRBT',A,B,C,D):-hnf('TableRBT2.emptyTableRBT'(A),B,C,D).
apply('TableRBT2.lookupRBT',A,'TableRBT2.lookupRBT'(A),B,B).
apply('TableRBT2.lookupRBT'(A),B,C,D,E):-hnf('TableRBT2.lookupRBT'(A,B),C,D,E).
apply('TableRBT2.lookupRBTree',A,'TableRBT2.lookupRBTree'(A),B,B).
apply('TableRBT2.lookupRBTree'(A),B,'TableRBT2.lookupRBTree'(A,B),C,C).
apply('TableRBT2.lookupRBTree'(A,B),C,D,E,F):-hnf('TableRBT2.lookupRBTree'(A,B,C),D,E,F).
apply('TableRBT2.updateRBT',A,'TableRBT2.updateRBT'(A),B,B).
apply('TableRBT2.updateRBT'(A),B,'TableRBT2.updateRBT'(A,B),C,C).
apply('TableRBT2.updateRBT'(A,B),C,D,E,F):-hnf('TableRBT2.updateRBT'(A,B,C),D,E,F).
apply('TableRBT2.updateRBTree',A,'TableRBT2.updateRBTree'(A),B,B).
apply('TableRBT2.updateRBTree'(A),B,'TableRBT2.updateRBTree'(A,B),C,C).
apply('TableRBT2.updateRBTree'(A,B),C,'TableRBT2.updateRBTree'(A,B,C),D,D).
apply('TableRBT2.updateRBTree'(A,B,C),D,E,F,G):-hnf('TableRBT2.updateRBTree'(A,B,C,D),E,F,G).
apply('TableRBT2.tableRBT2list',A,B,C,D):-hnf('TableRBT2.tableRBT2list'(A),B,C,D).
apply('TableRBT2.rbtBalance',A,B,C,D):-hnf('TableRBT2.rbtBalance'(A),B,C,D).
apply('TableRBT2.rbtBalanceL',A,B,C,D):-hnf('TableRBT2.rbtBalanceL'(A),B,C,D).
apply('TableRBT2.rbtBalanceR',A,B,C,D):-hnf('TableRBT2.rbtBalanceR'(A),B,C,D).
apply('TableRBT2.ins_7577',A,'TableRBT2.ins_7577'(A),B,B).
apply('TableRBT2.ins_7577'(A),B,'TableRBT2.ins_7577'(A,B),C,C).
apply('TableRBT2.ins_7577'(A,B),C,'TableRBT2.ins_7577'(A,B,C),D,D).
apply('TableRBT2.ins_7577'(A,B,C),D,E,F,G):-hnf('TableRBT2.ins_7577'(A,B,C,D),E,F,G).
apply('TableRBT2.tableRBT2_lambda0_8750',A,B,C,D):-hnf('TableRBT2.tableRBT2_lambda0_8750'(A),B,C,D).
apply('TableRBT2.t2l_7590',A,'TableRBT2.t2l_7590'(A),B,B).
apply('TableRBT2.t2l_7590'(A),B,C,D,E):-hnf('TableRBT2.t2l_7590'(A,B),C,D,E).
apply('TableRBT2.tableRBT2_lambda1_8751',A,'TableRBT2.tableRBT2_lambda1_8751'(A),B,B).
apply('TableRBT2.tableRBT2_lambda1_8751'(A),B,'TableRBT2.tableRBT2_lambda1_8751'(A,B),C,C).
apply('TableRBT2.tableRBT2_lambda1_8751'(A,B),C,'TableRBT2.tableRBT2_lambda1_8751'(A,B,C),D,D).
apply('TableRBT2.tableRBT2_lambda1_8751'(A,B,C),D,'TableRBT2.tableRBT2_lambda1_8751'(A,B,C,D),E,E).
apply('TableRBT2.tableRBT2_lambda1_8751'(A,B,C,D),E,'TableRBT2.tableRBT2_lambda1_8751'(A,B,C,D,E),F,F).
apply('TableRBT2.tableRBT2_lambda1_8751'(A,B,C,D,E),F,G,H,I):-hnf('TableRBT2.tableRBT2_lambda1_8751'(A,B,C,D,E,F),G,H,I).
apply('System.showDate',A,B,C,D):-hnf('System.showDate'(A),B,C,D).
apply('System.digit2_2404',A,B,C,D):-hnf('System.digit2_2404'(A),B,C,D).
apply('List.nub',A,B,C,D):-hnf('List.nub'(A),B,C,D).
apply('List.nubBy',A,'List.nubBy'(A),B,B).
apply('List.nubBy'(A),B,C,D,E):-hnf('List.nubBy'(A,B),C,D,E).
apply('List.delete',A,'List.delete'(A),B,B).
apply('List.delete'(A),B,C,D,E):-hnf('List.delete'(A,B),C,D,E).
apply('List.union',A,'List.union'(A),B,B).
apply('List.union'(A),B,C,D,E):-hnf('List.union'(A,B),C,D,E).
apply('List.intersect',A,'List.intersect'(A),B,B).
apply('List.intersect'(A),B,C,D,E):-hnf('List.intersect'(A,B),C,D,E).
apply('List.intersperse',A,'List.intersperse'(A),B,B).
apply('List.intersperse'(A),B,C,D,E):-hnf('List.intersperse'(A,B),C,D,E).
apply('List.transpose',A,B,C,D):-hnf('List.transpose'(A),B,C,D).
apply('List.partition',A,'List.partition'(A),B,B).
apply('List.partition'(A),B,C,D,E):-hnf('List.partition'(A,B),C,D,E).
apply('List.group',A,B,C,D):-hnf('List.group'(A),B,C,D).
apply('List.groupBy',A,'List.groupBy'(A),B,B).
apply('List.groupBy'(A),B,C,D,E):-hnf('List.groupBy'(A,B),C,D,E).
apply('List.replace',A,'List.replace'(A),B,B).
apply('List.replace'(A),B,'List.replace'(A,B),C,C).
apply('List.replace'(A,B),C,D,E,F):-hnf('List.replace'(A,B,C),D,E,F).
apply('List.isPrefixOf',A,'List.isPrefixOf'(A),B,B).
apply('List.isPrefixOf'(A),B,C,D,E):-hnf('List.isPrefixOf'(A,B),C,D,E).
apply('List.sortBy',A,'List.sortBy'(A),B,B).
apply('List.sortBy'(A),B,C,D,E):-hnf('List.sortBy'(A,B),C,D,E).
apply('List.insertBy',A,'List.insertBy'(A),B,B).
apply('List.insertBy'(A),B,'List.insertBy'(A,B),C,C).
apply('List.insertBy'(A,B),C,D,E,F):-hnf('List.insertBy'(A,B,C),D,E,F).
apply('List.last',A,B,C,D):-hnf('List.last'(A),B,C,D).
apply('List.list_lambda0_3110',A,'List.list_lambda0_3110'(A),B,B).
apply('List.list_lambda0_3110'(A),B,'List.list_lambda0_3110'(A,B),C,C).
apply('List.list_lambda0_3110'(A,B),C,D,E,F):-hnf('List.list_lambda0_3110'(A,B,C),D,E,F).
apply('List.select_2741',A,'List.select_2741'(A),B,B).
apply('List.select_2741'(A),B,'List.select_2741'(A,B),C,C).
apply('List.select_2741'(A,B),C,D,E,F):-hnf('List.select_2741'(A,B,C),D,E,F).
apply('List.list_lambda1_3111',A,'List.list_lambda1_3111'(A),B,B).
apply('List.list_lambda1_3111'(A),B,'List.list_lambda1_3111'(A,B),C,C).
apply('List.list_lambda1_3111'(A,B),C,D,E,F):-hnf('List.list_lambda1_3111'(A,B,C),D,E,F).
apply('Char.isUpper',A,B,C,D):-hnf('Char.isUpper'(A),B,C,D).
apply('Char.isLower',A,B,C,D):-hnf('Char.isLower'(A),B,C,D).
apply('Char.isAlpha',A,B,C,D):-hnf('Char.isAlpha'(A),B,C,D).
apply('Char.isDigit',A,B,C,D):-hnf('Char.isDigit'(A),B,C,D).
apply('Char.isAlphaNum',A,B,C,D):-hnf('Char.isAlphaNum'(A),B,C,D).
apply('Char.isOctDigit',A,B,C,D):-hnf('Char.isOctDigit'(A),B,C,D).
apply('Char.isHexDigit',A,B,C,D):-hnf('Char.isHexDigit'(A),B,C,D).
apply('Char.isSpace',A,B,C,D):-hnf('Char.isSpace'(A),B,C,D).
apply('Char.toUpper',A,B,C,D):-hnf('Char.toUpper'(A),B,C,D).
apply('Char.toLower',A,B,C,D):-hnf('Char.toLower'(A),B,C,D).
apply('Char.digitToInt',A,B,C,D):-hnf('Char.digitToInt'(A),B,C,D).
apply('Char.intToDigit',A,B,C,D):-hnf('Char.intToDigit'(A),B,C,D).
apply(&,A,&(A),B,B).
apply(&(A),B,C,D,E):-hnf(&(A,B),C,D,E).
apply(+,A,+(A),B,B).
apply(+(A),B,C,D,E):-hnf(A+B,C,D,E).
apply(-,A,-(A),B,B).
apply(-(A),B,C,D,E):-hnf(A-B,C,D,E).
apply(*,A,*(A),B,B).
apply(*(A),B,C,D,E):-hnf(A*B,C,D,E).
apply(div,A,div(A),B,B).
apply(div(A),B,C,D,E):-hnf(div(A,B),C,D,E).
apply(mod,A,mod(A),B,B).
apply(mod(A),B,C,D,E):-hnf(A mod B,C,D,E).
apply(<,A,<(A),B,B).
apply(<(A),B,C,D,E):-hnf(A<B,C,D,E).
apply(>,A,>(A),B,B).
apply(>(A),B,C,D,E):-hnf(A>B,C,D,E).
apply(<=,A,<=(A),B,B).
apply(<=(A),B,C,D,E):-hnf(<=(A,B),C,D,E).
apply(>=,A,>=(A),B,B).
apply(>=(A),B,C,D,E):-hnf(A>=B,C,D,E).
apply(ord,A,B,C,D):-hnf(ord(A),B,C,D).
apply(chr,A,B,C,D):-hnf(chr(A),B,C,D).
apply(>>=,A,>>=(A),B,B).
apply(>>=(A),B,>>=(A,B),C,C).
apply(>>=(A,B),C,D,E,F):-hnf(>>=(A,B,C),D,E,F).
apply(>>,A,>>(A),B,B).
apply(>>(A),B,A>>B,C,C).
apply(A>>B,C,D,E,F):-hnf(>>(A,B,C),D,E,F).
apply(putChar,A,putChar(A),B,B).
apply(putChar(A),B,C,D,E):-hnf(putChar(A,B),C,D,E).
apply(getChar,A,B,C,D):-hnf(getChar(A),B,C,D).
apply(return,A,return(A),B,B).
apply(return(A),B,C,D,E):-hnf(return(A,B),C,D,E).
apply(readFile,A,readFile(A),B,B).
apply(readFile(A),B,C,D,E):-hnf(readFile(A,B),C,D,E).
apply('#readFileContents',A,'#readFileContents'(A),B,B).
apply('#readFileContents'(A),B,C,D,E):-hnf('#readFileContents'(A,B),C,D,E).
apply(writeFile,A,writeFile(A),B,B).
apply(writeFile(A),B,writeFile(A,B),C,C).
apply(writeFile(A,B),C,D,E,F):-hnf(writeFile(A,B,C),D,E,F).
apply(appendFile,A,appendFile(A),B,B).
apply(appendFile(A),B,appendFile(A,B),C,C).
apply(appendFile(A,B),C,D,E,F):-hnf(appendFile(A,B,C),D,E,F).
apply('#writeFileContents',A,'#writeFileContents'(A),B,B).
apply('#writeFileContents'(A),B,'#writeFileContents'(A,B),C,C).
apply('#writeFileContents'(A,B),C,D,E,F):-hnf('#writeFileContents'(A,B,C),D,E,F).
apply(catchFail,A,catchFail(A),B,B).
apply(catchFail(A),B,catchFail(A,B),C,C).
apply(catchFail(A,B),C,D,E,F):-hnf(catchFail(A,B,C),D,E,F).
apply(findall,A,B,C,D):-hnf(findall(A),B,C,D).
apply(findfirst,A,B,C,D):-hnf(findfirst(A),B,C,D).
apply(show,A,B,C,D):-hnf(show(A),B,C,D).
apply(seq,A,seq(A),B,B).
apply(seq(A),B,C,D,E):-hnf(seq(A,B),C,D,E).
apply(error,A,B,C,D):-hnf(error(A),B,C,D).
apply('Unsafe.unsafePerformIO',A,B,C,D):-hnf('Unsafe.unsafePerformIO'(A),B,C,D).
apply('Unsafe.isVar',A,B,C,D):-hnf('Unsafe.isVar'(A),B,C,D).
apply('Unsafe.spawnConstraint',A,'Unsafe.spawnConstraint'(A),B,B).
apply('Unsafe.spawnConstraint'(A),B,C,D,E):-hnf('Unsafe.spawnConstraint'(A,B),C,D,E).
apply('AbsCurry.readCurryFile',A,'AbsCurry.readCurryFile'(A),B,B).
apply('AbsCurry.readCurryFile'(A),B,C,D,E):-hnf('AbsCurry.readCurryFile'(A,B),C,D,E).
apply('Flat.readFlatCurryFile',A,'Flat.readFlatCurryFile'(A),B,B).
apply('Flat.readFlatCurryFile'(A),B,C,D,E):-hnf('Flat.readFlatCurryFile'(A,B),C,D,E).
apply('FlatCurry.readFlatCurryFile',A,'FlatCurry.readFlatCurryFile'(A),B,B).
apply('FlatCurry.readFlatCurryFile'(A),B,C,D,E):-hnf('FlatCurry.readFlatCurryFile'(A,B),C,D,E).
apply('System.getCPUTime',A,B,C,D):-hnf('System.getCPUTime'(A),B,C,D).
apply('System.getElapsedTime',A,B,C,D):-hnf('System.getElapsedTime'(A),B,C,D).
apply('System.getDate',A,B,C,D):-hnf('System.getDate'(A),B,C,D).
apply('System.getArgs',A,B,C,D):-hnf('System.getArgs'(A),B,C,D).
apply('System.getEnviron',A,'System.getEnviron'(A),B,B).
apply('System.getEnviron'(A),B,C,D,E):-hnf('System.getEnviron'(A,B),C,D,E).
apply('System.getHostname',A,B,C,D):-hnf('System.getHostname'(A),B,C,D).
apply('System.getPID',A,B,C,D):-hnf('System.getPID'(A),B,C,D).
apply('System.system',A,'System.system'(A),B,B).
apply('System.system'(A),B,C,D,E):-hnf('System.system'(A,B),C,D,E).
apply('System.sleep',A,'System.sleep'(A),B,B).
apply('System.sleep'(A),B,C,D,E):-hnf('System.sleep'(A,B),C,D,E).
apply('System.evalTime',A,B,C,D):-hnf('System.evalTime'(A),B,C,D).
apply('System.evalSpace',A,B,C,D):-hnf('System.evalSpace'(A),B,C,D).
apply('IOExts.setAssoc',A,'IOExts.setAssoc'(A),B,B).
apply('IOExts.setAssoc'(A),B,'IOExts.setAssoc'(A,B),C,C).
apply('IOExts.setAssoc'(A,B),C,D,E,F):-hnf('IOExts.setAssoc'(A,B,C),D,E,F).
apply('IOExts.getAssoc',A,'IOExts.getAssoc'(A),B,B).
apply('IOExts.getAssoc'(A),B,C,D,E):-hnf('IOExts.getAssoc'(A,B),C,D,E).
apply('Time.getClockTime',A,B,C,D):-hnf('Time.getClockTime'(A),B,C,D).
apply('Directory.doesFileExist',A,'Directory.doesFileExist'(A),B,B).
apply('Directory.doesFileExist'(A),B,C,D,E):-hnf('Directory.doesFileExist'(A,B),C,D,E).
apply('Directory.doesDirectoryExist',A,'Directory.doesDirectoryExist'(A),B,B).
apply('Directory.doesDirectoryExist'(A),B,C,D,E):-hnf('Directory.doesDirectoryExist'(A,B),C,D,E).
apply('Directory.getModificationTime',A,'Directory.getModificationTime'(A),B,B).
apply('Directory.getModificationTime'(A),B,C,D,E):-hnf('Directory.getModificationTime'(A,B),C,D,E).
apply('Directory.getDirectoryContents',A,'Directory.getDirectoryContents'(A),B,B).
apply('Directory.getDirectoryContents'(A),B,C,D,E):-hnf('Directory.getDirectoryContents'(A,B),C,D,E).
apply('Term.showQTerm',A,B,C,D):-hnf('Term.showQTerm'(A),B,C,D).
apply('Term.showTerm',A,B,C,D):-hnf('Term.showTerm'(A),B,C,D).
apply('Term.readQTerm',A,B,C,D):-hnf('Term.readQTerm'(A),B,C,D).
apply('Term.readTerm',A,B,C,D):-hnf('Term.readTerm'(A),B,C,D).
apply('Ports.openPort',A,'Ports.openPort'(A),B,B).
apply('Ports.openPort'(A),B,C,D,E):-hnf('Ports.openPort'(A,B),C,D,E).
apply('#basicserverloop',A,'#basicserverloop'(A),B,B).
apply('#basicserverloop'(A),B,C,D,E):-hnf('#basicserverloop'(A,B),C,D,E).
apply('Ports.send',A,'Ports.send'(A),B,B).
apply('Ports.send'(A),B,C,D,E):-hnf('Ports.send'(A,B),C,D,E).
apply('Ports.openProcessPort',A,'Ports.openProcessPort'(A),B,B).
apply('Ports.openProcessPort'(A),B,C,D,E):-hnf('Ports.openProcessPort'(A,B),C,D,E).
apply('Ports.openSocketConnectPort',A,'Ports.openSocketConnectPort'(A),B,B).
apply('Ports.openSocketConnectPort'(A),B,'Ports.openSocketConnectPort'(A,B),C,C).
apply('Ports.openSocketConnectPort'(A,B),C,D,E,F):-hnf('Ports.openSocketConnectPort'(A,B,C),D,E,F).
apply('Ports.ping',A,'Ports.ping'(A),B,B).
apply('Ports.ping'(A),B,'Ports.ping'(A,B),C,C).
apply('Ports.ping'(A,B),C,D,E,F):-hnf('Ports.ping'(A,B,C),D,E,F).
apply('Ports.timeoutOnStream',A,'Ports.timeoutOnStream'(A),B,B).
apply('Ports.timeoutOnStream'(A),B,C,D,E):-hnf('Ports.timeoutOnStream'(A,B),C,D,E).
apply('Ports.openPortOnSocket',A,'Ports.openPortOnSocket'(A),B,B).
apply('Ports.openPortOnSocket'(A),B,'Ports.openPortOnSocket'(A,B),C,C).
apply('Ports.openPortOnSocket'(A,B),C,D,E,F):-hnf('Ports.openPortOnSocket'(A,B,C),D,E,F).
apply('Ports.connectPortAtSocket',A,'Ports.connectPortAtSocket'(A),B,B).
apply('Ports.connectPortAtSocket'(A),B,'Ports.connectPortAtSocket'(A,B),C,C).
apply('Ports.connectPortAtSocket'(A,B),C,'Ports.connectPortAtSocket'(A,B,C),D,D).
apply('Ports.connectPortAtSocket'(A,B,C),D,E,F,G):-hnf('Ports.connectPortAtSocket'(A,B,C,D),E,F,G).
apply('Ports.choiceSPEP',A,'Ports.choiceSPEP'(A),B,B).
apply('Ports.choiceSPEP'(A),B,C,D,E):-hnf('Ports.choiceSPEP'(A,B),C,D,E).
apply('CLPR.+.',A,'CLPR.+.'(A),B,B).
apply('CLPR.+.'(A),B,C,D,E):-hnf('CLPR.+.'(A,B),C,D,E).
apply('CLPR.-.',A,'CLPR.-.'(A),B,B).
apply('CLPR.-.'(A),B,C,D,E):-hnf('CLPR.-.'(A,B),C,D,E).
apply('CLPR.*.',A,'CLPR.*.'(A),B,B).
apply('CLPR.*.'(A),B,C,D,E):-hnf('CLPR.*.'(A,B),C,D,E).
apply('CLPR./.',A,'CLPR./.'(A),B,B).
apply('CLPR./.'(A),B,C,D,E):-hnf('CLPR./.'(A,B),C,D,E).
apply('CLPR.<.',A,'CLPR.<.'(A),B,B).
apply('CLPR.<.'(A),B,C,D,E):-hnf('CLPR.<.'(A,B),C,D,E).
apply('CLPR.>.',A,'CLPR.>.'(A),B,B).
apply('CLPR.>.'(A),B,C,D,E):-hnf('CLPR.>.'(A,B),C,D,E).
apply('CLPR.<=.',A,'CLPR.<=.'(A),B,B).
apply('CLPR.<=.'(A),B,C,D,E):-hnf('CLPR.<=.'(A,B),C,D,E).
apply('CLPR.>=.',A,'CLPR.>=.'(A),B,B).
apply('CLPR.>=.'(A),B,C,D,E):-hnf('CLPR.>=.'(A,B),C,D,E).
apply('CLPR.i2f',A,B,C,D):-hnf('CLPR.i2f'(A),B,C,D).
apply('CLPFD.+#',A,'CLPFD.+#'(A),B,B).
apply('CLPFD.+#'(A),B,C,D,E):-hnf('CLPFD.+#'(A,B),C,D,E).
apply('CLPFD.-#',A,'CLPFD.-#'(A),B,B).
apply('CLPFD.-#'(A),B,C,D,E):-hnf('CLPFD.-#'(A,B),C,D,E).
apply('CLPFD.*#',A,'CLPFD.*#'(A),B,B).
apply('CLPFD.*#'(A),B,C,D,E):-hnf('CLPFD.*#'(A,B),C,D,E).
apply('CLPFD.=#',A,'CLPFD.=#'(A),B,B).
apply('CLPFD.=#'(A),B,C,D,E):-hnf('CLPFD.=#'(A,B),C,D,E).
apply('CLPFD./=#',A,'CLPFD./=#'(A),B,B).
apply('CLPFD./=#'(A),B,C,D,E):-hnf('CLPFD./=#'(A,B),C,D,E).
apply('CLPFD.<#',A,'CLPFD.<#'(A),B,B).
apply('CLPFD.<#'(A),B,C,D,E):-hnf('CLPFD.<#'(A,B),C,D,E).
apply('CLPFD.>#',A,'CLPFD.>#'(A),B,B).
apply('CLPFD.>#'(A),B,C,D,E):-hnf('CLPFD.>#'(A,B),C,D,E).
apply('CLPFD.<=#',A,'CLPFD.<=#'(A),B,B).
apply('CLPFD.<=#'(A),B,C,D,E):-hnf('CLPFD.<=#'(A,B),C,D,E).
apply('CLPFD.>=#',A,'CLPFD.>=#'(A),B,B).
apply('CLPFD.>=#'(A),B,C,D,E):-hnf('CLPFD.>=#'(A,B),C,D,E).
apply('CLPFD.domain',A,'CLPFD.domain'(A),B,B).
apply('CLPFD.domain'(A),B,'CLPFD.domain'(A,B),C,C).
apply('CLPFD.domain'(A,B),C,D,E,F):-hnf('CLPFD.domain'(A,B,C),D,E,F).
apply('CLPFD.all_different',A,B,C,D):-hnf('CLPFD.all_different'(A),B,C,D).
apply('CLPFD.labeling',A,B,C,D):-hnf('CLPFD.labeling'(A),B,C,D).
apply('TermDB.openDB',A,'TermDB.openDB'(A),B,B).
apply('TermDB.openDB'(A),B,C,D,E):-hnf('TermDB.openDB'(A,B),C,D,E).
apply('TermDB.closeDB',A,'TermDB.closeDB'(A),B,B).
apply('TermDB.closeDB'(A),B,C,D,E):-hnf('TermDB.closeDB'(A,B),C,D,E).
apply('TermDB.storeDB',A,'TermDB.storeDB'(A),B,B).
apply('TermDB.storeDB'(A),B,'TermDB.storeDB'(A,B),C,C).
apply('TermDB.storeDB'(A,B),C,D,E,F):-hnf('TermDB.storeDB'(A,B,C),D,E,F).
apply('TermDB.eraseDB',A,'TermDB.eraseDB'(A),B,B).
apply('TermDB.eraseDB'(A),B,'TermDB.eraseDB'(A,B),C,C).
apply('TermDB.eraseDB'(A,B),C,D,E,F):-hnf('TermDB.eraseDB'(A,B,C),D,E,F).
apply('TermDB.findallDB',A,'TermDB.findallDB'(A),B,B).
apply('TermDB.findallDB'(A),B,'TermDB.findallDB'(A,B),C,C).
apply('TermDB.findallDB'(A,B),C,D,E,F):-hnf('TermDB.findallDB'(A,B,C),D,E,F).
apply('.',A,'.'(A),B,B).
apply('.'(A),B,C,D,E):-hnf([A|B],C,D,E).
apply('(,)',A,'(,)'(A),B,B).
apply('(,)'(A),B,C,D,E):-hnf('(,)'(A,B),C,D,E).
apply('(,,)',A,'(,,)'(A),B,B).
apply('(,,)'(A),B,'(,,)'(A,B),C,C).
apply('(,,)'(A,B),C,D,E,F):-hnf('(,,)'(A,B,C),D,E,F).
apply('(,,,)',A,'(,,,)'(A),B,B).
apply('(,,,)'(A),B,'(,,,)'(A,B),C,C).
apply('(,,,)'(A,B),C,'(,,,)'(A,B,C),D,D).
apply('(,,,)'(A,B,C),D,E,F,G):-hnf('(,,,)'(A,B,C,D),E,F,G).
apply('(,,,,)',A,'(,,,,)'(A),B,B).
apply('(,,,,)'(A),B,'(,,,,)'(A,B),C,C).
apply('(,,,,)'(A,B),C,'(,,,,)'(A,B,C),D,D).
apply('(,,,,)'(A,B,C),D,'(,,,,)'(A,B,C,D),E,E).
apply('(,,,,)'(A,B,C,D),E,F,G,H):-hnf('(,,,,)'(A,B,C,D,E),F,G,H).
apply('(,,,,,)',A,'(,,,,,)'(A),B,B).
apply('(,,,,,)'(A),B,'(,,,,,)'(A,B),C,C).
apply('(,,,,,)'(A,B),C,'(,,,,,)'(A,B,C),D,D).
apply('(,,,,,)'(A,B,C),D,'(,,,,,)'(A,B,C,D),E,E).
apply('(,,,,,)'(A,B,C,D),E,'(,,,,,)'(A,B,C,D,E),F,F).
apply('(,,,,,)'(A,B,C,D,E),F,G,H,I):-hnf('(,,,,,)'(A,B,C,D,E,F),G,H,I).
apply('(,,,,,,)',A,'(,,,,,,)'(A),B,B).
apply('(,,,,,,)'(A),B,'(,,,,,,)'(A,B),C,C).
apply('(,,,,,,)'(A,B),C,'(,,,,,,)'(A,B,C),D,D).
apply('(,,,,,,)'(A,B,C),D,'(,,,,,,)'(A,B,C,D),E,E).
apply('(,,,,,,)'(A,B,C,D),E,'(,,,,,,)'(A,B,C,D,E),F,F).
apply('(,,,,,,)'(A,B,C,D,E),F,'(,,,,,,)'(A,B,C,D,E,F),G,G).
apply('(,,,,,,)'(A,B,C,D,E,F),G,H,I,J):-hnf('(,,,,,,)'(A,B,C,D,E,F,G),H,I,J).
apply('(,,,,,,,)',A,'(,,,,,,,)'(A),B,B).
apply('(,,,,,,,)'(A),B,'(,,,,,,,)'(A,B),C,C).
apply('(,,,,,,,)'(A,B),C,'(,,,,,,,)'(A,B,C),D,D).
apply('(,,,,,,,)'(A,B,C),D,'(,,,,,,,)'(A,B,C,D),E,E).
apply('(,,,,,,,)'(A,B,C,D),E,'(,,,,,,,)'(A,B,C,D,E),F,F).
apply('(,,,,,,,)'(A,B,C,D,E),F,'(,,,,,,,)'(A,B,C,D,E,F),G,G).
apply('(,,,,,,,)'(A,B,C,D,E,F),G,'(,,,,,,,)'(A,B,C,D,E,F,G),H,H).
apply('(,,,,,,,)'(A,B,C,D,E,F,G),H,I,J,K):-hnf('(,,,,,,,)'(A,B,C,D,E,F,G,H),I,J,K).
apply('(,,,,,,,,)',A,'(,,,,,,,,)'(A),B,B).
apply('(,,,,,,,,)'(A),B,'(,,,,,,,,)'(A,B),C,C).
apply('(,,,,,,,,)'(A,B),C,'(,,,,,,,,)'(A,B,C),D,D).
apply('(,,,,,,,,)'(A,B,C),D,'(,,,,,,,,)'(A,B,C,D),E,E).
apply('(,,,,,,,,)'(A,B,C,D),E,'(,,,,,,,,)'(A,B,C,D,E),F,F).
apply('(,,,,,,,,)'(A,B,C,D,E),F,'(,,,,,,,,)'(A,B,C,D,E,F),G,G).
apply('(,,,,,,,,)'(A,B,C,D,E,F),G,'(,,,,,,,,)'(A,B,C,D,E,F,G),H,H).
apply('(,,,,,,,,)'(A,B,C,D,E,F,G),H,'(,,,,,,,,)'(A,B,C,D,E,F,G,H),I,I).
apply('(,,,,,,,,)'(A,B,C,D,E,F,G,H),I,J,K,L):-hnf('(,,,,,,,,)'(A,B,C,D,E,F,G,H,I),J,K,L).
apply('(,,,,,,,,,)',A,'(,,,,,,,,,)'(A),B,B).
apply('(,,,,,,,,,)'(A),B,'(,,,,,,,,,)'(A,B),C,C).
apply('(,,,,,,,,,)'(A,B),C,'(,,,,,,,,,)'(A,B,C),D,D).
apply('(,,,,,,,,,)'(A,B,C),D,'(,,,,,,,,,)'(A,B,C,D),E,E).
apply('(,,,,,,,,,)'(A,B,C,D),E,'(,,,,,,,,,)'(A,B,C,D,E),F,F).
apply('(,,,,,,,,,)'(A,B,C,D,E),F,'(,,,,,,,,,)'(A,B,C,D,E,F),G,G).
apply('(,,,,,,,,,)'(A,B,C,D,E,F),G,'(,,,,,,,,,)'(A,B,C,D,E,F,G),H,H).
apply('(,,,,,,,,,)'(A,B,C,D,E,F,G),H,'(,,,,,,,,,)'(A,B,C,D,E,F,G,H),I,I).
apply('(,,,,,,,,,)'(A,B,C,D,E,F,G,H),I,'(,,,,,,,,,)'(A,B,C,D,E,F,G,H,I),J,J).
apply('(,,,,,,,,,)'(A,B,C,D,E,F,G,H,I),J,K,L,M):-hnf('(,,,,,,,,,)'(A,B,C,D,E,F,G,H,I,J),K,L,M).
apply('(,,,,,,,,,,)',A,'(,,,,,,,,,,)'(A),B,B).
apply('(,,,,,,,,,,)'(A),B,'(,,,,,,,,,,)'(A,B),C,C).
apply('(,,,,,,,,,,)'(A,B),C,'(,,,,,,,,,,)'(A,B,C),D,D).
apply('(,,,,,,,,,,)'(A,B,C),D,'(,,,,,,,,,,)'(A,B,C,D),E,E).
apply('(,,,,,,,,,,)'(A,B,C,D),E,'(,,,,,,,,,,)'(A,B,C,D,E),F,F).
apply('(,,,,,,,,,,)'(A,B,C,D,E),F,'(,,,,,,,,,,)'(A,B,C,D,E,F),G,G).
apply('(,,,,,,,,,,)'(A,B,C,D,E,F),G,'(,,,,,,,,,,)'(A,B,C,D,E,F,G),H,H).
apply('(,,,,,,,,,,)'(A,B,C,D,E,F,G),H,'(,,,,,,,,,,)'(A,B,C,D,E,F,G,H),I,I).
apply('(,,,,,,,,,,)'(A,B,C,D,E,F,G,H),I,'(,,,,,,,,,,)'(A,B,C,D,E,F,G,H,I),J,J).
apply('(,,,,,,,,,,)'(A,B,C,D,E,F,G,H,I),J,'(,,,,,,,,,,)'(A,B,C,D,E,F,G,H,I,J),K,K).
apply('(,,,,,,,,,,)'(A,B,C,D,E,F,G,H,I,J),K,L,M,N):-hnf('(,,,,,,,,,,)'(A,B,C,D,E,F,G,H,I,J,K),L,M,N).
apply('(,,,,,,,,,,,)',A,'(,,,,,,,,,,,)'(A),B,B).
apply('(,,,,,,,,,,,)'(A),B,'(,,,,,,,,,,,)'(A,B),C,C).
apply('(,,,,,,,,,,,)'(A,B),C,'(,,,,,,,,,,,)'(A,B,C),D,D).
apply('(,,,,,,,,,,,)'(A,B,C),D,'(,,,,,,,,,,,)'(A,B,C,D),E,E).
apply('(,,,,,,,,,,,)'(A,B,C,D),E,'(,,,,,,,,,,,)'(A,B,C,D,E),F,F).
apply('(,,,,,,,,,,,)'(A,B,C,D,E),F,'(,,,,,,,,,,,)'(A,B,C,D,E,F),G,G).
apply('(,,,,,,,,,,,)'(A,B,C,D,E,F),G,'(,,,,,,,,,,,)'(A,B,C,D,E,F,G),H,H).
apply('(,,,,,,,,,,,)'(A,B,C,D,E,F,G),H,'(,,,,,,,,,,,)'(A,B,C,D,E,F,G,H),I,I).
apply('(,,,,,,,,,,,)'(A,B,C,D,E,F,G,H),I,'(,,,,,,,,,,,)'(A,B,C,D,E,F,G,H,I),J,J).
apply('(,,,,,,,,,,,)'(A,B,C,D,E,F,G,H,I),J,'(,,,,,,,,,,,)'(A,B,C,D,E,F,G,H,I,J),K,K).
apply('(,,,,,,,,,,,)'(A,B,C,D,E,F,G,H,I,J),K,'(,,,,,,,,,,,)'(A,B,C,D,E,F,G,H,I,J,K),L,L).
apply('(,,,,,,,,,,,)'(A,B,C,D,E,F,G,H,I,J,K),L,M,N,O):-hnf('(,,,,,,,,,,,)'(A,B,C,D,E,F,G,H,I,J,K,L),M,N,O).
apply('Just',A,B,C,D):-hnf('Just'(A),B,C,D).
apply('Left',A,B,C,D):-hnf('Left'(A),B,C,D).
apply('Right',A,B,C,D):-hnf('Right'(A),B,C,D).
apply('Flat.Prog',A,'Flat.Prog'(A),B,B).
apply('Flat.Prog'(A),B,'Flat.Prog'(A,B),C,C).
apply('Flat.Prog'(A,B),C,'Flat.Prog'(A,B,C),D,D).
apply('Flat.Prog'(A,B,C),D,'Flat.Prog'(A,B,C,D),E,E).
apply('Flat.Prog'(A,B,C,D),E,'Flat.Prog'(A,B,C,D,E),F,F).
apply('Flat.Prog'(A,B,C,D,E),F,G,H,I):-hnf('Flat.Prog'(A,B,C,D,E,F),G,H,I).
apply('Flat.Type',A,'Flat.Type'(A),B,B).
apply('Flat.Type'(A),B,'Flat.Type'(A,B),C,C).
apply('Flat.Type'(A,B),C,D,E,F):-hnf('Flat.Type'(A,B,C),D,E,F).
apply('Flat.Cons',A,'Flat.Cons'(A),B,B).
apply('Flat.Cons'(A),B,'Flat.Cons'(A,B),C,C).
apply('Flat.Cons'(A,B),C,D,E,F):-hnf('Flat.Cons'(A,B,C),D,E,F).
apply('Flat.TVar',A,B,C,D):-hnf('Flat.TVar'(A),B,C,D).
apply('Flat.FuncType',A,'Flat.FuncType'(A),B,B).
apply('Flat.FuncType'(A),B,C,D,E):-hnf('Flat.FuncType'(A,B),C,D,E).
apply('Flat.TCons',A,'Flat.TCons'(A),B,B).
apply('Flat.TCons'(A),B,C,D,E):-hnf('Flat.TCons'(A,B),C,D,E).
apply('Flat.Op',A,'Flat.Op'(A),B,B).
apply('Flat.Op'(A),B,'Flat.Op'(A,B),C,C).
apply('Flat.Op'(A,B),C,D,E,F):-hnf('Flat.Op'(A,B,C),D,E,F).
apply('Flat.Func',A,'Flat.Func'(A),B,B).
apply('Flat.Func'(A),B,'Flat.Func'(A,B),C,C).
apply('Flat.Func'(A,B),C,'Flat.Func'(A,B,C),D,D).
apply('Flat.Func'(A,B,C),D,E,F,G):-hnf('Flat.Func'(A,B,C,D),E,F,G).
apply('Flat.Rule',A,'Flat.Rule'(A),B,B).
apply('Flat.Rule'(A),B,C,D,E):-hnf('Flat.Rule'(A,B),C,D,E).
apply('Flat.External',A,B,C,D):-hnf('Flat.External'(A),B,C,D).
apply('Flat.Var',A,B,C,D):-hnf('Flat.Var'(A),B,C,D).
apply('Flat.Lit',A,B,C,D):-hnf('Flat.Lit'(A),B,C,D).
apply('Flat.Comb',A,'Flat.Comb'(A),B,B).
apply('Flat.Comb'(A),B,'Flat.Comb'(A,B),C,C).
apply('Flat.Comb'(A,B),C,D,E,F):-hnf('Flat.Comb'(A,B,C),D,E,F).
apply('Flat.Apply',A,'Flat.Apply'(A),B,B).
apply('Flat.Apply'(A),B,C,D,E):-hnf('Flat.Apply'(A,B),C,D,E).
apply('Flat.Constr',A,'Flat.Constr'(A),B,B).
apply('Flat.Constr'(A),B,C,D,E):-hnf('Flat.Constr'(A,B),C,D,E).
apply('Flat.Or',A,'Flat.Or'(A),B,B).
apply('Flat.Or'(A),B,C,D,E):-hnf('Flat.Or'(A,B),C,D,E).
apply('Flat.Case',A,'Flat.Case'(A),B,B).
apply('Flat.Case'(A),B,'Flat.Case'(A,B),C,C).
apply('Flat.Case'(A,B),C,D,E,F):-hnf('Flat.Case'(A,B,C),D,E,F).
apply('Flat.Choice',A,B,C,D):-hnf('Flat.Choice'(A),B,C,D).
apply('Flat.GuardedExpr',A,'Flat.GuardedExpr'(A),B,B).
apply('Flat.GuardedExpr'(A),B,'Flat.GuardedExpr'(A,B),C,C).
apply('Flat.GuardedExpr'(A,B),C,D,E,F):-hnf('Flat.GuardedExpr'(A,B,C),D,E,F).
apply('Flat.Branch',A,'Flat.Branch'(A),B,B).
apply('Flat.Branch'(A),B,C,D,E):-hnf('Flat.Branch'(A,B),C,D,E).
apply('Flat.Pattern',A,'Flat.Pattern'(A),B,B).
apply('Flat.Pattern'(A),B,C,D,E):-hnf('Flat.Pattern'(A,B),C,D,E).
apply('Flat.LPattern',A,B,C,D):-hnf('Flat.LPattern'(A),B,C,D).
apply('Flat.Intc',A,B,C,D):-hnf('Flat.Intc'(A),B,C,D).
apply('Flat.Floatc',A,B,C,D):-hnf('Flat.Floatc'(A),B,C,D).
apply('Flat.Charc',A,B,C,D):-hnf('Flat.Charc'(A),B,C,D).
apply('Flat.Trans',A,'Flat.Trans'(A),B,B).
apply('Flat.Trans'(A),B,C,D,E):-hnf('Flat.Trans'(A,B),C,D,E).
apply('SetRBT2.RBS',A,'SetRBT2.RBS'(A),B,B).
apply('SetRBT2.RBS'(A),B,'SetRBT2.RBS'(A,B),C,C).
apply('SetRBT2.RBS'(A,B),C,'SetRBT2.RBS'(A,B,C),D,D).
apply('SetRBT2.RBS'(A,B,C),D,E,F,G):-hnf('SetRBT2.RBS'(A,B,C,D),E,F,G).
apply('SetRBT2.SetRBT',A,'SetRBT2.SetRBT'(A),B,B).
apply('SetRBT2.SetRBT'(A),B,C,D,E):-hnf('SetRBT2.SetRBT'(A,B),C,D,E).
apply('TableRBT2.RBT',A,'TableRBT2.RBT'(A),B,B).
apply('TableRBT2.RBT'(A),B,'TableRBT2.RBT'(A,B),C,C).
apply('TableRBT2.RBT'(A,B),C,'TableRBT2.RBT'(A,B,C),D,D).
apply('TableRBT2.RBT'(A,B,C),D,'TableRBT2.RBT'(A,B,C,D),E,E).
apply('TableRBT2.RBT'(A,B,C,D),E,F,G,H):-hnf('TableRBT2.RBT'(A,B,C,D,E),F,G,H).
apply('TableRBT2.TableRBT',A,'TableRBT2.TableRBT'(A),B,B).
apply('TableRBT2.TableRBT'(A),B,C,D,E):-hnf('TableRBT2.TableRBT'(A,B),C,D,E).
apply('System.Date',A,'System.Date'(A),B,B).
apply('System.Date'(A),B,'System.Date'(A,B),C,C).
apply('System.Date'(A,B),C,'System.Date'(A,B,C),D,D).
apply('System.Date'(A,B,C),D,'System.Date'(A,B,C,D),E,E).
apply('System.Date'(A,B,C,D),E,'System.Date'(A,B,C,D,E),F,F).
apply('System.Date'(A,B,C,D,E),F,G,H,I):-hnf('System.Date'(A,B,C,D,E,F),G,H,I).
apply('$stream',A,B,C,D):-hnf('$stream'(A),B,C,D).

:- block constrEq(?,?,-,?).
constrEq(A,B,C,D):-hnf(A,E,C,F),hnf(B,G,F,H),constrEq_hnf(E,G,H,D).

:- block constrEq_hnf(?,?,-,?).
constrEq_hnf(A,B,C,D):-var(A),!,bind_trynf(A,B,C,D).
constrEq_hnf(A,B,C,D):-var(B),!,bind_trynf(B,A,C,D).
constrEq_hnf('()','()',A,A):-!.
constrEq_hnf([],[],A,A):-!.
constrEq_hnf([A|B],[C|D],E,F):-!,hnf(&(A=:=C,B=:=D),G,E,F).
constrEq_hnf('True','True',A,A):-!.
constrEq_hnf('False','False',A,A):-!.
constrEq_hnf('(,)'(A,B),'(,)'(C,D),E,F):-!,hnf(&(A=:=C,B=:=D),G,E,F).
constrEq_hnf('(,,)'(A,B,C),'(,,)'(D,E,F),G,H):-!,hnf(&(A=:=D,&(B=:=E,C=:=F)),I,G,H).
constrEq_hnf('(,,,)'(A,B,C,D),'(,,,)'(E,F,G,H),I,J):-!,hnf(&(A=:=E,&(B=:=F,&(C=:=G,D=:=H))),K,I,J).
constrEq_hnf('(,,,,)'(A,B,C,D,E),'(,,,,)'(F,G,H,I,J),K,L):-!,hnf(&(A=:=F,&(B=:=G,&(C=:=H,&(D=:=I,E=:=J)))),M,K,L).
constrEq_hnf('(,,,,,)'(A,B,C,D,E,F),'(,,,,,)'(G,H,I,J,K,L),M,N):-!,hnf(&(A=:=G,&(B=:=H,&(C=:=I,&(D=:=J,&(E=:=K,F=:=L))))),O,M,N).
constrEq_hnf('(,,,,,,)'(A,B,C,D,E,F,G),'(,,,,,,)'(H,I,J,K,L,M,N),O,P):-!,hnf(&(A=:=H,&(B=:=I,&(C=:=J,&(D=:=K,&(E=:=L,&(F=:=M,G=:=N)))))),Q,O,P).
constrEq_hnf('(,,,,,,,)'(A,B,C,D,E,F,G,H),'(,,,,,,,)'(I,J,K,L,M,N,O,P),Q,R):-!,hnf(&(A=:=I,&(B=:=J,&(C=:=K,&(D=:=L,&(E=:=M,&(F=:=N,&(G=:=O,H=:=P))))))),S,Q,R).
constrEq_hnf('(,,,,,,,,)'(A,B,C,D,E,F,G,H,I),'(,,,,,,,,)'(J,K,L,M,N,O,P,Q,R),S,T):-!,hnf(&(A=:=J,&(B=:=K,&(C=:=L,&(D=:=M,&(E=:=N,&(F=:=O,&(G=:=P,&(H=:=Q,I=:=R)))))))),U,S,T).
constrEq_hnf('(,,,,,,,,,)'(A,B,C,D,E,F,G,H,I,J),'(,,,,,,,,,)'(K,L,M,N,O,P,Q,R,S,T),U,V):-!,hnf(&(A=:=K,&(B=:=L,&(C=:=M,&(D=:=N,&(E=:=O,&(F=:=P,&(G=:=Q,&(H=:=R,&(I=:=S,J=:=T))))))))),W,U,V).
constrEq_hnf('(,,,,,,,,,,)'(A,B,C,D,E,F,G,H,I,J,K),'(,,,,,,,,,,)'(L,M,N,O,P,Q,R,S,T,U,V),W,X):-!,hnf(&(A=:=L,&(B=:=M,&(C=:=N,&(D=:=O,&(E=:=P,&(F=:=Q,&(G=:=R,&(H=:=S,&(I=:=T,&(J=:=U,K=:=V)))))))))),Y,W,X).
constrEq_hnf('(,,,,,,,,,,,)'(A,B,C,D,E,F,G,H,I,J,K,L),'(,,,,,,,,,,,)'(M,N,O,P,Q,R,S,T,U,V,W,X),Y,Z):-!,hnf(&(A=:=M,&(B=:=N,&(C=:=O,&(D=:=P,&(E=:=Q,&(F=:=R,&(G=:=S,&(H=:=T,&(I=:=U,&(J=:=V,&(K=:=W,L=:=X))))))))))),A1,Y,Z).
constrEq_hnf('Nothing','Nothing',A,A):-!.
constrEq_hnf('Just'(A),'Just'(B),C,D):-!,hnf(A=:=B,E,C,D).
constrEq_hnf('Left'(A),'Left'(B),C,D):-!,hnf(A=:=B,E,C,D).
constrEq_hnf('Right'(A),'Right'(B),C,D):-!,hnf(A=:=B,E,C,D).
constrEq_hnf('Flat.Prog'(A,B,C,D,E,F),'Flat.Prog'(G,H,I,J,K,L),M,N):-!,hnf(&(A=:=G,&(B=:=H,&(C=:=I,&(D=:=J,&(E=:=K,F=:=L))))),O,M,N).
constrEq_hnf('Flat.Type'(A,B,C),'Flat.Type'(D,E,F),G,H):-!,hnf(&(A=:=D,&(B=:=E,C=:=F)),I,G,H).
constrEq_hnf('Flat.Cons'(A,B,C),'Flat.Cons'(D,E,F),G,H):-!,hnf(&(A=:=D,&(B=:=E,C=:=F)),I,G,H).
constrEq_hnf('Flat.TVar'(A),'Flat.TVar'(B),C,D):-!,hnf(A=:=B,E,C,D).
constrEq_hnf('Flat.FuncType'(A,B),'Flat.FuncType'(C,D),E,F):-!,hnf(&(A=:=C,B=:=D),G,E,F).
constrEq_hnf('Flat.TCons'(A,B),'Flat.TCons'(C,D),E,F):-!,hnf(&(A=:=C,B=:=D),G,E,F).
constrEq_hnf('Flat.Op'(A,B,C),'Flat.Op'(D,E,F),G,H):-!,hnf(&(A=:=D,&(B=:=E,C=:=F)),I,G,H).
constrEq_hnf('Flat.InfixOp','Flat.InfixOp',A,A):-!.
constrEq_hnf('Flat.InfixlOp','Flat.InfixlOp',A,A):-!.
constrEq_hnf('Flat.InfixrOp','Flat.InfixrOp',A,A):-!.
constrEq_hnf('Flat.Func'(A,B,C,D),'Flat.Func'(E,F,G,H),I,J):-!,hnf(&(A=:=E,&(B=:=F,&(C=:=G,D=:=H))),K,I,J).
constrEq_hnf('Flat.Rule'(A,B),'Flat.Rule'(C,D),E,F):-!,hnf(&(A=:=C,B=:=D),G,E,F).
constrEq_hnf('Flat.External'(A),'Flat.External'(B),C,D):-!,hnf(A=:=B,E,C,D).
constrEq_hnf('Flat.Rigid','Flat.Rigid',A,A):-!.
constrEq_hnf('Flat.Flex','Flat.Flex',A,A):-!.
constrEq_hnf('Flat.FuncCall','Flat.FuncCall',A,A):-!.
constrEq_hnf('Flat.ConsCall','Flat.ConsCall',A,A):-!.
constrEq_hnf('Flat.PartCall','Flat.PartCall',A,A):-!.
constrEq_hnf('Flat.Var'(A),'Flat.Var'(B),C,D):-!,hnf(A=:=B,E,C,D).
constrEq_hnf('Flat.Lit'(A),'Flat.Lit'(B),C,D):-!,hnf(A=:=B,E,C,D).
constrEq_hnf('Flat.Comb'(A,B,C),'Flat.Comb'(D,E,F),G,H):-!,hnf(&(A=:=D,&(B=:=E,C=:=F)),I,G,H).
constrEq_hnf('Flat.Apply'(A,B),'Flat.Apply'(C,D),E,F):-!,hnf(&(A=:=C,B=:=D),G,E,F).
constrEq_hnf('Flat.Constr'(A,B),'Flat.Constr'(C,D),E,F):-!,hnf(&(A=:=C,B=:=D),G,E,F).
constrEq_hnf('Flat.Or'(A,B),'Flat.Or'(C,D),E,F):-!,hnf(&(A=:=C,B=:=D),G,E,F).
constrEq_hnf('Flat.Case'(A,B,C),'Flat.Case'(D,E,F),G,H):-!,hnf(&(A=:=D,&(B=:=E,C=:=F)),I,G,H).
constrEq_hnf('Flat.Choice'(A),'Flat.Choice'(B),C,D):-!,hnf(A=:=B,E,C,D).
constrEq_hnf('Flat.GuardedExpr'(A,B,C),'Flat.GuardedExpr'(D,E,F),G,H):-!,hnf(&(A=:=D,&(B=:=E,C=:=F)),I,G,H).
constrEq_hnf('Flat.Branch'(A,B),'Flat.Branch'(C,D),E,F):-!,hnf(&(A=:=C,B=:=D),G,E,F).
constrEq_hnf('Flat.Pattern'(A,B),'Flat.Pattern'(C,D),E,F):-!,hnf(&(A=:=C,B=:=D),G,E,F).
constrEq_hnf('Flat.LPattern'(A),'Flat.LPattern'(B),C,D):-!,hnf(A=:=B,E,C,D).
constrEq_hnf('Flat.Intc'(A),'Flat.Intc'(B),C,D):-!,hnf(A=:=B,E,C,D).
constrEq_hnf('Flat.Floatc'(A),'Flat.Floatc'(B),C,D):-!,hnf(A=:=B,E,C,D).
constrEq_hnf('Flat.Charc'(A),'Flat.Charc'(B),C,D):-!,hnf(A=:=B,E,C,D).
constrEq_hnf('Flat.Trans'(A,B),'Flat.Trans'(C,D),E,F):-!,hnf(&(A=:=C,B=:=D),G,E,F).
constrEq_hnf('SetRBT2.RBSRed','SetRBT2.RBSRed',A,A):-!.
constrEq_hnf('SetRBT2.RBSBlack','SetRBT2.RBSBlack',A,A):-!.
constrEq_hnf('SetRBT2.RBS'(A,B,C,D),'SetRBT2.RBS'(E,F,G,H),I,J):-!,hnf(&(A=:=E,&(B=:=F,&(C=:=G,D=:=H))),K,I,J).
constrEq_hnf('SetRBT2.RBSEmpty','SetRBT2.RBSEmpty',A,A):-!.
constrEq_hnf('SetRBT2.SetRBT'(A,B),'SetRBT2.SetRBT'(C,D),E,F):-!,hnf(&(A=:=C,B=:=D),G,E,F).
constrEq_hnf('TableRBT2.RBTRed','TableRBT2.RBTRed',A,A):-!.
constrEq_hnf('TableRBT2.RBTBlack','TableRBT2.RBTBlack',A,A):-!.
constrEq_hnf('TableRBT2.RBT'(A,B,C,D,E),'TableRBT2.RBT'(F,G,H,I,J),K,L):-!,hnf(&(A=:=F,&(B=:=G,&(C=:=H,&(D=:=I,E=:=J)))),M,K,L).
constrEq_hnf('TableRBT2.RBTEmpty','TableRBT2.RBTEmpty',A,A):-!.
constrEq_hnf('TableRBT2.TableRBT'(A,B),'TableRBT2.TableRBT'(C,D),E,F):-!,hnf(&(A=:=C,B=:=D),G,E,F).
constrEq_hnf('System.Date'(A,B,C,D,E,F),'System.Date'(G,H,I,J,K,L),M,N):-!,hnf(&(A=:=G,&(B=:=H,&(C=:=I,&(D=:=J,&(E=:=K,F=:=L))))),O,M,N).
constrEq_hnf('$stream'(A),'$stream'(B),C,D):-!,hnf(A=:=B,E,C,D).
constrEq_hnf(A,A,B,B):-integer(A),!.
constrEq_hnf(A,B,C,C):-float(A),!,{A=B}.
constrEq_hnf(A,B,C,D):-functor(A,E,F),functor(B,G,H),E==G,F==H,gen_constrEq_hnf_body(1,F,A,B,I),hnf(I,J,C,D).

gen_constrEq_hnf_body(A,B,C,D,success):-A>B,!.
gen_constrEq_hnf_body(A,B,C,D,E=:=F):-A=B,!,arg(A,C,E),arg(A,D,F).
gen_constrEq_hnf_body(A,B,C,D,&(E=:=F,G)):-arg(A,C,E),arg(A,D,F),H is A+1,gen_constrEq_hnf_body(H,B,C,D,G).

bind_trynf(A,B,C,D):-nf(B,E,C,F),(nonvar(F)->bind_direct(A,E,F,D);bind(A,B,C,D)).
bind_direct(A,B,C,C):-var(B),!,A=B.
bind_direct(A,B,C,C):-occurs_not(A,B),A=B.

bind(A,B,C,C):-var(B),!,A=B.
bind(A,'()',B,B):-!,A='()'.
bind(A,[],B,B):-!,A=[].
bind(A,[B|C],D,E):-!,occurs_not(A,B),occurs_not(A,C),A=[F|G],hnf(B,H,D,I),bind(F,H,I,J),hnf(C,K,J,L),bind(G,K,L,E).
bind(A,'True',B,B):-!,A='True'.
bind(A,'False',B,B):-!,A='False'.
bind(A,'(,)'(B,C),D,E):-!,occurs_not(A,B),occurs_not(A,C),A='(,)'(F,G),hnf(B,H,D,I),bind(F,H,I,J),hnf(C,K,J,L),bind(G,K,L,E).
bind(A,'(,,)'(B,C,D),E,F):-!,occurs_not(A,B),occurs_not(A,C),occurs_not(A,D),A='(,,)'(G,H,I),hnf(B,J,E,K),bind(G,J,K,L),hnf(C,M,L,N),bind(H,M,N,O),hnf(D,P,O,Q),bind(I,P,Q,F).
bind(A,'(,,,)'(B,C,D,E),F,G):-!,occurs_not(A,B),occurs_not(A,C),occurs_not(A,D),occurs_not(A,E),A='(,,,)'(H,I,J,K),hnf(B,L,F,M),bind(H,L,M,N),hnf(C,O,N,P),bind(I,O,P,Q),hnf(D,R,Q,S),bind(J,R,S,T),hnf(E,U,T,V),bind(K,U,V,G).
bind(A,'(,,,,)'(B,C,D,E,F),G,H):-!,occurs_not(A,B),occurs_not(A,C),occurs_not(A,D),occurs_not(A,E),occurs_not(A,F),A='(,,,,)'(I,J,K,L,M),hnf(B,N,G,O),bind(I,N,O,P),hnf(C,Q,P,R),bind(J,Q,R,S),hnf(D,T,S,U),bind(K,T,U,V),hnf(E,W,V,X),bind(L,W,X,Y),hnf(F,Z,Y,A1),bind(M,Z,A1,H).
bind(A,'(,,,,,)'(B,C,D,E,F,G),H,I):-!,occurs_not(A,B),occurs_not(A,C),occurs_not(A,D),occurs_not(A,E),occurs_not(A,F),occurs_not(A,G),A='(,,,,,)'(J,K,L,M,N,O),hnf(B,P,H,Q),bind(J,P,Q,R),hnf(C,S,R,T),bind(K,S,T,U),hnf(D,V,U,W),bind(L,V,W,X),hnf(E,Y,X,Z),bind(M,Y,Z,A1),hnf(F,B1,A1,C1),bind(N,B1,C1,D1),hnf(G,E1,D1,F1),bind(O,E1,F1,I).
bind(A,'(,,,,,,)'(B,C,D,E,F,G,H),I,J):-!,occurs_not(A,B),occurs_not(A,C),occurs_not(A,D),occurs_not(A,E),occurs_not(A,F),occurs_not(A,G),occurs_not(A,H),A='(,,,,,,)'(K,L,M,N,O,P,Q),hnf(B,R,I,S),bind(K,R,S,T),hnf(C,U,T,V),bind(L,U,V,W),hnf(D,X,W,Y),bind(M,X,Y,Z),hnf(E,A1,Z,B1),bind(N,A1,B1,C1),hnf(F,D1,C1,E1),bind(O,D1,E1,F1),hnf(G,G1,F1,H1),bind(P,G1,H1,I1),hnf(H,J1,I1,K1),bind(Q,J1,K1,J).
bind(A,'(,,,,,,,)'(B,C,D,E,F,G,H,I),J,K):-!,occurs_not(A,B),occurs_not(A,C),occurs_not(A,D),occurs_not(A,E),occurs_not(A,F),occurs_not(A,G),occurs_not(A,H),occurs_not(A,I),A='(,,,,,,,)'(L,M,N,O,P,Q,R,S),hnf(B,T,J,U),bind(L,T,U,V),hnf(C,W,V,X),bind(M,W,X,Y),hnf(D,Z,Y,A1),bind(N,Z,A1,B1),hnf(E,C1,B1,D1),bind(O,C1,D1,E1),hnf(F,F1,E1,G1),bind(P,F1,G1,H1),hnf(G,I1,H1,J1),bind(Q,I1,J1,K1),hnf(H,L1,K1,M1),bind(R,L1,M1,N1),hnf(I,O1,N1,P1),bind(S,O1,P1,K).
bind(A,'(,,,,,,,,)'(B,C,D,E,F,G,H,I,J),K,L):-!,occurs_not(A,B),occurs_not(A,C),occurs_not(A,D),occurs_not(A,E),occurs_not(A,F),occurs_not(A,G),occurs_not(A,H),occurs_not(A,I),occurs_not(A,J),A='(,,,,,,,,)'(M,N,O,P,Q,R,S,T,U),hnf(B,V,K,W),bind(M,V,W,X),hnf(C,Y,X,Z),bind(N,Y,Z,A1),hnf(D,B1,A1,C1),bind(O,B1,C1,D1),hnf(E,E1,D1,F1),bind(P,E1,F1,G1),hnf(F,H1,G1,I1),bind(Q,H1,I1,J1),hnf(G,K1,J1,L1),bind(R,K1,L1,M1),hnf(H,N1,M1,O1),bind(S,N1,O1,P1),hnf(I,Q1,P1,R1),bind(T,Q1,R1,S1),hnf(J,T1,S1,U1),bind(U,T1,U1,L).
bind(A,'(,,,,,,,,,)'(B,C,D,E,F,G,H,I,J,K),L,M):-!,occurs_not(A,B),occurs_not(A,C),occurs_not(A,D),occurs_not(A,E),occurs_not(A,F),occurs_not(A,G),occurs_not(A,H),occurs_not(A,I),occurs_not(A,J),occurs_not(A,K),A='(,,,,,,,,,)'(N,O,P,Q,R,S,T,U,V,W),hnf(B,X,L,Y),bind(N,X,Y,Z),hnf(C,A1,Z,B1),bind(O,A1,B1,C1),hnf(D,D1,C1,E1),bind(P,D1,E1,F1),hnf(E,G1,F1,H1),bind(Q,G1,H1,I1),hnf(F,J1,I1,K1),bind(R,J1,K1,L1),hnf(G,M1,L1,N1),bind(S,M1,N1,O1),hnf(H,P1,O1,Q1),bind(T,P1,Q1,R1),hnf(I,S1,R1,T1),bind(U,S1,T1,U1),hnf(J,V1,U1,W1),bind(V,V1,W1,X1),hnf(K,Y1,X1,Z1),bind(W,Y1,Z1,M).
bind(A,'(,,,,,,,,,,)'(B,C,D,E,F,G,H,I,J,K,L),M,N):-!,occurs_not(A,B),occurs_not(A,C),occurs_not(A,D),occurs_not(A,E),occurs_not(A,F),occurs_not(A,G),occurs_not(A,H),occurs_not(A,I),occurs_not(A,J),occurs_not(A,K),occurs_not(A,L),A='(,,,,,,,,,,)'(O,P,Q,R,S,T,U,V,W,X,Y),hnf(B,Z,M,A1),bind(O,Z,A1,B1),hnf(C,C1,B1,D1),bind(P,C1,D1,E1),hnf(D,F1,E1,G1),bind(Q,F1,G1,H1),hnf(E,I1,H1,J1),bind(R,I1,J1,K1),hnf(F,L1,K1,M1),bind(S,L1,M1,N1),hnf(G,O1,N1,P1),bind(T,O1,P1,Q1),hnf(H,R1,Q1,S1),bind(U,R1,S1,T1),hnf(I,U1,T1,V1),bind(V,U1,V1,W1),hnf(J,X1,W1,Y1),bind(W,X1,Y1,Z1),hnf(K,A2,Z1,B2),bind(X,A2,B2,C2),hnf(L,D2,C2,E2),bind(Y,D2,E2,N).
bind(A,'(,,,,,,,,,,,)'(B,C,D,E,F,G,H,I,J,K,L,M),N,O):-!,occurs_not(A,B),occurs_not(A,C),occurs_not(A,D),occurs_not(A,E),occurs_not(A,F),occurs_not(A,G),occurs_not(A,H),occurs_not(A,I),occurs_not(A,J),occurs_not(A,K),occurs_not(A,L),occurs_not(A,M),A='(,,,,,,,,,,,)'(P,Q,R,S,T,U,V,W,X,Y,Z,A1),hnf(B,B1,N,C1),bind(P,B1,C1,D1),hnf(C,E1,D1,F1),bind(Q,E1,F1,G1),hnf(D,H1,G1,I1),bind(R,H1,I1,J1),hnf(E,K1,J1,L1),bind(S,K1,L1,M1),hnf(F,N1,M1,O1),bind(T,N1,O1,P1),hnf(G,Q1,P1,R1),bind(U,Q1,R1,S1),hnf(H,T1,S1,U1),bind(V,T1,U1,V1),hnf(I,W1,V1,X1),bind(W,W1,X1,Y1),hnf(J,Z1,Y1,A2),bind(X,Z1,A2,B2),hnf(K,C2,B2,D2),bind(Y,C2,D2,E2),hnf(L,F2,E2,G2),bind(Z,F2,G2,H2),hnf(M,I2,H2,J2),bind(A1,I2,J2,O).
bind(A,'Nothing',B,B):-!,A='Nothing'.
bind(A,'Just'(B),C,D):-!,occurs_not(A,B),A='Just'(E),hnf(B,F,C,G),bind(E,F,G,D).
bind(A,'Left'(B),C,D):-!,occurs_not(A,B),A='Left'(E),hnf(B,F,C,G),bind(E,F,G,D).
bind(A,'Right'(B),C,D):-!,occurs_not(A,B),A='Right'(E),hnf(B,F,C,G),bind(E,F,G,D).
bind(A,'Flat.Prog'(B,C,D,E,F,G),H,I):-!,occurs_not(A,B),occurs_not(A,C),occurs_not(A,D),occurs_not(A,E),occurs_not(A,F),occurs_not(A,G),A='Flat.Prog'(J,K,L,M,N,O),hnf(B,P,H,Q),bind(J,P,Q,R),hnf(C,S,R,T),bind(K,S,T,U),hnf(D,V,U,W),bind(L,V,W,X),hnf(E,Y,X,Z),bind(M,Y,Z,A1),hnf(F,B1,A1,C1),bind(N,B1,C1,D1),hnf(G,E1,D1,F1),bind(O,E1,F1,I).
bind(A,'Flat.Type'(B,C,D),E,F):-!,occurs_not(A,B),occurs_not(A,C),occurs_not(A,D),A='Flat.Type'(G,H,I),hnf(B,J,E,K),bind(G,J,K,L),hnf(C,M,L,N),bind(H,M,N,O),hnf(D,P,O,Q),bind(I,P,Q,F).
bind(A,'Flat.Cons'(B,C,D),E,F):-!,occurs_not(A,B),occurs_not(A,C),occurs_not(A,D),A='Flat.Cons'(G,H,I),hnf(B,J,E,K),bind(G,J,K,L),hnf(C,M,L,N),bind(H,M,N,O),hnf(D,P,O,Q),bind(I,P,Q,F).
bind(A,'Flat.TVar'(B),C,D):-!,occurs_not(A,B),A='Flat.TVar'(E),hnf(B,F,C,G),bind(E,F,G,D).
bind(A,'Flat.FuncType'(B,C),D,E):-!,occurs_not(A,B),occurs_not(A,C),A='Flat.FuncType'(F,G),hnf(B,H,D,I),bind(F,H,I,J),hnf(C,K,J,L),bind(G,K,L,E).
bind(A,'Flat.TCons'(B,C),D,E):-!,occurs_not(A,B),occurs_not(A,C),A='Flat.TCons'(F,G),hnf(B,H,D,I),bind(F,H,I,J),hnf(C,K,J,L),bind(G,K,L,E).
bind(A,'Flat.Op'(B,C,D),E,F):-!,occurs_not(A,B),occurs_not(A,C),occurs_not(A,D),A='Flat.Op'(G,H,I),hnf(B,J,E,K),bind(G,J,K,L),hnf(C,M,L,N),bind(H,M,N,O),hnf(D,P,O,Q),bind(I,P,Q,F).
bind(A,'Flat.InfixOp',B,B):-!,A='Flat.InfixOp'.
bind(A,'Flat.InfixlOp',B,B):-!,A='Flat.InfixlOp'.
bind(A,'Flat.InfixrOp',B,B):-!,A='Flat.InfixrOp'.
bind(A,'Flat.Func'(B,C,D,E),F,G):-!,occurs_not(A,B),occurs_not(A,C),occurs_not(A,D),occurs_not(A,E),A='Flat.Func'(H,I,J,K),hnf(B,L,F,M),bind(H,L,M,N),hnf(C,O,N,P),bind(I,O,P,Q),hnf(D,R,Q,S),bind(J,R,S,T),hnf(E,U,T,V),bind(K,U,V,G).
bind(A,'Flat.Rule'(B,C),D,E):-!,occurs_not(A,B),occurs_not(A,C),A='Flat.Rule'(F,G),hnf(B,H,D,I),bind(F,H,I,J),hnf(C,K,J,L),bind(G,K,L,E).
bind(A,'Flat.External'(B),C,D):-!,occurs_not(A,B),A='Flat.External'(E),hnf(B,F,C,G),bind(E,F,G,D).
bind(A,'Flat.Rigid',B,B):-!,A='Flat.Rigid'.
bind(A,'Flat.Flex',B,B):-!,A='Flat.Flex'.
bind(A,'Flat.FuncCall',B,B):-!,A='Flat.FuncCall'.
bind(A,'Flat.ConsCall',B,B):-!,A='Flat.ConsCall'.
bind(A,'Flat.PartCall',B,B):-!,A='Flat.PartCall'.
bind(A,'Flat.Var'(B),C,D):-!,occurs_not(A,B),A='Flat.Var'(E),hnf(B,F,C,G),bind(E,F,G,D).
bind(A,'Flat.Lit'(B),C,D):-!,occurs_not(A,B),A='Flat.Lit'(E),hnf(B,F,C,G),bind(E,F,G,D).
bind(A,'Flat.Comb'(B,C,D),E,F):-!,occurs_not(A,B),occurs_not(A,C),occurs_not(A,D),A='Flat.Comb'(G,H,I),hnf(B,J,E,K),bind(G,J,K,L),hnf(C,M,L,N),bind(H,M,N,O),hnf(D,P,O,Q),bind(I,P,Q,F).
bind(A,'Flat.Apply'(B,C),D,E):-!,occurs_not(A,B),occurs_not(A,C),A='Flat.Apply'(F,G),hnf(B,H,D,I),bind(F,H,I,J),hnf(C,K,J,L),bind(G,K,L,E).
bind(A,'Flat.Constr'(B,C),D,E):-!,occurs_not(A,B),occurs_not(A,C),A='Flat.Constr'(F,G),hnf(B,H,D,I),bind(F,H,I,J),hnf(C,K,J,L),bind(G,K,L,E).
bind(A,'Flat.Or'(B,C),D,E):-!,occurs_not(A,B),occurs_not(A,C),A='Flat.Or'(F,G),hnf(B,H,D,I),bind(F,H,I,J),hnf(C,K,J,L),bind(G,K,L,E).
bind(A,'Flat.Case'(B,C,D),E,F):-!,occurs_not(A,B),occurs_not(A,C),occurs_not(A,D),A='Flat.Case'(G,H,I),hnf(B,J,E,K),bind(G,J,K,L),hnf(C,M,L,N),bind(H,M,N,O),hnf(D,P,O,Q),bind(I,P,Q,F).
bind(A,'Flat.Choice'(B),C,D):-!,occurs_not(A,B),A='Flat.Choice'(E),hnf(B,F,C,G),bind(E,F,G,D).
bind(A,'Flat.GuardedExpr'(B,C,D),E,F):-!,occurs_not(A,B),occurs_not(A,C),occurs_not(A,D),A='Flat.GuardedExpr'(G,H,I),hnf(B,J,E,K),bind(G,J,K,L),hnf(C,M,L,N),bind(H,M,N,O),hnf(D,P,O,Q),bind(I,P,Q,F).
bind(A,'Flat.Branch'(B,C),D,E):-!,occurs_not(A,B),occurs_not(A,C),A='Flat.Branch'(F,G),hnf(B,H,D,I),bind(F,H,I,J),hnf(C,K,J,L),bind(G,K,L,E).
bind(A,'Flat.Pattern'(B,C),D,E):-!,occurs_not(A,B),occurs_not(A,C),A='Flat.Pattern'(F,G),hnf(B,H,D,I),bind(F,H,I,J),hnf(C,K,J,L),bind(G,K,L,E).
bind(A,'Flat.LPattern'(B),C,D):-!,occurs_not(A,B),A='Flat.LPattern'(E),hnf(B,F,C,G),bind(E,F,G,D).
bind(A,'Flat.Intc'(B),C,D):-!,occurs_not(A,B),A='Flat.Intc'(E),hnf(B,F,C,G),bind(E,F,G,D).
bind(A,'Flat.Floatc'(B),C,D):-!,occurs_not(A,B),A='Flat.Floatc'(E),hnf(B,F,C,G),bind(E,F,G,D).
bind(A,'Flat.Charc'(B),C,D):-!,occurs_not(A,B),A='Flat.Charc'(E),hnf(B,F,C,G),bind(E,F,G,D).
bind(A,'Flat.Trans'(B,C),D,E):-!,occurs_not(A,B),occurs_not(A,C),A='Flat.Trans'(F,G),hnf(B,H,D,I),bind(F,H,I,J),hnf(C,K,J,L),bind(G,K,L,E).
bind(A,'SetRBT2.RBSRed',B,B):-!,A='SetRBT2.RBSRed'.
bind(A,'SetRBT2.RBSBlack',B,B):-!,A='SetRBT2.RBSBlack'.
bind(A,'SetRBT2.RBS'(B,C,D,E),F,G):-!,occurs_not(A,B),occurs_not(A,C),occurs_not(A,D),occurs_not(A,E),A='SetRBT2.RBS'(H,I,J,K),hnf(B,L,F,M),bind(H,L,M,N),hnf(C,O,N,P),bind(I,O,P,Q),hnf(D,R,Q,S),bind(J,R,S,T),hnf(E,U,T,V),bind(K,U,V,G).
bind(A,'SetRBT2.RBSEmpty',B,B):-!,A='SetRBT2.RBSEmpty'.
bind(A,'SetRBT2.SetRBT'(B,C),D,E):-!,occurs_not(A,B),occurs_not(A,C),A='SetRBT2.SetRBT'(F,G),hnf(B,H,D,I),bind(F,H,I,J),hnf(C,K,J,L),bind(G,K,L,E).
bind(A,'TableRBT2.RBTRed',B,B):-!,A='TableRBT2.RBTRed'.
bind(A,'TableRBT2.RBTBlack',B,B):-!,A='TableRBT2.RBTBlack'.
bind(A,'TableRBT2.RBT'(B,C,D,E,F),G,H):-!,occurs_not(A,B),occurs_not(A,C),occurs_not(A,D),occurs_not(A,E),occurs_not(A,F),A='TableRBT2.RBT'(I,J,K,L,M),hnf(B,N,G,O),bind(I,N,O,P),hnf(C,Q,P,R),bind(J,Q,R,S),hnf(D,T,S,U),bind(K,T,U,V),hnf(E,W,V,X),bind(L,W,X,Y),hnf(F,Z,Y,A1),bind(M,Z,A1,H).
bind(A,'TableRBT2.RBTEmpty',B,B):-!,A='TableRBT2.RBTEmpty'.
bind(A,'TableRBT2.TableRBT'(B,C),D,E):-!,occurs_not(A,B),occurs_not(A,C),A='TableRBT2.TableRBT'(F,G),hnf(B,H,D,I),bind(F,H,I,J),hnf(C,K,J,L),bind(G,K,L,E).
bind(A,'System.Date'(B,C,D,E,F,G),H,I):-!,occurs_not(A,B),occurs_not(A,C),occurs_not(A,D),occurs_not(A,E),occurs_not(A,F),occurs_not(A,G),A='System.Date'(J,K,L,M,N,O),hnf(B,P,H,Q),bind(J,P,Q,R),hnf(C,S,R,T),bind(K,S,T,U),hnf(D,V,U,W),bind(L,V,W,X),hnf(E,Y,X,Z),bind(M,Y,Z,A1),hnf(F,B1,A1,C1),bind(N,B1,C1,D1),hnf(G,E1,D1,F1),bind(O,E1,F1,I).
bind(A,'$stream'(B),C,D):-!,occurs_not(A,B),A='$stream'(E),hnf(B,F,C,G),bind(E,F,G,D).
bind(A,B,C,C):-integer(B),!,A=B.
bind(A,B,C,C):-float(B),!,{A=B}.
bind(A,B,C,D):-functor(B,E,F),occurs_not_args(1,F,A,B),functor(A,E,F),bind_args(1,F,A,B,C,D).

occurs_not_args(A,B,C,D):-A>B,!.
occurs_not_args(A,B,C,D):-arg(A,D,E),occurs_not(C,E),F is A+1,occurs_not_args(F,B,C,D).

bind_args(A,B,C,D,E,E):-A>B,!.
bind_args(A,B,C,D,E,F):-arg(A,C,G),arg(A,D,H),hnf(H,I,E,J),bind(G,I,J,K),L is A+1,bind_args(L,B,C,D,K,F).

occurs_not(A,B):-var(B),!,A\==B.
occurs_not(A,'()'):-!.
occurs_not(A,[]):-!.
occurs_not(A,[B|C]):-!,occurs_not(A,B),occurs_not(A,C).
occurs_not(A,'True'):-!.
occurs_not(A,'False'):-!.
occurs_not(A,'(,)'(B,C)):-!,occurs_not(A,B),occurs_not(A,C).
occurs_not(A,'(,,)'(B,C,D)):-!,occurs_not(A,B),occurs_not(A,C),occurs_not(A,D).
occurs_not(A,'(,,,)'(B,C,D,E)):-!,occurs_not(A,B),occurs_not(A,C),occurs_not(A,D),occurs_not(A,E).
occurs_not(A,'(,,,,)'(B,C,D,E,F)):-!,occurs_not(A,B),occurs_not(A,C),occurs_not(A,D),occurs_not(A,E),occurs_not(A,F).
occurs_not(A,'(,,,,,)'(B,C,D,E,F,G)):-!,occurs_not(A,B),occurs_not(A,C),occurs_not(A,D),occurs_not(A,E),occurs_not(A,F),occurs_not(A,G).
occurs_not(A,'(,,,,,,)'(B,C,D,E,F,G,H)):-!,occurs_not(A,B),occurs_not(A,C),occurs_not(A,D),occurs_not(A,E),occurs_not(A,F),occurs_not(A,G),occurs_not(A,H).
occurs_not(A,'(,,,,,,,)'(B,C,D,E,F,G,H,I)):-!,occurs_not(A,B),occurs_not(A,C),occurs_not(A,D),occurs_not(A,E),occurs_not(A,F),occurs_not(A,G),occurs_not(A,H),occurs_not(A,I).
occurs_not(A,'(,,,,,,,,)'(B,C,D,E,F,G,H,I,J)):-!,occurs_not(A,B),occurs_not(A,C),occurs_not(A,D),occurs_not(A,E),occurs_not(A,F),occurs_not(A,G),occurs_not(A,H),occurs_not(A,I),occurs_not(A,J).
occurs_not(A,'(,,,,,,,,,)'(B,C,D,E,F,G,H,I,J,K)):-!,occurs_not(A,B),occurs_not(A,C),occurs_not(A,D),occurs_not(A,E),occurs_not(A,F),occurs_not(A,G),occurs_not(A,H),occurs_not(A,I),occurs_not(A,J),occurs_not(A,K).
occurs_not(A,'(,,,,,,,,,,)'(B,C,D,E,F,G,H,I,J,K,L)):-!,occurs_not(A,B),occurs_not(A,C),occurs_not(A,D),occurs_not(A,E),occurs_not(A,F),occurs_not(A,G),occurs_not(A,H),occurs_not(A,I),occurs_not(A,J),occurs_not(A,K),occurs_not(A,L).
occurs_not(A,'(,,,,,,,,,,,)'(B,C,D,E,F,G,H,I,J,K,L,M)):-!,occurs_not(A,B),occurs_not(A,C),occurs_not(A,D),occurs_not(A,E),occurs_not(A,F),occurs_not(A,G),occurs_not(A,H),occurs_not(A,I),occurs_not(A,J),occurs_not(A,K),occurs_not(A,L),occurs_not(A,M).
occurs_not(A,'Nothing'):-!.
occurs_not(A,'Just'(B)):-!,occurs_not(A,B).
occurs_not(A,'Left'(B)):-!,occurs_not(A,B).
occurs_not(A,'Right'(B)):-!,occurs_not(A,B).
occurs_not(A,'Flat.Prog'(B,C,D,E,F,G)):-!,occurs_not(A,B),occurs_not(A,C),occurs_not(A,D),occurs_not(A,E),occurs_not(A,F),occurs_not(A,G).
occurs_not(A,'Flat.Type'(B,C,D)):-!,occurs_not(A,B),occurs_not(A,C),occurs_not(A,D).
occurs_not(A,'Flat.Cons'(B,C,D)):-!,occurs_not(A,B),occurs_not(A,C),occurs_not(A,D).
occurs_not(A,'Flat.TVar'(B)):-!,occurs_not(A,B).
occurs_not(A,'Flat.FuncType'(B,C)):-!,occurs_not(A,B),occurs_not(A,C).
occurs_not(A,'Flat.TCons'(B,C)):-!,occurs_not(A,B),occurs_not(A,C).
occurs_not(A,'Flat.Op'(B,C,D)):-!,occurs_not(A,B),occurs_not(A,C),occurs_not(A,D).
occurs_not(A,'Flat.InfixOp'):-!.
occurs_not(A,'Flat.InfixlOp'):-!.
occurs_not(A,'Flat.InfixrOp'):-!.
occurs_not(A,'Flat.Func'(B,C,D,E)):-!,occurs_not(A,B),occurs_not(A,C),occurs_not(A,D),occurs_not(A,E).
occurs_not(A,'Flat.Rule'(B,C)):-!,occurs_not(A,B),occurs_not(A,C).
occurs_not(A,'Flat.External'(B)):-!,occurs_not(A,B).
occurs_not(A,'Flat.Rigid'):-!.
occurs_not(A,'Flat.Flex'):-!.
occurs_not(A,'Flat.FuncCall'):-!.
occurs_not(A,'Flat.ConsCall'):-!.
occurs_not(A,'Flat.PartCall'):-!.
occurs_not(A,'Flat.Var'(B)):-!,occurs_not(A,B).
occurs_not(A,'Flat.Lit'(B)):-!,occurs_not(A,B).
occurs_not(A,'Flat.Comb'(B,C,D)):-!,occurs_not(A,B),occurs_not(A,C),occurs_not(A,D).
occurs_not(A,'Flat.Apply'(B,C)):-!,occurs_not(A,B),occurs_not(A,C).
occurs_not(A,'Flat.Constr'(B,C)):-!,occurs_not(A,B),occurs_not(A,C).
occurs_not(A,'Flat.Or'(B,C)):-!,occurs_not(A,B),occurs_not(A,C).
occurs_not(A,'Flat.Case'(B,C,D)):-!,occurs_not(A,B),occurs_not(A,C),occurs_not(A,D).
occurs_not(A,'Flat.Choice'(B)):-!,occurs_not(A,B).
occurs_not(A,'Flat.GuardedExpr'(B,C,D)):-!,occurs_not(A,B),occurs_not(A,C),occurs_not(A,D).
occurs_not(A,'Flat.Branch'(B,C)):-!,occurs_not(A,B),occurs_not(A,C).
occurs_not(A,'Flat.Pattern'(B,C)):-!,occurs_not(A,B),occurs_not(A,C).
occurs_not(A,'Flat.LPattern'(B)):-!,occurs_not(A,B).
occurs_not(A,'Flat.Intc'(B)):-!,occurs_not(A,B).
occurs_not(A,'Flat.Floatc'(B)):-!,occurs_not(A,B).
occurs_not(A,'Flat.Charc'(B)):-!,occurs_not(A,B).
occurs_not(A,'Flat.Trans'(B,C)):-!,occurs_not(A,B),occurs_not(A,C).
occurs_not(A,'SetRBT2.RBSRed'):-!.
occurs_not(A,'SetRBT2.RBSBlack'):-!.
occurs_not(A,'SetRBT2.RBS'(B,C,D,E)):-!,occurs_not(A,B),occurs_not(A,C),occurs_not(A,D),occurs_not(A,E).
occurs_not(A,'SetRBT2.RBSEmpty'):-!.
occurs_not(A,'SetRBT2.SetRBT'(B,C)):-!,occurs_not(A,B),occurs_not(A,C).
occurs_not(A,'TableRBT2.RBTRed'):-!.
occurs_not(A,'TableRBT2.RBTBlack'):-!.
occurs_not(A,'TableRBT2.RBT'(B,C,D,E,F)):-!,occurs_not(A,B),occurs_not(A,C),occurs_not(A,D),occurs_not(A,E),occurs_not(A,F).
occurs_not(A,'TableRBT2.RBTEmpty'):-!.
occurs_not(A,'TableRBT2.TableRBT'(B,C)):-!,occurs_not(A,B),occurs_not(A,C).
occurs_not(A,'System.Date'(B,C,D,E,F,G)):-!,occurs_not(A,B),occurs_not(A,C),occurs_not(A,D),occurs_not(A,E),occurs_not(A,F),occurs_not(A,G).
occurs_not(A,'$stream'(B)):-!,occurs_not(A,B).
occurs_not(_,_).

:- block boolEq(?,?,?,-,?).
boolEq(A,B,C,D,E):-hnf(A,F,D,G),hnf(B,H,G,I),boolEq_hnf(F,H,C,I,E).

:- block boolEq_hnf(-,?,?,?,?), boolEq_hnf(?,-,?,?,?), boolEq_hnf(?,?,?,-,?).
boolEq_hnf('()','()',A,B,C):-!,hnf('True',A,B,C).
boolEq_hnf([],[],A,B,C):-!,hnf('True',A,B,C).
boolEq_hnf([A|B],[C|D],E,F,G):-!,hnf(&&(A==C,&&(B==D,'True')),E,F,G).
boolEq_hnf('True','True',A,B,C):-!,hnf('True',A,B,C).
boolEq_hnf('False','False',A,B,C):-!,hnf('True',A,B,C).
boolEq_hnf('(,)'(A,B),'(,)'(C,D),E,F,G):-!,hnf(&&(A==C,&&(B==D,'True')),E,F,G).
boolEq_hnf('(,,)'(A,B,C),'(,,)'(D,E,F),G,H,I):-!,hnf(&&(A==D,&&(B==E,&&(C==F,'True'))),G,H,I).
boolEq_hnf('(,,,)'(A,B,C,D),'(,,,)'(E,F,G,H),I,J,K):-!,hnf(&&(A==E,&&(B==F,&&(C==G,&&(D==H,'True')))),I,J,K).
boolEq_hnf('(,,,,)'(A,B,C,D,E),'(,,,,)'(F,G,H,I,J),K,L,M):-!,hnf(&&(A==F,&&(B==G,&&(C==H,&&(D==I,&&(E==J,'True'))))),K,L,M).
boolEq_hnf('(,,,,,)'(A,B,C,D,E,F),'(,,,,,)'(G,H,I,J,K,L),M,N,O):-!,hnf(&&(A==G,&&(B==H,&&(C==I,&&(D==J,&&(E==K,&&(F==L,'True')))))),M,N,O).
boolEq_hnf('(,,,,,,)'(A,B,C,D,E,F,G),'(,,,,,,)'(H,I,J,K,L,M,N),O,P,Q):-!,hnf(&&(A==H,&&(B==I,&&(C==J,&&(D==K,&&(E==L,&&(F==M,&&(G==N,'True'))))))),O,P,Q).
boolEq_hnf('(,,,,,,,)'(A,B,C,D,E,F,G,H),'(,,,,,,,)'(I,J,K,L,M,N,O,P),Q,R,S):-!,hnf(&&(A==I,&&(B==J,&&(C==K,&&(D==L,&&(E==M,&&(F==N,&&(G==O,&&(H==P,'True')))))))),Q,R,S).
boolEq_hnf('(,,,,,,,,)'(A,B,C,D,E,F,G,H,I),'(,,,,,,,,)'(J,K,L,M,N,O,P,Q,R),S,T,U):-!,hnf(&&(A==J,&&(B==K,&&(C==L,&&(D==M,&&(E==N,&&(F==O,&&(G==P,&&(H==Q,&&(I==R,'True'))))))))),S,T,U).
boolEq_hnf('(,,,,,,,,,)'(A,B,C,D,E,F,G,H,I,J),'(,,,,,,,,,)'(K,L,M,N,O,P,Q,R,S,T),U,V,W):-!,hnf(&&(A==K,&&(B==L,&&(C==M,&&(D==N,&&(E==O,&&(F==P,&&(G==Q,&&(H==R,&&(I==S,&&(J==T,'True')))))))))),U,V,W).
boolEq_hnf('(,,,,,,,,,,)'(A,B,C,D,E,F,G,H,I,J,K),'(,,,,,,,,,,)'(L,M,N,O,P,Q,R,S,T,U,V),W,X,Y):-!,hnf(&&(A==L,&&(B==M,&&(C==N,&&(D==O,&&(E==P,&&(F==Q,&&(G==R,&&(H==S,&&(I==T,&&(J==U,&&(K==V,'True'))))))))))),W,X,Y).
boolEq_hnf('(,,,,,,,,,,,)'(A,B,C,D,E,F,G,H,I,J,K,L),'(,,,,,,,,,,,)'(M,N,O,P,Q,R,S,T,U,V,W,X),Y,Z,A1):-!,hnf(&&(A==M,&&(B==N,&&(C==O,&&(D==P,&&(E==Q,&&(F==R,&&(G==S,&&(H==T,&&(I==U,&&(J==V,&&(K==W,&&(L==X,'True')))))))))))),Y,Z,A1).
boolEq_hnf('Nothing','Nothing',A,B,C):-!,hnf('True',A,B,C).
boolEq_hnf('Just'(A),'Just'(B),C,D,E):-!,hnf(&&(A==B,'True'),C,D,E).
boolEq_hnf('Left'(A),'Left'(B),C,D,E):-!,hnf(&&(A==B,'True'),C,D,E).
boolEq_hnf('Right'(A),'Right'(B),C,D,E):-!,hnf(&&(A==B,'True'),C,D,E).
boolEq_hnf('Flat.Prog'(A,B,C,D,E,F),'Flat.Prog'(G,H,I,J,K,L),M,N,O):-!,hnf(&&(A==G,&&(B==H,&&(C==I,&&(D==J,&&(E==K,&&(F==L,'True')))))),M,N,O).
boolEq_hnf('Flat.Type'(A,B,C),'Flat.Type'(D,E,F),G,H,I):-!,hnf(&&(A==D,&&(B==E,&&(C==F,'True'))),G,H,I).
boolEq_hnf('Flat.Cons'(A,B,C),'Flat.Cons'(D,E,F),G,H,I):-!,hnf(&&(A==D,&&(B==E,&&(C==F,'True'))),G,H,I).
boolEq_hnf('Flat.TVar'(A),'Flat.TVar'(B),C,D,E):-!,hnf(&&(A==B,'True'),C,D,E).
boolEq_hnf('Flat.FuncType'(A,B),'Flat.FuncType'(C,D),E,F,G):-!,hnf(&&(A==C,&&(B==D,'True')),E,F,G).
boolEq_hnf('Flat.TCons'(A,B),'Flat.TCons'(C,D),E,F,G):-!,hnf(&&(A==C,&&(B==D,'True')),E,F,G).
boolEq_hnf('Flat.Op'(A,B,C),'Flat.Op'(D,E,F),G,H,I):-!,hnf(&&(A==D,&&(B==E,&&(C==F,'True'))),G,H,I).
boolEq_hnf('Flat.InfixOp','Flat.InfixOp',A,B,C):-!,hnf('True',A,B,C).
boolEq_hnf('Flat.InfixlOp','Flat.InfixlOp',A,B,C):-!,hnf('True',A,B,C).
boolEq_hnf('Flat.InfixrOp','Flat.InfixrOp',A,B,C):-!,hnf('True',A,B,C).
boolEq_hnf('Flat.Func'(A,B,C,D),'Flat.Func'(E,F,G,H),I,J,K):-!,hnf(&&(A==E,&&(B==F,&&(C==G,&&(D==H,'True')))),I,J,K).
boolEq_hnf('Flat.Rule'(A,B),'Flat.Rule'(C,D),E,F,G):-!,hnf(&&(A==C,&&(B==D,'True')),E,F,G).
boolEq_hnf('Flat.External'(A),'Flat.External'(B),C,D,E):-!,hnf(&&(A==B,'True'),C,D,E).
boolEq_hnf('Flat.Rigid','Flat.Rigid',A,B,C):-!,hnf('True',A,B,C).
boolEq_hnf('Flat.Flex','Flat.Flex',A,B,C):-!,hnf('True',A,B,C).
boolEq_hnf('Flat.FuncCall','Flat.FuncCall',A,B,C):-!,hnf('True',A,B,C).
boolEq_hnf('Flat.ConsCall','Flat.ConsCall',A,B,C):-!,hnf('True',A,B,C).
boolEq_hnf('Flat.PartCall','Flat.PartCall',A,B,C):-!,hnf('True',A,B,C).
boolEq_hnf('Flat.Var'(A),'Flat.Var'(B),C,D,E):-!,hnf(&&(A==B,'True'),C,D,E).
boolEq_hnf('Flat.Lit'(A),'Flat.Lit'(B),C,D,E):-!,hnf(&&(A==B,'True'),C,D,E).
boolEq_hnf('Flat.Comb'(A,B,C),'Flat.Comb'(D,E,F),G,H,I):-!,hnf(&&(A==D,&&(B==E,&&(C==F,'True'))),G,H,I).
boolEq_hnf('Flat.Apply'(A,B),'Flat.Apply'(C,D),E,F,G):-!,hnf(&&(A==C,&&(B==D,'True')),E,F,G).
boolEq_hnf('Flat.Constr'(A,B),'Flat.Constr'(C,D),E,F,G):-!,hnf(&&(A==C,&&(B==D,'True')),E,F,G).
boolEq_hnf('Flat.Or'(A,B),'Flat.Or'(C,D),E,F,G):-!,hnf(&&(A==C,&&(B==D,'True')),E,F,G).
boolEq_hnf('Flat.Case'(A,B,C),'Flat.Case'(D,E,F),G,H,I):-!,hnf(&&(A==D,&&(B==E,&&(C==F,'True'))),G,H,I).
boolEq_hnf('Flat.Choice'(A),'Flat.Choice'(B),C,D,E):-!,hnf(&&(A==B,'True'),C,D,E).
boolEq_hnf('Flat.GuardedExpr'(A,B,C),'Flat.GuardedExpr'(D,E,F),G,H,I):-!,hnf(&&(A==D,&&(B==E,&&(C==F,'True'))),G,H,I).
boolEq_hnf('Flat.Branch'(A,B),'Flat.Branch'(C,D),E,F,G):-!,hnf(&&(A==C,&&(B==D,'True')),E,F,G).
boolEq_hnf('Flat.Pattern'(A,B),'Flat.Pattern'(C,D),E,F,G):-!,hnf(&&(A==C,&&(B==D,'True')),E,F,G).
boolEq_hnf('Flat.LPattern'(A),'Flat.LPattern'(B),C,D,E):-!,hnf(&&(A==B,'True'),C,D,E).
boolEq_hnf('Flat.Intc'(A),'Flat.Intc'(B),C,D,E):-!,hnf(&&(A==B,'True'),C,D,E).
boolEq_hnf('Flat.Floatc'(A),'Flat.Floatc'(B),C,D,E):-!,hnf(&&(A==B,'True'),C,D,E).
boolEq_hnf('Flat.Charc'(A),'Flat.Charc'(B),C,D,E):-!,hnf(&&(A==B,'True'),C,D,E).
boolEq_hnf('Flat.Trans'(A,B),'Flat.Trans'(C,D),E,F,G):-!,hnf(&&(A==C,&&(B==D,'True')),E,F,G).
boolEq_hnf('SetRBT2.RBSRed','SetRBT2.RBSRed',A,B,C):-!,hnf('True',A,B,C).
boolEq_hnf('SetRBT2.RBSBlack','SetRBT2.RBSBlack',A,B,C):-!,hnf('True',A,B,C).
boolEq_hnf('SetRBT2.RBS'(A,B,C,D),'SetRBT2.RBS'(E,F,G,H),I,J,K):-!,hnf(&&(A==E,&&(B==F,&&(C==G,&&(D==H,'True')))),I,J,K).
boolEq_hnf('SetRBT2.RBSEmpty','SetRBT2.RBSEmpty',A,B,C):-!,hnf('True',A,B,C).
boolEq_hnf('SetRBT2.SetRBT'(A,B),'SetRBT2.SetRBT'(C,D),E,F,G):-!,hnf(&&(A==C,&&(B==D,'True')),E,F,G).
boolEq_hnf('TableRBT2.RBTRed','TableRBT2.RBTRed',A,B,C):-!,hnf('True',A,B,C).
boolEq_hnf('TableRBT2.RBTBlack','TableRBT2.RBTBlack',A,B,C):-!,hnf('True',A,B,C).
boolEq_hnf('TableRBT2.RBT'(A,B,C,D,E),'TableRBT2.RBT'(F,G,H,I,J),K,L,M):-!,hnf(&&(A==F,&&(B==G,&&(C==H,&&(D==I,&&(E==J,'True'))))),K,L,M).
boolEq_hnf('TableRBT2.RBTEmpty','TableRBT2.RBTEmpty',A,B,C):-!,hnf('True',A,B,C).
boolEq_hnf('TableRBT2.TableRBT'(A,B),'TableRBT2.TableRBT'(C,D),E,F,G):-!,hnf(&&(A==C,&&(B==D,'True')),E,F,G).
boolEq_hnf('System.Date'(A,B,C,D,E,F),'System.Date'(G,H,I,J,K,L),M,N,O):-!,hnf(&&(A==G,&&(B==H,&&(C==I,&&(D==J,&&(E==K,&&(F==L,'True')))))),M,N,O).
boolEq_hnf('$stream'(A),'$stream'(B),C,D,E):-!,hnf(&&(A==B,'True'),C,D,E).
boolEq_hnf(A,B,C,D,D):-number(A),!,(A==B->C='True';C='False').
boolEq_hnf(A,B,C,D,E):-functor(A,F,G),functor(B,H,I),(F==H,G==I,gen_boolEq_hnf_body(1,G,A,B,J)->hnf(J,C,D,E);D=E,C='False').

gen_boolEq_hnf_body(A,B,C,D,'True'):-A>B,!.
gen_boolEq_hnf_body(A,B,C,D,&&(E==F,G)):-arg(A,C,E),arg(A,D,F),H is A+1,gen_boolEq_hnf_body(H,B,C,D,G).

:- block nf(?,?,-,?).
nf(A,B,C,D):-hnf(A,E,C,F),nf_hnf(E,B,F,D).

:- block nf_hnf(?,?,-,?).
nf_hnf(A,B,C,C):-var(A),!,B=A.
nf_hnf('()','()',A,A):-!.
nf_hnf([],[],A,A):-!.
nf_hnf([A|B],[C|D],E,F):-!,nf(A,C,E,G),nf(B,D,G,F).
nf_hnf('True','True',A,A):-!.
nf_hnf('False','False',A,A):-!.
nf_hnf('(,)'(A,B),'(,)'(C,D),E,F):-!,nf(A,C,E,G),nf(B,D,G,F).
nf_hnf('(,,)'(A,B,C),'(,,)'(D,E,F),G,H):-!,nf(A,D,G,I),nf(B,E,I,J),nf(C,F,J,H).
nf_hnf('(,,,)'(A,B,C,D),'(,,,)'(E,F,G,H),I,J):-!,nf(A,E,I,K),nf(B,F,K,L),nf(C,G,L,M),nf(D,H,M,J).
nf_hnf('(,,,,)'(A,B,C,D,E),'(,,,,)'(F,G,H,I,J),K,L):-!,nf(A,F,K,M),nf(B,G,M,N),nf(C,H,N,O),nf(D,I,O,P),nf(E,J,P,L).
nf_hnf('(,,,,,)'(A,B,C,D,E,F),'(,,,,,)'(G,H,I,J,K,L),M,N):-!,nf(A,G,M,O),nf(B,H,O,P),nf(C,I,P,Q),nf(D,J,Q,R),nf(E,K,R,S),nf(F,L,S,N).
nf_hnf('(,,,,,,)'(A,B,C,D,E,F,G),'(,,,,,,)'(H,I,J,K,L,M,N),O,P):-!,nf(A,H,O,Q),nf(B,I,Q,R),nf(C,J,R,S),nf(D,K,S,T),nf(E,L,T,U),nf(F,M,U,V),nf(G,N,V,P).
nf_hnf('(,,,,,,,)'(A,B,C,D,E,F,G,H),'(,,,,,,,)'(I,J,K,L,M,N,O,P),Q,R):-!,nf(A,I,Q,S),nf(B,J,S,T),nf(C,K,T,U),nf(D,L,U,V),nf(E,M,V,W),nf(F,N,W,X),nf(G,O,X,Y),nf(H,P,Y,R).
nf_hnf('(,,,,,,,,)'(A,B,C,D,E,F,G,H,I),'(,,,,,,,,)'(J,K,L,M,N,O,P,Q,R),S,T):-!,nf(A,J,S,U),nf(B,K,U,V),nf(C,L,V,W),nf(D,M,W,X),nf(E,N,X,Y),nf(F,O,Y,Z),nf(G,P,Z,A1),nf(H,Q,A1,B1),nf(I,R,B1,T).
nf_hnf('(,,,,,,,,,)'(A,B,C,D,E,F,G,H,I,J),'(,,,,,,,,,)'(K,L,M,N,O,P,Q,R,S,T),U,V):-!,nf(A,K,U,W),nf(B,L,W,X),nf(C,M,X,Y),nf(D,N,Y,Z),nf(E,O,Z,A1),nf(F,P,A1,B1),nf(G,Q,B1,C1),nf(H,R,C1,D1),nf(I,S,D1,E1),nf(J,T,E1,V).
nf_hnf('(,,,,,,,,,,)'(A,B,C,D,E,F,G,H,I,J,K),'(,,,,,,,,,,)'(L,M,N,O,P,Q,R,S,T,U,V),W,X):-!,nf(A,L,W,Y),nf(B,M,Y,Z),nf(C,N,Z,A1),nf(D,O,A1,B1),nf(E,P,B1,C1),nf(F,Q,C1,D1),nf(G,R,D1,E1),nf(H,S,E1,F1),nf(I,T,F1,G1),nf(J,U,G1,H1),nf(K,V,H1,X).
nf_hnf('(,,,,,,,,,,,)'(A,B,C,D,E,F,G,H,I,J,K,L),'(,,,,,,,,,,,)'(M,N,O,P,Q,R,S,T,U,V,W,X),Y,Z):-!,nf(A,M,Y,A1),nf(B,N,A1,B1),nf(C,O,B1,C1),nf(D,P,C1,D1),nf(E,Q,D1,E1),nf(F,R,E1,F1),nf(G,S,F1,G1),nf(H,T,G1,H1),nf(I,U,H1,I1),nf(J,V,I1,J1),nf(K,W,J1,K1),nf(L,X,K1,Z).
nf_hnf('Nothing','Nothing',A,A):-!.
nf_hnf('Just'(A),'Just'(B),C,D):-!,nf(A,B,C,D).
nf_hnf('Left'(A),'Left'(B),C,D):-!,nf(A,B,C,D).
nf_hnf('Right'(A),'Right'(B),C,D):-!,nf(A,B,C,D).
nf_hnf('Flat.Prog'(A,B,C,D,E,F),'Flat.Prog'(G,H,I,J,K,L),M,N):-!,nf(A,G,M,O),nf(B,H,O,P),nf(C,I,P,Q),nf(D,J,Q,R),nf(E,K,R,S),nf(F,L,S,N).
nf_hnf('Flat.Type'(A,B,C),'Flat.Type'(D,E,F),G,H):-!,nf(A,D,G,I),nf(B,E,I,J),nf(C,F,J,H).
nf_hnf('Flat.Cons'(A,B,C),'Flat.Cons'(D,E,F),G,H):-!,nf(A,D,G,I),nf(B,E,I,J),nf(C,F,J,H).
nf_hnf('Flat.TVar'(A),'Flat.TVar'(B),C,D):-!,nf(A,B,C,D).
nf_hnf('Flat.FuncType'(A,B),'Flat.FuncType'(C,D),E,F):-!,nf(A,C,E,G),nf(B,D,G,F).
nf_hnf('Flat.TCons'(A,B),'Flat.TCons'(C,D),E,F):-!,nf(A,C,E,G),nf(B,D,G,F).
nf_hnf('Flat.Op'(A,B,C),'Flat.Op'(D,E,F),G,H):-!,nf(A,D,G,I),nf(B,E,I,J),nf(C,F,J,H).
nf_hnf('Flat.InfixOp','Flat.InfixOp',A,A):-!.
nf_hnf('Flat.InfixlOp','Flat.InfixlOp',A,A):-!.
nf_hnf('Flat.InfixrOp','Flat.InfixrOp',A,A):-!.
nf_hnf('Flat.Func'(A,B,C,D),'Flat.Func'(E,F,G,H),I,J):-!,nf(A,E,I,K),nf(B,F,K,L),nf(C,G,L,M),nf(D,H,M,J).
nf_hnf('Flat.Rule'(A,B),'Flat.Rule'(C,D),E,F):-!,nf(A,C,E,G),nf(B,D,G,F).
nf_hnf('Flat.External'(A),'Flat.External'(B),C,D):-!,nf(A,B,C,D).
nf_hnf('Flat.Rigid','Flat.Rigid',A,A):-!.
nf_hnf('Flat.Flex','Flat.Flex',A,A):-!.
nf_hnf('Flat.FuncCall','Flat.FuncCall',A,A):-!.
nf_hnf('Flat.ConsCall','Flat.ConsCall',A,A):-!.
nf_hnf('Flat.PartCall','Flat.PartCall',A,A):-!.
nf_hnf('Flat.Var'(A),'Flat.Var'(B),C,D):-!,nf(A,B,C,D).
nf_hnf('Flat.Lit'(A),'Flat.Lit'(B),C,D):-!,nf(A,B,C,D).
nf_hnf('Flat.Comb'(A,B,C),'Flat.Comb'(D,E,F),G,H):-!,nf(A,D,G,I),nf(B,E,I,J),nf(C,F,J,H).
nf_hnf('Flat.Apply'(A,B),'Flat.Apply'(C,D),E,F):-!,nf(A,C,E,G),nf(B,D,G,F).
nf_hnf('Flat.Constr'(A,B),'Flat.Constr'(C,D),E,F):-!,nf(A,C,E,G),nf(B,D,G,F).
nf_hnf('Flat.Or'(A,B),'Flat.Or'(C,D),E,F):-!,nf(A,C,E,G),nf(B,D,G,F).
nf_hnf('Flat.Case'(A,B,C),'Flat.Case'(D,E,F),G,H):-!,nf(A,D,G,I),nf(B,E,I,J),nf(C,F,J,H).
nf_hnf('Flat.Choice'(A),'Flat.Choice'(B),C,D):-!,nf(A,B,C,D).
nf_hnf('Flat.GuardedExpr'(A,B,C),'Flat.GuardedExpr'(D,E,F),G,H):-!,nf(A,D,G,I),nf(B,E,I,J),nf(C,F,J,H).
nf_hnf('Flat.Branch'(A,B),'Flat.Branch'(C,D),E,F):-!,nf(A,C,E,G),nf(B,D,G,F).
nf_hnf('Flat.Pattern'(A,B),'Flat.Pattern'(C,D),E,F):-!,nf(A,C,E,G),nf(B,D,G,F).
nf_hnf('Flat.LPattern'(A),'Flat.LPattern'(B),C,D):-!,nf(A,B,C,D).
nf_hnf('Flat.Intc'(A),'Flat.Intc'(B),C,D):-!,nf(A,B,C,D).
nf_hnf('Flat.Floatc'(A),'Flat.Floatc'(B),C,D):-!,nf(A,B,C,D).
nf_hnf('Flat.Charc'(A),'Flat.Charc'(B),C,D):-!,nf(A,B,C,D).
nf_hnf('Flat.Trans'(A,B),'Flat.Trans'(C,D),E,F):-!,nf(A,C,E,G),nf(B,D,G,F).
nf_hnf('SetRBT2.RBSRed','SetRBT2.RBSRed',A,A):-!.
nf_hnf('SetRBT2.RBSBlack','SetRBT2.RBSBlack',A,A):-!.
nf_hnf('SetRBT2.RBS'(A,B,C,D),'SetRBT2.RBS'(E,F,G,H),I,J):-!,nf(A,E,I,K),nf(B,F,K,L),nf(C,G,L,M),nf(D,H,M,J).
nf_hnf('SetRBT2.RBSEmpty','SetRBT2.RBSEmpty',A,A):-!.
nf_hnf('SetRBT2.SetRBT'(A,B),'SetRBT2.SetRBT'(C,D),E,F):-!,nf(A,C,E,G),nf(B,D,G,F).
nf_hnf('TableRBT2.RBTRed','TableRBT2.RBTRed',A,A):-!.
nf_hnf('TableRBT2.RBTBlack','TableRBT2.RBTBlack',A,A):-!.
nf_hnf('TableRBT2.RBT'(A,B,C,D,E),'TableRBT2.RBT'(F,G,H,I,J),K,L):-!,nf(A,F,K,M),nf(B,G,M,N),nf(C,H,N,O),nf(D,I,O,P),nf(E,J,P,L).
nf_hnf('TableRBT2.RBTEmpty','TableRBT2.RBTEmpty',A,A):-!.
nf_hnf('TableRBT2.TableRBT'(A,B),'TableRBT2.TableRBT'(C,D),E,F):-!,nf(A,C,E,G),nf(B,D,G,F).
nf_hnf('System.Date'(A,B,C,D,E,F),'System.Date'(G,H,I,J,K,L),M,N):-!,nf(A,G,M,O),nf(B,H,O,P),nf(C,I,P,Q),nf(D,J,Q,R),nf(E,K,R,S),nf(F,L,S,N).
nf_hnf('$stream'(A),'$stream'(B),C,D):-!,nf(A,B,C,D).
nf_hnf(A,A,B,B):-number(A),!.
nf_hnf(A,B,C,D):-functor(A,E,F),functor(B,E,F),nf_hnf_args(1,F,A,B,C,D).

nf_hnf_args(A,B,C,D,E,E):-A>B,!.
nf_hnf_args(A,B,C,D,E,F):-arg(A,C,G),arg(A,D,H),nf(G,H,E,I),J is A+1,nf_hnf_args(J,B,C,D,I,F).

propagateShare(A,A):-var(A),!.
propagateShare('()','()'):-!.
propagateShare([],[]):-!.
propagateShare([A|B],[C|D]):-!,propSharArg(A,C),propSharArg(B,D).
propagateShare('True','True'):-!.
propagateShare('False','False'):-!.
propagateShare('(,)'(A,B),'(,)'(C,D)):-!,propSharArg(A,C),propSharArg(B,D).
propagateShare('(,,)'(A,B,C),'(,,)'(D,E,F)):-!,propSharArg(A,D),propSharArg(B,E),propSharArg(C,F).
propagateShare('(,,,)'(A,B,C,D),'(,,,)'(E,F,G,H)):-!,propSharArg(A,E),propSharArg(B,F),propSharArg(C,G),propSharArg(D,H).
propagateShare('(,,,,)'(A,B,C,D,E),'(,,,,)'(F,G,H,I,J)):-!,propSharArg(A,F),propSharArg(B,G),propSharArg(C,H),propSharArg(D,I),propSharArg(E,J).
propagateShare('(,,,,,)'(A,B,C,D,E,F),'(,,,,,)'(G,H,I,J,K,L)):-!,propSharArg(A,G),propSharArg(B,H),propSharArg(C,I),propSharArg(D,J),propSharArg(E,K),propSharArg(F,L).
propagateShare('(,,,,,,)'(A,B,C,D,E,F,G),'(,,,,,,)'(H,I,J,K,L,M,N)):-!,propSharArg(A,H),propSharArg(B,I),propSharArg(C,J),propSharArg(D,K),propSharArg(E,L),propSharArg(F,M),propSharArg(G,N).
propagateShare('(,,,,,,,)'(A,B,C,D,E,F,G,H),'(,,,,,,,)'(I,J,K,L,M,N,O,P)):-!,propSharArg(A,I),propSharArg(B,J),propSharArg(C,K),propSharArg(D,L),propSharArg(E,M),propSharArg(F,N),propSharArg(G,O),propSharArg(H,P).
propagateShare('(,,,,,,,,)'(A,B,C,D,E,F,G,H,I),'(,,,,,,,,)'(J,K,L,M,N,O,P,Q,R)):-!,propSharArg(A,J),propSharArg(B,K),propSharArg(C,L),propSharArg(D,M),propSharArg(E,N),propSharArg(F,O),propSharArg(G,P),propSharArg(H,Q),propSharArg(I,R).
propagateShare('(,,,,,,,,,)'(A,B,C,D,E,F,G,H,I,J),'(,,,,,,,,,)'(K,L,M,N,O,P,Q,R,S,T)):-!,propSharArg(A,K),propSharArg(B,L),propSharArg(C,M),propSharArg(D,N),propSharArg(E,O),propSharArg(F,P),propSharArg(G,Q),propSharArg(H,R),propSharArg(I,S),propSharArg(J,T).
propagateShare('(,,,,,,,,,,)'(A,B,C,D,E,F,G,H,I,J,K),'(,,,,,,,,,,)'(L,M,N,O,P,Q,R,S,T,U,V)):-!,propSharArg(A,L),propSharArg(B,M),propSharArg(C,N),propSharArg(D,O),propSharArg(E,P),propSharArg(F,Q),propSharArg(G,R),propSharArg(H,S),propSharArg(I,T),propSharArg(J,U),propSharArg(K,V).
propagateShare('(,,,,,,,,,,,)'(A,B,C,D,E,F,G,H,I,J,K,L),'(,,,,,,,,,,,)'(M,N,O,P,Q,R,S,T,U,V,W,X)):-!,propSharArg(A,M),propSharArg(B,N),propSharArg(C,O),propSharArg(D,P),propSharArg(E,Q),propSharArg(F,R),propSharArg(G,S),propSharArg(H,T),propSharArg(I,U),propSharArg(J,V),propSharArg(K,W),propSharArg(L,X).
propagateShare('Nothing','Nothing'):-!.
propagateShare('Just'(A),'Just'(B)):-!,propSharArg(A,B).
propagateShare('Left'(A),'Left'(B)):-!,propSharArg(A,B).
propagateShare('Right'(A),'Right'(B)):-!,propSharArg(A,B).
propagateShare('Flat.Prog'(A,B,C,D,E,F),'Flat.Prog'(G,H,I,J,K,L)):-!,propSharArg(A,G),propSharArg(B,H),propSharArg(C,I),propSharArg(D,J),propSharArg(E,K),propSharArg(F,L).
propagateShare('Flat.Type'(A,B,C),'Flat.Type'(D,E,F)):-!,propSharArg(A,D),propSharArg(B,E),propSharArg(C,F).
propagateShare('Flat.Cons'(A,B,C),'Flat.Cons'(D,E,F)):-!,propSharArg(A,D),propSharArg(B,E),propSharArg(C,F).
propagateShare('Flat.TVar'(A),'Flat.TVar'(B)):-!,propSharArg(A,B).
propagateShare('Flat.FuncType'(A,B),'Flat.FuncType'(C,D)):-!,propSharArg(A,C),propSharArg(B,D).
propagateShare('Flat.TCons'(A,B),'Flat.TCons'(C,D)):-!,propSharArg(A,C),propSharArg(B,D).
propagateShare('Flat.Op'(A,B,C),'Flat.Op'(D,E,F)):-!,propSharArg(A,D),propSharArg(B,E),propSharArg(C,F).
propagateShare('Flat.InfixOp','Flat.InfixOp'):-!.
propagateShare('Flat.InfixlOp','Flat.InfixlOp'):-!.
propagateShare('Flat.InfixrOp','Flat.InfixrOp'):-!.
propagateShare('Flat.Func'(A,B,C,D),'Flat.Func'(E,F,G,H)):-!,propSharArg(A,E),propSharArg(B,F),propSharArg(C,G),propSharArg(D,H).
propagateShare('Flat.Rule'(A,B),'Flat.Rule'(C,D)):-!,propSharArg(A,C),propSharArg(B,D).
propagateShare('Flat.External'(A),'Flat.External'(B)):-!,propSharArg(A,B).
propagateShare('Flat.Rigid','Flat.Rigid'):-!.
propagateShare('Flat.Flex','Flat.Flex'):-!.
propagateShare('Flat.FuncCall','Flat.FuncCall'):-!.
propagateShare('Flat.ConsCall','Flat.ConsCall'):-!.
propagateShare('Flat.PartCall','Flat.PartCall'):-!.
propagateShare('Flat.Var'(A),'Flat.Var'(B)):-!,propSharArg(A,B).
propagateShare('Flat.Lit'(A),'Flat.Lit'(B)):-!,propSharArg(A,B).
propagateShare('Flat.Comb'(A,B,C),'Flat.Comb'(D,E,F)):-!,propSharArg(A,D),propSharArg(B,E),propSharArg(C,F).
propagateShare('Flat.Apply'(A,B),'Flat.Apply'(C,D)):-!,propSharArg(A,C),propSharArg(B,D).
propagateShare('Flat.Constr'(A,B),'Flat.Constr'(C,D)):-!,propSharArg(A,C),propSharArg(B,D).
propagateShare('Flat.Or'(A,B),'Flat.Or'(C,D)):-!,propSharArg(A,C),propSharArg(B,D).
propagateShare('Flat.Case'(A,B,C),'Flat.Case'(D,E,F)):-!,propSharArg(A,D),propSharArg(B,E),propSharArg(C,F).
propagateShare('Flat.Choice'(A),'Flat.Choice'(B)):-!,propSharArg(A,B).
propagateShare('Flat.GuardedExpr'(A,B,C),'Flat.GuardedExpr'(D,E,F)):-!,propSharArg(A,D),propSharArg(B,E),propSharArg(C,F).
propagateShare('Flat.Branch'(A,B),'Flat.Branch'(C,D)):-!,propSharArg(A,C),propSharArg(B,D).
propagateShare('Flat.Pattern'(A,B),'Flat.Pattern'(C,D)):-!,propSharArg(A,C),propSharArg(B,D).
propagateShare('Flat.LPattern'(A),'Flat.LPattern'(B)):-!,propSharArg(A,B).
propagateShare('Flat.Intc'(A),'Flat.Intc'(B)):-!,propSharArg(A,B).
propagateShare('Flat.Floatc'(A),'Flat.Floatc'(B)):-!,propSharArg(A,B).
propagateShare('Flat.Charc'(A),'Flat.Charc'(B)):-!,propSharArg(A,B).
propagateShare('Flat.Trans'(A,B),'Flat.Trans'(C,D)):-!,propSharArg(A,C),propSharArg(B,D).
propagateShare('SetRBT2.RBSRed','SetRBT2.RBSRed'):-!.
propagateShare('SetRBT2.RBSBlack','SetRBT2.RBSBlack'):-!.
propagateShare('SetRBT2.RBS'(A,B,C,D),'SetRBT2.RBS'(E,F,G,H)):-!,propSharArg(A,E),propSharArg(B,F),propSharArg(C,G),propSharArg(D,H).
propagateShare('SetRBT2.RBSEmpty','SetRBT2.RBSEmpty'):-!.
propagateShare('SetRBT2.SetRBT'(A,B),'SetRBT2.SetRBT'(C,D)):-!,propSharArg(A,C),propSharArg(B,D).
propagateShare('TableRBT2.RBTRed','TableRBT2.RBTRed'):-!.
propagateShare('TableRBT2.RBTBlack','TableRBT2.RBTBlack'):-!.
propagateShare('TableRBT2.RBT'(A,B,C,D,E),'TableRBT2.RBT'(F,G,H,I,J)):-!,propSharArg(A,F),propSharArg(B,G),propSharArg(C,H),propSharArg(D,I),propSharArg(E,J).
propagateShare('TableRBT2.RBTEmpty','TableRBT2.RBTEmpty'):-!.
propagateShare('TableRBT2.TableRBT'(A,B),'TableRBT2.TableRBT'(C,D)):-!,propSharArg(A,C),propSharArg(B,D).
propagateShare('System.Date'(A,B,C,D,E,F),'System.Date'(G,H,I,J,K,L)):-!,propSharArg(A,G),propSharArg(B,H),propSharArg(C,I),propSharArg(D,J),propSharArg(E,K),propSharArg(F,L).
propagateShare('Ports.internalPort'(A,B,C,D),'Ports.internalPort'(A,B,C,D)):-!.
propagateShare('$stream'(A),'$stream'(A)):-!.
propagateShare(A,A):-number(A),!.
propagateShare(A,B):-functor(A,C,D),functor(B,C,D),propagateShare_args(1,D,A,B).

propagateShare_args(A,B,C,D):-A>B,!.
propagateShare_args(A,B,C,D):-arg(A,C,E),arg(A,D,F),propSharArg(E,F),G is A+1,propagateShare_args(G,B,C,D).

translate(:,'.').
translate('.','prelude..').
translate(optimizeFlatCurry,'OptFlat.optimizeFlatCurry').
translate('(,,,,,,,,,,)','(,,,,,,,,,,)').
translate('()','()').
translate('(,,,,,,)','(,,,,,,)').
translate('Int','Int').
translate('Success','Success').
translate('Char','Char').
translate('Maybe','Maybe').
translate('(,,,,,)','(,,,,,)').
translate('(,)','(,)').
translate('(,,,,)','(,,,,)').
translate('(,,,)','(,,,)').
translate('IO','IO').
translate('(,,)','(,,)').
translate('<tuple>','<tuple>').
translate('(,,,,,,,,)','(,,,,,,,,)').
translate([],[]).
translate('(,,,,,,,,,)','(,,,,,,,,,)').
translate('Either','Either').
translate('String','String').
translate('(,,,,,,,)','(,,,,,,,)').
translate('Float','Float').
translate('Bool','Bool').
translate('(,,,,,,,,,,,)','(,,,,,,,,,,,)').
translate('Left','Left').
translate('(,)','(,)').
translate(curry,curry).
translate(writeFile,writeFile).
translate('Nothing','Nothing').
translate(lookup,lookup).
translate(browse,browse).
translate('()','()').
translate(maybe,maybe).
translate(enumFromThen,enumFromThen).
translate(reverse,reverse).
translate(takeWhile,takeWhile).
translate(/=,/=).
translate('False','False').
translate(until,until).
translate('PEVAL','PEVAL').
translate('(,,)','(,,)').
translate(ord,ord).
translate(best,best).
translate(putStr,putStr).
translate(catchFail,catchFail).
translate(concatMap,concatMap).
translate(mod,mod).
translate(drop,drop).
translate(any,any).
translate(or,or).
translate('<unary-minus>','<unary-minus>').
translate('(,,,,,,,,,,,)','(,,,,,,,,,,,)').
translate([],[]).
translate(foldr,foldr).
translate(inject,inject).
translate('(,,,)','(,,,)').
translate('$!','$!').
translate('(,,,,)','(,,,,)').
translate(take,take).
translate(>>=,>>=).
translate(unwords,unwords).
translate(foldl,foldl).
translate(success,success).
translate(and,and).
translate(null,null).
translate(findall,findall).
translate(try,try).
translate(words,words).
translate(id,id).
translate(not,not).
translate(head,head).
translate(>>,>>).
translate(appendFile,appendFile).
translate(>=,>=).
translate('<tuple>','<tuple>').
translate(readFile,readFile).
translate(otherwise,otherwise).
translate(span,span).
translate(enumFromThenTo,enumFromThenTo).
translate(mapIO,mapIO).
translate(either,either).
translate(tryone,tryone).
translate(splitAt,splitAt).
translate(zipWith,zipWith).
translate(mapIO_,mapIO_).
translate(seq,seq).
translate(dropWhile,dropWhile).
translate('(,,,,,,,)','(,,,,,,,)').
translate(if_then_else,if_then_else).
translate('(,,,,,,,,,)','(,,,,,,,,,)').
translate(doSolve,doSolve).
translate('True','True').
translate(zip3,zip3).
translate(putStrLn,putStrLn).
translate(error,error).
translate(zip,zip).
translate(==,==).
translate(sequenceIO_,sequenceIO_).
translate(fst,fst).
translate(tail,tail).
translate(enumFromTo,enumFromTo).
translate(solveAll,solveAll).
translate(notElem,notElem).
translate(all,all).
translate(getChar,getChar).
translate(if_then_else,if_then_else).
translate('(,,,,,)','(,,,,,)').
translate(sequenceIO,sequenceIO).
translate(unzip,unzip).
translate(done,done).
translate(browseList,browseList).
translate(once,once).
translate('(,,,,,,,,,,)','(,,,,,,,,,,)').
translate(map,map).
translate(>,>).
translate(return,return).
translate(<,<).
translate(:,:).
translate(flip,flip).
translate(unzip3,unzip3).
translate(unlines,unlines).
translate(repeat,repeat).
translate('(,,,,,,,,)','(,,,,,,,,)').
translate(=:=,=:=).
translate(break,break).
translate(<=,<=).
translate('(,,,,,,)','(,,,,,,)').
translate(enumFrom,enumFrom).
translate(&>,&>).
translate('Right','Right').
translate('.','.').
translate(show,show).
translate(-,-).
translate(foldr1,foldr1).
translate(+,+).
translate('||','||').
translate(*,*).
translate(concat,concat).
translate(lines,lines).
translate('Just','Just').
translate(&,&).
translate(replicate,replicate).
translate('!!','!!').
translate($,$).
translate(condSearch,condSearch).
translate(iterate,iterate).
translate(chr,chr).
translate(filter,filter).
translate(foldl1,foldl1).
translate(getLine,getLine).
translate(&&,&&).
translate(zipWith3,zipWith3).
translate(one,one).
translate(print,print).
translate(div,div).
translate(snd,snd).
translate(solveAll2,solveAll2).
translate(putChar,putChar).
translate(++,++).
translate(findfirst,findfirst).
translate(uncurry,uncurry).
translate(elem,elem).
translate(const,const).
translate(unpack,unpack).
translate(length,length).
translate(failed,failed).
translate('Literal','Flat.Literal').
translate('OpDecl','Flat.OpDecl').
translate('ConsDecl','Flat.ConsDecl').
translate('Pattern','Flat.Pattern').
translate('Rule','Flat.Rule').
translate('Translation','Flat.Translation').
translate('FuncDecl','Flat.FuncDecl').
translate('BranchExpr','Flat.BranchExpr').
translate('Fixity','Flat.Fixity').
translate('TypeDecl','Flat.TypeDecl').
translate('TypeExpr','Flat.TypeExpr').
translate('CaseType','Flat.CaseType').
translate('Expr','Flat.Expr').
translate('CombType','Flat.CombType').
translate('Prog','Flat.Prog').
translate('TVarIndex','Flat.TVarIndex').
translate('VarIndex','Flat.VarIndex').
translate('Comb','Flat.Comb').
translate('External','Flat.External').
translate('Choice','Flat.Choice').
translate('GuardedExpr','Flat.GuardedExpr').
translate('Pattern','Flat.Pattern').
translate('Lit','Flat.Lit').
translate('Apply','Flat.Apply').
translate(readFlatCurryWithParseOptions,'Flat.readFlatCurryWithParseOptions').
translate(readFlatCurry,'Flat.readFlatCurry').
translate('Rigid','Flat.Rigid').
translate('Rule','Flat.Rule').
translate('TCons','Flat.TCons').
translate('FuncType','Flat.FuncType').
translate('TVar','Flat.TVar').
translate('PartCall','Flat.PartCall').
translate('Constr','Flat.Constr').
translate('InfixrOp','Flat.InfixrOp').
translate(readFlatCurryFile,'Flat.readFlatCurryFile').
translate('Cons','Flat.Cons').
translate('Case','Flat.Case').
translate('ConsCall','Flat.ConsCall').
translate('Charc','Flat.Charc').
translate('Type','Flat.Type').
translate(splitFlatModName,'Flat.splitFlatModName').
translate('Var','Flat.Var').
translate('LPattern','Flat.LPattern').
translate('Floatc','Flat.Floatc').
translate('InfixOp','Flat.InfixOp').
translate('InfixlOp','Flat.InfixlOp').
translate('Func','Flat.Func').
translate('FuncCall','Flat.FuncCall').
translate('Flex','Flat.Flex').
translate('Branch','Flat.Branch').
translate('Prog','Flat.Prog').
translate('Trans','Flat.Trans').
translate('Or','Flat.Or').
translate('Op','Flat.Op').
translate('Intc','Flat.Intc').
translate(writeFLC,'FlatTools.writeFLC').
translate(showCurryVar,'FlatTools.showCurryVar').
translate(showCurryType,'FlatTools.showCurryType').
translate(showCurryExpr,'FlatTools.showCurryExpr').
translate(showFlatProg,'FlatTools.showFlatProg').
translate('SetRBT','SetRBT2.SetRBT').
translate(emptySetRBT,'SetRBT2.emptySetRBT').
translate(insertRBT,'SetRBT2.insertRBT').
translate(elemRBT,'SetRBT2.elemRBT').
translate(unionRBT,'SetRBT2.unionRBT').
translate(setRBT2list,'SetRBT2.setRBT2list').
translate(sortRBT,'SetRBT2.sortRBT').
translate(intersectRBT,'SetRBT2.intersectRBT').
translate(insertMultiRBT,'SetRBT2.insertMultiRBT').
translate('TableRBT','TableRBT2.TableRBT').
translate(emptyTableRBT,'TableRBT2.emptyTableRBT').
translate(updateRBT,'TableRBT2.updateRBT').
translate(tableRBT2list,'TableRBT2.tableRBT2list').
translate(lookupRBT,'TableRBT2.lookupRBT').
translate('Date','System.Date').
translate(showDate,'System.showDate').
translate(getCPUTime,'System.getCPUTime').
translate(getElapsedTime,'System.getElapsedTime').
translate(getHostname,'System.getHostname').
translate(getArgs,'System.getArgs').
translate(sleep,'System.sleep').
translate(getEnviron,'System.getEnviron').
translate('Date','System.Date').
translate(system,'System.system').
translate(evalSpace,'System.evalSpace').
translate(getDate,'System.getDate').
translate(getPID,'System.getPID').
translate(evalTime,'System.evalTime').
translate(doesFileExist,'Directory.doesFileExist').
translate(getModificationTime,'Directory.getModificationTime').
translate(doesDirectoryExist,'Directory.doesDirectoryExist').
translate(getDirectoryContents,'Directory.getDirectoryContents').
translate(nub,'List.nub').
translate(isPrefixOf,'List.isPrefixOf').
translate(transpose,'List.transpose').
translate(intersect,'List.intersect').
translate(last,'List.last').
translate(intersperse,'List.intersperse').
translate(insertBy,'List.insertBy').
translate(sortBy,'List.sortBy').
translate(replace,'List.replace').
translate(union,'List.union').
translate(nubBy,'List.nubBy').
translate(group,'List.group').
translate(partition,'List.partition').
translate(delete,'List.delete').
translate(groupBy,'List.groupBy').
translate(isAlphaNum,'Char.isAlphaNum').
translate(isDigit,'Char.isDigit').
translate(isUpper,'Char.isUpper').
translate(isHexDigit,'Char.isHexDigit').
translate(isLower,'Char.isLower').
translate(isAlpha,'Char.isAlpha').
translate(digitToInt,'Char.digitToInt').
translate(toUpper,'Char.toUpper').
translate(isOctDigit,'Char.isOctDigit').
translate(isSpace,'Char.isSpace').
translate(intToDigit,'Char.intToDigit').
translate(toLower,'Char.toLower').
functiontype('OptFlat.optimizeFlatCurry','FuncType'('TCons'([],['TCons'('Char',[])]),'FuncType'('TCons'([],['TCons'('Char',[])]),'FuncType'('TCons'([],['TCons'('Char',[])]),'FuncType'('TCons'([],['TCons'('Char',[])]),'TCons'('IO',['TCons'('()',[])])))))).
functiontype('OptFlat.getStartingState','FuncType'('TCons'('Flat.Prog',[]),'FuncType'('TCons'([],['TCons'('Flat.Prog',[])]),'FuncType'('TCons'([],['TCons'('Char',[])]),'FuncType'('TCons'([],['TCons'('Char',[])]),'TCons'('(,)',['TCons'('Flat.Prog',[]),'TCons'('Flat.Prog',[])])))))).
functiontype('OptFlat.makeOneFuncProg','FuncType'('TCons'('Flat.Prog',[]),'FuncType'('TCons'([],['TCons'('Char',[])]),'TCons'('Flat.Prog',[])))).
functiontype('OptFlat.getFunc','FuncType'('TCons'([],['TCons'('Char',[])]),'FuncType'('TCons'([],['TCons'('Flat.FuncDecl',[])]),'TCons'('Flat.FuncDecl',[])))).
functiontype('OptFlat.getTrans','FuncType'('TCons'([],['TCons'('Char',[])]),'FuncType'('TCons'([],['TCons'('Flat.Translation',[])]),'TCons'('(,)',['TCons'([],['TCons'('Char',[])]),'TCons'('Flat.Translation',[])])))).
functiontype('OptFlat.makeOptimizedFlatProg','FuncType'('TCons'('Flat.Prog',[]),'FuncType'('TCons'('Flat.Prog',[]),'FuncType'('TCons'([],['TCons'('Char',[])]),'TCons'('Flat.Prog',[]))))).
functiontype('OptFlat.optFuncDecls','FuncType'('TCons'([],['TCons'('Flat.FuncDecl',[])]),'FuncType'('TCons'([],['TCons'('Flat.FuncDecl',[])]),'TCons'([],['TCons'('Flat.FuncDecl',[])])))).
functiontype('OptFlat.optFuncDecls\'','FuncType'('TCons'([],['TCons'('Flat.FuncDecl',[])]),'FuncType'('TCons'('SetRBT2.SetRBT',['TCons'([],['TCons'('Char',[])])]),'FuncType'('TCons'([],['TCons'('Flat.FuncDecl',[])]),'TCons'([],['TCons'('Flat.FuncDecl',[])]))))).
functiontype('OptFlat.lookupFuncCalls','FuncType'('TCons'([],['TCons'([],['TCons'('Char',[])])]),'FuncType'('TCons'([],['TCons'('Flat.FuncDecl',[])]),'FuncType'('TCons'('SetRBT2.SetRBT',['TCons'([],['TCons'('Char',[])])]),'FuncType'('TCons'([],['TCons'('Flat.FuncDecl',[])]),'TCons'('(,)',['TCons'([],['TCons'('Flat.FuncDecl',[])]),'TCons'('SetRBT2.SetRBT',['TCons'([],['TCons'('Char',[])])])])))))).
functiontype('OptFlat.lookupFuncDeclInRest','FuncType'('TCons'([],['TCons'('Char',[])]),'FuncType'('TCons'([],['TCons'('Flat.FuncDecl',[])]),'TCons'([],['TCons'('Flat.FuncDecl',[])])))).
functiontype('OptFlat.getAllFuncCalls','FuncType'('TCons'('Flat.FuncDecl',[]),'TCons'([],['TCons'([],['TCons'('Char',[])])]))).
functiontype('OptFlat.getAllFuncCallsOfExpr','FuncType'('TCons'('Flat.Expr',[]),'TCons'([],['TCons'([],['TCons'('Char',[])])]))).
functiontype('OptFlat.getAllFuncCallsOfBranchExpr','FuncType'('TCons'('Flat.BranchExpr',[]),'TCons'([],['TCons'([],['TCons'('Char',[])])]))).
functiontype('OptFlat.readAllImportedFlatProgs','FuncType'('TCons'('Flat.Prog',[]),'FuncType'('TCons'([],['TCons'('Char',[])]),'TCons'('IO',['TCons'([],['TCons'('Flat.Prog',[])])])))).
functiontype('OptFlat.readAllImportedFlatProgs\'','FuncType'('TCons'([],['TCons'([],['TCons'('Char',[])])]),'FuncType'('TCons'([],['TCons'('Char',[])]),'FuncType'('TCons'('SetRBT2.SetRBT',['TCons'([],['TCons'('Char',[])])]),'TCons'('IO',['TCons'([],['TCons'('Flat.Prog',[])])]))))).
functiontype('OptFlat.tryReadFlatCurry','FuncType'('TCons'([],['TCons'('Char',[])]),'FuncType'('TCons'([],['TCons'('Char',[])]),'TCons'('IO',['TCons'('Flat.Prog',[])])))).
functiontype('OptFlat.getModname','FuncType'('TCons'('Flat.Prog',[]),'TCons'([],['TCons'('Char',[])]))).
functiontype('OptFlat.getImports','FuncType'('TCons'('Flat.Prog',[]),'TCons'([],['TCons'([],['TCons'('Char',[])])]))).
functiontype('OptFlat.getFuncDecls','FuncType'('TCons'('Flat.Prog',[]),'TCons'([],['TCons'('Flat.FuncDecl',[])]))).
functiontype('OptFlat.getFuncName','FuncType'('TCons'('Flat.FuncDecl',[]),'TCons'([],['TCons'('Char',[])]))).
functiontype('OptFlat.getTransName','FuncType'('TCons'('Flat.Translation',[]),'TCons'([],['TCons'('Char',[])]))).
functiontype('OptFlat.getInternalName','FuncType'('TCons'('Flat.Translation',[]),'TCons'([],['TCons'('Char',[])]))).
functiontype('OptFlat.mergeFlatProgList','FuncType'('TCons'([],['TCons'('Flat.Prog',[])]),'TCons'('Flat.Prog',[]))).
functiontype('OptFlat.mergeFlatProgs','FuncType'('TCons'('Flat.Prog',[]),'FuncType'('TCons'('Flat.Prog',[]),'TCons'('Flat.Prog',[])))).
functiontype('OptFlat.leString','FuncType'('TCons'([],['TCons'('Char',[])]),'FuncType'('TCons'([],['TCons'('Char',[])]),'TCons'('Bool',[])))).
functiontype('OptFlat.leChar','FuncType'('TCons'('Char',[]),'FuncType'('TCons'('Char',[]),'TCons'('Bool',[])))).
functiontype('OptFlat.leList','FuncType'('FuncType'(A,'FuncType'(A,'TCons'('Bool',[]))),'FuncType'('TCons'([],[A]),'FuncType'('TCons'([],[A]),'TCons'('Bool',[]))))).
functiontype('OptFlat.leFuncDecl','FuncType'('TCons'('Flat.FuncDecl',[]),'FuncType'('TCons'('Flat.FuncDecl',[]),'TCons'('Bool',[])))).
functiontype('OptFlat.list2SetRBT','FuncType'('FuncType'(A,'FuncType'(A,'TCons'('Bool',[]))),'FuncType'('TCons'([],[A]),'TCons'('SetRBT2.SetRBT',[A])))).
functiontype('OptFlat.lambdafun_9659','FuncType'('TCons'('Flat.Prog',[]),'FuncType'('TCons'([],['TCons'('Char',[])]),'FuncType'('TCons'([],['TCons'('Char',[])]),'FuncType'('TCons'([],['TCons'('Char',[])]),'FuncType'('TCons'([],['TCons'('Flat.Prog',[])]),'TCons'('IO',['TCons'('()',[])]))))))).
functiontype('OptFlat.optFlat_lambda1_9661','FuncType'('TCons'([],['TCons'('Char',[])]),'FuncType'('TCons'('Flat.Prog',[]),'TCons'('IO',['TCons'('()',[])])))).
functiontype('OptFlat.optFlat_lambda0_9662','FuncType'('TCons'([],['TCons'('Char',[])]),'FuncType'('TCons'([],['TCons'('Char',[])]),'FuncType'('TCons'('(,)',['TCons'('Flat.Prog',[]),'TCons'('Flat.Prog',[])]),'TCons'('IO',['TCons'('()',[])]))))).
functiontype('OptFlat.lambdafun_9660','FuncType'('TCons'([],['TCons'('Char',[])]),'FuncType'('TCons'([],['TCons'('Char',[])]),'FuncType'('TCons'([],['TCons'('Char',[])]),'FuncType'('TCons'('Flat.Prog',[]),'TCons'('IO',['TCons'('()',[])])))))).
functiontype('OptFlat.optFlat_lambda2_9663','FuncType'('TCons'([],['TCons'('Char',[])]),'FuncType'('TCons'([],['TCons'('Flat.TypeDecl',[])]),'FuncType'('TCons'([],['TCons'('Flat.FuncDecl',[])]),'FuncType'('TCons'([],['TCons'('Flat.OpDecl',[])]),'FuncType'('TCons'('(,)',['TCons'([],['TCons'('Char',[])]),'TCons'('Flat.Translation',[])]),'TCons'('Flat.Prog',[]))))))).
functiontype('OptFlat.optFlat_lambda3_9664','FuncType'('TCons'([],['TCons'('Flat.FuncDecl',[])]),'FuncType'('TCons'([],['TCons'('Flat.FuncDecl',[])]),'FuncType'('TCons'('SetRBT2.SetRBT',['TCons'([],['TCons'('Char',[])])]),'TCons'([],['TCons'('Flat.FuncDecl',[])]))))).
functiontype('OptFlat.optFlat_lambda5_9665','FuncType'('TCons'('Flat.FuncDecl',[]),'FuncType'('TCons'([],['TCons'('Flat.FuncDecl',[])]),'FuncType'('TCons'('(,)',['TCons'([],['TCons'('Flat.FuncDecl',[])]),'TCons'('SetRBT2.SetRBT',['TCons'([],['TCons'('Char',[])])])]),'TCons'([],['TCons'('Flat.FuncDecl',[])]))))).
functiontype('OptFlat.optFlat_lambda4_9666','FuncType'('TCons'('Flat.FuncDecl',[]),'FuncType'('TCons'([],['TCons'('Flat.FuncDecl',[])]),'FuncType'('TCons'([],['TCons'('Flat.FuncDecl',[])]),'FuncType'('TCons'('SetRBT2.SetRBT',['TCons'([],['TCons'('Char',[])])]),'FuncType'('TCons'([],['TCons'([],['TCons'('Char',[])])]),'TCons'([],['TCons'('Flat.FuncDecl',[])]))))))).
functiontype('OptFlat.lambdafun_9667','FuncType'('TCons'([],['TCons'('Flat.Prog',[])]),'TCons'('IO',['TCons'([],['TCons'('Flat.Prog',[])])]))).
functiontype('OptFlat.lambdafun_9668','FuncType'('TCons'([],['TCons'('Flat.Prog',[])]),'TCons'('IO',['TCons'([],['TCons'('Flat.Prog',[])])]))).
functiontype('OptFlat.lambdafun_9669','FuncType'('TCons'('Flat.Prog',[]),'FuncType'('TCons'([],['TCons'('Flat.Prog',[])]),'TCons'('IO',['TCons'([],['TCons'('Flat.Prog',[])])])))).
functiontype('OptFlat.lambdafun_9670','FuncType'('TCons'([],['TCons'('Char',[])]),'FuncType'('TCons'([],['TCons'([],['TCons'('Char',[])])]),'FuncType'('TCons'([],['TCons'('Char',[])]),'FuncType'('TCons'('SetRBT2.SetRBT',['TCons'([],['TCons'('Char',[])])]),'FuncType'('TCons'('Flat.Prog',[]),'TCons'('IO',['TCons'([],['TCons'('Flat.Prog',[])])]))))))).
functiontype(seq,'FuncType'(A,'FuncType'(B,B))).
functiontype(error,'FuncType'('TCons'([],['TCons'('Char',[])]),A)).
functiontype(==,'FuncType'(A,'FuncType'(A,'TCons'('Bool',[])))).
functiontype(ord,'FuncType'('TCons'('Char',[]),'TCons'('Int',[]))).
functiontype(chr,'FuncType'('TCons'('Int',[]),'TCons'('Char',[]))).
functiontype(+,'FuncType'('TCons'('Int',[]),'FuncType'('TCons'('Int',[]),'TCons'('Int',[])))).
functiontype(-,'FuncType'('TCons'('Int',[]),'FuncType'('TCons'('Int',[]),'TCons'('Int',[])))).
functiontype(*,'FuncType'('TCons'('Int',[]),'FuncType'('TCons'('Int',[]),'TCons'('Int',[])))).
functiontype(div,'FuncType'('TCons'('Int',[]),'FuncType'('TCons'('Int',[]),'TCons'('Int',[])))).
functiontype(mod,'FuncType'('TCons'('Int',[]),'FuncType'('TCons'('Int',[]),'TCons'('Int',[])))).
functiontype(<,'FuncType'('TCons'('Int',[]),'FuncType'('TCons'('Int',[]),'TCons'('Bool',[])))).
functiontype(>,'FuncType'('TCons'('Int',[]),'FuncType'('TCons'('Int',[]),'TCons'('Bool',[])))).
functiontype(<=,'FuncType'('TCons'('Int',[]),'FuncType'('TCons'('Int',[]),'TCons'('Bool',[])))).
functiontype(>=,'FuncType'('TCons'('Int',[]),'FuncType'('TCons'('Int',[]),'TCons'('Bool',[])))).
functiontype(=:=,'FuncType'(A,'FuncType'(A,'TCons'('Success',[])))).
functiontype(success,'TCons'('Success',[])).
functiontype(&,'FuncType'('TCons'('Success',[]),'FuncType'('TCons'('Success',[]),'TCons'('Success',[])))).
functiontype(>>=,'FuncType'('TCons'('IO',[A]),'FuncType'('FuncType'(A,'TCons'('IO',[B])),'TCons'('IO',[B])))).
functiontype(return,'FuncType'(A,'TCons'('IO',[A]))).
functiontype(putChar,'FuncType'('TCons'('Char',[]),'TCons'('IO',['TCons'('()',[])]))).
functiontype(getChar,'TCons'('IO',['TCons'('Char',[])])).
functiontype(readFile,'FuncType'('TCons'([],['TCons'('Char',[])]),'TCons'('IO',['TCons'([],['TCons'('Char',[])])]))).
functiontype(writeFile,'FuncType'('TCons'([],['TCons'('Char',[])]),'FuncType'('TCons'([],['TCons'('Char',[])]),'TCons'('IO',['TCons'('()',[])])))).
functiontype(appendFile,'FuncType'('TCons'([],['TCons'('Char',[])]),'FuncType'('TCons'([],['TCons'('Char',[])]),'TCons'('IO',['TCons'('()',[])])))).
functiontype(catchFail,'FuncType'('TCons'('IO',[A]),'FuncType'('TCons'('IO',[A]),'TCons'('IO',[A])))).
functiontype(show,'FuncType'(A,'TCons'([],['TCons'('Char',[])]))).
functiontype(try,'FuncType'('FuncType'(A,'TCons'('Success',[])),'TCons'([],['FuncType'(A,'TCons'('Success',[]))]))).
functiontype('prelude..','FuncType'('FuncType'(A,B),'FuncType'('FuncType'(C,A),'FuncType'(C,B)))).
functiontype(id,'FuncType'(A,A)).
functiontype(const,'FuncType'(A,'FuncType'(B,A))).
functiontype(curry,'FuncType'('FuncType'('TCons'('(,)',[A,B]),C),'FuncType'(A,'FuncType'(B,C)))).
functiontype(uncurry,'FuncType'('FuncType'(A,'FuncType'(B,C)),'FuncType'('TCons'('(,)',[A,B]),C))).
functiontype(flip,'FuncType'('FuncType'(A,'FuncType'(B,C)),'FuncType'(B,'FuncType'(A,C)))).
functiontype(until,'FuncType'('FuncType'(A,'TCons'('Bool',[])),'FuncType'('FuncType'(A,A),'FuncType'(A,A)))).
functiontype($,'FuncType'('FuncType'(A,B),'FuncType'(A,B))).
functiontype('$!','FuncType'('FuncType'(A,B),'FuncType'(A,B))).
functiontype(failed,A).
functiontype(&&,'FuncType'('TCons'('Bool',[]),'FuncType'('TCons'('Bool',[]),'TCons'('Bool',[])))).
functiontype('||','FuncType'('TCons'('Bool',[]),'FuncType'('TCons'('Bool',[]),'TCons'('Bool',[])))).
functiontype(not,'FuncType'('TCons'('Bool',[]),'TCons'('Bool',[]))).
functiontype(otherwise,'TCons'('Bool',[])).
functiontype(if_then_else,'FuncType'('TCons'('Bool',[]),'FuncType'(A,'FuncType'(A,A)))).
functiontype(/=,'FuncType'(A,'FuncType'(A,'TCons'('Bool',[])))).
functiontype(fst,'FuncType'('TCons'('(,)',[A,B]),A)).
functiontype(snd,'FuncType'('TCons'('(,)',[A,B]),B)).
functiontype(head,'FuncType'('TCons'([],[A]),A)).
functiontype(tail,'FuncType'('TCons'([],[A]),'TCons'([],[A]))).
functiontype(null,'FuncType'('TCons'([],[A]),'TCons'('Bool',[]))).
functiontype(++,'FuncType'('TCons'([],[A]),'FuncType'('TCons'([],[A]),'TCons'([],[A])))).
functiontype(length,'FuncType'('TCons'([],[A]),'TCons'('Int',[]))).
functiontype('!!','FuncType'('TCons'([],[A]),'FuncType'('TCons'('Int',[]),A))).
functiontype(map,'FuncType'('FuncType'(A,B),'FuncType'('TCons'([],[A]),'TCons'([],[B])))).
functiontype(foldl,'FuncType'('FuncType'(A,'FuncType'(B,A)),'FuncType'(A,'FuncType'('TCons'([],[B]),A)))).
functiontype(foldl1,'FuncType'('FuncType'(A,'FuncType'(A,A)),'FuncType'('TCons'([],[A]),A))).
functiontype(foldr,'FuncType'('FuncType'(A,'FuncType'(B,B)),'FuncType'(B,'FuncType'('TCons'([],[A]),B)))).
functiontype(foldr1,'FuncType'('FuncType'(A,'FuncType'(A,A)),'FuncType'('TCons'([],[A]),A))).
functiontype(filter,'FuncType'('FuncType'(A,'TCons'('Bool',[])),'FuncType'('TCons'([],[A]),'TCons'([],[A])))).
functiontype(zip,'FuncType'('TCons'([],[A]),'FuncType'('TCons'([],[B]),'TCons'([],['TCons'('(,)',[A,B])])))).
functiontype(zip3,'FuncType'('TCons'([],[A]),'FuncType'('TCons'([],[B]),'FuncType'('TCons'([],[C]),'TCons'([],['TCons'('(,,)',[A,B,C])]))))).
functiontype(zipWith,'FuncType'('FuncType'(A,'FuncType'(B,C)),'FuncType'('TCons'([],[A]),'FuncType'('TCons'([],[B]),'TCons'([],[C]))))).
functiontype(zipWith3,'FuncType'('FuncType'(A,'FuncType'(B,'FuncType'(C,D))),'FuncType'('TCons'([],[A]),'FuncType'('TCons'([],[B]),'FuncType'('TCons'([],[C]),'TCons'([],[D])))))).
functiontype(unzip,'FuncType'('TCons'([],['TCons'('(,)',[A,B])]),'TCons'('(,)',['TCons'([],[A]),'TCons'([],[B])]))).
functiontype(unzip3,'FuncType'('TCons'([],['TCons'('(,,)',[A,B,C])]),'TCons'('(,,)',['TCons'([],[A]),'TCons'([],[B]),'TCons'([],[C])]))).
functiontype(concat,'FuncType'('TCons'([],['TCons'([],[A])]),'TCons'([],[A]))).
functiontype(concatMap,'FuncType'('FuncType'(A,'TCons'([],[B])),'FuncType'('TCons'([],[A]),'TCons'([],[B])))).
functiontype(iterate,'FuncType'('FuncType'(A,A),'FuncType'(A,'TCons'([],[A])))).
functiontype(repeat,'FuncType'(A,'TCons'([],[A]))).
functiontype(replicate,'FuncType'('TCons'('Int',[]),'FuncType'(A,'TCons'([],[A])))).
functiontype(take,'FuncType'('TCons'('Int',[]),'FuncType'('TCons'([],[A]),'TCons'([],[A])))).
functiontype(drop,'FuncType'('TCons'('Int',[]),'FuncType'('TCons'([],[A]),'TCons'([],[A])))).
functiontype(splitAt,'FuncType'('TCons'('Int',[]),'FuncType'('TCons'([],[A]),'TCons'('(,)',['TCons'([],[A]),'TCons'([],[A])])))).
functiontype(takeWhile,'FuncType'('FuncType'(A,'TCons'('Bool',[])),'FuncType'('TCons'([],[A]),'TCons'([],[A])))).
functiontype(dropWhile,'FuncType'('FuncType'(A,'TCons'('Bool',[])),'FuncType'('TCons'([],[A]),'TCons'([],[A])))).
functiontype(span,'FuncType'('FuncType'(A,'TCons'('Bool',[])),'FuncType'('TCons'([],[A]),'TCons'('(,)',['TCons'([],[A]),'TCons'([],[A])])))).
functiontype(break,'FuncType'('FuncType'(A,'TCons'('Bool',[])),'FuncType'('TCons'([],[A]),'TCons'('(,)',['TCons'([],[A]),'TCons'([],[A])])))).
functiontype(lines,'FuncType'('TCons'([],['TCons'('Char',[])]),'TCons'([],['TCons'([],['TCons'('Char',[])])]))).
functiontype(unlines,'FuncType'('TCons'([],['TCons'([],['TCons'('Char',[])])]),'TCons'([],['TCons'('Char',[])]))).
functiontype(words,'FuncType'('TCons'([],['TCons'('Char',[])]),'TCons'([],['TCons'([],['TCons'('Char',[])])]))).
functiontype(unwords,'FuncType'('TCons'([],['TCons'([],['TCons'('Char',[])])]),'TCons'([],['TCons'('Char',[])]))).
functiontype(reverse,'FuncType'('TCons'([],[A]),'TCons'([],[A]))).
functiontype(and,'FuncType'('TCons'([],['TCons'('Bool',[])]),'TCons'('Bool',[]))).
functiontype(or,'FuncType'('TCons'([],['TCons'('Bool',[])]),'TCons'('Bool',[]))).
functiontype(any,'FuncType'('FuncType'(A,'TCons'('Bool',[])),'FuncType'('TCons'([],[A]),'TCons'('Bool',[])))).
functiontype(all,'FuncType'('FuncType'(A,'TCons'('Bool',[])),'FuncType'('TCons'([],[A]),'TCons'('Bool',[])))).
functiontype(elem,'FuncType'(A,'FuncType'('TCons'([],[A]),'TCons'('Bool',[])))).
functiontype(notElem,'FuncType'(A,'FuncType'('TCons'([],[A]),'TCons'('Bool',[])))).
functiontype(lookup,'FuncType'(A,'FuncType'('TCons'([],['TCons'('(,)',[A,B])]),'TCons'('Maybe',[B])))).
functiontype(enumFrom,'FuncType'('TCons'('Int',[]),'TCons'([],['TCons'('Int',[])]))).
functiontype(enumFromThen,'FuncType'('TCons'('Int',[]),'FuncType'('TCons'('Int',[]),'TCons'([],['TCons'('Int',[])])))).
functiontype(enumFromTo,'FuncType'('TCons'('Int',[]),'FuncType'('TCons'('Int',[]),'TCons'([],['TCons'('Int',[])])))).
functiontype(enumFromThenTo,'FuncType'('TCons'('Int',[]),'FuncType'('TCons'('Int',[]),'FuncType'('TCons'('Int',[]),'TCons'([],['TCons'('Int',[])]))))).
functiontype(&>,'FuncType'('TCons'('Success',[]),'FuncType'('TCons'('Success',[]),'TCons'('Success',[])))).
functiontype(maybe,'FuncType'(A,'FuncType'('FuncType'(B,A),'FuncType'('TCons'('Maybe',[B]),A)))).
functiontype(either,'FuncType'('FuncType'(A,B),'FuncType'('FuncType'(C,B),'FuncType'('TCons'('Either',[A,C]),B)))).
functiontype(>>,'FuncType'('TCons'('IO',[A]),'FuncType'('TCons'('IO',[B]),'TCons'('IO',[B])))).
functiontype(done,'TCons'('IO',['TCons'('()',[])])).
functiontype(putStr,'FuncType'('TCons'([],['TCons'('Char',[])]),'TCons'('IO',['TCons'('()',[])]))).
functiontype(putStrLn,'FuncType'('TCons'([],['TCons'('Char',[])]),'TCons'('IO',['TCons'('()',[])]))).
functiontype(getLine,'TCons'('IO',['TCons'([],['TCons'('Char',[])])])).
functiontype(print,'FuncType'(A,'TCons'('IO',['TCons'('()',[])]))).
functiontype(doSolve,'FuncType'('TCons'('Success',[]),'TCons'('IO',['TCons'('()',[])]))).
functiontype(sequenceIO,'FuncType'('TCons'([],['TCons'('IO',[A])]),'TCons'('IO',['TCons'([],[A])]))).
functiontype(sequenceIO_,'FuncType'('TCons'([],['TCons'('IO',[A])]),'TCons'('IO',['TCons'('()',[])]))).
functiontype(mapIO,'FuncType'('FuncType'(A,'TCons'('IO',[B])),'FuncType'('TCons'([],[A]),'TCons'('IO',['TCons'([],[B])])))).
functiontype(mapIO_,'FuncType'('FuncType'(A,'TCons'('IO',[B])),'FuncType'('TCons'([],[A]),'TCons'('IO',['TCons'('()',[])])))).
functiontype(inject,'FuncType'('FuncType'(A,'TCons'('Success',[])),'FuncType'('FuncType'(A,'TCons'('Success',[])),'FuncType'(A,'TCons'('Success',[]))))).
functiontype(solveAll,'FuncType'('FuncType'(A,'TCons'('Success',[])),'TCons'([],['FuncType'(A,'TCons'('Success',[]))]))).
functiontype(solveAll2,'FuncType'('FuncType'(A,'TCons'('Success',[])),'TCons'([],['FuncType'(A,'TCons'('Success',[]))]))).
functiontype(once,'FuncType'('FuncType'(A,'TCons'('Success',[])),'FuncType'(A,'TCons'('Success',[])))).
functiontype(tryone,'FuncType'('FuncType'(A,'TCons'('Success',[])),A)).
functiontype(one,'FuncType'('FuncType'(A,'TCons'('Success',[])),'TCons'([],['FuncType'(A,'TCons'('Success',[]))]))).
functiontype(condSearch,'FuncType'('FuncType'(A,'TCons'('Success',[])),'FuncType'('FuncType'(A,'TCons'('Bool',[])),'TCons'([],['FuncType'(A,'TCons'('Success',[]))])))).
functiontype(best,'FuncType'('FuncType'(A,'TCons'('Success',[])),'FuncType'('FuncType'(A,'FuncType'(A,'TCons'('Bool',[]))),'TCons'([],['FuncType'(A,'TCons'('Success',[]))])))).
functiontype(findall,'FuncType'('FuncType'(A,'TCons'('Success',[])),'TCons'([],[A]))).
functiontype(findfirst,'FuncType'('FuncType'(A,'TCons'('Success',[])),A)).
functiontype(browse,'FuncType'('FuncType'(A,'TCons'('Success',[])),'TCons'('IO',['TCons'('()',[])]))).
functiontype(browseList,'FuncType'('TCons'([],['FuncType'(A,'TCons'('Success',[]))]),'TCons'('IO',['TCons'('()',[])]))).
functiontype(unpack,'FuncType'('FuncType'(A,'TCons'('Success',[])),A)).
functiontype('PEVAL','FuncType'(A,A)).
functiontype(prelude_lambda0_1997,'FuncType'('FuncType'(A,B),'FuncType'('FuncType'(C,A),'FuncType'(C,B)))).
functiontype(prelude_lambda1_1998,'FuncType'(A,'FuncType'(B,'FuncType'('TCons'('(,)',['TCons'([],[A]),'TCons'([],[B])]),'TCons'('(,)',['TCons'([],[A]),'TCons'([],[B])]))))).
functiontype(prelude_lambda2_1999,'FuncType'(A,'FuncType'(B,'FuncType'(C,'FuncType'('TCons'('(,,)',['TCons'([],[A]),'TCons'([],[B]),'TCons'([],[C])]),'TCons'('(,,)',['TCons'([],[A]),'TCons'([],[B]),'TCons'([],[C])])))))).
functiontype(takep_452,'FuncType'('TCons'('Int',[]),'FuncType'('TCons'([],[A]),'TCons'([],[A])))).
functiontype(dropp_459,'FuncType'('TCons'('Int',[]),'FuncType'('TCons'([],[A]),'TCons'([],[A])))).
functiontype(splitAtp_466,'FuncType'('TCons'('Int',[]),'FuncType'('TCons'([],[A]),'TCons'('(,)',['TCons'([],[A]),'TCons'([],[A])])))).
functiontype(prelude_lambda3_2000,'FuncType'(A,'FuncType'('TCons'('(,)',['TCons'([],[A]),'TCons'([],[A])]),'TCons'('(,)',['TCons'([],[A]),'TCons'([],[A])])))).
functiontype(prelude_lambda4_2001,'FuncType'(A,'FuncType'('TCons'('(,)',['TCons'([],[A]),'TCons'([],[A])]),'TCons'('(,)',['TCons'([],[A]),'TCons'([],[A])])))).
functiontype(splitline_490,'FuncType'('TCons'([],['TCons'('Char',[])]),'TCons'('(,)',['TCons'([],['TCons'('Char',[])]),'TCons'([],['TCons'('Char',[])])]))).
functiontype(prelude_lambda5_2002,'FuncType'('TCons'('Char',[]),'FuncType'('TCons'('(,)',['TCons'([],['TCons'('Char',[])]),'TCons'([],['TCons'('Char',[])])]),'TCons'('(,)',['TCons'([],['TCons'('Char',[])]),'TCons'([],['TCons'('Char',[])])])))).
functiontype(prelude_lambda6_2003,'FuncType'('TCons'('(,)',['TCons'([],['TCons'('Char',[])]),'TCons'([],['TCons'('Char',[])])]),'TCons'([],['TCons'([],['TCons'('Char',[])])]))).
functiontype(prelude_lambda7_2004,'FuncType'('TCons'([],['TCons'('Char',[])]),'TCons'([],['TCons'('Char',[])]))).
functiontype(isSpace_500,'FuncType'('TCons'('Char',[]),'TCons'('Bool',[]))).
functiontype(prelude_lambda9_2005,'FuncType'('TCons'('(,)',['TCons'([],['TCons'('Char',[])]),'TCons'([],['TCons'('Char',[])])]),'TCons'([],['TCons'([],['TCons'('Char',[])])]))).
functiontype(prelude_lambda8_2006,'FuncType'('TCons'([],['TCons'('Char',[])]),'TCons'([],['TCons'([],['TCons'('Char',[])])]))).
functiontype(prelude_lambda10_2007,'FuncType'('TCons'([],['TCons'('Char',[])]),'FuncType'('TCons'([],['TCons'('Char',[])]),'TCons'([],['TCons'('Char',[])])))).
functiontype(prelude_lambda11_2008,'FuncType'(A,'FuncType'(A,'TCons'('Bool',[])))).
functiontype(prelude_lambda12_2009,'FuncType'(A,'FuncType'(A,'TCons'('Bool',[])))).
functiontype(prelude_lambda13_2010,'FuncType'('TCons'('Int',[]),'FuncType'('TCons'('Int',[]),'FuncType'('TCons'('Int',[]),'TCons'('Int',[]))))).
functiontype(p_528,'FuncType'('TCons'('Int',[]),'FuncType'('TCons'('Int',[]),'FuncType'('TCons'('Int',[]),'FuncType'('TCons'('Int',[]),'TCons'('Bool',[])))))).
functiontype(prelude_lambda14_2011,'FuncType'('TCons'('IO',[A]),'FuncType'(B,'TCons'('IO',[A])))).
functiontype(lambdafun_2012,'FuncType'('TCons'('Char',[]),'TCons'('IO',['TCons'([],['TCons'('Char',[])])]))).
functiontype(lambdafun_2013,'FuncType'('TCons'('Char',[]),'FuncType'('TCons'([],['TCons'('Char',[])]),'TCons'('IO',['TCons'([],['TCons'('Char',[])])])))).
functiontype(lambdafun_2014,'FuncType'(A,'FuncType'('TCons'([],[A]),'TCons'('IO',['TCons'([],[A])])))).
functiontype(lambdafun_2015,'FuncType'('TCons'([],['TCons'('IO',[A])]),'FuncType'(A,'TCons'('IO',['TCons'([],[A])])))).
functiontype(prelude_lambda15_2016,'FuncType'('FuncType'(A,'TCons'('Success',[])),'FuncType'('FuncType'(A,'TCons'('Success',[])),'FuncType'(A,'TCons'('Success',[]))))).
functiontype(evalall_563,'FuncType'('TCons'([],['FuncType'(A,'TCons'('Success',[]))]),'TCons'([],['FuncType'(A,'TCons'('Success',[]))]))).
functiontype(evalall2_564,'FuncType'('TCons'([],['FuncType'(A,'TCons'('Success',[]))]),'TCons'([],['FuncType'(A,'TCons'('Success',[]))]))).
functiontype(evalall3_565,'FuncType'('TCons'([],['FuncType'(A,'TCons'('Success',[]))]),'FuncType'('TCons'([],['FuncType'(A,'TCons'('Success',[]))]),'TCons'([],['FuncType'(A,'TCons'('Success',[]))])))).
functiontype(evalResult_580,'FuncType'('TCons'([],['FuncType'(A,'TCons'('Success',[]))]),'TCons'([],['FuncType'(A,'TCons'('Success',[]))]))).
functiontype(prelude_lambda16_2017,'FuncType'('FuncType'(A,'TCons'('Success',[])),'FuncType'(A,'TCons'('Success',[])))).
functiontype(prelude_lambda17_2018,'FuncType'('FuncType'(A,'TCons'('Success',[])),'FuncType'('FuncType'(A,'TCons'('Bool',[])),'FuncType'(A,'TCons'('Success',[]))))).
functiontype(bestHelp_595,'FuncType'('FuncType'(A,'FuncType'(A,'TCons'('Bool',[]))),'FuncType'('TCons'([],['FuncType'(A,'TCons'('Success',[]))]),'FuncType'('TCons'([],['FuncType'(A,'TCons'('Success',[]))]),'FuncType'('TCons'([],['FuncType'(A,'TCons'('Success',[]))]),'TCons'([],['FuncType'(A,'TCons'('Success',[]))])))))).
functiontype(evalY_596,'FuncType'('FuncType'(A,'FuncType'(A,'TCons'('Bool',[]))),'FuncType'('TCons'([],['FuncType'(A,'TCons'('Success',[]))]),'FuncType'('TCons'([],['FuncType'(A,'TCons'('Success',[]))]),'FuncType'('TCons'([],['FuncType'(A,'TCons'('Success',[]))]),'TCons'([],['FuncType'(A,'TCons'('Success',[]))])))))).
functiontype(evalX_597,'FuncType'('FuncType'(A,'FuncType'(A,'TCons'('Bool',[]))),'FuncType'('TCons'([],['FuncType'(A,'TCons'('Success',[]))]),'FuncType'('TCons'([],['FuncType'(A,'TCons'('Success',[]))]),'FuncType'('TCons'([],['FuncType'(A,'TCons'('Success',[]))]),'FuncType'('TCons'([],['FuncType'(A,'TCons'('Success',[]))]),'TCons'([],['FuncType'(A,'TCons'('Success',[]))]))))))).
functiontype(evalA_598,'FuncType'('FuncType'(A,'FuncType'(A,'TCons'('Bool',[]))),'FuncType'('TCons'([],['FuncType'(A,'TCons'('Success',[]))]),'FuncType'('TCons'([],['FuncType'(A,'TCons'('Success',[]))]),'FuncType'('TCons'([],['FuncType'(A,'TCons'('Success',[]))]),'FuncType'('TCons'([],['FuncType'(A,'TCons'('Success',[]))]),'TCons'([],['FuncType'(A,'TCons'('Success',[]))]))))))).
functiontype(constrain_599,'FuncType'('FuncType'(A,'FuncType'(A,'TCons'('Bool',[]))),'FuncType'('FuncType'(A,'TCons'('Success',[])),'FuncType'('TCons'([],['FuncType'(A,'TCons'('Success',[]))]),'FuncType'(A,'TCons'('Success',[])))))).
functiontype(prelude_lambda18_2019,'FuncType'('FuncType'(A,'TCons'('Success',[])),'FuncType'('FuncType'(A,'FuncType'(A,'TCons'('Bool',[]))),'FuncType'(A,'TCons'('Success',[]))))).
functiontype('Flat.readFlatCurryFile','FuncType'('TCons'([],['TCons'('Char',[])]),'TCons'('IO',['TCons'('Flat.Prog',[])]))).
functiontype('Flat.readFlatCurry','FuncType'('TCons'([],['TCons'('Char',[])]),'TCons'('IO',['TCons'('Flat.Prog',[])]))).
functiontype('Flat.readFlatCurryWithParseOptions','FuncType'('TCons'([],['TCons'('Char',[])]),'FuncType'('TCons'([],['TCons'('Char',[])]),'TCons'('IO',['TCons'('Flat.Prog',[])])))).
functiontype('Flat.splitFlatModName','FuncType'('TCons'([],['TCons'('Char',[])]),'TCons'('(,)',['TCons'([],['TCons'('Char',[])]),'TCons'([],['TCons'('Char',[])])]))).
functiontype('Flat.lambdafun_2843','FuncType'('TCons'('Bool',[]),'FuncType'('TCons'([],['TCons'('Char',[])]),'FuncType'('TCons'([],['TCons'('Char',[])]),'FuncType'('TCons'('Bool',[]),'TCons'('IO',['TCons'('Flat.Prog',[])])))))).
functiontype('Flat.lambdafun_2845','FuncType'('TCons'([],['TCons'('Char',[])]),'FuncType'('TCons'([],['TCons'('Char',[])]),'FuncType'('TCons'([],['TCons'('Char',[])]),'TCons'('IO',['TCons'('()',[])]))))).
functiontype('Flat.lambdafun_2844','FuncType'('TCons'([],['TCons'('Char',[])]),'FuncType'('TCons'([],['TCons'('Char',[])]),'FuncType'('TCons'('Bool',[]),'TCons'('IO',['TCons'('Flat.Prog',[])]))))).
functiontype('Flat.flat_lambda0_2846','FuncType'('TCons'([],['TCons'('Char',[])]),'FuncType'('TCons'('(,)',['TCons'([],['TCons'('Char',[])]),'TCons'([],['TCons'('Char',[])])]),'TCons'('(,)',['TCons'([],['TCons'('Char',[])]),'TCons'([],['TCons'('Char',[])])])))).
functiontype('Flat.flat_lambda1_2847','FuncType'('TCons'('Char',[]),'TCons'('Bool',[]))).
functiontype('FlatTools.showFlatProg','FuncType'('TCons'('Flat.Prog',[]),'TCons'([],['TCons'('Char',[])]))).
functiontype('FlatTools.flatShowFixity','FuncType'('TCons'('Flat.Fixity',[]),'TCons'([],['TCons'('Char',[])]))).
functiontype('FlatTools.flatShowOp','FuncType'('TCons'('Flat.OpDecl',[]),'TCons'([],['TCons'('Char',[])]))).
functiontype('FlatTools.flatShowType','FuncType'('TCons'('Flat.TypeDecl',[]),'TCons'([],['TCons'('Char',[])]))).
functiontype('FlatTools.flatShowCons','FuncType'('TCons'('Flat.ConsDecl',[]),'TCons'([],['TCons'('Char',[])]))).
functiontype('FlatTools.flatShowFunc','FuncType'('TCons'('Flat.FuncDecl',[]),'TCons'([],['TCons'('Char',[])]))).
functiontype('FlatTools.flatShowRule','FuncType'('TCons'('Flat.Rule',[]),'TCons'([],['TCons'('Char',[])]))).
functiontype('FlatTools.flatShowTypeExpr','FuncType'('TCons'('Flat.TypeExpr',[]),'TCons'([],['TCons'('Char',[])]))).
functiontype('FlatTools.flatShowExpr','FuncType'('TCons'('Flat.Expr',[]),'TCons'([],['TCons'('Char',[])]))).
functiontype('FlatTools.flatShowLit','FuncType'('TCons'('Flat.Literal',[]),'TCons'([],['TCons'('Char',[])]))).
functiontype('FlatTools.flatShowBranch','FuncType'('TCons'('Flat.BranchExpr',[]),'TCons'([],['TCons'('Char',[])]))).
functiontype('FlatTools.flatShowPattern','FuncType'('TCons'('Flat.Pattern',[]),'TCons'([],['TCons'('Char',[])]))).
functiontype('FlatTools.flatShowTrans','FuncType'('TCons'('Flat.Translation',[]),'TCons'([],['TCons'('Char',[])]))).
functiontype('FlatTools.flatShowList','FuncType'('FuncType'(A,'TCons'([],['TCons'('Char',[])])),'FuncType'('TCons'([],[A]),'TCons'([],['TCons'('Char',[])])))).
functiontype('FlatTools.flatShowListElems','FuncType'('FuncType'(A,'TCons'([],['TCons'('Char',[])])),'FuncType'('TCons'([],[A]),'TCons'([],['TCons'('Char',[])])))).
functiontype('FlatTools.flatShowString','FuncType'('TCons'([],['TCons'('Char',[])]),'TCons'([],['TCons'('Char',[])]))).
functiontype('FlatTools.showCurryType','FuncType'('FuncType'('TCons'([],['TCons'('Char',[])]),'TCons'([],['TCons'('Char',[])])),'FuncType'('TCons'('Bool',[]),'FuncType'('TCons'('Flat.TypeExpr',[]),'TCons'([],['TCons'('Char',[])]))))).
functiontype('FlatTools.isFuncType','FuncType'('TCons'('Flat.TypeExpr',[]),'TCons'('Bool',[]))).
functiontype('FlatTools.showCurryExpr','FuncType'('FuncType'('TCons'([],['TCons'('Char',[])]),'TCons'([],['TCons'('Char',[])])),'FuncType'('TCons'('Bool',[]),'FuncType'('TCons'('Int',[]),'FuncType'('TCons'('Flat.Expr',[]),'TCons'([],['TCons'('Char',[])])))))).
functiontype('FlatTools.showCurryVar','FuncType'(A,'TCons'([],['TCons'('Char',[])]))).
functiontype('FlatTools.showCurryLit','FuncType'('TCons'('Flat.Literal',[]),'TCons'([],['TCons'('Char',[])]))).
functiontype('FlatTools.showCurryCase','FuncType'('FuncType'('TCons'([],['TCons'('Char',[])]),'TCons'([],['TCons'('Char',[])])),'FuncType'('TCons'('Int',[]),'FuncType'('TCons'('Flat.BranchExpr',[]),'TCons'([],['TCons'('Char',[])]))))).
functiontype('FlatTools.showCurryFiniteList','FuncType'('FuncType'('TCons'([],['TCons'('Char',[])]),'TCons'([],['TCons'('Char',[])])),'FuncType'('TCons'('Int',[]),'FuncType'('TCons'('Flat.Expr',[]),'TCons'([],['TCons'([],['TCons'('Char',[])])]))))).
functiontype('FlatTools.showCurryElems','FuncType'('FuncType'(A,'TCons'([],['TCons'('Char',[])])),'FuncType'('TCons'([],[A]),'TCons'([],['TCons'('Char',[])])))).
functiontype('FlatTools.maybeShowBrackets','FuncType'('TCons'('Bool',[]),'FuncType'('TCons'([],['TCons'('Char',[])]),'TCons'([],['TCons'('Char',[])])))).
functiontype('FlatTools.sceBlanks','FuncType'('TCons'('Int',[]),'TCons'([],['TCons'('Char',[])]))).
functiontype('FlatTools.isFiniteList','FuncType'('TCons'('Flat.Expr',[]),'TCons'('Bool',[]))).
functiontype('FlatTools.writeFLC','FuncType'('TCons'([],['TCons'('Char',[])]),'FuncType'('TCons'('Flat.Prog',[]),'TCons'('IO',['TCons'('()',[])])))).
functiontype('FlatTools.showFlcProg','FuncType'('TCons'('Flat.Prog',[]),'TCons'([],['TCons'('Char',[])]))).
functiontype('FlatTools.flcShowOp','FuncType'('TCons'('Flat.OpDecl',[]),'TCons'([],['TCons'('Char',[])]))).
functiontype('FlatTools.flcShowFixity','FuncType'('TCons'('Flat.Fixity',[]),'TCons'([],['TCons'('Char',[])]))).
functiontype('FlatTools.flcShowType','FuncType'('TCons'('Flat.TypeDecl',[]),'TCons'([],['TCons'('Char',[])]))).
functiontype('FlatTools.flcShowCons','FuncType'('TCons'('Flat.ConsDecl',[]),'TCons'([],['TCons'('Char',[])]))).
functiontype('FlatTools.flcShowFunc','FuncType'('TCons'('Flat.FuncDecl',[]),'TCons'([],['TCons'('Char',[])]))).
functiontype('FlatTools.flcShowRule','FuncType'('TCons'('Flat.Rule',[]),'TCons'([],['TCons'('Char',[])]))).
functiontype('FlatTools.flcShowTypeExpr','FuncType'('TCons'('Flat.TypeExpr',[]),'TCons'([],['TCons'('Char',[])]))).
functiontype('FlatTools.flcShowCombType','FuncType'('TCons'('Flat.CombType',[]),'TCons'([],['TCons'('Char',[])]))).
functiontype('FlatTools.flcShowExpr','FuncType'('TCons'('Flat.Expr',[]),'TCons'([],['TCons'('Char',[])]))).
functiontype('FlatTools.flcShowLit','FuncType'('TCons'('Flat.Literal',[]),'TCons'([],['TCons'('Char',[])]))).
functiontype('FlatTools.flcShowBranch','FuncType'('TCons'('Flat.BranchExpr',[]),'TCons'([],['TCons'('Char',[])]))).
functiontype('FlatTools.flcShowTrans','FuncType'('TCons'('Flat.Translation',[]),'TCons'([],['TCons'('Char',[])]))).
functiontype('FlatTools.flcShowList','FuncType'('FuncType'(A,'TCons'([],['TCons'('Char',[])])),'FuncType'('TCons'([],[A]),'TCons'([],['TCons'('Char',[])])))).
functiontype('FlatTools.flcShowListElems','FuncType'('FuncType'(A,'TCons'([],['TCons'('Char',[])])),'FuncType'('TCons'([],[A]),'TCons'([],['TCons'('Char',[])])))).
functiontype('FlatTools.flcShowString','FuncType'('TCons'([],['TCons'('Char',[])]),'TCons'([],['TCons'('Char',[])]))).
functiontype('FlatTools.ppshow','FuncType'('TCons'([],['TCons'('Char',[])]),'TCons'('IO',['TCons'('()',[])]))).
functiontype('FlatTools.pptest','FuncType'('TCons'([],['TCons'('Char',[])]),'TCons'('IO',['TCons'('()',[])]))).
functiontype('FlatTools.flcshow','FuncType'('TCons'([],['TCons'('Char',[])]),'TCons'('IO',['TCons'('()',[])]))).
functiontype('FlatTools.flctest','FuncType'('TCons'([],['TCons'('Char',[])]),'TCons'('IO',['TCons'('()',[])]))).
functiontype('FlatTools.showPattern_3583','FuncType'('TCons'([],['TCons'('Char',[])]),'FuncType'('TCons'([],['TCons'('Int',[])]),'TCons'([],['TCons'('Char',[])])))).
functiontype('FlatTools.lambdafun_6063','FuncType'('TCons'('Flat.Prog',[]),'TCons'('IO',['TCons'('()',[])]))).
functiontype('FlatTools.lambdafun_6064','FuncType'('TCons'('Flat.Prog',[]),'TCons'('IO',['TCons'('()',[])]))).
functiontype('SetRBT2.emptySetRBT','FuncType'('FuncType'(A,'FuncType'(A,'TCons'('Bool',[]))),'TCons'('SetRBT2.SetRBT',[A]))).
functiontype('SetRBT2.elemRBT','FuncType'(A,'FuncType'('TCons'('SetRBT2.SetRBT',[A]),'TCons'('Bool',[])))).
functiontype('SetRBT2.elemRBTree','FuncType'('FuncType'(A,'FuncType'(A,'TCons'('Bool',[]))),'FuncType'(A,'FuncType'('TCons'('SetRBT2.RBT',[A]),'TCons'('Bool',[]))))).
functiontype('SetRBT2.insertRBT','FuncType'(A,'FuncType'('TCons'('SetRBT2.SetRBT',[A]),'TCons'('SetRBT2.SetRBT',[A])))).
functiontype('SetRBT2.insertRBTree','FuncType'('FuncType'(A,'FuncType'(A,'TCons'('Bool',[]))),'FuncType'(A,'FuncType'('TCons'('SetRBT2.RBT',[A]),'TCons'('SetRBT2.RBT',[A]))))).
functiontype('SetRBT2.insertMultiRBT','FuncType'(A,'FuncType'('TCons'('SetRBT2.SetRBT',[A]),'TCons'('SetRBT2.SetRBT',[A])))).
functiontype('SetRBT2.insertMultiRBTree','FuncType'('FuncType'(A,'FuncType'(A,'TCons'('Bool',[]))),'FuncType'(A,'FuncType'('TCons'('SetRBT2.RBT',[A]),'TCons'('SetRBT2.RBT',[A]))))).
functiontype('SetRBT2.setRBT2list','FuncType'('TCons'('SetRBT2.SetRBT',[A]),'TCons'([],[A]))).
functiontype('SetRBT2.unionRBT','FuncType'('TCons'('SetRBT2.SetRBT',[A]),'FuncType'('TCons'('SetRBT2.SetRBT',[A]),'TCons'('SetRBT2.SetRBT',[A])))).
functiontype('SetRBT2.intersectRBT','FuncType'('TCons'('SetRBT2.SetRBT',[A]),'FuncType'('TCons'('SetRBT2.SetRBT',[A]),'TCons'('SetRBT2.SetRBT',[A])))).
functiontype('SetRBT2.sortRBT','FuncType'('FuncType'(A,'FuncType'(A,'TCons'('Bool',[]))),'FuncType'('TCons'([],[A]),'TCons'([],[A])))).
functiontype('SetRBT2.rbsBalance','FuncType'('TCons'('SetRBT2.RBT',[A]),'TCons'('SetRBT2.RBT',[A]))).
functiontype('SetRBT2.rbsBalanceL','FuncType'('TCons'('SetRBT2.RBT',[A]),'TCons'('SetRBT2.RBT',[A]))).
functiontype('SetRBT2.rbsBalanceR','FuncType'('TCons'('SetRBT2.RBT',[A]),'TCons'('SetRBT2.RBT',[A]))).
functiontype('SetRBT2.ins_6383','FuncType'(A,'FuncType'('FuncType'(A,'FuncType'(A,'TCons'('Bool',[]))),'FuncType'('TCons'('SetRBT2.RBT',[A]),'TCons'('SetRBT2.RBT',[A]))))).
functiontype('SetRBT2.setRBT2_lambda0_7386','FuncType'('TCons'('SetRBT2.RBT',[A]),'TCons'('SetRBT2.RBT',[A]))).
functiontype('SetRBT2.ins_6398','FuncType'(A,'FuncType'('FuncType'(A,'FuncType'(A,'TCons'('Bool',[]))),'FuncType'('TCons'('SetRBT2.RBT',[A]),'TCons'('SetRBT2.RBT',[A]))))).
functiontype('SetRBT2.setRBT2_lambda1_7387','FuncType'('TCons'('SetRBT2.RBT',[A]),'TCons'('SetRBT2.RBT',[A]))).
functiontype('SetRBT2.s2l_6409','FuncType'('TCons'('SetRBT2.RBT',[A]),'FuncType'('TCons'([],[A]),'TCons'([],[A])))).
functiontype('SetRBT2.setRBT2_lambda3_7388','FuncType'('TCons'('SetRBT2.SetRBT',[A]),'FuncType'(A,'TCons'('Bool',[])))).
functiontype('SetRBT2.setRBT2_lambda2_7389','FuncType'('TCons'('SetRBT2.SetRBT',[A]),'FuncType'('TCons'('SetRBT2.SetRBT',[A]),'FuncType'('TCons'('SetRBT2.SetRBT',[A]),'TCons'('SetRBT2.SetRBT',[A]))))).
functiontype('SetRBT2.setRBT2_lambda4_7390','FuncType'('TCons'('SetRBT2.RBSColor',[]),'FuncType'(A,'FuncType'('TCons'('SetRBT2.RBT',[A]),'FuncType'('TCons'('SetRBT2.RBT',[A]),'FuncType'('TCons'('SetRBT2.RBT',[A]),'TCons'('SetRBT2.RBT',[A]))))))).
functiontype('TableRBT2.emptyTableRBT','FuncType'('FuncType'(A,'FuncType'(A,'TCons'('Bool',[]))),'TCons'('TableRBT2.TableRBT',[A,B]))).
functiontype('TableRBT2.lookupRBT','FuncType'(A,'FuncType'('TCons'('TableRBT2.TableRBT',[A,B]),'TCons'('Maybe',[B])))).
functiontype('TableRBT2.lookupRBTree','FuncType'('FuncType'(A,'FuncType'(A,'TCons'('Bool',[]))),'FuncType'(A,'FuncType'('TCons'('TableRBT2.RBT',[A,B]),'TCons'('Maybe',[B]))))).
functiontype('TableRBT2.updateRBT','FuncType'(A,'FuncType'(B,'FuncType'('TCons'('TableRBT2.TableRBT',[A,B]),'TCons'('TableRBT2.TableRBT',[A,B]))))).
functiontype('TableRBT2.updateRBTree','FuncType'('FuncType'(A,'FuncType'(A,'TCons'('Bool',[]))),'FuncType'(A,'FuncType'(B,'FuncType'('TCons'('TableRBT2.RBT',[A,B]),'TCons'('TableRBT2.RBT',[A,B])))))).
functiontype('TableRBT2.tableRBT2list','FuncType'('TCons'('TableRBT2.TableRBT',[A,B]),'TCons'([],['TCons'('(,)',[A,B])]))).
functiontype('TableRBT2.rbtBalance','FuncType'('TCons'('TableRBT2.RBT',[A,B]),'TCons'('TableRBT2.RBT',[A,B]))).
functiontype('TableRBT2.rbtBalanceL','FuncType'('TCons'('TableRBT2.RBT',[A,B]),'TCons'('TableRBT2.RBT',[A,B]))).
functiontype('TableRBT2.rbtBalanceR','FuncType'('TCons'('TableRBT2.RBT',[A,B]),'TCons'('TableRBT2.RBT',[A,B]))).
functiontype('TableRBT2.ins_7577','FuncType'(A,'FuncType'(B,'FuncType'('FuncType'(A,'FuncType'(A,'TCons'('Bool',[]))),'FuncType'('TCons'('TableRBT2.RBT',[A,B]),'TCons'('TableRBT2.RBT',[A,B])))))).
functiontype('TableRBT2.tableRBT2_lambda0_8750','FuncType'('TCons'('TableRBT2.RBT',[A,B]),'TCons'('TableRBT2.RBT',[A,B]))).
functiontype('TableRBT2.t2l_7590','FuncType'('TCons'('TableRBT2.RBT',[A,B]),'FuncType'('TCons'([],['TCons'('(,)',[A,B])]),'TCons'([],['TCons'('(,)',[A,B])])))).
functiontype('TableRBT2.tableRBT2_lambda1_8751','FuncType'('TCons'('TableRBT2.RBTColor',[]),'FuncType'(A,'FuncType'(B,'FuncType'('TCons'('TableRBT2.RBT',[A,B]),'FuncType'('TCons'('TableRBT2.RBT',[A,B]),'FuncType'('TCons'('TableRBT2.RBT',[A,B]),'TCons'('TableRBT2.RBT',[A,B])))))))).
functiontype('System.getDate','TCons'('IO',['TCons'('System.Date',[])])).
functiontype('System.getCPUTime','TCons'('IO',['TCons'('Int',[])])).
functiontype('System.getElapsedTime','TCons'('IO',['TCons'('Int',[])])).
functiontype('System.getArgs','TCons'('IO',['TCons'([],['TCons'([],['TCons'('Char',[])])])])).
functiontype('System.getEnviron','FuncType'('TCons'([],['TCons'('Char',[])]),'TCons'('IO',['TCons'([],['TCons'('Char',[])])]))).
functiontype('System.getHostname','TCons'('IO',['TCons'([],['TCons'('Char',[])])])).
functiontype('System.getPID','TCons'('IO',['TCons'('Int',[])])).
functiontype('System.system','FuncType'('TCons'([],['TCons'('Char',[])]),'TCons'('IO',['TCons'('Int',[])]))).
functiontype('System.sleep','FuncType'('TCons'('Int',[]),'TCons'('IO',['TCons'('()',[])]))).
functiontype('System.evalTime','FuncType'(A,A)).
functiontype('System.evalSpace','FuncType'(A,A)).
functiontype('System.showDate','FuncType'('TCons'('System.Date',[]),'TCons'([],['TCons'('Char',[])]))).
functiontype('System.digit2_2404','FuncType'('TCons'('Int',[]),'TCons'([],['TCons'('Char',[])]))).
functiontype('Directory.doesFileExist','FuncType'('TCons'([],['TCons'('Char',[])]),'TCons'('IO',['TCons'('Bool',[])]))).
functiontype('Directory.doesDirectoryExist','FuncType'('TCons'([],['TCons'('Char',[])]),'TCons'('IO',['TCons'('Bool',[])]))).
functiontype('Directory.getModificationTime','FuncType'('TCons'([],['TCons'('Char',[])]),'TCons'('IO',['TCons'('Int',[])]))).
functiontype('Directory.getDirectoryContents','FuncType'('TCons'([],['TCons'('Char',[])]),'TCons'('IO',['TCons'([],['TCons'([],['TCons'('Char',[])])])]))).
functiontype('List.nub','FuncType'('TCons'([],[A]),'TCons'([],[A]))).
functiontype('List.nubBy','FuncType'('FuncType'(A,'FuncType'(A,'TCons'('Bool',[]))),'FuncType'('TCons'([],[A]),'TCons'([],[A])))).
functiontype('List.delete','FuncType'(A,'FuncType'('TCons'([],[A]),'TCons'([],[A])))).
functiontype('List.union','FuncType'('TCons'([],[A]),'FuncType'('TCons'([],[A]),'TCons'([],[A])))).
functiontype('List.intersect','FuncType'('TCons'([],[A]),'FuncType'('TCons'([],[A]),'TCons'([],[A])))).
functiontype('List.intersperse','FuncType'(A,'FuncType'('TCons'([],[A]),'TCons'([],[A])))).
functiontype('List.transpose','FuncType'('TCons'([],['TCons'([],[A])]),'TCons'([],['TCons'([],[A])]))).
functiontype('List.partition','FuncType'('FuncType'(A,'TCons'('Bool',[])),'FuncType'('TCons'([],[A]),'TCons'('(,)',['TCons'([],[A]),'TCons'([],[A])])))).
functiontype('List.group','FuncType'('TCons'([],[A]),'TCons'([],['TCons'([],[A])]))).
functiontype('List.groupBy','FuncType'('FuncType'(A,'FuncType'(A,'TCons'('Bool',[]))),'FuncType'('TCons'([],[A]),'TCons'([],['TCons'([],[A])])))).
functiontype('List.replace','FuncType'(A,'FuncType'('TCons'('Int',[]),'FuncType'('TCons'([],[A]),'TCons'([],[A]))))).
functiontype('List.isPrefixOf','FuncType'('TCons'([],[A]),'FuncType'('TCons'([],[A]),'TCons'('Bool',[])))).
functiontype('List.sortBy','FuncType'('FuncType'(A,'FuncType'(A,'TCons'('Bool',[]))),'FuncType'('TCons'([],[A]),'TCons'([],[A])))).
functiontype('List.insertBy','FuncType'('FuncType'(A,'FuncType'(A,'TCons'('Bool',[]))),'FuncType'(A,'FuncType'('TCons'([],[A]),'TCons'([],[A]))))).
functiontype('List.last','FuncType'('TCons'([],[A]),A)).
functiontype('List.list_lambda0_3110','FuncType'('FuncType'(A,'FuncType'(A,'TCons'('Bool',[]))),'FuncType'(A,'FuncType'(A,'TCons'('Bool',[]))))).
functiontype('List.select_2741','FuncType'('FuncType'(A,'TCons'('Bool',[])),'FuncType'(A,'FuncType'('TCons'('(,)',['TCons'([],[A]),'TCons'([],[A])]),'TCons'('(,)',['TCons'([],[A]),'TCons'([],[A])]))))).
functiontype('List.list_lambda1_3111','FuncType'(A,'FuncType'('FuncType'(A,'FuncType'(A,'TCons'('Bool',[]))),'FuncType'('TCons'('(,)',['TCons'([],[A]),'TCons'([],[A])]),'TCons'([],['TCons'([],[A])]))))).
functiontype('Char.isUpper','FuncType'('TCons'('Char',[]),'TCons'('Bool',[]))).
functiontype('Char.isLower','FuncType'('TCons'('Char',[]),'TCons'('Bool',[]))).
functiontype('Char.isAlpha','FuncType'('TCons'('Char',[]),'TCons'('Bool',[]))).
functiontype('Char.isDigit','FuncType'('TCons'('Char',[]),'TCons'('Bool',[]))).
functiontype('Char.isAlphaNum','FuncType'('TCons'('Char',[]),'TCons'('Bool',[]))).
functiontype('Char.isOctDigit','FuncType'('TCons'('Char',[]),'TCons'('Bool',[]))).
functiontype('Char.isHexDigit','FuncType'('TCons'('Char',[]),'TCons'('Bool',[]))).
functiontype('Char.isSpace','FuncType'('TCons'('Char',[]),'TCons'('Bool',[]))).
functiontype('Char.toUpper','FuncType'('TCons'('Char',[]),'TCons'('Char',[]))).
functiontype('Char.toLower','FuncType'('TCons'('Char',[]),'TCons'('Char',[]))).
functiontype('Char.digitToInt','FuncType'('TCons'('Char',[]),'TCons'('Int',[]))).
functiontype('Char.intToDigit','FuncType'('TCons'('Int',[]),'TCons'('Char',[]))).

functiontype('()','TCons'('()',[])).
functiontype([],'TCons'([],[A])).
functiontype('.','FuncType'(A,'FuncType'('TCons'([],[A]),'TCons'([],[A])))).
functiontype('True','TCons'('Bool',[])).
functiontype('False','TCons'('Bool',[])).
functiontype('(,)','FuncType'(A,'FuncType'(B,'TCons'('(,)',[A,B])))).
functiontype('(,,)','FuncType'(A,'FuncType'(B,'FuncType'(C,'TCons'('(,,)',[A,B,C]))))).
functiontype('(,,,)','FuncType'(A,'FuncType'(B,'FuncType'(C,'FuncType'(D,'TCons'('(,,,)',[A,B,C,D])))))).
functiontype('(,,,,)','FuncType'(A,'FuncType'(B,'FuncType'(C,'FuncType'(D,'FuncType'(E,'TCons'('(,,,,)',[A,B,C,D,E]))))))).
functiontype('(,,,,,)','FuncType'(A,'FuncType'(B,'FuncType'(C,'FuncType'(D,'FuncType'(E,'FuncType'(F,'TCons'('(,,,,,)',[A,B,C,D,E,F])))))))).
functiontype('(,,,,,,)','FuncType'(A,'FuncType'(B,'FuncType'(C,'FuncType'(D,'FuncType'(E,'FuncType'(F,'FuncType'(G,'TCons'('(,,,,,,)',[A,B,C,D,E,F,G]))))))))).
functiontype('(,,,,,,,)','FuncType'(A,'FuncType'(B,'FuncType'(C,'FuncType'(D,'FuncType'(E,'FuncType'(F,'FuncType'(G,'FuncType'(H,'TCons'('(,,,,,,,)',[A,B,C,D,E,F,G,H])))))))))).
functiontype('(,,,,,,,,)','FuncType'(A,'FuncType'(B,'FuncType'(C,'FuncType'(D,'FuncType'(E,'FuncType'(F,'FuncType'(G,'FuncType'(H,'FuncType'(I,'TCons'('(,,,,,,,,)',[A,B,C,D,E,F,G,H,I]))))))))))).
functiontype('(,,,,,,,,,)','FuncType'(A,'FuncType'(B,'FuncType'(C,'FuncType'(D,'FuncType'(E,'FuncType'(F,'FuncType'(G,'FuncType'(H,'FuncType'(I,'FuncType'(J,'TCons'('(,,,,,,,,,)',[A,B,C,D,E,F,G,H,I,J])))))))))))).
functiontype('(,,,,,,,,,,)','FuncType'(A,'FuncType'(B,'FuncType'(C,'FuncType'(D,'FuncType'(E,'FuncType'(F,'FuncType'(G,'FuncType'(H,'FuncType'(I,'FuncType'(J,'FuncType'(K,'TCons'('(,,,,,,,,,,)',[A,B,C,D,E,F,G,H,I,J,K]))))))))))))).
functiontype('(,,,,,,,,,,,)','FuncType'(A,'FuncType'(B,'FuncType'(C,'FuncType'(D,'FuncType'(E,'FuncType'(F,'FuncType'(G,'FuncType'(H,'FuncType'(I,'FuncType'(J,'FuncType'(K,'FuncType'(L,'TCons'('(,,,,,,,,,,,)',[A,B,C,D,E,F,G,H,I,J,K,L])))))))))))))).
functiontype('Nothing','TCons'('Maybe',[A])).
functiontype('Just','FuncType'(A,'TCons'('Maybe',[A]))).
functiontype('Left','FuncType'(A,'TCons'('Either',[A,B]))).
functiontype('Right','FuncType'(A,'TCons'('Either',[B,A]))).
functiontype('Flat.Prog','FuncType'('TCons'([],['TCons'('Char',[])]),'FuncType'('TCons'([],['TCons'([],['TCons'('Char',[])])]),'FuncType'('TCons'([],['TCons'('Flat.TypeDecl',[])]),'FuncType'('TCons'([],['TCons'('Flat.FuncDecl',[])]),'FuncType'('TCons'([],['TCons'('Flat.OpDecl',[])]),'FuncType'('TCons'([],['TCons'('Flat.Translation',[])]),'TCons'('Flat.Prog',[])))))))).
functiontype('Flat.Type','FuncType'('TCons'([],['TCons'('Char',[])]),'FuncType'('TCons'([],['TCons'('Int',[])]),'FuncType'('TCons'([],['TCons'('Flat.ConsDecl',[])]),'TCons'('Flat.TypeDecl',[]))))).
functiontype('Flat.Cons','FuncType'('TCons'([],['TCons'('Char',[])]),'FuncType'('TCons'('Int',[]),'FuncType'('TCons'([],['TCons'('Flat.TypeExpr',[])]),'TCons'('Flat.ConsDecl',[]))))).
functiontype('Flat.TVar','FuncType'('TCons'('Int',[]),'TCons'('Flat.TypeExpr',[]))).
functiontype('Flat.FuncType','FuncType'('TCons'('Flat.TypeExpr',[]),'FuncType'('TCons'('Flat.TypeExpr',[]),'TCons'('Flat.TypeExpr',[])))).
functiontype('Flat.TCons','FuncType'('TCons'([],['TCons'('Char',[])]),'FuncType'('TCons'([],['TCons'('Flat.TypeExpr',[])]),'TCons'('Flat.TypeExpr',[])))).
functiontype('Flat.Op','FuncType'('TCons'([],['TCons'('Char',[])]),'FuncType'('TCons'('Flat.Fixity',[]),'FuncType'('TCons'('Int',[]),'TCons'('Flat.OpDecl',[]))))).
functiontype('Flat.InfixOp','TCons'('Flat.Fixity',[])).
functiontype('Flat.InfixlOp','TCons'('Flat.Fixity',[])).
functiontype('Flat.InfixrOp','TCons'('Flat.Fixity',[])).
functiontype('Flat.Func','FuncType'('TCons'([],['TCons'('Char',[])]),'FuncType'('TCons'('Int',[]),'FuncType'('TCons'('Flat.TypeExpr',[]),'FuncType'('TCons'('Flat.Rule',[]),'TCons'('Flat.FuncDecl',[])))))).
functiontype('Flat.Rule','FuncType'('TCons'([],['TCons'('Int',[])]),'FuncType'('TCons'('Flat.Expr',[]),'TCons'('Flat.Rule',[])))).
functiontype('Flat.External','FuncType'('TCons'([],['TCons'('Char',[])]),'TCons'('Flat.Rule',[]))).
functiontype('Flat.Rigid','TCons'('Flat.CaseType',[])).
functiontype('Flat.Flex','TCons'('Flat.CaseType',[])).
functiontype('Flat.FuncCall','TCons'('Flat.CombType',[])).
functiontype('Flat.ConsCall','TCons'('Flat.CombType',[])).
functiontype('Flat.PartCall','TCons'('Flat.CombType',[])).
functiontype('Flat.Var','FuncType'('TCons'('Int',[]),'TCons'('Flat.Expr',[]))).
functiontype('Flat.Lit','FuncType'('TCons'('Flat.Literal',[]),'TCons'('Flat.Expr',[]))).
functiontype('Flat.Comb','FuncType'('TCons'('Flat.CombType',[]),'FuncType'('TCons'([],['TCons'('Char',[])]),'FuncType'('TCons'([],['TCons'('Flat.Expr',[])]),'TCons'('Flat.Expr',[]))))).
functiontype('Flat.Apply','FuncType'('TCons'('Flat.Expr',[]),'FuncType'('TCons'('Flat.Expr',[]),'TCons'('Flat.Expr',[])))).
functiontype('Flat.Constr','FuncType'('TCons'([],['TCons'('Int',[])]),'FuncType'('TCons'('Flat.Expr',[]),'TCons'('Flat.Expr',[])))).
functiontype('Flat.Or','FuncType'('TCons'('Flat.Expr',[]),'FuncType'('TCons'('Flat.Expr',[]),'TCons'('Flat.Expr',[])))).
functiontype('Flat.Case','FuncType'('TCons'('Flat.CaseType',[]),'FuncType'('TCons'('Flat.Expr',[]),'FuncType'('TCons'([],['TCons'('Flat.BranchExpr',[])]),'TCons'('Flat.Expr',[]))))).
functiontype('Flat.Choice','FuncType'('TCons'('Flat.Expr',[]),'TCons'('Flat.Expr',[]))).
functiontype('Flat.GuardedExpr','FuncType'('TCons'([],['TCons'('Int',[])]),'FuncType'('TCons'('Flat.Expr',[]),'FuncType'('TCons'('Flat.Expr',[]),'TCons'('Flat.Expr',[]))))).
functiontype('Flat.Branch','FuncType'('TCons'('Flat.Pattern',[]),'FuncType'('TCons'('Flat.Expr',[]),'TCons'('Flat.BranchExpr',[])))).
functiontype('Flat.Pattern','FuncType'('TCons'([],['TCons'('Char',[])]),'FuncType'('TCons'([],['TCons'('Int',[])]),'TCons'('Flat.Pattern',[])))).
functiontype('Flat.LPattern','FuncType'('TCons'('Flat.Literal',[]),'TCons'('Flat.Pattern',[]))).
functiontype('Flat.Intc','FuncType'('TCons'('Int',[]),'TCons'('Flat.Literal',[]))).
functiontype('Flat.Floatc','FuncType'('TCons'('Float',[]),'TCons'('Flat.Literal',[]))).
functiontype('Flat.Charc','FuncType'('TCons'('Char',[]),'TCons'('Flat.Literal',[]))).
functiontype('Flat.Trans','FuncType'('TCons'([],['TCons'('Char',[])]),'FuncType'('TCons'([],['TCons'('Char',[])]),'TCons'('Flat.Translation',[])))).
functiontype('SetRBT2.RBSRed','TCons'('SetRBT2.RBSColor',[])).
functiontype('SetRBT2.RBSBlack','TCons'('SetRBT2.RBSColor',[])).
functiontype('SetRBT2.RBS','FuncType'('TCons'('SetRBT2.RBSColor',[]),'FuncType'(A,'FuncType'('TCons'('SetRBT2.RBT',[A]),'FuncType'('TCons'('SetRBT2.RBT',[A]),'TCons'('SetRBT2.RBT',[A])))))).
functiontype('SetRBT2.RBSEmpty','TCons'('SetRBT2.RBT',[A])).
functiontype('SetRBT2.SetRBT','FuncType'('FuncType'(A,'FuncType'(A,'TCons'('Bool',[]))),'FuncType'('TCons'('SetRBT2.RBT',[A]),'TCons'('SetRBT2.SetRBT',[A])))).
functiontype('TableRBT2.RBTRed','TCons'('TableRBT2.RBTColor',[])).
functiontype('TableRBT2.RBTBlack','TCons'('TableRBT2.RBTColor',[])).
functiontype('TableRBT2.RBT','FuncType'('TCons'('TableRBT2.RBTColor',[]),'FuncType'(A,'FuncType'(B,'FuncType'('TCons'('TableRBT2.RBT',[A,B]),'FuncType'('TCons'('TableRBT2.RBT',[A,B]),'TCons'('TableRBT2.RBT',[A,B]))))))).
functiontype('TableRBT2.RBTEmpty','TCons'('TableRBT2.RBT',[A,B])).
functiontype('TableRBT2.TableRBT','FuncType'('FuncType'(A,'FuncType'(A,'TCons'('Bool',[]))),'FuncType'('TCons'('TableRBT2.RBT',[A,B]),'TCons'('TableRBT2.TableRBT',[A,B])))).
functiontype('System.Date','FuncType'('TCons'('Int',[]),'FuncType'('TCons'('Int',[]),'FuncType'('TCons'('Int',[]),'FuncType'('TCons'('Int',[]),'FuncType'('TCons'('Int',[]),'FuncType'('TCons'('Int',[]),'TCons'('System.Date',[])))))))).

evaluation('OptFlat.optimizeFlatCurry','Rule'([0,1,2,3,4],'Apply'('Comb'('FuncCall',>>=,['Comb'('FuncCall','OptFlat.tryReadFlatCurry',['Var'(1),'Var'(0)]),'Comb'('PartCall','OptFlat.lambdafun_9660',['Var'(0),'Var'(3),'Var'(2)])]),'Var'(4)))).
evaluation('OptFlat.getStartingState','Rule'([0,1,2,3],'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',elem,['Lit'('Charc'(109)),'Var'(2)]),'Comb'('ConsCall','(,)',['Comb'('FuncCall','OptFlat.makeOneFuncProg',['Var'(0),'Var'(3)]),'Comb'('FuncCall','OptFlat.mergeFlatProgList',['Comb'('ConsCall','.',['Var'(0),'Var'(1)])])]),'Comb'('ConsCall','(,)',['Var'(0),'Comb'('FuncCall','OptFlat.mergeFlatProgList',['Var'(1)])])]))).
evaluation('OptFlat.makeOneFuncProg','Rule'([0,1],'Case'('Flex','Var'(0),['Branch'('Pattern'('Flat.Prog',[2,3,4,5,6,7]),'Comb'('FuncCall','OptFlat.optFlat_lambda2_9663',['Var'(2),'Var'(4),'Var'(5),'Var'(6),'Comb'('FuncCall','OptFlat.getTrans',['Var'(1),'Var'(7)])]))]))).
evaluation('OptFlat.getFunc','Rule'([0,1],'Case'('Flex','Var'(1),['Branch'('Pattern'([],[]),'Comb'('FuncCall',error,['Comb'('ConsCall','.',['Lit'('Charc'(67)),'Comb'('ConsCall','.',['Lit'('Charc'(97)),'Comb'('ConsCall','.',['Lit'('Charc'(110)),'Comb'('ConsCall','.',['Lit'('Charc'(110)),'Comb'('ConsCall','.',['Lit'('Charc'(111)),'Comb'('ConsCall','.',['Lit'('Charc'(116)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(102)),'Comb'('ConsCall','.',['Lit'('Charc'(105)),'Comb'('ConsCall','.',['Lit'('Charc'(110)),'Comb'('ConsCall','.',['Lit'('Charc'(100)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(109)),'Comb'('ConsCall','.',['Lit'('Charc'(97)),'Comb'('ConsCall','.',['Lit'('Charc'(105)),'Comb'('ConsCall','.',['Lit'('Charc'(110)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(102)),'Comb'('ConsCall','.',['Lit'('Charc'(117)),'Comb'('ConsCall','.',['Lit'('Charc'(110)),'Comb'('ConsCall','.',['Lit'('Charc'(99)),'Comb'('ConsCall','.',['Lit'('Charc'(116)),'Comb'('ConsCall','.',['Lit'('Charc'(105)),'Comb'('ConsCall','.',['Lit'('Charc'(111)),'Comb'('ConsCall','.',['Lit'('Charc'(110)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(105)),'Comb'('ConsCall','.',['Lit'('Charc'(110)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(109)),'Comb'('ConsCall','.',['Lit'('Charc'(111)),'Comb'('ConsCall','.',['Lit'('Charc'(100)),'Comb'('ConsCall','.',['Lit'('Charc'(117)),'Comb'('ConsCall','.',['Lit'('Charc'(108)),'Comb'('ConsCall','.',['Lit'('Charc'(101)),'Comb'('ConsCall','.',['Lit'('Charc'(46)),'Comb'('ConsCall',[],[])])])])])])])])])])])])])])])])])])])])])])])])])])])])])])])])])])])])])])),'Branch'('Pattern'('.',[2,3]),'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',==,['Var'(0),'Comb'('FuncCall','OptFlat.getFuncName',['Var'(2)])]),'Var'(2),'Comb'('FuncCall','OptFlat.getFunc',['Var'(0),'Var'(3)])]))]))).
evaluation('OptFlat.getTrans','Rule'([0,1],'Case'('Flex','Var'(1),['Branch'('Pattern'([],[]),'Comb'('FuncCall',error,['Comb'('ConsCall','.',['Lit'('Charc'(67)),'Comb'('ConsCall','.',['Lit'('Charc'(97)),'Comb'('ConsCall','.',['Lit'('Charc'(110)),'Comb'('ConsCall','.',['Lit'('Charc'(110)),'Comb'('ConsCall','.',['Lit'('Charc'(111)),'Comb'('ConsCall','.',['Lit'('Charc'(116)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(102)),'Comb'('ConsCall','.',['Lit'('Charc'(105)),'Comb'('ConsCall','.',['Lit'('Charc'(110)),'Comb'('ConsCall','.',['Lit'('Charc'(100)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(101)),'Comb'('ConsCall','.',['Lit'('Charc'(110)),'Comb'('ConsCall','.',['Lit'('Charc'(116)),'Comb'('ConsCall','.',['Lit'('Charc'(114)),'Comb'('ConsCall','.',['Lit'('Charc'(121)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(111)),'Comb'('ConsCall','.',['Lit'('Charc'(102)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(109)),'Comb'('ConsCall','.',['Lit'('Charc'(97)),'Comb'('ConsCall','.',['Lit'('Charc'(105)),'Comb'('ConsCall','.',['Lit'('Charc'(110)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(102)),'Comb'('ConsCall','.',['Lit'('Charc'(117)),'Comb'('ConsCall','.',['Lit'('Charc'(110)),'Comb'('ConsCall','.',['Lit'('Charc'(99)),'Comb'('ConsCall','.',['Lit'('Charc'(116)),'Comb'('ConsCall','.',['Lit'('Charc'(105)),'Comb'('ConsCall','.',['Lit'('Charc'(111)),'Comb'('ConsCall','.',['Lit'('Charc'(110)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(105)),'Comb'('ConsCall','.',['Lit'('Charc'(110)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(116)),'Comb'('ConsCall','.',['Lit'('Charc'(114)),'Comb'('ConsCall','.',['Lit'('Charc'(97)),'Comb'('ConsCall','.',['Lit'('Charc'(110)),'Comb'('ConsCall','.',['Lit'('Charc'(115)),'Comb'('ConsCall','.',['Lit'('Charc'(108)),'Comb'('ConsCall','.',['Lit'('Charc'(97)),'Comb'('ConsCall','.',['Lit'('Charc'(116)),'Comb'('ConsCall','.',['Lit'('Charc'(105)),'Comb'('ConsCall','.',['Lit'('Charc'(111)),'Comb'('ConsCall','.',['Lit'('Charc'(110)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(116)),'Comb'('ConsCall','.',['Lit'('Charc'(97)),'Comb'('ConsCall','.',['Lit'('Charc'(98)),'Comb'('ConsCall','.',['Lit'('Charc'(108)),'Comb'('ConsCall','.',['Lit'('Charc'(101)),'Comb'('ConsCall',[],[])])])])])])])])])])])])])])])])])])])])])])])])])])])])])])])])])])])])])])])])])])])])])])])])])])])])])])])])])),'Branch'('Pattern'('.',[2,3]),'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',==,['Var'(0),'Comb'('FuncCall','OptFlat.getTransName',['Var'(2)])]),'Comb'('ConsCall','(,)',['Comb'('FuncCall','OptFlat.getInternalName',['Var'(2)]),'Var'(2)]),'Comb'('FuncCall','OptFlat.getTrans',['Var'(0),'Var'(3)])]))]))).
evaluation('OptFlat.makeOptimizedFlatProg','Rule'([0,1,2],'Case'('Flex','Var'(0),['Branch'('Pattern'('Flat.Prog',[3,4,5,6,7,8]),'Case'('Flex','Var'(1),['Branch'('Pattern'('Flat.Prog',[9,10,11,12,13,14]),'Comb'('ConsCall','Flat.Prog',['Var'(3),'Comb'('ConsCall',[],[]),'Comb'('FuncCall',++,['Var'(5),'Var'(11)]),'Comb'('FuncCall','OptFlat.optFuncDecls',['Var'(6),'Var'(12)]),'Comb'('FuncCall',++,['Var'(7),'Var'(13)]),'Var'(8)]))]))]))).
evaluation('OptFlat.optFuncDecls','Rule'([0,1],'Comb'('FuncCall','OptFlat.optFlat_lambda3_9664',['Var'(0),'Var'(1),'Comb'('FuncCall','OptFlat.list2SetRBT',['Comb'('FuncCall','OptFlat.leString',[]),'Comb'('FuncCall',map,['Comb'('PartCall','OptFlat.getFuncName',[]),'Var'(0)])])]))).
evaluation('OptFlat.optFuncDecls\'','Rule'([0,1,2],'Case'('Flex','Var'(0),['Branch'('Pattern'([],[]),'Comb'('ConsCall',[],[])),'Branch'('Pattern'('.',[3,4]),'Comb'('FuncCall','OptFlat.optFlat_lambda4_9666',['Var'(3),'Var'(2),'Var'(4),'Var'(1),'Comb'('FuncCall','OptFlat.getAllFuncCalls',['Var'(3)])]))]))).
evaluation('OptFlat.lookupFuncCalls','Rule'([0,1,2,3],'Case'('Flex','Var'(0),['Branch'('Pattern'([],[]),'Comb'('ConsCall','(,)',['Var'(1),'Var'(2)])),'Branch'('Pattern'('.',[4,5]),'Comb'('FuncCall',if_then_else,['Comb'('FuncCall','SetRBT2.elemRBT',['Var'(4),'Var'(2)]),'Comb'('FuncCall','OptFlat.lookupFuncCalls',['Var'(5),'Var'(1),'Var'(2),'Var'(3)]),'Comb'('FuncCall','OptFlat.lookupFuncCalls',['Var'(5),'Comb'('FuncCall',++,['Var'(1),'Comb'('FuncCall','OptFlat.lookupFuncDeclInRest',['Var'(4),'Var'(3)])]),'Comb'('FuncCall','SetRBT2.insertRBT',['Var'(4),'Var'(2)]),'Var'(3)])]))]))).
evaluation('OptFlat.lookupFuncDeclInRest','Rule'([0,1],'Case'('Flex','Var'(1),['Branch'('Pattern'([],[]),'Comb'('ConsCall',[],[])),'Branch'('Pattern'('.',[2,3]),'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',==,['Var'(0),'Comb'('FuncCall','OptFlat.getFuncName',['Var'(2)])]),'Comb'('ConsCall','.',['Var'(2),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall','OptFlat.lookupFuncDeclInRest',['Var'(0),'Var'(3)])]))]))).
evaluation('OptFlat.getAllFuncCalls','Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'('Flat.Func',[1,2,3,4]),'Case'('Flex','Var'(4),['Branch'('Pattern'('Flat.External',[5]),'Comb'('ConsCall',[],[])),'Branch'('Pattern'('Flat.Rule',[6,7]),'Comb'('FuncCall','List.nub',['Comb'('FuncCall','OptFlat.getAllFuncCallsOfExpr',['Var'(7)])]))]))]))).
evaluation('OptFlat.getAllFuncCallsOfExpr','Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'('Flat.Var',[1]),'Comb'('ConsCall',[],[])),'Branch'('Pattern'('Flat.Lit',[2]),'Comb'('ConsCall',[],[])),'Branch'('Pattern'('Flat.Comb',[3,4,5]),'Comb'('ConsCall','.',['Var'(4),'Comb'('FuncCall',concatMap,['Comb'('PartCall','OptFlat.getAllFuncCallsOfExpr',[]),'Var'(5)])])),'Branch'('Pattern'('Flat.Apply',[6,7]),'Comb'('FuncCall',++,['Comb'('FuncCall','OptFlat.getAllFuncCallsOfExpr',['Var'(6)]),'Comb'('FuncCall','OptFlat.getAllFuncCallsOfExpr',['Var'(7)])])),'Branch'('Pattern'('Flat.Constr',[8,9]),'Comb'('FuncCall','OptFlat.getAllFuncCallsOfExpr',['Var'(9)])),'Branch'('Pattern'('Flat.Or',[10,11]),'Comb'('FuncCall',++,['Comb'('FuncCall','OptFlat.getAllFuncCallsOfExpr',['Var'(10)]),'Comb'('FuncCall','OptFlat.getAllFuncCallsOfExpr',['Var'(11)])])),'Branch'('Pattern'('Flat.Case',[12,13,14]),'Comb'('FuncCall',++,['Comb'('FuncCall','OptFlat.getAllFuncCallsOfExpr',['Var'(13)]),'Comb'('FuncCall',concatMap,['Comb'('PartCall','OptFlat.getAllFuncCallsOfBranchExpr',[]),'Var'(14)])])),'Branch'('Pattern'('Flat.Choice',[15]),'Comb'('FuncCall','OptFlat.getAllFuncCallsOfExpr',['Var'(15)])),'Branch'('Pattern'('Flat.GuardedExpr',[16,17,18]),'Comb'('FuncCall',++,['Comb'('FuncCall','OptFlat.getAllFuncCallsOfExpr',['Var'(17)]),'Comb'('FuncCall','OptFlat.getAllFuncCallsOfExpr',['Var'(18)])]))]))).
evaluation('OptFlat.getAllFuncCallsOfBranchExpr','Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'('Flat.Branch',[1,2]),'Comb'('FuncCall','OptFlat.getAllFuncCallsOfExpr',['Var'(2)]))]))).
evaluation('OptFlat.readAllImportedFlatProgs','Rule'([0,1,2],'Apply'('Comb'('FuncCall',>>,['Comb'('FuncCall',putStr,['Comb'('ConsCall','.',['Lit'('Charc'(76)),'Comb'('ConsCall','.',['Lit'('Charc'(111)),'Comb'('ConsCall','.',['Lit'('Charc'(97)),'Comb'('ConsCall','.',['Lit'('Charc'(100)),'Comb'('ConsCall','.',['Lit'('Charc'(105)),'Comb'('ConsCall','.',['Lit'('Charc'(110)),'Comb'('ConsCall','.',['Lit'('Charc'(103)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(105)),'Comb'('ConsCall','.',['Lit'('Charc'(109)),'Comb'('ConsCall','.',['Lit'('Charc'(112)),'Comb'('ConsCall','.',['Lit'('Charc'(111)),'Comb'('ConsCall','.',['Lit'('Charc'(114)),'Comb'('ConsCall','.',['Lit'('Charc'(116)),'Comb'('ConsCall','.',['Lit'('Charc'(101)),'Comb'('ConsCall','.',['Lit'('Charc'(100)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(109)),'Comb'('ConsCall','.',['Lit'('Charc'(111)),'Comb'('ConsCall','.',['Lit'('Charc'(100)),'Comb'('ConsCall','.',['Lit'('Charc'(117)),'Comb'('ConsCall','.',['Lit'('Charc'(108)),'Comb'('ConsCall','.',['Lit'('Charc'(101)),'Comb'('ConsCall','.',['Lit'('Charc'(115)),'Comb'('ConsCall','.',['Lit'('Charc'(46)),'Comb'('ConsCall','.',['Lit'('Charc'(46)),'Comb'('ConsCall','.',['Lit'('Charc'(46)),'Comb'('ConsCall','.',['Lit'('Charc'(10)),'Comb'('ConsCall',[],[])])])])])])])])])])])])])])])])])])])])])])])])])])])])])]),'Comb'('FuncCall',>>=,['Comb'('FuncCall','OptFlat.readAllImportedFlatProgs\'',['Comb'('FuncCall','OptFlat.getImports',['Var'(0)]),'Var'(1),'Comb'('FuncCall','SetRBT2.emptySetRBT',['Comb'('FuncCall','OptFlat.leString',[])])]),'Comb'('PartCall','OptFlat.lambdafun_9667',[])])]),'Var'(2)))).
evaluation('OptFlat.readAllImportedFlatProgs\'','Rule'([0,1,2,5],'Case'('Rigid','Var'(0),['Branch'('Pattern'([],[]),'Apply'('Comb'('FuncCall',return,['Comb'('ConsCall',[],[])]),'Var'(5))),'Branch'('Pattern'('.',[3,4]),'Apply'('Comb'('FuncCall',if_then_else,['Comb'('FuncCall','SetRBT2.elemRBT',['Var'(3),'Var'(2)]),'Comb'('FuncCall',>>=,['Comb'('FuncCall','OptFlat.readAllImportedFlatProgs\'',['Var'(4),'Var'(1),'Var'(2)]),'Comb'('PartCall','OptFlat.lambdafun_9668',[])]),'Comb'('FuncCall',>>=,['Comb'('FuncCall','OptFlat.tryReadFlatCurry',['Var'(3),'Var'(1)]),'Comb'('PartCall','OptFlat.lambdafun_9670',['Var'(3),'Var'(4),'Var'(1),'Var'(2)])])]),'Var'(5)))]))).
evaluation('OptFlat.tryReadFlatCurry','Rule'([0,1,2],'Apply'('Comb'('FuncCall',if_then_else,['Comb'('FuncCall',elem,['Lit'('Charc'(114)),'Var'(1)]),'Comb'('FuncCall','Flat.readFlatCurryFile',['Comb'('FuncCall',++,['Var'(0),'Comb'('ConsCall','.',['Lit'('Charc'(46)),'Comb'('ConsCall','.',['Lit'('Charc'(102)),'Comb'('ConsCall','.',['Lit'('Charc'(108)),'Comb'('ConsCall','.',['Lit'('Charc'(99)),'Comb'('ConsCall',[],[])])])])])])]),'Comb'('FuncCall','Flat.readFlatCurry',['Var'(0)])]),'Var'(2)))).
evaluation('OptFlat.getModname','Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'('Flat.Prog',[1,2,3,4,5,6]),'Var'(1))]))).
evaluation('OptFlat.getImports','Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'('Flat.Prog',[1,2,3,4,5,6]),'Var'(2))]))).
evaluation('OptFlat.getFuncDecls','Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'('Flat.Prog',[1,2,3,4,5,6]),'Var'(4))]))).
evaluation('OptFlat.getFuncName','Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'('Flat.Func',[1,2,3,4]),'Var'(1))]))).
evaluation('OptFlat.getTransName','Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'('Flat.Trans',[1,2]),'Var'(1))]))).
evaluation('OptFlat.getInternalName','Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'('Flat.Trans',[1,2]),'Var'(2))]))).
evaluation('OptFlat.mergeFlatProgList','Rule'([0],'Comb'('FuncCall',foldl1,['Comb'('PartCall','OptFlat.mergeFlatProgs',[]),'Var'(0)]))).
evaluation('OptFlat.mergeFlatProgs','Rule'([0,1],'Case'('Flex','Var'(0),['Branch'('Pattern'('Flat.Prog',[2,3,4,5,6,7]),'Case'('Flex','Var'(1),['Branch'('Pattern'('Flat.Prog',[8,9,10,11,12,13]),'Comb'('ConsCall','Flat.Prog',['Var'(2),'Comb'('FuncCall','List.nub',['Comb'('FuncCall',++,['Var'(3),'Var'(9)])]),'Comb'('FuncCall',++,['Var'(4),'Var'(10)]),'Comb'('FuncCall',++,['Var'(5),'Var'(11)]),'Comb'('FuncCall',++,['Var'(6),'Var'(12)]),'Comb'('FuncCall',++,['Var'(7),'Var'(13)])]))]))]))).
evaluation('OptFlat.leString','Rule'([0,1],'Apply'('Apply'('Comb'('PartCall','OptFlat.leList',['Comb'('PartCall','OptFlat.leChar',[])]),'Var'(0)),'Var'(1)))).
evaluation('OptFlat.leChar','Rule'([0,1],'Comb'('FuncCall',<,['Comb'('FuncCall',ord,['Var'(0)]),'Comb'('FuncCall',ord,['Var'(1)])]))).
evaluation('OptFlat.leList','Rule'([0,1,2],'Case'('Flex','Var'(1),['Branch'('Pattern'([],[]),'Case'('Flex','Var'(2),['Branch'('Pattern'([],[]),'Comb'('ConsCall','False',[])),'Branch'('Pattern'('.',[3,4]),'Comb'('ConsCall','True',[]))])),'Branch'('Pattern'('.',[5,6]),'Case'('Flex','Var'(2),['Branch'('Pattern'([],[]),'Comb'('ConsCall','False',[])),'Branch'('Pattern'('.',[7,8]),'Comb'('FuncCall','||',['Apply'('Apply'('Var'(0),'Var'(5)),'Var'(7)),'Comb'('FuncCall',&&,['Comb'('FuncCall',==,['Var'(5),'Var'(7)]),'Comb'('FuncCall','OptFlat.leList',['Var'(0),'Var'(6),'Var'(8)])])]))]))]))).
evaluation('OptFlat.leFuncDecl','Rule'([0,1],'Apply'('Apply'('Comb'('FuncCall','OptFlat.leString',[]),'Comb'('FuncCall','OptFlat.getFuncName',['Var'(0)])),'Comb'('FuncCall','OptFlat.getFuncName',['Var'(1)])))).
evaluation('OptFlat.list2SetRBT','Rule'([0,1],'Comb'('FuncCall',foldr,['Comb'('PartCall','SetRBT2.insertRBT',[]),'Comb'('FuncCall','SetRBT2.emptySetRBT',['Var'(0)]),'Var'(1)]))).
evaluation('OptFlat.lambdafun_9659','Rule'([0,1,2,3,4,5],'Apply'('Comb'('FuncCall',>>,['Comb'('FuncCall',putStr,['Comb'('ConsCall','.',['Lit'('Charc'(79)),'Comb'('ConsCall','.',['Lit'('Charc'(112)),'Comb'('ConsCall','.',['Lit'('Charc'(116)),'Comb'('ConsCall','.',['Lit'('Charc'(105)),'Comb'('ConsCall','.',['Lit'('Charc'(109)),'Comb'('ConsCall','.',['Lit'('Charc'(105)),'Comb'('ConsCall','.',['Lit'('Charc'(122)),'Comb'('ConsCall','.',['Lit'('Charc'(105)),'Comb'('ConsCall','.',['Lit'('Charc'(110)),'Comb'('ConsCall','.',['Lit'('Charc'(103)),'Comb'('ConsCall','.',['Lit'('Charc'(46)),'Comb'('ConsCall','.',['Lit'('Charc'(46)),'Comb'('ConsCall','.',['Lit'('Charc'(46)),'Comb'('ConsCall','.',['Lit'('Charc'(10)),'Comb'('ConsCall',[],[])])])])])])])])])])])])])])])]),'Comb'('FuncCall','OptFlat.optFlat_lambda0_9662',['Var'(3),'Var'(1),'Comb'('FuncCall','OptFlat.getStartingState',['Var'(0),'Var'(4),'Var'(1),'Var'(2)])])]),'Var'(5)))).
evaluation('OptFlat.optFlat_lambda1_9661','Rule'([0,1,2],'Apply'('Comb'('FuncCall',>>,['Comb'('FuncCall','FlatTools.writeFLC',['Comb'('FuncCall',++,['Var'(0),'Comb'('ConsCall','.',['Lit'('Charc'(46)),'Comb'('ConsCall','.',['Lit'('Charc'(102)),'Comb'('ConsCall','.',['Lit'('Charc'(108)),'Comb'('ConsCall','.',['Lit'('Charc'(99)),'Comb'('ConsCall',[],[])])])])])]),'Var'(1)]),'Comb'('FuncCall',>>,['Comb'('FuncCall',putStr,['Comb'('FuncCall',++,['Var'(0),'Comb'('ConsCall','.',['Lit'('Charc'(46)),'Comb'('ConsCall','.',['Lit'('Charc'(102)),'Comb'('ConsCall','.',['Lit'('Charc'(108)),'Comb'('ConsCall','.',['Lit'('Charc'(99)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(119)),'Comb'('ConsCall','.',['Lit'('Charc'(114)),'Comb'('ConsCall','.',['Lit'('Charc'(105)),'Comb'('ConsCall','.',['Lit'('Charc'(116)),'Comb'('ConsCall','.',['Lit'('Charc'(116)),'Comb'('ConsCall','.',['Lit'('Charc'(101)),'Comb'('ConsCall','.',['Lit'('Charc'(110)),'Comb'('ConsCall','.',['Lit'('Charc'(46)),'Comb'('ConsCall','.',['Lit'('Charc'(10)),'Comb'('ConsCall',[],[])])])])])])])])])])])])])])])])]),'Comb'('FuncCall',done,[])])]),'Var'(2)))).
evaluation('OptFlat.optFlat_lambda0_9662','Rule'([0,1,2,5],'Case'('Rigid','Var'(2),['Branch'('Pattern'('(,)',[3,4]),'Apply'('Comb'('FuncCall','OptFlat.optFlat_lambda1_9661',['Var'(0),'Comb'('FuncCall','OptFlat.makeOptimizedFlatProg',['Var'(3),'Var'(4),'Var'(1)])]),'Var'(5)))]))).
evaluation('OptFlat.lambdafun_9660','Rule'([0,1,2,3,4],'Apply'('Comb'('FuncCall',>>=,['Comb'('FuncCall','OptFlat.readAllImportedFlatProgs',['Var'(3),'Var'(0)]),'Comb'('PartCall','OptFlat.lambdafun_9659',['Var'(3),'Var'(0),'Var'(1),'Var'(2)])]),'Var'(4)))).
evaluation('OptFlat.optFlat_lambda2_9663','Rule'([0,1,2,3,4],'Case'('Flex','Var'(4),['Branch'('Pattern'('(,)',[5,6]),'Comb'('ConsCall','Flat.Prog',['Var'(0),'Comb'('ConsCall',[],[]),'Var'(1),'Comb'('ConsCall','.',['Comb'('FuncCall','OptFlat.getFunc',['Var'(5),'Var'(2)]),'Comb'('ConsCall',[],[])]),'Var'(3),'Comb'('ConsCall','.',['Var'(6),'Comb'('ConsCall',[],[])])]))]))).
evaluation('OptFlat.optFlat_lambda3_9664','Rule'([0,1,2],'Comb'('FuncCall','OptFlat.optFuncDecls\'',['Var'(0),'Var'(2),'Var'(1)]))).
evaluation('OptFlat.optFlat_lambda5_9665','Rule'([0,1,2],'Case'('Flex','Var'(2),['Branch'('Pattern'('(,)',[3,4]),'Comb'('ConsCall','.',['Var'(0),'Comb'('FuncCall','OptFlat.optFuncDecls\'',['Var'(3),'Var'(4),'Var'(1)])]))]))).
evaluation('OptFlat.optFlat_lambda4_9666','Rule'([0,1,2,3,4],'Comb'('FuncCall','OptFlat.optFlat_lambda5_9665',['Var'(0),'Var'(1),'Comb'('FuncCall','OptFlat.lookupFuncCalls',['Var'(4),'Var'(2),'Var'(3),'Var'(1)])]))).
evaluation('OptFlat.lambdafun_9667','Rule'([0,1],'Apply'('Comb'('FuncCall',>>,['Comb'('FuncCall',putStr,['Comb'('ConsCall','.',['Lit'('Charc'(65)),'Comb'('ConsCall','.',['Lit'('Charc'(108)),'Comb'('ConsCall','.',['Lit'('Charc'(108)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(109)),'Comb'('ConsCall','.',['Lit'('Charc'(111)),'Comb'('ConsCall','.',['Lit'('Charc'(100)),'Comb'('ConsCall','.',['Lit'('Charc'(117)),'Comb'('ConsCall','.',['Lit'('Charc'(108)),'Comb'('ConsCall','.',['Lit'('Charc'(101)),'Comb'('ConsCall','.',['Lit'('Charc'(115)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(105)),'Comb'('ConsCall','.',['Lit'('Charc'(109)),'Comb'('ConsCall','.',['Lit'('Charc'(112)),'Comb'('ConsCall','.',['Lit'('Charc'(111)),'Comb'('ConsCall','.',['Lit'('Charc'(114)),'Comb'('ConsCall','.',['Lit'('Charc'(116)),'Comb'('ConsCall','.',['Lit'('Charc'(101)),'Comb'('ConsCall','.',['Lit'('Charc'(100)),'Comb'('ConsCall','.',['Lit'('Charc'(46)),'Comb'('ConsCall','.',['Lit'('Charc'(10)),'Comb'('ConsCall',[],[])])])])])])])])])])])])])])])])])])])])])])])]),'Comb'('FuncCall',return,['Var'(0)])]),'Var'(1)))).
evaluation('OptFlat.lambdafun_9668','Rule'([0,1],'Apply'('Comb'('FuncCall',return,['Var'(0)]),'Var'(1)))).
evaluation('OptFlat.lambdafun_9669','Rule'([0,1,2],'Apply'('Comb'('FuncCall',return,['Comb'('ConsCall','.',['Var'(0),'Var'(1)])]),'Var'(2)))).
evaluation('OptFlat.lambdafun_9670','Rule'([0,1,2,3,4,5],'Apply'('Comb'('FuncCall',>>,['Comb'('FuncCall',putStr,['Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(73)),'Comb'('ConsCall','.',['Lit'('Charc'(109)),'Comb'('ConsCall','.',['Lit'('Charc'(112)),'Comb'('ConsCall','.',['Lit'('Charc'(111)),'Comb'('ConsCall','.',['Lit'('Charc'(114)),'Comb'('ConsCall','.',['Lit'('Charc'(116)),'Comb'('ConsCall','.',['Lit'('Charc'(101)),'Comb'('ConsCall','.',['Lit'('Charc'(100)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(109)),'Comb'('ConsCall','.',['Lit'('Charc'(111)),'Comb'('ConsCall','.',['Lit'('Charc'(100)),'Comb'('ConsCall','.',['Lit'('Charc'(117)),'Comb'('ConsCall','.',['Lit'('Charc'(108)),'Comb'('ConsCall','.',['Lit'('Charc'(101)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])])])])])])])])])])])])])])])])]),'Comb'('FuncCall',++,['Var'(0),'Comb'('ConsCall','.',['Lit'('Charc'(46)),'Comb'('ConsCall','.',['Lit'('Charc'(10)),'Comb'('ConsCall',[],[])])])])])]),'Comb'('FuncCall',>>=,['Comb'('FuncCall','OptFlat.readAllImportedFlatProgs\'',['Comb'('FuncCall',++,['Var'(1),'Comb'('FuncCall','OptFlat.getImports',['Var'(4)])]),'Var'(2),'Comb'('FuncCall','SetRBT2.insertRBT',['Var'(0),'Var'(3)])]),'Comb'('PartCall','OptFlat.lambdafun_9669',['Var'(4)])])]),'Var'(5)))).
evaluation(==,'External'(==)).
evaluation(=:=,'External'(=:=)).
evaluation(success,'External'(success)).
evaluation('prelude..','Rule'([0,1,2],'Apply'('Comb'('PartCall',prelude_lambda0_1997,['Var'(0),'Var'(1)]),'Var'(2)))).
evaluation(id,'Rule'([0],'Var'(0))).
evaluation(const,'Rule'([0,1],'Var'(0))).
evaluation(curry,'Rule'([0,1,2],'Apply'('Var'(0),'Comb'('ConsCall','(,)',['Var'(1),'Var'(2)])))).
evaluation(uncurry,'Rule'([0,1],'Case'('Flex','Var'(1),['Branch'('Pattern'('(,)',[2,3]),'Apply'('Apply'('Var'(0),'Var'(2)),'Var'(3)))]))).
evaluation(flip,'Rule'([0,1,2],'Apply'('Apply'('Var'(0),'Var'(2)),'Var'(1)))).
evaluation(until,'Rule'([0,1,2],'Comb'('FuncCall',if_then_else,['Apply'('Var'(0),'Var'(2)),'Var'(2),'Comb'('FuncCall',until,['Var'(0),'Var'(1),'Apply'('Var'(1),'Var'(2))])]))).
evaluation($,'Rule'([0,1],'Apply'('Var'(0),'Var'(1)))).
evaluation('$!','Rule'([0,1],'Comb'('FuncCall',seq,['Var'(1),'Apply'('Var'(0),'Var'(1))]))).
evaluation(failed,'Rule'([],'GuardedExpr'([0],'Constr'([],'Comb'('FuncCall',=:=,['Lit'('Intc'(1)),'Lit'('Intc'(2))])),'Var'(0)))).
evaluation(&&,'Rule'([0,1],'Case'('Flex','Var'(0),['Branch'('Pattern'('True',[]),'Var'(1)),'Branch'('Pattern'('False',[]),'Comb'('ConsCall','False',[]))]))).
evaluation('||','Rule'([0,1],'Case'('Flex','Var'(0),['Branch'('Pattern'('True',[]),'Comb'('ConsCall','True',[])),'Branch'('Pattern'('False',[]),'Var'(1))]))).
evaluation(not,'Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'('True',[]),'Comb'('ConsCall','False',[])),'Branch'('Pattern'('False',[]),'Comb'('ConsCall','True',[]))]))).
evaluation(otherwise,'Rule'([],'Comb'('ConsCall','True',[]))).
evaluation(if_then_else,'Rule'([0,1,2],'Case'('Rigid','Var'(0),['Branch'('Pattern'('True',[]),'Var'(1)),'Branch'('Pattern'('False',[]),'Var'(2))]))).
evaluation(/=,'Rule'([0,1],'Comb'('FuncCall',not,['Comb'('FuncCall',==,['Var'(0),'Var'(1)])]))).
evaluation(fst,'Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'('(,)',[1,2]),'Var'(1))]))).
evaluation(snd,'Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'('(,)',[1,2]),'Var'(2))]))).
evaluation(head,'Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'('.',[1,2]),'Var'(1))]))).
evaluation(tail,'Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'('.',[1,2]),'Var'(2))]))).
evaluation(null,'Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'([],[]),'Comb'('ConsCall','True',[])),'Branch'('Pattern'('.',[1,2]),'Comb'('ConsCall','False',[]))]))).
evaluation(++,'Rule'([0,1],'Case'('Flex','Var'(0),['Branch'('Pattern'([],[]),'Var'(1)),'Branch'('Pattern'('.',[2,3]),'Comb'('ConsCall','.',['Var'(2),'Comb'('FuncCall',++,['Var'(3),'Var'(1)])]))]))).
evaluation(length,'Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'([],[]),'Lit'('Intc'(0))),'Branch'('Pattern'('.',[1,2]),'Comb'('FuncCall',+,['Lit'('Intc'(1)),'Comb'('FuncCall',length,['Var'(2)])]))]))).
evaluation('!!','Rule'([0,1],'Case'('Flex','Var'(0),['Branch'('Pattern'('.',[2,3]),'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',==,['Var'(1),'Lit'('Intc'(0))]),'Var'(2),'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',>,['Var'(1),'Lit'('Intc'(0))]),'Comb'('FuncCall','!!',['Var'(3),'Comb'('FuncCall',-,['Var'(1),'Lit'('Intc'(1))])]),'Comb'('FuncCall',failed,[])])]))]))).
evaluation(map,'Rule'([0,1],'Case'('Flex','Var'(1),['Branch'('Pattern'([],[]),'Comb'('ConsCall',[],[])),'Branch'('Pattern'('.',[2,3]),'Comb'('ConsCall','.',['Apply'('Var'(0),'Var'(2)),'Comb'('FuncCall',map,['Var'(0),'Var'(3)])]))]))).
evaluation(foldl,'Rule'([0,1,2],'Case'('Flex','Var'(2),['Branch'('Pattern'([],[]),'Var'(1)),'Branch'('Pattern'('.',[3,4]),'Comb'('FuncCall',foldl,['Var'(0),'Apply'('Apply'('Var'(0),'Var'(1)),'Var'(3)),'Var'(4)]))]))).
evaluation(foldl1,'Rule'([0,1],'Case'('Flex','Var'(1),['Branch'('Pattern'('.',[2,3]),'Comb'('FuncCall',foldl,['Var'(0),'Var'(2),'Var'(3)]))]))).
evaluation(foldr,'Rule'([0,1,2],'Case'('Flex','Var'(2),['Branch'('Pattern'([],[]),'Var'(1)),'Branch'('Pattern'('.',[3,4]),'Apply'('Apply'('Var'(0),'Var'(3)),'Comb'('FuncCall',foldr,['Var'(0),'Var'(1),'Var'(4)])))]))).
evaluation(foldr1,'Rule'([0,1],'Case'('Flex','Var'(1),['Branch'('Pattern'('.',[2,3]),'Case'('Flex','Var'(3),['Branch'('Pattern'([],[]),'Var'(2)),'Branch'('Pattern'('.',[4,5]),'Apply'('Apply'('Var'(0),'Var'(2)),'Comb'('FuncCall',foldr1,['Var'(0),'Comb'('ConsCall','.',['Var'(4),'Var'(5)])])))]))]))).
evaluation(filter,'Rule'([0,1],'Case'('Flex','Var'(1),['Branch'('Pattern'([],[]),'Comb'('ConsCall',[],[])),'Branch'('Pattern'('.',[2,3]),'Comb'('FuncCall',if_then_else,['Apply'('Var'(0),'Var'(2)),'Comb'('ConsCall','.',['Var'(2),'Comb'('FuncCall',filter,['Var'(0),'Var'(3)])]),'Comb'('FuncCall',filter,['Var'(0),'Var'(3)])]))]))).
evaluation(zip,'Rule'([0,1],'Case'('Flex','Var'(0),['Branch'('Pattern'([],[]),'Comb'('ConsCall',[],[])),'Branch'('Pattern'('.',[2,3]),'Case'('Flex','Var'(1),['Branch'('Pattern'([],[]),'Comb'('ConsCall',[],[])),'Branch'('Pattern'('.',[4,5]),'Comb'('ConsCall','.',['Comb'('ConsCall','(,)',['Var'(2),'Var'(4)]),'Comb'('FuncCall',zip,['Var'(3),'Var'(5)])]))]))]))).
evaluation(zip3,'Rule'([0,1,2],'Case'('Flex','Var'(0),['Branch'('Pattern'([],[]),'Comb'('ConsCall',[],[])),'Branch'('Pattern'('.',[3,4]),'Case'('Flex','Var'(1),['Branch'('Pattern'([],[]),'Comb'('ConsCall',[],[])),'Branch'('Pattern'('.',[5,6]),'Case'('Flex','Var'(2),['Branch'('Pattern'([],[]),'Comb'('ConsCall',[],[])),'Branch'('Pattern'('.',[7,8]),'Comb'('ConsCall','.',['Comb'('ConsCall','(,,)',['Var'(3),'Var'(5),'Var'(7)]),'Comb'('FuncCall',zip3,['Var'(4),'Var'(6),'Var'(8)])]))]))]))]))).
evaluation(zipWith,'Rule'([0,1,2],'Case'('Flex','Var'(1),['Branch'('Pattern'([],[]),'Comb'('ConsCall',[],[])),'Branch'('Pattern'('.',[3,4]),'Case'('Flex','Var'(2),['Branch'('Pattern'([],[]),'Comb'('ConsCall',[],[])),'Branch'('Pattern'('.',[5,6]),'Comb'('ConsCall','.',['Apply'('Apply'('Var'(0),'Var'(3)),'Var'(5)),'Comb'('FuncCall',zipWith,['Var'(0),'Var'(4),'Var'(6)])]))]))]))).
evaluation(zipWith3,'Rule'([0,1,2,3],'Case'('Flex','Var'(1),['Branch'('Pattern'([],[]),'Comb'('ConsCall',[],[])),'Branch'('Pattern'('.',[4,5]),'Case'('Flex','Var'(2),['Branch'('Pattern'([],[]),'Comb'('ConsCall',[],[])),'Branch'('Pattern'('.',[6,7]),'Case'('Flex','Var'(3),['Branch'('Pattern'([],[]),'Comb'('ConsCall',[],[])),'Branch'('Pattern'('.',[8,9]),'Comb'('ConsCall','.',['Apply'('Apply'('Apply'('Var'(0),'Var'(4)),'Var'(6)),'Var'(8)),'Comb'('FuncCall',zipWith3,['Var'(0),'Var'(5),'Var'(7),'Var'(9)])]))]))]))]))).
evaluation(unzip,'Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'([],[]),'Comb'('ConsCall','(,)',['Comb'('ConsCall',[],[]),'Comb'('ConsCall',[],[])])),'Branch'('Pattern'('.',[1,2]),'Case'('Flex','Var'(1),['Branch'('Pattern'('(,)',[3,4]),'Comb'('FuncCall',prelude_lambda1_1998,['Var'(3),'Var'(4),'Comb'('FuncCall',unzip,['Var'(2)])]))]))]))).
evaluation(unzip3,'Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'([],[]),'Comb'('ConsCall','(,,)',['Comb'('ConsCall',[],[]),'Comb'('ConsCall',[],[]),'Comb'('ConsCall',[],[])])),'Branch'('Pattern'('.',[1,2]),'Case'('Flex','Var'(1),['Branch'('Pattern'('(,,)',[3,4,5]),'Comb'('FuncCall',prelude_lambda2_1999,['Var'(3),'Var'(4),'Var'(5),'Comb'('FuncCall',unzip3,['Var'(2)])]))]))]))).
evaluation(concat,'Rule'([0],'Comb'('FuncCall',foldr,['Comb'('PartCall',++,[]),'Comb'('ConsCall',[],[]),'Var'(0)]))).
evaluation(concatMap,'Rule'([0,1],'Apply'('Comb'('FuncCall','prelude..',['Comb'('PartCall',concat,[]),'Comb'('PartCall',map,['Var'(0)])]),'Var'(1)))).
evaluation(iterate,'Rule'([0,1],'Comb'('ConsCall','.',['Var'(1),'Comb'('FuncCall',iterate,['Var'(0),'Apply'('Var'(0),'Var'(1))])]))).
evaluation(repeat,'Rule'([0],'Comb'('ConsCall','.',['Var'(0),'Comb'('FuncCall',repeat,['Var'(0)])]))).
evaluation(replicate,'Rule'([0,1],'Comb'('FuncCall',take,['Var'(0),'Comb'('FuncCall',repeat,['Var'(1)])]))).
evaluation(take,'Rule'([0,1],'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',<=,['Var'(0),'Lit'('Intc'(0))]),'Comb'('ConsCall',[],[]),'Comb'('FuncCall',takep_452,['Var'(0),'Var'(1)])]))).
evaluation(drop,'Rule'([0,1],'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',<=,['Var'(0),'Lit'('Intc'(0))]),'Var'(1),'Comb'('FuncCall',dropp_459,['Var'(0),'Var'(1)])]))).
evaluation(splitAt,'Rule'([0,1],'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',<=,['Var'(0),'Lit'('Intc'(0))]),'Comb'('ConsCall','(,)',['Comb'('ConsCall',[],[]),'Var'(1)]),'Comb'('FuncCall',splitAtp_466,['Var'(0),'Var'(1)])]))).
evaluation(takeWhile,'Rule'([0,1],'Case'('Flex','Var'(1),['Branch'('Pattern'([],[]),'Comb'('ConsCall',[],[])),'Branch'('Pattern'('.',[2,3]),'Comb'('FuncCall',if_then_else,['Apply'('Var'(0),'Var'(2)),'Comb'('ConsCall','.',['Var'(2),'Comb'('FuncCall',takeWhile,['Var'(0),'Var'(3)])]),'Comb'('ConsCall',[],[])]))]))).
evaluation(dropWhile,'Rule'([0,1],'Case'('Flex','Var'(1),['Branch'('Pattern'([],[]),'Comb'('ConsCall',[],[])),'Branch'('Pattern'('.',[2,3]),'Comb'('FuncCall',if_then_else,['Apply'('Var'(0),'Var'(2)),'Comb'('FuncCall',dropWhile,['Var'(0),'Var'(3)]),'Comb'('ConsCall','.',['Var'(2),'Var'(3)])]))]))).
evaluation(span,'Rule'([0,1],'Case'('Flex','Var'(1),['Branch'('Pattern'([],[]),'Comb'('ConsCall','(,)',['Comb'('ConsCall',[],[]),'Comb'('ConsCall',[],[])])),'Branch'('Pattern'('.',[2,3]),'Comb'('FuncCall',if_then_else,['Apply'('Var'(0),'Var'(2)),'Comb'('FuncCall',prelude_lambda4_2001,['Var'(2),'Comb'('FuncCall',span,['Var'(0),'Var'(3)])]),'Comb'('ConsCall','(,)',['Comb'('ConsCall',[],[]),'Comb'('ConsCall','.',['Var'(2),'Var'(3)])])]))]))).
evaluation(break,'Rule'([0,1],'Apply'('Comb'('PartCall',span,['Comb'('FuncCall','prelude..',['Comb'('PartCall',not,[]),'Var'(0)])]),'Var'(1)))).
evaluation(lines,'Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'([],[]),'Comb'('ConsCall',[],[])),'Branch'('Pattern'('.',[1,2]),'Comb'('FuncCall',prelude_lambda6_2003,['Comb'('FuncCall',splitline_490,['Comb'('ConsCall','.',['Var'(1),'Var'(2)])])]))]))).
evaluation(unlines,'Rule'([0],'Apply'('Comb'('FuncCall',concatMap,['Comb'('PartCall',prelude_lambda7_2004,[])]),'Var'(0)))).
evaluation(words,'Rule'([0],'Comb'('FuncCall',prelude_lambda8_2006,['Comb'('FuncCall',dropWhile,['Comb'('PartCall',isSpace_500,[]),'Var'(0)])]))).
evaluation(unwords,'Rule'([0],'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',==,['Var'(0),'Comb'('ConsCall',[],[])]),'Comb'('ConsCall',[],[]),'Comb'('FuncCall',foldr1,['Comb'('PartCall',prelude_lambda10_2007,[]),'Var'(0)])]))).
evaluation(reverse,'Rule'([0],'Apply'('Comb'('PartCall',foldl,['Comb'('PartCall',flip,['Comb'('PartCall','.',[])]),'Comb'('ConsCall',[],[])]),'Var'(0)))).
evaluation(and,'Rule'([0],'Apply'('Comb'('PartCall',foldr,['Comb'('PartCall',&&,[]),'Comb'('ConsCall','True',[])]),'Var'(0)))).
evaluation(or,'Rule'([0],'Apply'('Comb'('PartCall',foldr,['Comb'('PartCall','||',[]),'Comb'('ConsCall','False',[])]),'Var'(0)))).
evaluation(any,'Rule'([0,1],'Apply'('Comb'('FuncCall','prelude..',['Comb'('FuncCall',or,[]),'Comb'('PartCall',map,['Var'(0)])]),'Var'(1)))).
evaluation(all,'Rule'([0,1],'Apply'('Comb'('FuncCall','prelude..',['Comb'('FuncCall',and,[]),'Comb'('PartCall',map,['Var'(0)])]),'Var'(1)))).
evaluation(elem,'Rule'([0,1],'Apply'('Comb'('FuncCall',any,['Comb'('PartCall',prelude_lambda11_2008,['Var'(0)])]),'Var'(1)))).
evaluation(notElem,'Rule'([0,1],'Apply'('Comb'('FuncCall',all,['Comb'('PartCall',prelude_lambda12_2009,['Var'(0)])]),'Var'(1)))).
evaluation(lookup,'Rule'([0,1],'Case'('Flex','Var'(1),['Branch'('Pattern'([],[]),'Comb'('ConsCall','Nothing',[])),'Branch'('Pattern'('.',[2,3]),'Case'('Flex','Var'(2),['Branch'('Pattern'('(,)',[4,5]),'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',==,['Var'(0),'Var'(4)]),'Comb'('ConsCall','Just',['Var'(5)]),'Comb'('FuncCall',lookup,['Var'(0),'Var'(3)])]))]))]))).
evaluation(enumFrom,'Rule'([0],'Comb'('ConsCall','.',['Var'(0),'Comb'('FuncCall',enumFrom,['Comb'('FuncCall',+,['Var'(0),'Lit'('Intc'(1))])])]))).
evaluation(enumFromThen,'Rule'([0,1],'Comb'('FuncCall',iterate,['Comb'('PartCall',prelude_lambda13_2010,['Var'(1),'Var'(0)]),'Var'(0)]))).
evaluation(enumFromTo,'Rule'([0,1],'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',>,['Var'(0),'Var'(1)]),'Comb'('ConsCall',[],[]),'Comb'('ConsCall','.',['Var'(0),'Comb'('FuncCall',enumFromTo,['Comb'('FuncCall',+,['Var'(0),'Lit'('Intc'(1))]),'Var'(1)])])]))).
evaluation(enumFromThenTo,'Rule'([0,1,2],'Comb'('FuncCall',takeWhile,['Comb'('PartCall',p_528,['Var'(1),'Var'(0),'Var'(2)]),'Comb'('FuncCall',enumFromThen,['Var'(0),'Var'(1)])]))).
evaluation(&>,'Rule'([0,1],'GuardedExpr'([],'Constr'([],'Var'(0)),'Var'(1)))).
evaluation(maybe,'Rule'([0,1,2],'Case'('Flex','Var'(2),['Branch'('Pattern'('Nothing',[]),'Var'(0)),'Branch'('Pattern'('Just',[3]),'Apply'('Var'(1),'Var'(3)))]))).
evaluation(either,'Rule'([0,1,2],'Case'('Flex','Var'(2),['Branch'('Pattern'('Left',[3]),'Apply'('Var'(0),'Var'(3))),'Branch'('Pattern'('Right',[4]),'Apply'('Var'(1),'Var'(4)))]))).
evaluation(done,'Rule'([0],'Apply'('Comb'('FuncCall',return,['Comb'('ConsCall','()',[])]),'Var'(0)))).
evaluation(putStr,'Rule'([0,3],'Case'('Rigid','Var'(0),['Branch'('Pattern'([],[]),'Apply'('Comb'('FuncCall',done,[]),'Var'(3))),'Branch'('Pattern'('.',[1,2]),'Apply'('Comb'('FuncCall',>>,['Comb'('FuncCall',putChar,['Var'(1)]),'Comb'('FuncCall',putStr,['Var'(2)])]),'Var'(3)))]))).
evaluation(putStrLn,'Rule'([0,1],'Apply'('Comb'('FuncCall',>>,['Comb'('FuncCall',putStr,['Var'(0)]),'Comb'('FuncCall',putChar,['Lit'('Charc'(10))])]),'Var'(1)))).
evaluation(getLine,'Rule'([0],'Apply'('Comb'('FuncCall',>>=,['Comb'('FuncCall',getChar,[]),'Comb'('PartCall',lambdafun_2012,[])]),'Var'(0)))).
evaluation(print,'Rule'([0,1],'Apply'('Comb'('FuncCall',putStrLn,['Comb'('FuncCall',show,['Var'(0)])]),'Var'(1)))).
evaluation(doSolve,'Rule'([0,1],'GuardedExpr'([],'Constr'([],'Var'(0)),'Apply'('Comb'('FuncCall',done,[]),'Var'(1))))).
evaluation(sequenceIO,'Rule'([0,3],'Case'('Rigid','Var'(0),['Branch'('Pattern'([],[]),'Apply'('Comb'('FuncCall',return,['Comb'('ConsCall',[],[])]),'Var'(3))),'Branch'('Pattern'('.',[1,2]),'Apply'('Comb'('FuncCall',>>=,['Var'(1),'Comb'('PartCall',lambdafun_2015,['Var'(2)])]),'Var'(3)))]))).
evaluation(sequenceIO_,'Rule'([0,1],'Apply'('Apply'('Comb'('PartCall',foldr,['Comb'('PartCall',>>,[]),'Comb'('FuncCall',done,[])]),'Var'(0)),'Var'(1)))).
evaluation(mapIO,'Rule'([0,1,2],'Apply'('Apply'('Comb'('FuncCall','prelude..',['Comb'('PartCall',sequenceIO,[]),'Comb'('PartCall',map,['Var'(0)])]),'Var'(1)),'Var'(2)))).
evaluation(mapIO_,'Rule'([0,1,2],'Apply'('Apply'('Comb'('FuncCall','prelude..',['Comb'('FuncCall',sequenceIO_,[]),'Comb'('PartCall',map,['Var'(0)])]),'Var'(1)),'Var'(2)))).
evaluation(inject,'Rule'([0,1,2],'Apply'('Comb'('PartCall',prelude_lambda15_2016,['Var'(1),'Var'(0)]),'Var'(2)))).
evaluation(solveAll,'Rule'([0],'Comb'('FuncCall',evalall_563,['Comb'('FuncCall',try,['Var'(0)])]))).
evaluation(solveAll2,'Rule'([0],'Comb'('FuncCall',evalResult_580,['Comb'('FuncCall',try,['Var'(0)])]))).
evaluation(once,'Rule'([0,1],'Apply'('Comb'('FuncCall',head,['Comb'('FuncCall',solveAll,['Var'(0)])]),'Var'(1)))).
evaluation(one,'Rule'([0],'Comb'('FuncCall',solveAll,['Comb'('PartCall',prelude_lambda16_2017,['Var'(0)])]))).
evaluation(condSearch,'Rule'([0,1],'Comb'('FuncCall',one,['Comb'('PartCall',prelude_lambda17_2018,['Var'(0),'Var'(1)])]))).
evaluation(best,'Rule'([0,1],'Comb'('FuncCall',bestHelp_595,['Var'(1),'Comb'('ConsCall',[],[]),'Comb'('FuncCall',try,['Var'(0)]),'Comb'('ConsCall',[],[])]))).
evaluation(browse,'Rule'([0,1],'Apply'('Comb'('FuncCall',putStr,['Comb'('FuncCall',show,['Comb'('FuncCall',unpack,['Var'(0)])])]),'Var'(1)))).
evaluation(browseList,'Rule'([0,3],'Case'('Rigid','Var'(0),['Branch'('Pattern'([],[]),'Apply'('Comb'('FuncCall',done,[]),'Var'(3))),'Branch'('Pattern'('.',[1,2]),'Apply'('Comb'('FuncCall',>>,['Comb'('FuncCall',>>,['Comb'('FuncCall',browse,['Var'(1)]),'Comb'('FuncCall',putChar,['Lit'('Charc'(10))])]),'Comb'('FuncCall',browseList,['Var'(2)])]),'Var'(3)))]))).
evaluation(unpack,'Rule'([0],'GuardedExpr'([1],'Constr'([],'Apply'('Var'(0),'Var'(1))),'Var'(1)))).
evaluation('PEVAL','Rule'([0],'Var'(0))).
evaluation(prelude_lambda0_1997,'Rule'([0,1,2],'Apply'('Var'(0),'Apply'('Var'(1),'Var'(2))))).
evaluation(prelude_lambda1_1998,'Rule'([0,1,2],'Case'('Flex','Var'(2),['Branch'('Pattern'('(,)',[3,4]),'Comb'('ConsCall','(,)',['Comb'('ConsCall','.',['Var'(0),'Var'(3)]),'Comb'('ConsCall','.',['Var'(1),'Var'(4)])]))]))).
evaluation(prelude_lambda2_1999,'Rule'([0,1,2,3],'Case'('Flex','Var'(3),['Branch'('Pattern'('(,,)',[4,5,6]),'Comb'('ConsCall','(,,)',['Comb'('ConsCall','.',['Var'(0),'Var'(4)]),'Comb'('ConsCall','.',['Var'(1),'Var'(5)]),'Comb'('ConsCall','.',['Var'(2),'Var'(6)])]))]))).
evaluation(takep_452,'Rule'([0,1],'Case'('Flex','Var'(1),['Branch'('Pattern'([],[]),'Comb'('ConsCall',[],[])),'Branch'('Pattern'('.',[2,3]),'Comb'('ConsCall','.',['Var'(2),'Comb'('FuncCall',take,['Comb'('FuncCall',-,['Var'(0),'Lit'('Intc'(1))]),'Var'(3)])]))]))).
evaluation(dropp_459,'Rule'([0,1],'Case'('Flex','Var'(1),['Branch'('Pattern'([],[]),'Comb'('ConsCall',[],[])),'Branch'('Pattern'('.',[2,3]),'Comb'('FuncCall',drop,['Comb'('FuncCall',-,['Var'(0),'Lit'('Intc'(1))]),'Var'(3)]))]))).
evaluation(splitAtp_466,'Rule'([0,1],'Case'('Flex','Var'(1),['Branch'('Pattern'([],[]),'Comb'('ConsCall','(,)',['Comb'('ConsCall',[],[]),'Comb'('ConsCall',[],[])])),'Branch'('Pattern'('.',[2,3]),'Comb'('FuncCall',prelude_lambda3_2000,['Var'(2),'Comb'('FuncCall',splitAt,['Comb'('FuncCall',-,['Var'(0),'Lit'('Intc'(1))]),'Var'(3)])]))]))).
evaluation(prelude_lambda3_2000,'Rule'([0,1],'Case'('Flex','Var'(1),['Branch'('Pattern'('(,)',[2,3]),'Comb'('ConsCall','(,)',['Comb'('ConsCall','.',['Var'(0),'Var'(2)]),'Var'(3)]))]))).
evaluation(prelude_lambda4_2001,'Rule'([0,1],'Case'('Flex','Var'(1),['Branch'('Pattern'('(,)',[2,3]),'Comb'('ConsCall','(,)',['Comb'('ConsCall','.',['Var'(0),'Var'(2)]),'Var'(3)]))]))).
evaluation(splitline_490,'Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'([],[]),'Comb'('ConsCall','(,)',['Comb'('ConsCall',[],[]),'Comb'('ConsCall',[],[])])),'Branch'('Pattern'('.',[1,2]),'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',==,['Var'(1),'Lit'('Charc'(10))]),'Comb'('ConsCall','(,)',['Comb'('ConsCall',[],[]),'Var'(2)]),'Comb'('FuncCall',prelude_lambda5_2002,['Var'(1),'Comb'('FuncCall',splitline_490,['Var'(2)])])]))]))).
evaluation(prelude_lambda5_2002,'Rule'([0,1],'Case'('Flex','Var'(1),['Branch'('Pattern'('(,)',[2,3]),'Comb'('ConsCall','(,)',['Comb'('ConsCall','.',['Var'(0),'Var'(2)]),'Var'(3)]))]))).
evaluation(prelude_lambda6_2003,'Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'('(,)',[1,2]),'Comb'('ConsCall','.',['Var'(1),'Comb'('FuncCall',lines,['Var'(2)])]))]))).
evaluation(prelude_lambda7_2004,'Rule'([0],'Comb'('FuncCall',++,['Var'(0),'Comb'('ConsCall','.',['Lit'('Charc'(10)),'Comb'('ConsCall',[],[])])]))).
evaluation(isSpace_500,'Rule'([0],'Comb'('FuncCall','||',['Comb'('FuncCall',==,['Var'(0),'Lit'('Charc'(32))]),'Comb'('FuncCall','||',['Comb'('FuncCall',==,['Var'(0),'Lit'('Charc'(9))]),'Comb'('FuncCall','||',['Comb'('FuncCall',==,['Var'(0),'Lit'('Charc'(10))]),'Comb'('FuncCall',==,['Var'(0),'Lit'('Charc'(13))])])])]))).
evaluation(prelude_lambda9_2005,'Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'('(,)',[1,2]),'Comb'('ConsCall','.',['Var'(1),'Comb'('FuncCall',words,['Var'(2)])]))]))).
evaluation(prelude_lambda8_2006,'Rule'([0],'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',==,['Var'(0),'Comb'('ConsCall',[],[])]),'Comb'('ConsCall',[],[]),'Comb'('FuncCall',prelude_lambda9_2005,['Apply'('Comb'('FuncCall',break,['Comb'('PartCall',isSpace_500,[])]),'Var'(0))])]))).
evaluation(prelude_lambda10_2007,'Rule'([0,1],'Comb'('FuncCall',++,['Var'(0),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Var'(1)])]))).
evaluation(prelude_lambda11_2008,'Rule'([0,1],'Comb'('FuncCall',==,['Var'(0),'Var'(1)]))).
evaluation(prelude_lambda12_2009,'Rule'([0,1],'Comb'('FuncCall',/=,['Var'(0),'Var'(1)]))).
evaluation(prelude_lambda13_2010,'Rule'([0,1,2],'Comb'('FuncCall',+,['Comb'('FuncCall',-,['Var'(0),'Var'(1)]),'Var'(2)]))).
evaluation(p_528,'Rule'([0,1,2,3],'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',>=,['Var'(0),'Var'(1)]),'Comb'('FuncCall',<=,['Var'(3),'Var'(2)]),'Comb'('FuncCall',>=,['Var'(3),'Var'(2)])]))).
evaluation(prelude_lambda14_2011,'Rule'([0,1,2],'Apply'('Var'(0),'Var'(2)))).
evaluation(lambdafun_2012,'Rule'([0,1],'Apply'('Comb'('FuncCall',if_then_else,['Comb'('FuncCall',==,['Var'(0),'Lit'('Charc'(10))]),'Comb'('FuncCall',return,['Comb'('ConsCall',[],[])]),'Comb'('FuncCall',>>=,['Comb'('FuncCall',getLine,[]),'Comb'('PartCall',lambdafun_2013,['Var'(0)])])]),'Var'(1)))).
evaluation(lambdafun_2013,'Rule'([0,1,2],'Apply'('Comb'('FuncCall',return,['Comb'('ConsCall','.',['Var'(0),'Var'(1)])]),'Var'(2)))).
evaluation(lambdafun_2014,'Rule'([0,1,2],'Apply'('Comb'('FuncCall',return,['Comb'('ConsCall','.',['Var'(0),'Var'(1)])]),'Var'(2)))).
evaluation(lambdafun_2015,'Rule'([0,1,2],'Apply'('Comb'('FuncCall',>>=,['Comb'('FuncCall',sequenceIO,['Var'(0)]),'Comb'('PartCall',lambdafun_2014,['Var'(1)])]),'Var'(2)))).
evaluation(prelude_lambda15_2016,'Rule'([0,1,2],'Comb'('FuncCall',&,['Apply'('Var'(0),'Var'(2)),'Apply'('Var'(1),'Var'(2))]))).
evaluation(evalall_563,'Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'([],[]),'Comb'('ConsCall',[],[])),'Branch'('Pattern'('.',[1,2]),'Case'('Flex','Var'(2),['Branch'('Pattern'([],[]),'Comb'('ConsCall','.',['Var'(1),'Comb'('ConsCall',[],[])])),'Branch'('Pattern'('.',[3,4]),'Comb'('FuncCall',evalall3_565,['Comb'('FuncCall',try,['Var'(1)]),'Comb'('ConsCall','.',['Var'(3),'Var'(4)])]))]))]))).
evaluation(evalall2_564,'Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'([],[]),'Comb'('ConsCall',[],[])),'Branch'('Pattern'('.',[1,2]),'Comb'('FuncCall',evalall3_565,['Comb'('FuncCall',try,['Var'(1)]),'Var'(2)]))]))).
evaluation(evalall3_565,'Rule'([0,1],'Case'('Flex','Var'(0),['Branch'('Pattern'([],[]),'Comb'('FuncCall',evalall2_564,['Var'(1)])),'Branch'('Pattern'('.',[2,3]),'Case'('Flex','Var'(3),['Branch'('Pattern'([],[]),'Comb'('ConsCall','.',['Var'(2),'Comb'('FuncCall',evalall2_564,['Var'(1)])])),'Branch'('Pattern'('.',[4,5]),'Comb'('FuncCall',evalall3_565,['Comb'('FuncCall',try,['Var'(2)]),'Comb'('ConsCall','.',['Var'(4),'Comb'('FuncCall',++,['Var'(5),'Var'(1)])])]))]))]))).
evaluation(evalResult_580,'Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'([],[]),'Comb'('ConsCall',[],[])),'Branch'('Pattern'('.',[1,2]),'Case'('Flex','Var'(2),['Branch'('Pattern'([],[]),'Comb'('ConsCall','.',['Var'(1),'Comb'('ConsCall',[],[])])),'Branch'('Pattern'('.',[3,4]),'Apply'('Comb'('FuncCall',concatMap,['Comb'('PartCall',solveAll2,[])]),'Comb'('ConsCall','.',['Var'(1),'Comb'('ConsCall','.',['Var'(3),'Var'(4)])])))]))]))).
evaluation(prelude_lambda16_2017,'Rule'([0,1],'Comb'('FuncCall',=:=,['Var'(1),'Comb'('FuncCall',tryone,['Var'(0)])]))).
evaluation(prelude_lambda17_2018,'Rule'([0,1,2],'Comb'('FuncCall',&,['Apply'('Var'(0),'Var'(2)),'Comb'('FuncCall',=:=,['Apply'('Var'(1),'Var'(2)),'Comb'('ConsCall','True',[])])]))).
evaluation(bestHelp_595,'Rule'([0,1,2,3],'Case'('Flex','Var'(1),['Branch'('Pattern'([],[]),'Case'('Flex','Var'(2),['Branch'('Pattern'([],[]),'Var'(3)),'Branch'('Pattern'('.',[4,5]),'Comb'('FuncCall',evalY_596,['Var'(0),'Comb'('FuncCall',try,['Comb'('FuncCall',constrain_599,['Var'(0),'Var'(4),'Var'(3)])]),'Var'(5),'Var'(3)]))])),'Branch'('Pattern'('.',[6,7]),'Comb'('FuncCall',evalX_597,['Var'(0),'Comb'('FuncCall',try,['Var'(6)]),'Var'(7),'Var'(2),'Var'(3)]))]))).
evaluation(evalY_596,'Rule'([0,1,2,3],'Case'('Flex','Var'(1),['Branch'('Pattern'([],[]),'Comb'('FuncCall',bestHelp_595,['Var'(0),'Comb'('ConsCall',[],[]),'Var'(2),'Var'(3)])),'Branch'('Pattern'('.',[4,5]),'Case'('Flex','Var'(5),['Branch'('Pattern'([],[]),'Comb'('FuncCall',bestHelp_595,['Var'(0),'Comb'('ConsCall',[],[]),'Var'(2),'Comb'('ConsCall','.',['Var'(4),'Comb'('ConsCall',[],[])])])),'Branch'('Pattern'('.',[6,7]),'Comb'('FuncCall',bestHelp_595,['Var'(0),'Comb'('ConsCall','.',['Var'(4),'Comb'('ConsCall','.',['Var'(6),'Var'(7)])]),'Var'(2),'Var'(3)]))]))]))).
evaluation(evalX_597,'Rule'([0,1,2,3,4],'Case'('Flex','Var'(1),['Branch'('Pattern'([],[]),'Comb'('FuncCall',bestHelp_595,['Var'(0),'Var'(2),'Var'(3),'Var'(4)])),'Branch'('Pattern'('.',[5,6]),'Case'('Flex','Var'(6),['Branch'('Pattern'([],[]),'Comb'('FuncCall',bestHelp_595,['Var'(0),'Comb'('ConsCall',[],[]),'Comb'('FuncCall',++,['Var'(2),'Var'(3)]),'Comb'('ConsCall','.',['Var'(5),'Comb'('ConsCall',[],[])])]))]))]))).
evaluation(evalA_598,'Rule'([0,1,2,3,4],'Case'('Flex','Var'(1),['Branch'('Pattern'('.',[5,6]),'Case'('Flex','Var'(6),['Branch'('Pattern'('.',[7,8]),'Comb'('FuncCall',bestHelp_595,['Var'(0),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Var'(5),'Comb'('ConsCall','.',['Var'(7),'Var'(8)])]),'Var'(2)]),'Var'(3),'Var'(4)]))]))]))).
evaluation(constrain_599,'Rule'([0,1,2,5],'Case'('Flex','Var'(2),['Branch'('Pattern'([],[]),'Apply'('Var'(1),'Var'(5))),'Branch'('Pattern'('.',[3,4]),'Case'('Flex','Var'(4),['Branch'('Pattern'([],[]),'Apply'('Comb'('FuncCall',inject,['Var'(1),'Comb'('PartCall',prelude_lambda18_2019,['Var'(3),'Var'(0)])]),'Var'(5)))]))]))).
evaluation(prelude_lambda18_2019,'Rule'([0,1,2],'Constr'([3],'Comb'('FuncCall',&,['Apply'('Var'(0),'Var'(3)),'Comb'('FuncCall',=:=,['Apply'('Apply'('Var'(1),'Var'(2)),'Var'(3)),'Comb'('ConsCall','True',[])])])))).
evaluation('Flat.readFlatCurry','Rule'([0,1],'Apply'('Comb'('FuncCall','Flat.readFlatCurryWithParseOptions',['Var'(0),'Comb'('ConsCall','.',['Lit'('Charc'(45)),'Comb'('ConsCall','.',['Lit'('Charc'(113)),'Comb'('ConsCall','.',['Lit'('Charc'(117)),'Comb'('ConsCall','.',['Lit'('Charc'(105)),'Comb'('ConsCall','.',['Lit'('Charc'(101)),'Comb'('ConsCall','.',['Lit'('Charc'(116)),'Comb'('ConsCall',[],[])])])])])])])]),'Var'(1)))).
evaluation('Flat.readFlatCurryWithParseOptions','Rule'([0,1,2],'Apply'('Comb'('FuncCall',>>=,['Comb'('FuncCall','Directory.doesFileExist',['Comb'('FuncCall',++,['Var'(0),'Comb'('ConsCall','.',['Lit'('Charc'(46)),'Comb'('ConsCall','.',['Lit'('Charc'(99)),'Comb'('ConsCall','.',['Lit'('Charc'(117)),'Comb'('ConsCall','.',['Lit'('Charc'(114)),'Comb'('ConsCall','.',['Lit'('Charc'(114)),'Comb'('ConsCall','.',['Lit'('Charc'(121)),'Comb'('ConsCall',[],[])])])])])])])])]),'Comb'('PartCall','Flat.lambdafun_2844',['Var'(1),'Var'(0)])]),'Var'(2)))).
evaluation('Flat.splitFlatModName','Rule'([0],'Comb'('FuncCall',if_then_else,['Comb'('FuncCall','Char.isAlpha',['Comb'('FuncCall',head,['Var'(0)])]),'Comb'('FuncCall','Flat.flat_lambda0_2846',['Var'(0),'Comb'('FuncCall',break,['Comb'('PartCall','Flat.flat_lambda1_2847',[]),'Var'(0)])]),'Comb'('ConsCall','(,)',['Comb'('ConsCall','.',['Lit'('Charc'(112)),'Comb'('ConsCall','.',['Lit'('Charc'(114)),'Comb'('ConsCall','.',['Lit'('Charc'(101)),'Comb'('ConsCall','.',['Lit'('Charc'(108)),'Comb'('ConsCall','.',['Lit'('Charc'(117)),'Comb'('ConsCall','.',['Lit'('Charc'(100)),'Comb'('ConsCall','.',['Lit'('Charc'(101)),'Comb'('ConsCall',[],[])])])])])])])]),'Var'(0)])]))).
evaluation('Flat.lambdafun_2843','Rule'([0,1,2,3,4],'Apply'('Comb'('FuncCall',>>,['Comb'('FuncCall',if_then_else,['Comb'('FuncCall','||',['Var'(0),'Var'(3)]),'Comb'('FuncCall',>>=,['Comb'('FuncCall','System.getEnviron',['Comb'('ConsCall','.',['Lit'('Charc'(80)),'Comb'('ConsCall','.',['Lit'('Charc'(65)),'Comb'('ConsCall','.',['Lit'('Charc'(75)),'Comb'('ConsCall','.',['Lit'('Charc'(67)),'Comb'('ConsCall','.',['Lit'('Charc'(83)),'Comb'('ConsCall','.',['Lit'('Charc'(72)),'Comb'('ConsCall','.',['Lit'('Charc'(79)),'Comb'('ConsCall','.',['Lit'('Charc'(77)),'Comb'('ConsCall','.',['Lit'('Charc'(69)),'Comb'('ConsCall',[],[])])])])])])])])])])]),'Comb'('PartCall','Flat.lambdafun_2845',['Var'(1),'Var'(2)])]),'Comb'('FuncCall',done,[])]),'Comb'('FuncCall','Flat.readFlatCurryFile',['Comb'('FuncCall',++,['Var'(2),'Comb'('ConsCall','.',['Lit'('Charc'(46)),'Comb'('ConsCall','.',['Lit'('Charc'(102)),'Comb'('ConsCall','.',['Lit'('Charc'(108)),'Comb'('ConsCall','.',['Lit'('Charc'(99)),'Comb'('ConsCall',[],[])])])])])])])]),'Var'(4)))).
evaluation('Flat.lambdafun_2845','Rule'([0,1,2,3],'Apply'('Comb'('FuncCall',>>,['Comb'('FuncCall','System.system',['Comb'('FuncCall',++,['Var'(2),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(47)),'Comb'('ConsCall','.',['Lit'('Charc'(98)),'Comb'('ConsCall','.',['Lit'('Charc'(105)),'Comb'('ConsCall','.',['Lit'('Charc'(110)),'Comb'('ConsCall','.',['Lit'('Charc'(47)),'Comb'('ConsCall','.',['Lit'('Charc'(112)),'Comb'('ConsCall','.',['Lit'('Charc'(97)),'Comb'('ConsCall','.',['Lit'('Charc'(114)),'Comb'('ConsCall','.',['Lit'('Charc'(115)),'Comb'('ConsCall','.',['Lit'('Charc'(101)),'Comb'('ConsCall','.',['Lit'('Charc'(99)),'Comb'('ConsCall','.',['Lit'('Charc'(117)),'Comb'('ConsCall','.',['Lit'('Charc'(114)),'Comb'('ConsCall','.',['Lit'('Charc'(114)),'Comb'('ConsCall','.',['Lit'('Charc'(121)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(45)),'Comb'('ConsCall','.',['Lit'('Charc'(102)),'Comb'('ConsCall','.',['Lit'('Charc'(108)),'Comb'('ConsCall','.',['Lit'('Charc'(99)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])])])])])])])])])])])])])])])])])])])])])]),'Comb'('FuncCall',++,['Var'(0),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])]),'Var'(1)])])])])]),'Comb'('FuncCall',done,[])]),'Var'(3)))).
evaluation('Flat.lambdafun_2844','Rule'([0,1,2,3],'Apply'('Comb'('FuncCall',>>=,['Comb'('FuncCall','Directory.doesFileExist',['Comb'('FuncCall',++,['Var'(1),'Comb'('ConsCall','.',['Lit'('Charc'(46)),'Comb'('ConsCall','.',['Lit'('Charc'(108)),'Comb'('ConsCall','.',['Lit'('Charc'(99)),'Comb'('ConsCall','.',['Lit'('Charc'(117)),'Comb'('ConsCall','.',['Lit'('Charc'(114)),'Comb'('ConsCall','.',['Lit'('Charc'(114)),'Comb'('ConsCall','.',['Lit'('Charc'(121)),'Comb'('ConsCall',[],[])])])])])])])])])]),'Comb'('PartCall','Flat.lambdafun_2843',['Var'(2),'Var'(0),'Var'(1)])]),'Var'(3)))).
evaluation('Flat.flat_lambda0_2846','Rule'([0,1],'Case'('Flex','Var'(1),['Branch'('Pattern'('(,)',[2,3]),'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',==,['Var'(3),'Comb'('ConsCall',[],[])]),'Comb'('ConsCall','(,)',['Comb'('ConsCall','.',['Lit'('Charc'(112)),'Comb'('ConsCall','.',['Lit'('Charc'(114)),'Comb'('ConsCall','.',['Lit'('Charc'(101)),'Comb'('ConsCall','.',['Lit'('Charc'(108)),'Comb'('ConsCall','.',['Lit'('Charc'(117)),'Comb'('ConsCall','.',['Lit'('Charc'(100)),'Comb'('ConsCall','.',['Lit'('Charc'(101)),'Comb'('ConsCall',[],[])])])])])])])]),'Var'(0)]),'Comb'('ConsCall','(,)',['Var'(2),'Comb'('FuncCall',tail,['Var'(3)])])]))]))).
evaluation('Flat.flat_lambda1_2847','Rule'([0],'Comb'('FuncCall',==,['Var'(0),'Lit'('Charc'(46))]))).
evaluation('FlatTools.showFlatProg','Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'('Flat.Prog',[1,2,3,4,5,6]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(40)),'Comb'('ConsCall','.',['Lit'('Charc'(80)),'Comb'('ConsCall','.',['Lit'('Charc'(114)),'Comb'('ConsCall','.',['Lit'('Charc'(111)),'Comb'('ConsCall','.',['Lit'('Charc'(103)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])])])])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flatShowString',['Var'(1)]),'Comb'('FuncCall',++,['Comb'('FuncCall',if_then_else,['Comb'('FuncCall',==,['Var'(2),'Comb'('ConsCall',[],[])]),'Comb'('ConsCall','.',['Lit'('Charc'(10)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(91)),'Comb'('ConsCall','.',['Lit'('Charc'(93)),'Comb'('ConsCall',[],[])])])])])]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(10)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(91)),'Comb'('ConsCall',[],[])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flatShowListElems',['Comb'('PartCall','FlatTools.flatShowString',[]),'Var'(2)]),'Comb'('ConsCall','.',['Lit'('Charc'(93)),'Comb'('ConsCall',[],[])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall',if_then_else,['Comb'('FuncCall',==,['Var'(3),'Comb'('ConsCall',[],[])]),'Comb'('ConsCall','.',['Lit'('Charc'(10)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(91)),'Comb'('ConsCall','.',['Lit'('Charc'(93)),'Comb'('ConsCall',[],[])])])])])]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(10)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(91)),'Comb'('ConsCall',[],[])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flatShowListElems',['Comb'('PartCall','FlatTools.flatShowType',[]),'Var'(3)]),'Comb'('ConsCall','.',['Lit'('Charc'(10)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(93)),'Comb'('ConsCall',[],[])])])])])])]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(10)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(91)),'Comb'('ConsCall',[],[])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flatShowListElems',['Comb'('PartCall','FlatTools.flatShowFunc',[]),'Var'(4)]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(10)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(93)),'Comb'('ConsCall',[],[])])])])]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(10)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flatShowList',['Comb'('PartCall','FlatTools.flatShowOp',[]),'Var'(5)]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(10)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(91)),'Comb'('ConsCall',[],[])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flatShowListElems',['Comb'('PartCall','FlatTools.flatShowTrans',[]),'Var'(6)]),'Comb'('ConsCall','.',['Lit'('Charc'(10)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(93)),'Comb'('ConsCall','.',['Lit'('Charc'(10)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(41)),'Comb'('ConsCall','.',['Lit'('Charc'(10)),'Comb'('ConsCall',[],[])])])])])])])])])])])])])])])])])])])]))]))).
evaluation('FlatTools.flatShowFixity','Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'('Flat.InfixOp',[]),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(73)),'Comb'('ConsCall','.',['Lit'('Charc'(110)),'Comb'('ConsCall','.',['Lit'('Charc'(102)),'Comb'('ConsCall','.',['Lit'('Charc'(105)),'Comb'('ConsCall','.',['Lit'('Charc'(120)),'Comb'('ConsCall','.',['Lit'('Charc'(79)),'Comb'('ConsCall','.',['Lit'('Charc'(112)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])])])])])])])])])])),'Branch'('Pattern'('Flat.InfixlOp',[]),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(73)),'Comb'('ConsCall','.',['Lit'('Charc'(110)),'Comb'('ConsCall','.',['Lit'('Charc'(102)),'Comb'('ConsCall','.',['Lit'('Charc'(105)),'Comb'('ConsCall','.',['Lit'('Charc'(120)),'Comb'('ConsCall','.',['Lit'('Charc'(108)),'Comb'('ConsCall','.',['Lit'('Charc'(79)),'Comb'('ConsCall','.',['Lit'('Charc'(112)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])])])])])])])])])])])),'Branch'('Pattern'('Flat.InfixrOp',[]),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(73)),'Comb'('ConsCall','.',['Lit'('Charc'(110)),'Comb'('ConsCall','.',['Lit'('Charc'(102)),'Comb'('ConsCall','.',['Lit'('Charc'(105)),'Comb'('ConsCall','.',['Lit'('Charc'(120)),'Comb'('ConsCall','.',['Lit'('Charc'(114)),'Comb'('ConsCall','.',['Lit'('Charc'(79)),'Comb'('ConsCall','.',['Lit'('Charc'(112)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])])])])])])])])])])]))]))).
evaluation('FlatTools.flatShowOp','Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'('Flat.Op',[1,2,3]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(40)),'Comb'('ConsCall','.',['Lit'('Charc'(79)),'Comb'('ConsCall','.',['Lit'('Charc'(112)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flatShowString',['Var'(1)]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flatShowFixity',['Var'(2)]),'Comb'('FuncCall',++,['Comb'('FuncCall',show,['Var'(3)]),'Comb'('ConsCall','.',['Lit'('Charc'(41)),'Comb'('ConsCall',[],[])])])])])]))]))).
evaluation('FlatTools.flatShowType','Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'('Flat.Type',[1,2,3]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(10)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(40)),'Comb'('ConsCall','.',['Lit'('Charc'(84)),'Comb'('ConsCall','.',['Lit'('Charc'(121)),'Comb'('ConsCall','.',['Lit'('Charc'(112)),'Comb'('ConsCall','.',['Lit'('Charc'(101)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])])])])])])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flatShowString',['Var'(1)]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flatShowList',['Comb'('PartCall',show,[]),'Var'(2)]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flatShowList',['Comb'('PartCall','FlatTools.flatShowCons',[]),'Var'(3)]),'Comb'('ConsCall','.',['Lit'('Charc'(41)),'Comb'('ConsCall',[],[])])])])])]))]))).
evaluation('FlatTools.flatShowCons','Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'('Flat.Cons',[1,2,3]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(40)),'Comb'('ConsCall','.',['Lit'('Charc'(67)),'Comb'('ConsCall','.',['Lit'('Charc'(111)),'Comb'('ConsCall','.',['Lit'('Charc'(110)),'Comb'('ConsCall','.',['Lit'('Charc'(115)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])])])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flatShowString',['Var'(1)]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall',++,['Comb'('FuncCall',show,['Var'(2)]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flatShowList',['Comb'('PartCall','FlatTools.flatShowTypeExpr',[]),'Var'(3)]),'Comb'('ConsCall','.',['Lit'('Charc'(41)),'Comb'('ConsCall',[],[])])])])])])]))]))).
evaluation('FlatTools.flatShowFunc','Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'('Flat.Func',[1,2,3,4]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(10)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(40)),'Comb'('ConsCall','.',['Lit'('Charc'(70)),'Comb'('ConsCall','.',['Lit'('Charc'(117)),'Comb'('ConsCall','.',['Lit'('Charc'(110)),'Comb'('ConsCall','.',['Lit'('Charc'(99)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])])])])])])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flatShowString',['Var'(1)]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall',++,['Comb'('FuncCall',show,['Var'(2)]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flatShowTypeExpr',['Var'(3)]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flatShowRule',['Var'(4)]),'Comb'('ConsCall','.',['Lit'('Charc'(41)),'Comb'('ConsCall',[],[])])])])])])])])]))]))).
evaluation('FlatTools.flatShowRule','Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'('Flat.Rule',[1,2]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(40)),'Comb'('ConsCall','.',['Lit'('Charc'(82)),'Comb'('ConsCall','.',['Lit'('Charc'(117)),'Comb'('ConsCall','.',['Lit'('Charc'(108)),'Comb'('ConsCall','.',['Lit'('Charc'(101)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])])])])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flatShowList',['Comb'('PartCall',show,[]),'Var'(1)]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flatShowExpr',['Var'(2)]),'Comb'('ConsCall','.',['Lit'('Charc'(41)),'Comb'('ConsCall',[],[])])])])])),'Branch'('Pattern'('Flat.External',[3]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(40)),'Comb'('ConsCall','.',['Lit'('Charc'(69)),'Comb'('ConsCall','.',['Lit'('Charc'(120)),'Comb'('ConsCall','.',['Lit'('Charc'(116)),'Comb'('ConsCall','.',['Lit'('Charc'(101)),'Comb'('ConsCall','.',['Lit'('Charc'(114)),'Comb'('ConsCall','.',['Lit'('Charc'(110)),'Comb'('ConsCall','.',['Lit'('Charc'(97)),'Comb'('ConsCall','.',['Lit'('Charc'(108)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])])])])])])])])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flatShowString',['Var'(3)]),'Comb'('ConsCall','.',['Lit'('Charc'(41)),'Comb'('ConsCall',[],[])])])]))]))).
evaluation('FlatTools.flatShowTypeExpr','Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'('Flat.FuncType',[1,2]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(40)),'Comb'('ConsCall','.',['Lit'('Charc'(70)),'Comb'('ConsCall','.',['Lit'('Charc'(117)),'Comb'('ConsCall','.',['Lit'('Charc'(110)),'Comb'('ConsCall','.',['Lit'('Charc'(99)),'Comb'('ConsCall','.',['Lit'('Charc'(84)),'Comb'('ConsCall','.',['Lit'('Charc'(121)),'Comb'('ConsCall','.',['Lit'('Charc'(112)),'Comb'('ConsCall','.',['Lit'('Charc'(101)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])])])])])])])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flatShowTypeExpr',['Var'(1)]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flatShowTypeExpr',['Var'(2)]),'Comb'('ConsCall','.',['Lit'('Charc'(41)),'Comb'('ConsCall',[],[])])])])])])),'Branch'('Pattern'('Flat.TCons',[3,4]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(40)),'Comb'('ConsCall','.',['Lit'('Charc'(84)),'Comb'('ConsCall','.',['Lit'('Charc'(67)),'Comb'('ConsCall','.',['Lit'('Charc'(111)),'Comb'('ConsCall','.',['Lit'('Charc'(110)),'Comb'('ConsCall','.',['Lit'('Charc'(115)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])])])])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flatShowString',['Var'(3)]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flatShowList',['Comb'('PartCall','FlatTools.flatShowTypeExpr',[]),'Var'(4)]),'Comb'('ConsCall','.',['Lit'('Charc'(41)),'Comb'('ConsCall',[],[])])])])])),'Branch'('Pattern'('Flat.TVar',[5]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(40)),'Comb'('ConsCall','.',['Lit'('Charc'(84)),'Comb'('ConsCall','.',['Lit'('Charc'(86)),'Comb'('ConsCall','.',['Lit'('Charc'(97)),'Comb'('ConsCall','.',['Lit'('Charc'(114)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])])])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall',show,['Var'(5)]),'Comb'('ConsCall','.',['Lit'('Charc'(41)),'Comb'('ConsCall',[],[])])])]))]))).
evaluation('FlatTools.flatShowExpr','Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'('Flat.Var',[1]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(40)),'Comb'('ConsCall','.',['Lit'('Charc'(86)),'Comb'('ConsCall','.',['Lit'('Charc'(97)),'Comb'('ConsCall','.',['Lit'('Charc'(114)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall',show,['Var'(1)]),'Comb'('ConsCall','.',['Lit'('Charc'(41)),'Comb'('ConsCall',[],[])])])])),'Branch'('Pattern'('Flat.Lit',[2]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(40)),'Comb'('ConsCall','.',['Lit'('Charc'(76)),'Comb'('ConsCall','.',['Lit'('Charc'(105)),'Comb'('ConsCall','.',['Lit'('Charc'(116)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flatShowLit',['Var'(2)]),'Comb'('ConsCall','.',['Lit'('Charc'(41)),'Comb'('ConsCall',[],[])])])])),'Branch'('Pattern'('Flat.Comb',[3,4,5]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(40)),'Comb'('ConsCall','.',['Lit'('Charc'(67)),'Comb'('ConsCall','.',['Lit'('Charc'(111)),'Comb'('ConsCall','.',['Lit'('Charc'(109)),'Comb'('ConsCall','.',['Lit'('Charc'(98)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])])])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall',show,['Var'(3)]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flatShowString',['Var'(4)]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flatShowList',['Comb'('PartCall','FlatTools.flatShowExpr',[]),'Var'(5)]),'Comb'('ConsCall','.',['Lit'('Charc'(41)),'Comb'('ConsCall',[],[])])])])])])])),'Branch'('Pattern'('Flat.Apply',[6,7]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(40)),'Comb'('ConsCall','.',['Lit'('Charc'(65)),'Comb'('ConsCall','.',['Lit'('Charc'(112)),'Comb'('ConsCall','.',['Lit'('Charc'(112)),'Comb'('ConsCall','.',['Lit'('Charc'(108)),'Comb'('ConsCall','.',['Lit'('Charc'(121)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])])])])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flatShowExpr',['Var'(6)]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flatShowExpr',['Var'(7)]),'Comb'('ConsCall','.',['Lit'('Charc'(41)),'Comb'('ConsCall',[],[])])])])])])),'Branch'('Pattern'('Flat.Constr',[8,9]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(40)),'Comb'('ConsCall','.',['Lit'('Charc'(67)),'Comb'('ConsCall','.',['Lit'('Charc'(111)),'Comb'('ConsCall','.',['Lit'('Charc'(110)),'Comb'('ConsCall','.',['Lit'('Charc'(115)),'Comb'('ConsCall','.',['Lit'('Charc'(116)),'Comb'('ConsCall','.',['Lit'('Charc'(114)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])])])])])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flatShowList',['Comb'('PartCall',show,[]),'Var'(8)]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flatShowExpr',['Var'(9)]),'Comb'('ConsCall','.',['Lit'('Charc'(41)),'Comb'('ConsCall',[],[])])])])])),'Branch'('Pattern'('Flat.Or',[10,11]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(40)),'Comb'('ConsCall','.',['Lit'('Charc'(79)),'Comb'('ConsCall','.',['Lit'('Charc'(114)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flatShowExpr',['Var'(10)]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flatShowExpr',['Var'(11)]),'Comb'('ConsCall','.',['Lit'('Charc'(41)),'Comb'('ConsCall',[],[])])])])])])),'Branch'('Pattern'('Flat.Case',[12,13,14]),'Case'('Flex','Var'(12),['Branch'('Pattern'('Flat.Rigid',[]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(40)),'Comb'('ConsCall','.',['Lit'('Charc'(67)),'Comb'('ConsCall','.',['Lit'('Charc'(97)),'Comb'('ConsCall','.',['Lit'('Charc'(115)),'Comb'('ConsCall','.',['Lit'('Charc'(101)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(82)),'Comb'('ConsCall','.',['Lit'('Charc'(105)),'Comb'('ConsCall','.',['Lit'('Charc'(103)),'Comb'('ConsCall','.',['Lit'('Charc'(105)),'Comb'('ConsCall','.',['Lit'('Charc'(100)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])])])])])])])])])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flatShowExpr',['Var'(13)]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flatShowList',['Comb'('PartCall','FlatTools.flatShowBranch',[]),'Var'(14)]),'Comb'('ConsCall','.',['Lit'('Charc'(41)),'Comb'('ConsCall',[],[])])])])])),'Branch'('Pattern'('Flat.Flex',[]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(40)),'Comb'('ConsCall','.',['Lit'('Charc'(67)),'Comb'('ConsCall','.',['Lit'('Charc'(97)),'Comb'('ConsCall','.',['Lit'('Charc'(115)),'Comb'('ConsCall','.',['Lit'('Charc'(101)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(70)),'Comb'('ConsCall','.',['Lit'('Charc'(108)),'Comb'('ConsCall','.',['Lit'('Charc'(101)),'Comb'('ConsCall','.',['Lit'('Charc'(120)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])])])])])])])])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flatShowExpr',['Var'(13)]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flatShowList',['Comb'('PartCall','FlatTools.flatShowBranch',[]),'Var'(14)]),'Comb'('ConsCall','.',['Lit'('Charc'(41)),'Comb'('ConsCall',[],[])])])])]))])),'Branch'('Pattern'('Flat.GuardedExpr',[15,16,17]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(40)),'Comb'('ConsCall','.',['Lit'('Charc'(71)),'Comb'('ConsCall','.',['Lit'('Charc'(117)),'Comb'('ConsCall','.',['Lit'('Charc'(97)),'Comb'('ConsCall','.',['Lit'('Charc'(114)),'Comb'('ConsCall','.',['Lit'('Charc'(100)),'Comb'('ConsCall','.',['Lit'('Charc'(101)),'Comb'('ConsCall','.',['Lit'('Charc'(100)),'Comb'('ConsCall','.',['Lit'('Charc'(69)),'Comb'('ConsCall','.',['Lit'('Charc'(120)),'Comb'('ConsCall','.',['Lit'('Charc'(112)),'Comb'('ConsCall','.',['Lit'('Charc'(114)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])])])])])])])])])])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flatShowList',['Comb'('PartCall',show,[]),'Var'(15)]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flatShowExpr',['Var'(16)]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flatShowExpr',['Var'(17)]),'Comb'('ConsCall','.',['Lit'('Charc'(41)),'Comb'('ConsCall',[],[])])])])])])])),'Branch'('Pattern'('Flat.Choice',[18]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(40)),'Comb'('ConsCall','.',['Lit'('Charc'(67)),'Comb'('ConsCall','.',['Lit'('Charc'(104)),'Comb'('ConsCall','.',['Lit'('Charc'(111)),'Comb'('ConsCall','.',['Lit'('Charc'(105)),'Comb'('ConsCall','.',['Lit'('Charc'(99)),'Comb'('ConsCall','.',['Lit'('Charc'(101)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])])])])])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flatShowExpr',['Var'(18)]),'Comb'('ConsCall','.',['Lit'('Charc'(41)),'Comb'('ConsCall',[],[])])])]))]))).
evaluation('FlatTools.flatShowLit','Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'('Flat.Intc',[1]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(40)),'Comb'('ConsCall','.',['Lit'('Charc'(73)),'Comb'('ConsCall','.',['Lit'('Charc'(110)),'Comb'('ConsCall','.',['Lit'('Charc'(116)),'Comb'('ConsCall','.',['Lit'('Charc'(99)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])])])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall',show,['Var'(1)]),'Comb'('ConsCall','.',['Lit'('Charc'(41)),'Comb'('ConsCall',[],[])])])])),'Branch'('Pattern'('Flat.Floatc',[2]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(40)),'Comb'('ConsCall','.',['Lit'('Charc'(70)),'Comb'('ConsCall','.',['Lit'('Charc'(108)),'Comb'('ConsCall','.',['Lit'('Charc'(111)),'Comb'('ConsCall','.',['Lit'('Charc'(97)),'Comb'('ConsCall','.',['Lit'('Charc'(116)),'Comb'('ConsCall','.',['Lit'('Charc'(99)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])])])])])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall',show,['Var'(2)]),'Comb'('ConsCall','.',['Lit'('Charc'(41)),'Comb'('ConsCall',[],[])])])])),'Branch'('Pattern'('Flat.Charc',[3]),'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',&&,['Comb'('FuncCall',>=,['Comb'('FuncCall',ord,['Var'(3)]),'Lit'('Intc'(32))]),'Comb'('FuncCall',<,['Comb'('FuncCall',ord,['Var'(3)]),'Lit'('Intc'(127))])]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(40)),'Comb'('ConsCall','.',['Lit'('Charc'(67)),'Comb'('ConsCall','.',['Lit'('Charc'(104)),'Comb'('ConsCall','.',['Lit'('Charc'(97)),'Comb'('ConsCall','.',['Lit'('Charc'(114)),'Comb'('ConsCall','.',['Lit'('Charc'(99)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(39)),'Comb'('ConsCall',[],[])])])])])])])])]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Var'(3),'Comb'('ConsCall',[],[])]),'Comb'('ConsCall','.',['Lit'('Charc'(39)),'Comb'('ConsCall','.',['Lit'('Charc'(41)),'Comb'('ConsCall',[],[])])])])]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(40)),'Comb'('ConsCall','.',['Lit'('Charc'(67)),'Comb'('ConsCall','.',['Lit'('Charc'(104)),'Comb'('ConsCall','.',['Lit'('Charc'(97)),'Comb'('ConsCall','.',['Lit'('Charc'(114)),'Comb'('ConsCall','.',['Lit'('Charc'(99)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(40)),'Comb'('ConsCall','.',['Lit'('Charc'(99)),'Comb'('ConsCall','.',['Lit'('Charc'(104)),'Comb'('ConsCall','.',['Lit'('Charc'(114)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])])])])])])])])])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall',show,['Comb'('FuncCall',ord,['Var'(3)])]),'Comb'('ConsCall','.',['Lit'('Charc'(41)),'Comb'('ConsCall','.',['Lit'('Charc'(41)),'Comb'('ConsCall',[],[])])])])])]))]))).
evaluation('FlatTools.flatShowBranch','Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'('Flat.Branch',[1,2]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(40)),'Comb'('ConsCall','.',['Lit'('Charc'(66)),'Comb'('ConsCall','.',['Lit'('Charc'(114)),'Comb'('ConsCall','.',['Lit'('Charc'(97)),'Comb'('ConsCall','.',['Lit'('Charc'(110)),'Comb'('ConsCall','.',['Lit'('Charc'(99)),'Comb'('ConsCall','.',['Lit'('Charc'(104)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])])])])])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flatShowPattern',['Var'(1)]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flatShowExpr',['Var'(2)]),'Comb'('ConsCall','.',['Lit'('Charc'(41)),'Comb'('ConsCall',[],[])])])])]))]))).
evaluation('FlatTools.flatShowPattern','Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'('Flat.Pattern',[1,2]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(40)),'Comb'('ConsCall','.',['Lit'('Charc'(80)),'Comb'('ConsCall','.',['Lit'('Charc'(97)),'Comb'('ConsCall','.',['Lit'('Charc'(116)),'Comb'('ConsCall','.',['Lit'('Charc'(116)),'Comb'('ConsCall','.',['Lit'('Charc'(101)),'Comb'('ConsCall','.',['Lit'('Charc'(114)),'Comb'('ConsCall','.',['Lit'('Charc'(110)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])])])])])])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flatShowString',['Var'(1)]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flatShowList',['Comb'('PartCall',show,[]),'Var'(2)]),'Comb'('ConsCall','.',['Lit'('Charc'(41)),'Comb'('ConsCall',[],[])])])])])),'Branch'('Pattern'('Flat.LPattern',[3]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(40)),'Comb'('ConsCall','.',['Lit'('Charc'(76)),'Comb'('ConsCall','.',['Lit'('Charc'(80)),'Comb'('ConsCall','.',['Lit'('Charc'(97)),'Comb'('ConsCall','.',['Lit'('Charc'(116)),'Comb'('ConsCall','.',['Lit'('Charc'(116)),'Comb'('ConsCall','.',['Lit'('Charc'(101)),'Comb'('ConsCall','.',['Lit'('Charc'(114)),'Comb'('ConsCall','.',['Lit'('Charc'(110)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])])])])])])])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flatShowLit',['Var'(3)]),'Comb'('ConsCall','.',['Lit'('Charc'(41)),'Comb'('ConsCall',[],[])])])]))]))).
evaluation('FlatTools.flatShowTrans','Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'('Flat.Trans',[1,2]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(10)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(40)),'Comb'('ConsCall','.',['Lit'('Charc'(84)),'Comb'('ConsCall','.',['Lit'('Charc'(114)),'Comb'('ConsCall','.',['Lit'('Charc'(97)),'Comb'('ConsCall','.',['Lit'('Charc'(110)),'Comb'('ConsCall','.',['Lit'('Charc'(115)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])])])])])])])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flatShowString',['Var'(1)]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flatShowString',['Var'(2)]),'Comb'('ConsCall','.',['Lit'('Charc'(41)),'Comb'('ConsCall',[],[])])])])])]))]))).
evaluation('FlatTools.flatShowList','Rule'([0,1],'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(91)),'Comb'('ConsCall',[],[])])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flatShowListElems',['Var'(0),'Var'(1)]),'Comb'('ConsCall','.',['Lit'('Charc'(93)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])])])])]))).
evaluation('FlatTools.flatShowListElems','Rule'([0,1],'Comb'('FuncCall',concat,['Comb'('FuncCall','List.intersperse',['Comb'('ConsCall','.',['Lit'('Charc'(44)),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall',map,['Var'(0),'Var'(1)])])]))).
evaluation('FlatTools.flatShowString','Rule'([0],'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(34)),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall',++,['Var'(0),'Comb'('ConsCall','.',['Lit'('Charc'(34)),'Comb'('ConsCall',[],[])])])]))).
evaluation('FlatTools.showCurryType','Rule'([0,1,2],'Case'('Flex','Var'(2),['Branch'('Pattern'('Flat.TVar',[3]),'Comb'('ConsCall','.',['Comb'('FuncCall',chr,['Comb'('FuncCall',+,['Lit'('Intc'(97)),'Var'(3)])]),'Comb'('ConsCall',[],[])])),'Branch'('Pattern'('Flat.FuncType',[4,5]),'Comb'('FuncCall',++,['Comb'('FuncCall',if_then_else,['Var'(1),'Comb'('ConsCall','.',['Lit'('Charc'(40)),'Comb'('ConsCall',[],[])]),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.showCurryType',['Var'(0),'Comb'('FuncCall','FlatTools.isFuncType',['Var'(4)]),'Var'(4)]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(45)),'Comb'('ConsCall','.',['Lit'('Charc'(62)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.showCurryType',['Var'(0),'Comb'('ConsCall','False',[]),'Var'(5)]),'Comb'('FuncCall',if_then_else,['Var'(1),'Comb'('ConsCall','.',['Lit'('Charc'(41)),'Comb'('ConsCall',[],[])]),'Comb'('ConsCall',[],[])])])])])])),'Branch'('Pattern'('Flat.TCons',[6,7]),'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',==,['Var'(7),'Comb'('ConsCall',[],[])]),'Apply'('Var'(0),'Var'(6)),'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',&&,['Comb'('FuncCall',==,['Var'(6),'Comb'('ConsCall','.',['Lit'('Charc'(91)),'Comb'('ConsCall','.',['Lit'('Charc'(93)),'Comb'('ConsCall',[],[])])])]),'Comb'('FuncCall',==,['Comb'('FuncCall',head,['Var'(7)]),'Comb'('ConsCall','Flat.TCons',['Comb'('ConsCall','.',['Lit'('Charc'(67)),'Comb'('ConsCall','.',['Lit'('Charc'(104)),'Comb'('ConsCall','.',['Lit'('Charc'(97)),'Comb'('ConsCall','.',['Lit'('Charc'(114)),'Comb'('ConsCall',[],[])])])])]),'Comb'('ConsCall',[],[])])])]),'Comb'('ConsCall','.',['Lit'('Charc'(83)),'Comb'('ConsCall','.',['Lit'('Charc'(116)),'Comb'('ConsCall','.',['Lit'('Charc'(114)),'Comb'('ConsCall','.',['Lit'('Charc'(105)),'Comb'('ConsCall','.',['Lit'('Charc'(110)),'Comb'('ConsCall','.',['Lit'('Charc'(103)),'Comb'('ConsCall',[],[])])])])])])]),'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',==,['Var'(6),'Comb'('ConsCall','.',['Lit'('Charc'(91)),'Comb'('ConsCall','.',['Lit'('Charc'(93)),'Comb'('ConsCall',[],[])])])]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(91)),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.showCurryType',['Var'(0),'Comb'('ConsCall','False',[]),'Comb'('FuncCall',head,['Var'(7)])]),'Comb'('ConsCall','.',['Lit'('Charc'(93)),'Comb'('ConsCall',[],[])])])]),'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',==,['Comb'('FuncCall',take,['Lit'('Intc'(2)),'Var'(6)]),'Comb'('ConsCall','.',['Lit'('Charc'(40)),'Comb'('ConsCall','.',['Lit'('Charc'(44)),'Comb'('ConsCall',[],[])])])]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(40)),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall',++,['Comb'('FuncCall',concat,['Comb'('FuncCall','List.intersperse',['Comb'('ConsCall','.',['Lit'('Charc'(44)),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall',map,['Comb'('PartCall','FlatTools.showCurryType',['Var'(0),'Comb'('ConsCall','False',[])]),'Var'(7)])])]),'Comb'('ConsCall','.',['Lit'('Charc'(41)),'Comb'('ConsCall',[],[])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall',if_then_else,['Var'(1),'Comb'('ConsCall','.',['Lit'('Charc'(40)),'Comb'('ConsCall',[],[])]),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall',++,['Apply'('Var'(0),'Var'(6)),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall',++,['Comb'('FuncCall',concat,['Comb'('FuncCall','List.intersperse',['Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall',map,['Comb'('PartCall','FlatTools.showCurryType',['Var'(0),'Comb'('ConsCall','True',[])]),'Var'(7)])])]),'Comb'('FuncCall',if_then_else,['Var'(1),'Comb'('ConsCall','.',['Lit'('Charc'(41)),'Comb'('ConsCall',[],[])]),'Comb'('ConsCall',[],[])])])])])])])])])]))]))).
evaluation('FlatTools.isFuncType','Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'('Flat.TVar',[1]),'Comb'('ConsCall','False',[])),'Branch'('Pattern'('Flat.FuncType',[2,3]),'Comb'('ConsCall','True',[])),'Branch'('Pattern'('Flat.TCons',[4,5]),'Comb'('ConsCall','False',[]))]))).
evaluation('FlatTools.showCurryExpr','Rule'([0,1,2,3],'Case'('Flex','Var'(3),['Branch'('Pattern'('Flat.Var',[4]),'Comb'('FuncCall','FlatTools.showCurryVar',['Var'(4)])),'Branch'('Pattern'('Flat.Lit',[5]),'Comb'('FuncCall','FlatTools.showCurryLit',['Var'(5)])),'Branch'('Pattern'('Flat.Comb',[6,7,8]),'Case'('Flex','Var'(8),['Branch'('Pattern'([],[]),'Apply'('Var'(0),'Var'(7))),'Branch'('Pattern'('.',[9,10]),'Case'('Flex','Var'(10),['Branch'('Pattern'([],[]),'Comb'('FuncCall','FlatTools.maybeShowBrackets',['Var'(1),'Comb'('FuncCall',++,['Apply'('Var'(0),'Var'(7)),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall','FlatTools.showCurryExpr',['Var'(0),'Comb'('ConsCall','True',[]),'Var'(2),'Var'(9)])])])])),'Branch'('Pattern'('.',[11,12]),'Case'('Flex','Var'(12),['Branch'('Pattern'([],[]),'Comb'('FuncCall',if_then_else,['Comb'('FuncCall','Char.isAlpha',['Comb'('FuncCall',head,['Apply'('Var'(0),'Var'(7))])]),'Comb'('FuncCall','FlatTools.maybeShowBrackets',['Var'(1),'Comb'('FuncCall',++,['Apply'('Var'(0),'Var'(7)),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall','FlatTools.showCurryElems',['Comb'('PartCall','FlatTools.showCurryExpr',['Var'(0),'Comb'('ConsCall','True',[]),'Var'(2)]),'Comb'('ConsCall','.',['Var'(9),'Comb'('ConsCall','.',['Var'(11),'Comb'('ConsCall',[],[])])])])])])]),'Comb'('FuncCall',if_then_else,['Comb'('FuncCall','FlatTools.isFiniteList',['Comb'('ConsCall','Flat.Comb',['Var'(6),'Var'(7),'Comb'('ConsCall','.',['Var'(9),'Comb'('ConsCall','.',['Var'(11),'Comb'('ConsCall',[],[])])])])]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(91)),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall',++,['Comb'('FuncCall',concat,['Comb'('FuncCall','List.intersperse',['Comb'('ConsCall','.',['Lit'('Charc'(44)),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall','FlatTools.showCurryFiniteList',['Var'(0),'Var'(2),'Comb'('ConsCall','Flat.Comb',['Var'(6),'Var'(7),'Comb'('ConsCall','.',['Var'(9),'Comb'('ConsCall','.',['Var'(11),'Comb'('ConsCall',[],[])])])])])])]),'Comb'('ConsCall','.',['Lit'('Charc'(93)),'Comb'('ConsCall',[],[])])])]),'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',==,['Var'(7),'Comb'('ConsCall','.',['Lit'('Charc'(40)),'Comb'('ConsCall','.',['Lit'('Charc'(44)),'Comb'('ConsCall','.',['Lit'('Charc'(41)),'Comb'('ConsCall',[],[])])])])]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(40)),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.showCurryExpr',['Var'(0),'Comb'('ConsCall','False',[]),'Var'(2),'Var'(9)]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(44)),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.showCurryExpr',['Var'(0),'Comb'('ConsCall','False',[]),'Var'(2),'Var'(11)]),'Comb'('ConsCall','.',['Lit'('Charc'(41)),'Comb'('ConsCall',[],[])])])])])]),'Comb'('FuncCall','FlatTools.maybeShowBrackets',['Var'(1),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.showCurryExpr',['Var'(0),'Comb'('ConsCall','True',[]),'Var'(2),'Var'(9)]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall',++,['Apply'('Var'(0),'Var'(7)),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall','FlatTools.showCurryExpr',['Var'(0),'Comb'('ConsCall','True',[]),'Var'(2),'Var'(11)])])])])])])])])])),'Branch'('Pattern'('.',[13,14]),'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',&&,['Comb'('FuncCall',==,['Var'(7),'Comb'('ConsCall','.',['Lit'('Charc'(105)),'Comb'('ConsCall','.',['Lit'('Charc'(102)),'Comb'('ConsCall','.',['Lit'('Charc'(95)),'Comb'('ConsCall','.',['Lit'('Charc'(116)),'Comb'('ConsCall','.',['Lit'('Charc'(104)),'Comb'('ConsCall','.',['Lit'('Charc'(101)),'Comb'('ConsCall','.',['Lit'('Charc'(110)),'Comb'('ConsCall','.',['Lit'('Charc'(95)),'Comb'('ConsCall','.',['Lit'('Charc'(101)),'Comb'('ConsCall','.',['Lit'('Charc'(108)),'Comb'('ConsCall','.',['Lit'('Charc'(115)),'Comb'('ConsCall','.',['Lit'('Charc'(101)),'Comb'('ConsCall',[],[])])])])])])])])])])])])])]),'Comb'('FuncCall',==,['Var'(14),'Comb'('ConsCall',[],[])])]),'Comb'('FuncCall','FlatTools.maybeShowBrackets',['Var'(1),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(10)),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.sceBlanks',['Var'(2)]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(105)),'Comb'('ConsCall','.',['Lit'('Charc'(102)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.showCurryExpr',['Var'(0),'Comb'('ConsCall','False',[]),'Comb'('FuncCall',+,['Var'(2),'Lit'('Intc'(2))]),'Var'(9)]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(10)),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.sceBlanks',['Var'(2)]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(116)),'Comb'('ConsCall','.',['Lit'('Charc'(104)),'Comb'('ConsCall','.',['Lit'('Charc'(101)),'Comb'('ConsCall','.',['Lit'('Charc'(110)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])])])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.showCurryExpr',['Var'(0),'Comb'('ConsCall','False',[]),'Comb'('FuncCall',+,['Var'(2),'Lit'('Intc'(2))]),'Var'(11)]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(10)),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.sceBlanks',['Var'(2)]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(101)),'Comb'('ConsCall','.',['Lit'('Charc'(108)),'Comb'('ConsCall','.',['Lit'('Charc'(115)),'Comb'('ConsCall','.',['Lit'('Charc'(101)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])])])])])])]),'Comb'('FuncCall','FlatTools.showCurryExpr',['Var'(0),'Comb'('ConsCall','False',[]),'Comb'('FuncCall',+,['Var'(2),'Lit'('Intc'(2))]),'Var'(13)])])])])])])])])])])])])]),'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',==,['Comb'('FuncCall',take,['Lit'('Intc'(2)),'Var'(7)]),'Comb'('ConsCall','.',['Lit'('Charc'(40)),'Comb'('ConsCall','.',['Lit'('Charc'(44)),'Comb'('ConsCall',[],[])])])]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(40)),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall',++,['Comb'('FuncCall',concat,['Comb'('FuncCall','List.intersperse',['Comb'('ConsCall','.',['Lit'('Charc'(44)),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall',map,['Comb'('PartCall','FlatTools.showCurryExpr',['Var'(0),'Comb'('ConsCall','False',[]),'Var'(2)]),'Comb'('ConsCall','.',['Var'(9),'Comb'('ConsCall','.',['Var'(11),'Comb'('ConsCall','.',['Var'(13),'Var'(14)])])])])])]),'Comb'('ConsCall','.',['Lit'('Charc'(41)),'Comb'('ConsCall',[],[])])])]),'Comb'('FuncCall','FlatTools.maybeShowBrackets',['Var'(1),'Comb'('FuncCall',++,['Apply'('Var'(0),'Var'(7)),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall','FlatTools.showCurryElems',['Comb'('PartCall','FlatTools.showCurryExpr',['Var'(0),'Comb'('ConsCall','True',[]),'Var'(2)]),'Comb'('ConsCall','.',['Var'(9),'Comb'('ConsCall','.',['Var'(11),'Comb'('ConsCall','.',['Var'(13),'Var'(14)])])])])])])])])]))]))]))])),'Branch'('Pattern'('Flat.Apply',[15,16]),'Comb'('FuncCall','FlatTools.maybeShowBrackets',['Var'(1),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.showCurryExpr',['Var'(0),'Comb'('ConsCall','True',[]),'Var'(2),'Var'(15)]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall','FlatTools.showCurryExpr',['Var'(0),'Comb'('ConsCall','True',[]),'Var'(2),'Var'(16)])])])])),'Branch'('Pattern'('Flat.Constr',[17,18]),'Case'('Flex','Var'(17),['Branch'('Pattern'([],[]),'Comb'('FuncCall','FlatTools.showCurryExpr',['Var'(0),'Var'(1),'Var'(2),'Var'(18)])),'Branch'('Pattern'('.',[19,20]),'Comb'('FuncCall','FlatTools.maybeShowBrackets',['Var'(1),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(108)),'Comb'('ConsCall','.',['Lit'('Charc'(101)),'Comb'('ConsCall','.',['Lit'('Charc'(116)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall',concat,['Comb'('FuncCall','List.intersperse',['Comb'('ConsCall','.',['Lit'('Charc'(44)),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall',map,['Comb'('PartCall','FlatTools.showCurryVar',[]),'Comb'('ConsCall','.',['Var'(19),'Var'(20)])])])]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(102)),'Comb'('ConsCall','.',['Lit'('Charc'(114)),'Comb'('ConsCall','.',['Lit'('Charc'(101)),'Comb'('ConsCall','.',['Lit'('Charc'(101)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(105)),'Comb'('ConsCall','.',['Lit'('Charc'(110)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])])])])])])])])])]),'Comb'('FuncCall','FlatTools.showCurryExpr',['Var'(0),'Comb'('ConsCall','False',[]),'Var'(2),'Var'(18)])])])])]))])),'Branch'('Pattern'('Flat.Or',[21,22]),'Comb'('FuncCall','FlatTools.maybeShowBrackets',['Var'(1),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.showCurryExpr',['Var'(0),'Comb'('ConsCall','True',[]),'Var'(2),'Var'(21)]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(33)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])])])]),'Comb'('FuncCall','FlatTools.showCurryExpr',['Var'(0),'Comb'('ConsCall','True',[]),'Var'(2),'Var'(22)])])])])),'Branch'('Pattern'('Flat.Case',[23,24,25]),'Comb'('FuncCall','FlatTools.maybeShowBrackets',['Var'(1),'Comb'('FuncCall',++,['Comb'('FuncCall',if_then_else,['Comb'('FuncCall',==,['Var'(23),'Comb'('ConsCall','Flat.Rigid',[])]),'Comb'('ConsCall','.',['Lit'('Charc'(99)),'Comb'('ConsCall','.',['Lit'('Charc'(97)),'Comb'('ConsCall','.',['Lit'('Charc'(115)),'Comb'('ConsCall','.',['Lit'('Charc'(101)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])])])])])]),'Comb'('ConsCall','.',['Lit'('Charc'(102)),'Comb'('ConsCall','.',['Lit'('Charc'(99)),'Comb'('ConsCall','.',['Lit'('Charc'(97)),'Comb'('ConsCall','.',['Lit'('Charc'(115)),'Comb'('ConsCall','.',['Lit'('Charc'(101)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])])])])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.showCurryExpr',['Var'(0),'Comb'('ConsCall','True',[]),'Var'(2),'Var'(24)]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(111)),'Comb'('ConsCall','.',['Lit'('Charc'(102)),'Comb'('ConsCall','.',['Lit'('Charc'(10)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.showCurryElems',['Comb'('PartCall','FlatTools.showCurryCase',['Var'(0),'Comb'('FuncCall',+,['Var'(2),'Lit'('Intc'(2))])]),'Var'(25)]),'Comb'('FuncCall','FlatTools.sceBlanks',['Var'(2)])])])])])])),'Branch'('Pattern'('Flat.GuardedExpr',[26,27,28]),'Case'('Flex','Var'(26),['Branch'('Pattern'([],[]),'Comb'('FuncCall','FlatTools.maybeShowBrackets',['Var'(1),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.showCurryExpr',['Var'(0),'Comb'('ConsCall','False',[]),'Var'(2),'Var'(27)]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(61)),'Comb'('ConsCall','.',['Lit'('Charc'(62)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])])])])]),'Comb'('FuncCall','FlatTools.showCurryExpr',['Var'(0),'Comb'('ConsCall','False',[]),'Var'(2),'Var'(28)])])])])),'Branch'('Pattern'('.',[29,30]),'Comb'('FuncCall','FlatTools.maybeShowBrackets',['Var'(1),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.showCurryExpr',['Var'(0),'Comb'('ConsCall','False',[]),'Var'(2),'Var'(27)]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(61)),'Comb'('ConsCall','.',['Lit'('Charc'(62)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.showCurryExpr',['Var'(0),'Comb'('ConsCall','False',[]),'Var'(2),'Var'(28)]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(119)),'Comb'('ConsCall','.',['Lit'('Charc'(104)),'Comb'('ConsCall','.',['Lit'('Charc'(101)),'Comb'('ConsCall','.',['Lit'('Charc'(114)),'Comb'('ConsCall','.',['Lit'('Charc'(101)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])])])])])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall',concat,['Comb'('FuncCall','List.intersperse',['Comb'('ConsCall','.',['Lit'('Charc'(44)),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall',map,['Comb'('PartCall','FlatTools.showCurryVar',[]),'Comb'('ConsCall','.',['Var'(29),'Var'(30)])])])]),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(102)),'Comb'('ConsCall','.',['Lit'('Charc'(114)),'Comb'('ConsCall','.',['Lit'('Charc'(101)),'Comb'('ConsCall','.',['Lit'('Charc'(101)),'Comb'('ConsCall',[],[])])])])])])])])])])])]))])),'Branch'('Pattern'('Flat.Choice',[31]),'Comb'('FuncCall','FlatTools.maybeShowBrackets',['Var'(1),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(67)),'Comb'('ConsCall','.',['Lit'('Charc'(104)),'Comb'('ConsCall','.',['Lit'('Charc'(111)),'Comb'('ConsCall','.',['Lit'('Charc'(105)),'Comb'('ConsCall','.',['Lit'('Charc'(99)),'Comb'('ConsCall','.',['Lit'('Charc'(101)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])])])])])])])]),'Comb'('FuncCall','FlatTools.showCurryExpr',['Var'(0),'Comb'('ConsCall','True',[]),'Var'(2),'Var'(31)])])]))]))).
evaluation('FlatTools.showCurryVar','Rule'([0],'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(118)),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall',show,['Var'(0)])]))).
evaluation('FlatTools.showCurryLit','Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'('Flat.Intc',[1]),'Comb'('FuncCall',show,['Var'(1)])),'Branch'('Pattern'('Flat.Floatc',[2]),'Comb'('FuncCall',show,['Var'(2)])),'Branch'('Pattern'('Flat.Charc',[3]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(39)),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Var'(3),'Comb'('ConsCall',[],[])]),'Comb'('ConsCall','.',['Lit'('Charc'(39)),'Comb'('ConsCall',[],[])])])]))]))).
evaluation('FlatTools.showCurryCase','Rule'([0,1,2],'Case'('Flex','Var'(2),['Branch'('Pattern'('Flat.Branch',[3,4]),'Case'('Flex','Var'(3),['Branch'('Pattern'('Flat.Pattern',[5,6]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.sceBlanks',['Var'(1)]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.showPattern_3583',['Apply'('Var'(0),'Var'(5)),'Var'(6)]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(45)),'Comb'('ConsCall','.',['Lit'('Charc'(62)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.showCurryExpr',['Var'(0),'Comb'('ConsCall','False',[]),'Var'(1),'Var'(4)]),'Comb'('ConsCall','.',['Lit'('Charc'(10)),'Comb'('ConsCall',[],[])])])])])])),'Branch'('Pattern'('Flat.LPattern',[7]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.sceBlanks',['Var'(1)]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.showCurryLit',['Var'(7)]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(45)),'Comb'('ConsCall','.',['Lit'('Charc'(62)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.showCurryExpr',['Var'(0),'Comb'('ConsCall','False',[]),'Var'(1),'Var'(4)]),'Comb'('ConsCall','.',['Lit'('Charc'(10)),'Comb'('ConsCall',[],[])])])])])])]))]))]))).
evaluation('FlatTools.showCurryFiniteList','Rule'([0,1,2],'Case'('Flex','Var'(2),['Branch'('Pattern'('Flat.Comb',[3,4,5]),'Case'('Flex','Var'(4),['Branch'('Pattern'('.',[6,7]),'Case'('Flex','Var'(6),['Branch'('LPattern'('\'['),'Case'('Flex','Var'(7),['Branch'('Pattern'('.',[8,9]),'Case'('Flex','Var'(8),['Branch'('LPattern'('\']'),'Case'('Flex','Var'(9),['Branch'('Pattern'([],[]),'Case'('Flex','Var'(5),['Branch'('Pattern'([],[]),'Comb'('ConsCall',[],[]))]))]))]))])),'Branch'('LPattern'('\':'),'Case'('Flex','Var'(7),['Branch'('Pattern'([],[]),'Case'('Flex','Var'(5),['Branch'('Pattern'('.',[10,11]),'Case'('Flex','Var'(11),['Branch'('Pattern'('.',[12,13]),'Case'('Flex','Var'(13),['Branch'('Pattern'([],[]),'Comb'('ConsCall','.',['Comb'('FuncCall','FlatTools.showCurryExpr',['Var'(0),'Comb'('ConsCall','False',[]),'Var'(1),'Var'(10)]),'Comb'('FuncCall','FlatTools.showCurryFiniteList',['Var'(0),'Var'(1),'Var'(12)])]))]))]))]))]))]))]))]))).
evaluation('FlatTools.showCurryElems','Rule'([0,1],'Comb'('FuncCall',concat,['Comb'('FuncCall','List.intersperse',['Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall',map,['Var'(0),'Var'(1)])])]))).
evaluation('FlatTools.maybeShowBrackets','Rule'([0,1],'Comb'('FuncCall',++,['Comb'('FuncCall',if_then_else,['Var'(0),'Comb'('ConsCall','.',['Lit'('Charc'(40)),'Comb'('ConsCall',[],[])]),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall',++,['Var'(1),'Comb'('FuncCall',if_then_else,['Var'(0),'Comb'('ConsCall','.',['Lit'('Charc'(41)),'Comb'('ConsCall',[],[])]),'Comb'('ConsCall',[],[])])])]))).
evaluation('FlatTools.sceBlanks','Rule'([0],'Comb'('FuncCall',take,['Var'(0),'Comb'('FuncCall',repeat,['Lit'('Charc'(32))])]))).
evaluation('FlatTools.isFiniteList','Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'('Flat.Var',[1]),'Comb'('ConsCall','False',[])),'Branch'('Pattern'('Flat.Lit',[2]),'Comb'('ConsCall','False',[])),'Branch'('Pattern'('Flat.Comb',[3,4,5]),'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',&&,['Comb'('FuncCall',==,['Var'(4),'Comb'('ConsCall','.',['Lit'('Charc'(91)),'Comb'('ConsCall','.',['Lit'('Charc'(93)),'Comb'('ConsCall',[],[])])])]),'Comb'('FuncCall',==,['Var'(5),'Comb'('ConsCall',[],[])])]),'Comb'('ConsCall','True',[]),'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',&&,['Comb'('FuncCall',==,['Var'(4),'Comb'('ConsCall','.',['Lit'('Charc'(58)),'Comb'('ConsCall',[],[])])]),'Comb'('FuncCall',==,['Comb'('FuncCall',length,['Var'(5)]),'Lit'('Intc'(2))])]),'Comb'('FuncCall','FlatTools.isFiniteList',['Comb'('FuncCall','!!',['Var'(5),'Lit'('Intc'(1))])]),'Comb'('ConsCall','False',[])])])),'Branch'('Pattern'('Flat.Apply',[6,7]),'Comb'('ConsCall','False',[])),'Branch'('Pattern'('Flat.Constr',[8,9]),'Comb'('ConsCall','False',[])),'Branch'('Pattern'('Flat.Or',[10,11]),'Comb'('ConsCall','False',[])),'Branch'('Pattern'('Flat.Case',[12,13,14]),'Comb'('ConsCall','False',[])),'Branch'('Pattern'('Flat.Choice',[15]),'Comb'('ConsCall','False',[])),'Branch'('Pattern'('Flat.GuardedExpr',[16,17,18]),'Comb'('ConsCall','False',[]))]))).
evaluation('FlatTools.writeFLC','Rule'([0,1,2],'Apply'('Comb'('FuncCall',writeFile,['Var'(0),'Comb'('FuncCall','FlatTools.showFlcProg',['Var'(1)])]),'Var'(2)))).
evaluation('FlatTools.showFlcProg','Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'('Flat.Prog',[1,2,3,4,5,6]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(39)),'Comb'('ConsCall','.',['Lit'('Charc'(80)),'Comb'('ConsCall','.',['Lit'('Charc'(114)),'Comb'('ConsCall','.',['Lit'('Charc'(111)),'Comb'('ConsCall','.',['Lit'('Charc'(103)),'Comb'('ConsCall','.',['Lit'('Charc'(39)),'Comb'('ConsCall','.',['Lit'('Charc'(40)),'Comb'('ConsCall',[],[])])])])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flcShowString',['Var'(1)]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(44)),'Comb'('ConsCall','.',['Lit'('Charc'(10)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(91)),'Comb'('ConsCall',[],[])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flcShowListElems',['Comb'('PartCall','FlatTools.flcShowString',[]),'Var'(2)]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(93)),'Comb'('ConsCall','.',['Lit'('Charc'(44)),'Comb'('ConsCall','.',['Lit'('Charc'(10)),'Comb'('ConsCall',[],[])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall',if_then_else,['Comb'('FuncCall',==,['Var'(3),'Comb'('ConsCall',[],[])]),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(91)),'Comb'('ConsCall','.',['Lit'('Charc'(93)),'Comb'('ConsCall','.',['Lit'('Charc'(44)),'Comb'('ConsCall','.',['Lit'('Charc'(10)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])])])])])])]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(91)),'Comb'('ConsCall',[],[])])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flcShowListElems',['Comb'('PartCall','FlatTools.flcShowType',[]),'Var'(3)]),'Comb'('ConsCall','.',['Lit'('Charc'(10)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(93)),'Comb'('ConsCall','.',['Lit'('Charc'(44)),'Comb'('ConsCall','.',['Lit'('Charc'(10)),'Comb'('ConsCall',[],[])])])])])])])])]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(91)),'Comb'('ConsCall',[],[])])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flcShowListElems',['Comb'('PartCall','FlatTools.flcShowFunc',[]),'Var'(4)]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(10)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(93)),'Comb'('ConsCall','.',['Lit'('Charc'(44)),'Comb'('ConsCall','.',['Lit'('Charc'(10)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])])])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flcShowList',['Comb'('PartCall','FlatTools.flcShowOp',[]),'Var'(5)]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(44)),'Comb'('ConsCall','.',['Lit'('Charc'(10)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(91)),'Comb'('ConsCall',[],[])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flcShowListElems',['Comb'('PartCall','FlatTools.flcShowTrans',[]),'Var'(6)]),'Comb'('ConsCall','.',['Lit'('Charc'(10)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(93)),'Comb'('ConsCall','.',['Lit'('Charc'(41)),'Comb'('ConsCall','.',['Lit'('Charc'(46)),'Comb'('ConsCall','.',['Lit'('Charc'(10)),'Comb'('ConsCall',[],[])])])])])])])])])])])])])])])])])])]))]))).
evaluation('FlatTools.flcShowOp','Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'('Flat.Op',[1,2,3]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(39)),'Comb'('ConsCall','.',['Lit'('Charc'(79)),'Comb'('ConsCall','.',['Lit'('Charc'(112)),'Comb'('ConsCall','.',['Lit'('Charc'(39)),'Comb'('ConsCall','.',['Lit'('Charc'(40)),'Comb'('ConsCall',[],[])])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flcShowString',['Var'(1)]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(44)),'Comb'('ConsCall','.',['Lit'('Charc'(39)),'Comb'('ConsCall',[],[])])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flcShowFixity',['Var'(2)]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(39)),'Comb'('ConsCall','.',['Lit'('Charc'(44)),'Comb'('ConsCall',[],[])])]),'Comb'('FuncCall',++,['Comb'('FuncCall',show,['Var'(3)]),'Comb'('ConsCall','.',['Lit'('Charc'(41)),'Comb'('ConsCall',[],[])])])])])])])]))]))).
evaluation('FlatTools.flcShowFixity','Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'('Flat.InfixOp',[]),'Comb'('ConsCall','.',['Lit'('Charc'(73)),'Comb'('ConsCall','.',['Lit'('Charc'(110)),'Comb'('ConsCall','.',['Lit'('Charc'(102)),'Comb'('ConsCall','.',['Lit'('Charc'(105)),'Comb'('ConsCall','.',['Lit'('Charc'(120)),'Comb'('ConsCall','.',['Lit'('Charc'(79)),'Comb'('ConsCall','.',['Lit'('Charc'(112)),'Comb'('ConsCall',[],[])])])])])])])])),'Branch'('Pattern'('Flat.InfixlOp',[]),'Comb'('ConsCall','.',['Lit'('Charc'(73)),'Comb'('ConsCall','.',['Lit'('Charc'(110)),'Comb'('ConsCall','.',['Lit'('Charc'(102)),'Comb'('ConsCall','.',['Lit'('Charc'(105)),'Comb'('ConsCall','.',['Lit'('Charc'(120)),'Comb'('ConsCall','.',['Lit'('Charc'(108)),'Comb'('ConsCall','.',['Lit'('Charc'(79)),'Comb'('ConsCall','.',['Lit'('Charc'(112)),'Comb'('ConsCall',[],[])])])])])])])])])),'Branch'('Pattern'('Flat.InfixrOp',[]),'Comb'('ConsCall','.',['Lit'('Charc'(73)),'Comb'('ConsCall','.',['Lit'('Charc'(110)),'Comb'('ConsCall','.',['Lit'('Charc'(102)),'Comb'('ConsCall','.',['Lit'('Charc'(105)),'Comb'('ConsCall','.',['Lit'('Charc'(120)),'Comb'('ConsCall','.',['Lit'('Charc'(114)),'Comb'('ConsCall','.',['Lit'('Charc'(79)),'Comb'('ConsCall','.',['Lit'('Charc'(112)),'Comb'('ConsCall',[],[])])])])])])])])]))]))).
evaluation('FlatTools.flcShowType','Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'('Flat.Type',[1,2,3]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(10)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(39)),'Comb'('ConsCall','.',['Lit'('Charc'(84)),'Comb'('ConsCall','.',['Lit'('Charc'(121)),'Comb'('ConsCall','.',['Lit'('Charc'(112)),'Comb'('ConsCall','.',['Lit'('Charc'(101)),'Comb'('ConsCall','.',['Lit'('Charc'(39)),'Comb'('ConsCall','.',['Lit'('Charc'(40)),'Comb'('ConsCall',[],[])])])])])])])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flcShowString',['Var'(1)]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(44)),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flcShowList',['Comb'('PartCall',show,[]),'Var'(2)]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(44)),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flcShowList',['Comb'('PartCall','FlatTools.flcShowCons',[]),'Var'(3)]),'Comb'('ConsCall','.',['Lit'('Charc'(41)),'Comb'('ConsCall',[],[])])])])])])])]))]))).
evaluation('FlatTools.flcShowCons','Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'('Flat.Cons',[1,2,3]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(39)),'Comb'('ConsCall','.',['Lit'('Charc'(67)),'Comb'('ConsCall','.',['Lit'('Charc'(111)),'Comb'('ConsCall','.',['Lit'('Charc'(110)),'Comb'('ConsCall','.',['Lit'('Charc'(115)),'Comb'('ConsCall','.',['Lit'('Charc'(39)),'Comb'('ConsCall','.',['Lit'('Charc'(40)),'Comb'('ConsCall',[],[])])])])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flcShowString',['Var'(1)]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(44)),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall',++,['Comb'('FuncCall',show,['Var'(2)]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(44)),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flcShowList',['Comb'('PartCall','FlatTools.flcShowTypeExpr',[]),'Var'(3)]),'Comb'('ConsCall','.',['Lit'('Charc'(41)),'Comb'('ConsCall',[],[])])])])])])])]))]))).
evaluation('FlatTools.flcShowFunc','Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'('Flat.Func',[1,2,3,4]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(10)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(39)),'Comb'('ConsCall','.',['Lit'('Charc'(70)),'Comb'('ConsCall','.',['Lit'('Charc'(117)),'Comb'('ConsCall','.',['Lit'('Charc'(110)),'Comb'('ConsCall','.',['Lit'('Charc'(99)),'Comb'('ConsCall','.',['Lit'('Charc'(39)),'Comb'('ConsCall','.',['Lit'('Charc'(40)),'Comb'('ConsCall',[],[])])])])])])])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flcShowString',['Var'(1)]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(44)),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall',++,['Comb'('FuncCall',show,['Var'(2)]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(44)),'Comb'('ConsCall','.',['Lit'('Charc'(10)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])])])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flcShowTypeExpr',['Var'(3)]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(44)),'Comb'('ConsCall','.',['Lit'('Charc'(10)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])])])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flcShowRule',['Var'(4)]),'Comb'('ConsCall','.',['Lit'('Charc'(41)),'Comb'('ConsCall',[],[])])])])])])])])])]))]))).
evaluation('FlatTools.flcShowRule','Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'('Flat.Rule',[1,2]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(39)),'Comb'('ConsCall','.',['Lit'('Charc'(82)),'Comb'('ConsCall','.',['Lit'('Charc'(117)),'Comb'('ConsCall','.',['Lit'('Charc'(108)),'Comb'('ConsCall','.',['Lit'('Charc'(101)),'Comb'('ConsCall','.',['Lit'('Charc'(39)),'Comb'('ConsCall','.',['Lit'('Charc'(40)),'Comb'('ConsCall',[],[])])])])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flcShowList',['Comb'('PartCall',show,[]),'Var'(1)]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(44)),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flcShowExpr',['Var'(2)]),'Comb'('ConsCall','.',['Lit'('Charc'(41)),'Comb'('ConsCall',[],[])])])])])])),'Branch'('Pattern'('Flat.External',[3]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(39)),'Comb'('ConsCall','.',['Lit'('Charc'(69)),'Comb'('ConsCall','.',['Lit'('Charc'(120)),'Comb'('ConsCall','.',['Lit'('Charc'(116)),'Comb'('ConsCall','.',['Lit'('Charc'(101)),'Comb'('ConsCall','.',['Lit'('Charc'(114)),'Comb'('ConsCall','.',['Lit'('Charc'(110)),'Comb'('ConsCall','.',['Lit'('Charc'(97)),'Comb'('ConsCall','.',['Lit'('Charc'(108)),'Comb'('ConsCall','.',['Lit'('Charc'(39)),'Comb'('ConsCall','.',['Lit'('Charc'(40)),'Comb'('ConsCall',[],[])])])])])])])])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flcShowString',['Var'(3)]),'Comb'('ConsCall','.',['Lit'('Charc'(41)),'Comb'('ConsCall',[],[])])])]))]))).
evaluation('FlatTools.flcShowTypeExpr','Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'('Flat.FuncType',[1,2]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(39)),'Comb'('ConsCall','.',['Lit'('Charc'(70)),'Comb'('ConsCall','.',['Lit'('Charc'(117)),'Comb'('ConsCall','.',['Lit'('Charc'(110)),'Comb'('ConsCall','.',['Lit'('Charc'(99)),'Comb'('ConsCall','.',['Lit'('Charc'(84)),'Comb'('ConsCall','.',['Lit'('Charc'(121)),'Comb'('ConsCall','.',['Lit'('Charc'(112)),'Comb'('ConsCall','.',['Lit'('Charc'(101)),'Comb'('ConsCall','.',['Lit'('Charc'(39)),'Comb'('ConsCall','.',['Lit'('Charc'(40)),'Comb'('ConsCall',[],[])])])])])])])])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flcShowTypeExpr',['Var'(1)]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(44)),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flcShowTypeExpr',['Var'(2)]),'Comb'('ConsCall','.',['Lit'('Charc'(41)),'Comb'('ConsCall',[],[])])])])])])),'Branch'('Pattern'('Flat.TCons',[3,4]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(39)),'Comb'('ConsCall','.',['Lit'('Charc'(84)),'Comb'('ConsCall','.',['Lit'('Charc'(67)),'Comb'('ConsCall','.',['Lit'('Charc'(111)),'Comb'('ConsCall','.',['Lit'('Charc'(110)),'Comb'('ConsCall','.',['Lit'('Charc'(115)),'Comb'('ConsCall','.',['Lit'('Charc'(39)),'Comb'('ConsCall','.',['Lit'('Charc'(40)),'Comb'('ConsCall',[],[])])])])])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flcShowString',['Var'(3)]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(44)),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flcShowList',['Comb'('PartCall','FlatTools.flcShowTypeExpr',[]),'Var'(4)]),'Comb'('ConsCall','.',['Lit'('Charc'(41)),'Comb'('ConsCall',[],[])])])])])])),'Branch'('Pattern'('Flat.TVar',[5]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(39)),'Comb'('ConsCall','.',['Lit'('Charc'(84)),'Comb'('ConsCall','.',['Lit'('Charc'(86)),'Comb'('ConsCall','.',['Lit'('Charc'(97)),'Comb'('ConsCall','.',['Lit'('Charc'(114)),'Comb'('ConsCall','.',['Lit'('Charc'(39)),'Comb'('ConsCall','.',['Lit'('Charc'(40)),'Comb'('ConsCall',[],[])])])])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall',show,['Var'(5)]),'Comb'('ConsCall','.',['Lit'('Charc'(41)),'Comb'('ConsCall',[],[])])])]))]))).
evaluation('FlatTools.flcShowCombType','Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'('Flat.FuncCall',[]),'Comb'('ConsCall','.',['Lit'('Charc'(70)),'Comb'('ConsCall','.',['Lit'('Charc'(117)),'Comb'('ConsCall','.',['Lit'('Charc'(110)),'Comb'('ConsCall','.',['Lit'('Charc'(99)),'Comb'('ConsCall','.',['Lit'('Charc'(67)),'Comb'('ConsCall','.',['Lit'('Charc'(97)),'Comb'('ConsCall','.',['Lit'('Charc'(108)),'Comb'('ConsCall','.',['Lit'('Charc'(108)),'Comb'('ConsCall',[],[])])])])])])])])])),'Branch'('Pattern'('Flat.ConsCall',[]),'Comb'('ConsCall','.',['Lit'('Charc'(67)),'Comb'('ConsCall','.',['Lit'('Charc'(111)),'Comb'('ConsCall','.',['Lit'('Charc'(110)),'Comb'('ConsCall','.',['Lit'('Charc'(115)),'Comb'('ConsCall','.',['Lit'('Charc'(67)),'Comb'('ConsCall','.',['Lit'('Charc'(97)),'Comb'('ConsCall','.',['Lit'('Charc'(108)),'Comb'('ConsCall','.',['Lit'('Charc'(108)),'Comb'('ConsCall',[],[])])])])])])])])])),'Branch'('Pattern'('Flat.PartCall',[]),'Comb'('ConsCall','.',['Lit'('Charc'(80)),'Comb'('ConsCall','.',['Lit'('Charc'(97)),'Comb'('ConsCall','.',['Lit'('Charc'(114)),'Comb'('ConsCall','.',['Lit'('Charc'(116)),'Comb'('ConsCall','.',['Lit'('Charc'(67)),'Comb'('ConsCall','.',['Lit'('Charc'(97)),'Comb'('ConsCall','.',['Lit'('Charc'(108)),'Comb'('ConsCall','.',['Lit'('Charc'(108)),'Comb'('ConsCall',[],[])])])])])])])])]))]))).
evaluation('FlatTools.flcShowExpr','Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'('Flat.Var',[1]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(39)),'Comb'('ConsCall','.',['Lit'('Charc'(86)),'Comb'('ConsCall','.',['Lit'('Charc'(97)),'Comb'('ConsCall','.',['Lit'('Charc'(114)),'Comb'('ConsCall','.',['Lit'('Charc'(39)),'Comb'('ConsCall','.',['Lit'('Charc'(40)),'Comb'('ConsCall',[],[])])])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall',show,['Var'(1)]),'Comb'('ConsCall','.',['Lit'('Charc'(41)),'Comb'('ConsCall',[],[])])])])),'Branch'('Pattern'('Flat.Lit',[2]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(39)),'Comb'('ConsCall','.',['Lit'('Charc'(76)),'Comb'('ConsCall','.',['Lit'('Charc'(105)),'Comb'('ConsCall','.',['Lit'('Charc'(116)),'Comb'('ConsCall','.',['Lit'('Charc'(39)),'Comb'('ConsCall','.',['Lit'('Charc'(40)),'Comb'('ConsCall',[],[])])])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flcShowLit',['Var'(2)]),'Comb'('ConsCall','.',['Lit'('Charc'(41)),'Comb'('ConsCall',[],[])])])])),'Branch'('Pattern'('Flat.Comb',[3,4,5]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(39)),'Comb'('ConsCall','.',['Lit'('Charc'(67)),'Comb'('ConsCall','.',['Lit'('Charc'(111)),'Comb'('ConsCall','.',['Lit'('Charc'(109)),'Comb'('ConsCall','.',['Lit'('Charc'(98)),'Comb'('ConsCall','.',['Lit'('Charc'(39)),'Comb'('ConsCall','.',['Lit'('Charc'(40)),'Comb'('ConsCall','.',['Lit'('Charc'(39)),'Comb'('ConsCall',[],[])])])])])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flcShowCombType',['Var'(3)]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(39)),'Comb'('ConsCall','.',['Lit'('Charc'(44)),'Comb'('ConsCall',[],[])])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flcShowString',['Var'(4)]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(44)),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flcShowList',['Comb'('PartCall','FlatTools.flcShowExpr',[]),'Var'(5)]),'Comb'('ConsCall','.',['Lit'('Charc'(41)),'Comb'('ConsCall',[],[])])])])])])])])),'Branch'('Pattern'('Flat.Apply',[6,7]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(39)),'Comb'('ConsCall','.',['Lit'('Charc'(65)),'Comb'('ConsCall','.',['Lit'('Charc'(112)),'Comb'('ConsCall','.',['Lit'('Charc'(112)),'Comb'('ConsCall','.',['Lit'('Charc'(108)),'Comb'('ConsCall','.',['Lit'('Charc'(121)),'Comb'('ConsCall','.',['Lit'('Charc'(39)),'Comb'('ConsCall','.',['Lit'('Charc'(40)),'Comb'('ConsCall',[],[])])])])])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flcShowExpr',['Var'(6)]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(44)),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flcShowExpr',['Var'(7)]),'Comb'('ConsCall','.',['Lit'('Charc'(41)),'Comb'('ConsCall',[],[])])])])])])),'Branch'('Pattern'('Flat.Constr',[8,9]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(39)),'Comb'('ConsCall','.',['Lit'('Charc'(67)),'Comb'('ConsCall','.',['Lit'('Charc'(111)),'Comb'('ConsCall','.',['Lit'('Charc'(110)),'Comb'('ConsCall','.',['Lit'('Charc'(115)),'Comb'('ConsCall','.',['Lit'('Charc'(116)),'Comb'('ConsCall','.',['Lit'('Charc'(114)),'Comb'('ConsCall','.',['Lit'('Charc'(39)),'Comb'('ConsCall','.',['Lit'('Charc'(40)),'Comb'('ConsCall',[],[])])])])])])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flcShowList',['Comb'('PartCall',show,[]),'Var'(8)]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(44)),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flcShowExpr',['Var'(9)]),'Comb'('ConsCall','.',['Lit'('Charc'(41)),'Comb'('ConsCall',[],[])])])])])])),'Branch'('Pattern'('Flat.Or',[10,11]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(39)),'Comb'('ConsCall','.',['Lit'('Charc'(79)),'Comb'('ConsCall','.',['Lit'('Charc'(114)),'Comb'('ConsCall','.',['Lit'('Charc'(39)),'Comb'('ConsCall','.',['Lit'('Charc'(40)),'Comb'('ConsCall',[],[])])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flcShowExpr',['Var'(10)]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(44)),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flcShowExpr',['Var'(11)]),'Comb'('ConsCall','.',['Lit'('Charc'(41)),'Comb'('ConsCall',[],[])])])])])])),'Branch'('Pattern'('Flat.Case',[12,13,14]),'Case'('Flex','Var'(12),['Branch'('Pattern'('Flat.Rigid',[]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(39)),'Comb'('ConsCall','.',['Lit'('Charc'(67)),'Comb'('ConsCall','.',['Lit'('Charc'(97)),'Comb'('ConsCall','.',['Lit'('Charc'(115)),'Comb'('ConsCall','.',['Lit'('Charc'(101)),'Comb'('ConsCall','.',['Lit'('Charc'(39)),'Comb'('ConsCall','.',['Lit'('Charc'(40)),'Comb'('ConsCall','.',['Lit'('Charc'(39)),'Comb'('ConsCall','.',['Lit'('Charc'(82)),'Comb'('ConsCall','.',['Lit'('Charc'(105)),'Comb'('ConsCall','.',['Lit'('Charc'(103)),'Comb'('ConsCall','.',['Lit'('Charc'(105)),'Comb'('ConsCall','.',['Lit'('Charc'(100)),'Comb'('ConsCall','.',['Lit'('Charc'(39)),'Comb'('ConsCall','.',['Lit'('Charc'(44)),'Comb'('ConsCall',[],[])])])])])])])])])])])])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flcShowExpr',['Var'(13)]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(44)),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flcShowList',['Comb'('PartCall','FlatTools.flcShowBranch',[]),'Var'(14)]),'Comb'('ConsCall','.',['Lit'('Charc'(41)),'Comb'('ConsCall',[],[])])])])])])),'Branch'('Pattern'('Flat.Flex',[]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(39)),'Comb'('ConsCall','.',['Lit'('Charc'(67)),'Comb'('ConsCall','.',['Lit'('Charc'(97)),'Comb'('ConsCall','.',['Lit'('Charc'(115)),'Comb'('ConsCall','.',['Lit'('Charc'(101)),'Comb'('ConsCall','.',['Lit'('Charc'(39)),'Comb'('ConsCall','.',['Lit'('Charc'(40)),'Comb'('ConsCall','.',['Lit'('Charc'(39)),'Comb'('ConsCall','.',['Lit'('Charc'(70)),'Comb'('ConsCall','.',['Lit'('Charc'(108)),'Comb'('ConsCall','.',['Lit'('Charc'(101)),'Comb'('ConsCall','.',['Lit'('Charc'(120)),'Comb'('ConsCall','.',['Lit'('Charc'(39)),'Comb'('ConsCall','.',['Lit'('Charc'(44)),'Comb'('ConsCall',[],[])])])])])])])])])])])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flcShowExpr',['Var'(13)]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(44)),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flcShowList',['Comb'('PartCall','FlatTools.flcShowBranch',[]),'Var'(14)]),'Comb'('ConsCall','.',['Lit'('Charc'(41)),'Comb'('ConsCall',[],[])])])])])]))])),'Branch'('Pattern'('Flat.GuardedExpr',[15,16,17]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(39)),'Comb'('ConsCall','.',['Lit'('Charc'(71)),'Comb'('ConsCall','.',['Lit'('Charc'(117)),'Comb'('ConsCall','.',['Lit'('Charc'(97)),'Comb'('ConsCall','.',['Lit'('Charc'(114)),'Comb'('ConsCall','.',['Lit'('Charc'(100)),'Comb'('ConsCall','.',['Lit'('Charc'(101)),'Comb'('ConsCall','.',['Lit'('Charc'(100)),'Comb'('ConsCall','.',['Lit'('Charc'(69)),'Comb'('ConsCall','.',['Lit'('Charc'(120)),'Comb'('ConsCall','.',['Lit'('Charc'(112)),'Comb'('ConsCall','.',['Lit'('Charc'(114)),'Comb'('ConsCall','.',['Lit'('Charc'(39)),'Comb'('ConsCall','.',['Lit'('Charc'(40)),'Comb'('ConsCall',[],[])])])])])])])])])])])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flcShowList',['Comb'('PartCall',show,[]),'Var'(15)]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(44)),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flcShowExpr',['Var'(16)]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(44)),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flcShowExpr',['Var'(17)]),'Comb'('ConsCall','.',['Lit'('Charc'(41)),'Comb'('ConsCall',[],[])])])])])])])])),'Branch'('Pattern'('Flat.Choice',[18]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(39)),'Comb'('ConsCall','.',['Lit'('Charc'(67)),'Comb'('ConsCall','.',['Lit'('Charc'(104)),'Comb'('ConsCall','.',['Lit'('Charc'(111)),'Comb'('ConsCall','.',['Lit'('Charc'(105)),'Comb'('ConsCall','.',['Lit'('Charc'(99)),'Comb'('ConsCall','.',['Lit'('Charc'(101)),'Comb'('ConsCall','.',['Lit'('Charc'(39)),'Comb'('ConsCall','.',['Lit'('Charc'(40)),'Comb'('ConsCall',[],[])])])])])])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flcShowExpr',['Var'(18)]),'Comb'('ConsCall','.',['Lit'('Charc'(41)),'Comb'('ConsCall',[],[])])])]))]))).
evaluation('FlatTools.flcShowLit','Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'('Flat.Intc',[1]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(39)),'Comb'('ConsCall','.',['Lit'('Charc'(73)),'Comb'('ConsCall','.',['Lit'('Charc'(110)),'Comb'('ConsCall','.',['Lit'('Charc'(116)),'Comb'('ConsCall','.',['Lit'('Charc'(99)),'Comb'('ConsCall','.',['Lit'('Charc'(39)),'Comb'('ConsCall','.',['Lit'('Charc'(40)),'Comb'('ConsCall',[],[])])])])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall',show,['Var'(1)]),'Comb'('ConsCall','.',['Lit'('Charc'(41)),'Comb'('ConsCall',[],[])])])])),'Branch'('Pattern'('Flat.Floatc',[2]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(39)),'Comb'('ConsCall','.',['Lit'('Charc'(70)),'Comb'('ConsCall','.',['Lit'('Charc'(108)),'Comb'('ConsCall','.',['Lit'('Charc'(111)),'Comb'('ConsCall','.',['Lit'('Charc'(97)),'Comb'('ConsCall','.',['Lit'('Charc'(116)),'Comb'('ConsCall','.',['Lit'('Charc'(99)),'Comb'('ConsCall','.',['Lit'('Charc'(39)),'Comb'('ConsCall','.',['Lit'('Charc'(40)),'Comb'('ConsCall',[],[])])])])])])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall',show,['Var'(2)]),'Comb'('ConsCall','.',['Lit'('Charc'(41)),'Comb'('ConsCall',[],[])])])])),'Branch'('Pattern'('Flat.Charc',[3]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(39)),'Comb'('ConsCall','.',['Lit'('Charc'(67)),'Comb'('ConsCall','.',['Lit'('Charc'(104)),'Comb'('ConsCall','.',['Lit'('Charc'(97)),'Comb'('ConsCall','.',['Lit'('Charc'(114)),'Comb'('ConsCall','.',['Lit'('Charc'(99)),'Comb'('ConsCall','.',['Lit'('Charc'(39)),'Comb'('ConsCall','.',['Lit'('Charc'(40)),'Comb'('ConsCall',[],[])])])])])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall',show,['Comb'('FuncCall',ord,['Var'(3)])]),'Comb'('ConsCall','.',['Lit'('Charc'(41)),'Comb'('ConsCall',[],[])])])]))]))).
evaluation('FlatTools.flcShowBranch','Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'('Flat.Branch',[1,2]),'Case'('Flex','Var'(1),['Branch'('Pattern'('Flat.Pattern',[3,4]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(39)),'Comb'('ConsCall','.',['Lit'('Charc'(66)),'Comb'('ConsCall','.',['Lit'('Charc'(114)),'Comb'('ConsCall','.',['Lit'('Charc'(97)),'Comb'('ConsCall','.',['Lit'('Charc'(110)),'Comb'('ConsCall','.',['Lit'('Charc'(99)),'Comb'('ConsCall','.',['Lit'('Charc'(104)),'Comb'('ConsCall','.',['Lit'('Charc'(39)),'Comb'('ConsCall','.',['Lit'('Charc'(40)),'Comb'('ConsCall','.',['Lit'('Charc'(39)),'Comb'('ConsCall','.',['Lit'('Charc'(80)),'Comb'('ConsCall','.',['Lit'('Charc'(97)),'Comb'('ConsCall','.',['Lit'('Charc'(116)),'Comb'('ConsCall','.',['Lit'('Charc'(116)),'Comb'('ConsCall','.',['Lit'('Charc'(101)),'Comb'('ConsCall','.',['Lit'('Charc'(114)),'Comb'('ConsCall','.',['Lit'('Charc'(110)),'Comb'('ConsCall','.',['Lit'('Charc'(39)),'Comb'('ConsCall','.',['Lit'('Charc'(40)),'Comb'('ConsCall',[],[])])])])])])])])])])])])])])])])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flcShowString',['Var'(3)]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(44)),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flcShowList',['Comb'('PartCall',show,[]),'Var'(4)]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(41)),'Comb'('ConsCall','.',['Lit'('Charc'(44)),'Comb'('ConsCall',[],[])])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flcShowExpr',['Var'(2)]),'Comb'('ConsCall','.',['Lit'('Charc'(41)),'Comb'('ConsCall',[],[])])])])])])])])),'Branch'('Pattern'('Flat.LPattern',[5]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(39)),'Comb'('ConsCall','.',['Lit'('Charc'(66)),'Comb'('ConsCall','.',['Lit'('Charc'(114)),'Comb'('ConsCall','.',['Lit'('Charc'(97)),'Comb'('ConsCall','.',['Lit'('Charc'(110)),'Comb'('ConsCall','.',['Lit'('Charc'(99)),'Comb'('ConsCall','.',['Lit'('Charc'(104)),'Comb'('ConsCall','.',['Lit'('Charc'(39)),'Comb'('ConsCall','.',['Lit'('Charc'(40)),'Comb'('ConsCall','.',['Lit'('Charc'(39)),'Comb'('ConsCall','.',['Lit'('Charc'(76)),'Comb'('ConsCall','.',['Lit'('Charc'(80)),'Comb'('ConsCall','.',['Lit'('Charc'(97)),'Comb'('ConsCall','.',['Lit'('Charc'(116)),'Comb'('ConsCall','.',['Lit'('Charc'(116)),'Comb'('ConsCall','.',['Lit'('Charc'(101)),'Comb'('ConsCall','.',['Lit'('Charc'(114)),'Comb'('ConsCall','.',['Lit'('Charc'(110)),'Comb'('ConsCall','.',['Lit'('Charc'(39)),'Comb'('ConsCall','.',['Lit'('Charc'(40)),'Comb'('ConsCall',[],[])])])])])])])])])])])])])])])])])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flcShowLit',['Var'(5)]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(41)),'Comb'('ConsCall','.',['Lit'('Charc'(44)),'Comb'('ConsCall',[],[])])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flcShowExpr',['Var'(2)]),'Comb'('ConsCall','.',['Lit'('Charc'(41)),'Comb'('ConsCall',[],[])])])])])]))]))]))).
evaluation('FlatTools.flcShowTrans','Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'('Flat.Trans',[1,2]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(10)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(39)),'Comb'('ConsCall','.',['Lit'('Charc'(84)),'Comb'('ConsCall','.',['Lit'('Charc'(114)),'Comb'('ConsCall','.',['Lit'('Charc'(97)),'Comb'('ConsCall','.',['Lit'('Charc'(110)),'Comb'('ConsCall','.',['Lit'('Charc'(115)),'Comb'('ConsCall','.',['Lit'('Charc'(39)),'Comb'('ConsCall','.',['Lit'('Charc'(40)),'Comb'('ConsCall',[],[])])])])])])])])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flcShowString',['Var'(1)]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(44)),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flcShowString',['Var'(2)]),'Comb'('ConsCall','.',['Lit'('Charc'(41)),'Comb'('ConsCall',[],[])])])])])]))]))).
evaluation('FlatTools.flcShowList','Rule'([0,1],'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(91)),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.flcShowListElems',['Var'(0),'Var'(1)]),'Comb'('ConsCall','.',['Lit'('Charc'(93)),'Comb'('ConsCall',[],[])])])]))).
evaluation('FlatTools.flcShowListElems','Rule'([0,1],'Case'('Flex','Var'(1),['Branch'('Pattern'([],[]),'Comb'('ConsCall',[],[])),'Branch'('Pattern'('.',[2,3]),'Case'('Flex','Var'(3),['Branch'('Pattern'([],[]),'Apply'('Var'(0),'Var'(2))),'Branch'('Pattern'('.',[4,5]),'Comb'('FuncCall',++,['Apply'('Var'(0),'Var'(2)),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(44)),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall','FlatTools.flcShowListElems',['Var'(0),'Comb'('ConsCall','.',['Var'(4),'Var'(5)])])])]))]))]))).
evaluation('FlatTools.flcShowString','Rule'([0],'Comb'('FuncCall','FlatTools.flcShowList',['Comb'('PartCall','prelude..',['Comb'('PartCall',show,[]),'Comb'('PartCall',ord,[])]),'Var'(0)]))).
evaluation('FlatTools.ppshow','Rule'([0,1],'Apply'('Comb'('FuncCall',>>=,['Comb'('FuncCall','Flat.readFlatCurry',['Var'(0)]),'Comb'('PartCall','prelude..',['Comb'('PartCall',putStrLn,[]),'Comb'('PartCall','FlatTools.showFlatProg',[])])]),'Var'(1)))).
evaluation('FlatTools.pptest','Rule'([0,1],'Apply'('Comb'('FuncCall',>>=,['Comb'('FuncCall','Flat.readFlatCurry',['Var'(0)]),'Comb'('PartCall','FlatTools.lambdafun_6063',[])]),'Var'(1)))).
evaluation('FlatTools.flcshow','Rule'([0,1],'Apply'('Comb'('FuncCall',>>=,['Comb'('FuncCall','Flat.readFlatCurry',['Var'(0)]),'Comb'('PartCall','prelude..',['Comb'('PartCall',putStrLn,[]),'Comb'('PartCall','FlatTools.showFlcProg',[])])]),'Var'(1)))).
evaluation('FlatTools.flctest','Rule'([0,1],'Apply'('Comb'('FuncCall',>>=,['Comb'('FuncCall','Flat.readFlatCurry',['Var'(0)]),'Comb'('PartCall','FlatTools.lambdafun_6064',[])]),'Var'(1)))).
evaluation('FlatTools.showPattern_3583','Rule'([0,1],'Case'('Flex','Var'(1),['Branch'('Pattern'([],[]),'Var'(0)),'Branch'('Pattern'('.',[2,3]),'Case'('Flex','Var'(3),['Branch'('Pattern'([],[]),'Comb'('FuncCall',++,['Var'(0),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall','FlatTools.showCurryVar',['Var'(2)])])])),'Branch'('Pattern'('.',[4,5]),'Case'('Flex','Var'(5),['Branch'('Pattern'([],[]),'Comb'('FuncCall',if_then_else,['Comb'('FuncCall','Char.isAlpha',['Comb'('FuncCall',head,['Var'(0)])]),'Comb'('FuncCall',++,['Var'(0),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.showCurryVar',['Var'(2)]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall','FlatTools.showCurryVar',['Var'(4)])])])])]),'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',==,['Var'(0),'Comb'('ConsCall','.',['Lit'('Charc'(40)),'Comb'('ConsCall','.',['Lit'('Charc'(44)),'Comb'('ConsCall','.',['Lit'('Charc'(41)),'Comb'('ConsCall',[],[])])])])]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(40)),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.showCurryVar',['Var'(2)]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(44)),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.showCurryVar',['Var'(4)]),'Comb'('ConsCall','.',['Lit'('Charc'(41)),'Comb'('ConsCall',[],[])])])])])]),'Comb'('FuncCall',++,['Comb'('FuncCall','FlatTools.showCurryVar',['Var'(2)]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall',++,['Var'(0),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall','FlatTools.showCurryVar',['Var'(4)])])])])])])])),'Branch'('Pattern'('.',[6,7]),'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',==,['Comb'('FuncCall',take,['Lit'('Intc'(2)),'Var'(0)]),'Comb'('ConsCall','.',['Lit'('Charc'(40)),'Comb'('ConsCall','.',['Lit'('Charc'(44)),'Comb'('ConsCall',[],[])])])]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(40)),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall',++,['Comb'('FuncCall',concat,['Comb'('FuncCall','List.intersperse',['Comb'('ConsCall','.',['Lit'('Charc'(44)),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall',map,['Comb'('PartCall','FlatTools.showCurryVar',[]),'Comb'('ConsCall','.',['Var'(2),'Comb'('ConsCall','.',['Var'(4),'Comb'('ConsCall','.',['Var'(6),'Var'(7)])])])])])]),'Comb'('ConsCall','.',['Lit'('Charc'(41)),'Comb'('ConsCall',[],[])])])]),'Comb'('FuncCall',++,['Var'(0),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall','FlatTools.showCurryElems',['Comb'('PartCall','FlatTools.showCurryVar',[]),'Comb'('ConsCall','.',['Var'(2),'Comb'('ConsCall','.',['Var'(4),'Comb'('ConsCall','.',['Var'(6),'Var'(7)])])])])])])]))]))]))]))).
evaluation('FlatTools.lambdafun_6063','Rule'([0,1],'Apply'('Comb'('FuncCall',writeFile,['Comb'('ConsCall','.',['Lit'('Charc'(116)),'Comb'('ConsCall','.',['Lit'('Charc'(109)),'Comb'('ConsCall','.',['Lit'('Charc'(112)),'Comb'('ConsCall','.',['Lit'('Charc'(46)),'Comb'('ConsCall','.',['Lit'('Charc'(99)),'Comb'('ConsCall','.',['Lit'('Charc'(117)),'Comb'('ConsCall','.',['Lit'('Charc'(114)),'Comb'('ConsCall','.',['Lit'('Charc'(114)),'Comb'('ConsCall','.',['Lit'('Charc'(121)),'Comb'('ConsCall',[],[])])])])])])])])])]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(45)),'Comb'('ConsCall','.',['Lit'('Charc'(45)),'Comb'('ConsCall','.',['Lit'('Charc'(105)),'Comb'('ConsCall','.',['Lit'('Charc'(109)),'Comb'('ConsCall','.',['Lit'('Charc'(112)),'Comb'('ConsCall','.',['Lit'('Charc'(111)),'Comb'('ConsCall','.',['Lit'('Charc'(114)),'Comb'('ConsCall','.',['Lit'('Charc'(116)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(70)),'Comb'('ConsCall','.',['Lit'('Charc'(108)),'Comb'('ConsCall','.',['Lit'('Charc'(97)),'Comb'('ConsCall','.',['Lit'('Charc'(116)),'Comb'('ConsCall','.',['Lit'('Charc'(10)),'Comb'('ConsCall','.',['Lit'('Charc'(109)),'Comb'('ConsCall','.',['Lit'('Charc'(97)),'Comb'('ConsCall','.',['Lit'('Charc'(105)),'Comb'('ConsCall','.',['Lit'('Charc'(110)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(61)),'Comb'('ConsCall','.',['Lit'('Charc'(10)),'Comb'('ConsCall',[],[])])])])])])])])])])])])])])])])])])])])])]),'Comb'('FuncCall','FlatTools.showFlatProg',['Var'(0)])])]),'Var'(1)))).
evaluation('FlatTools.lambdafun_6064','Rule'([0,1],'Apply'('Comb'('FuncCall','FlatTools.writeFLC',['Comb'('ConsCall','.',['Lit'('Charc'(116)),'Comb'('ConsCall','.',['Lit'('Charc'(109)),'Comb'('ConsCall','.',['Lit'('Charc'(112)),'Comb'('ConsCall','.',['Lit'('Charc'(46)),'Comb'('ConsCall','.',['Lit'('Charc'(102)),'Comb'('ConsCall','.',['Lit'('Charc'(108)),'Comb'('ConsCall','.',['Lit'('Charc'(99)),'Comb'('ConsCall',[],[])])])])])])])]),'Var'(0)]),'Var'(1)))).
evaluation('SetRBT2.emptySetRBT','Rule'([0],'Comb'('ConsCall','SetRBT2.SetRBT',['Var'(0),'Comb'('ConsCall','SetRBT2.RBSEmpty',[])]))).
evaluation('SetRBT2.elemRBT','Rule'([0,1],'Case'('Flex','Var'(1),['Branch'('Pattern'('SetRBT2.SetRBT',[2,3]),'Comb'('FuncCall','SetRBT2.elemRBTree',['Var'(2),'Var'(0),'Var'(3)]))]))).
evaluation('SetRBT2.elemRBTree','Rule'([0,1,2],'Case'('Flex','Var'(2),['Branch'('Pattern'('SetRBT2.RBSEmpty',[]),'Comb'('ConsCall','False',[])),'Branch'('Pattern'('SetRBT2.RBS',[3,4,5,6]),'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',==,['Var'(4),'Var'(1)]),'Comb'('ConsCall','True',[]),'Comb'('FuncCall',if_then_else,['Apply'('Apply'('Var'(0),'Var'(1)),'Var'(4)),'Comb'('FuncCall','SetRBT2.elemRBTree',['Var'(0),'Var'(1),'Var'(5)]),'Comb'('FuncCall','SetRBT2.elemRBTree',['Var'(0),'Var'(1),'Var'(6)])])]))]))).
evaluation('SetRBT2.insertRBT','Rule'([0,1],'Case'('Flex','Var'(1),['Branch'('Pattern'('SetRBT2.SetRBT',[2,3]),'Comb'('ConsCall','SetRBT2.SetRBT',['Var'(2),'Comb'('FuncCall','SetRBT2.insertRBTree',['Var'(2),'Var'(0),'Var'(3)])]))]))).
evaluation('SetRBT2.insertRBTree','Rule'([0,1,2],'Comb'('FuncCall','SetRBT2.setRBT2_lambda0_7386',['Comb'('FuncCall','SetRBT2.ins_6383',['Var'(1),'Var'(0),'Var'(2)])]))).
evaluation('SetRBT2.insertMultiRBT','Rule'([0,1],'Case'('Flex','Var'(1),['Branch'('Pattern'('SetRBT2.SetRBT',[2,3]),'Comb'('ConsCall','SetRBT2.SetRBT',['Var'(2),'Comb'('FuncCall','SetRBT2.insertMultiRBTree',['Var'(2),'Var'(0),'Var'(3)])]))]))).
evaluation('SetRBT2.insertMultiRBTree','Rule'([0,1,2],'Comb'('FuncCall','SetRBT2.setRBT2_lambda1_7387',['Comb'('FuncCall','SetRBT2.ins_6398',['Var'(1),'Var'(0),'Var'(2)])]))).
evaluation('SetRBT2.setRBT2list','Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'('SetRBT2.SetRBT',[1,2]),'Comb'('FuncCall','SetRBT2.s2l_6409',['Var'(2),'Comb'('ConsCall',[],[])]))]))).
evaluation('SetRBT2.unionRBT','Rule'([0,1],'Comb'('FuncCall',foldr,['Comb'('PartCall','SetRBT2.insertRBT',[]),'Var'(1),'Comb'('FuncCall','SetRBT2.setRBT2list',['Var'(0)])]))).
evaluation('SetRBT2.intersectRBT','Rule'([0,1],'Comb'('FuncCall','SetRBT2.setRBT2_lambda2_7389',['Var'(1),'Var'(0),'Var'(0)]))).
evaluation('SetRBT2.sortRBT','Rule'([0,1],'Comb'('FuncCall','SetRBT2.setRBT2list',['Comb'('FuncCall',foldr,['Comb'('PartCall','SetRBT2.insertMultiRBT',[]),'Comb'('FuncCall','SetRBT2.emptySetRBT',['Var'(0)]),'Var'(1)])]))).
evaluation('SetRBT2.rbsBalance','Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'('SetRBT2.RBSEmpty',[]),'Comb'('ConsCall','SetRBT2.RBSEmpty',[])),'Branch'('Pattern'('SetRBT2.RBS',[1,2,3,4]),'Comb'('FuncCall','SetRBT2.setRBT2_lambda4_7390',['Var'(1),'Var'(2),'Var'(3),'Var'(4),'Comb'('FuncCall','SetRBT2.rbsBalanceL',['Comb'('ConsCall','SetRBT2.RBS',['Var'(1),'Var'(2),'Var'(3),'Var'(4)])])]))]))).
evaluation('SetRBT2.rbsBalanceL','Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'('SetRBT2.RBS',[1,2,3,4]),'Case'('Flex','Var'(3),['Branch'('Pattern'('SetRBT2.RBSEmpty',[]),'Comb'('ConsCall','SetRBT2.RBS',['Var'(1),'Var'(2),'Comb'('ConsCall','SetRBT2.RBSEmpty',[]),'Var'(4)])),'Branch'('Pattern'('SetRBT2.RBS',[5,6,7,8]),'Case'('Flex','Var'(7),['Branch'('Pattern'('SetRBT2.RBSEmpty',[]),'Case'('Flex','Var'(8),['Branch'('Pattern'('SetRBT2.RBSEmpty',[]),'Comb'('ConsCall','SetRBT2.RBS',['Var'(1),'Var'(2),'Comb'('ConsCall','SetRBT2.RBS',['Var'(5),'Var'(6),'Comb'('ConsCall','SetRBT2.RBSEmpty',[]),'Comb'('ConsCall','SetRBT2.RBSEmpty',[])]),'Var'(4)])),'Branch'('Pattern'('SetRBT2.RBS',[9,10,11,12]),'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',&&,['Comb'('FuncCall',==,['Var'(5),'Comb'('ConsCall','SetRBT2.RBSRed',[])]),'Comb'('FuncCall',==,['Var'(9),'Comb'('ConsCall','SetRBT2.RBSRed',[])])]),'Comb'('ConsCall','SetRBT2.RBS',['Comb'('ConsCall','SetRBT2.RBSRed',[]),'Var'(10),'Comb'('ConsCall','SetRBT2.RBS',['Comb'('ConsCall','SetRBT2.RBSBlack',[]),'Var'(6),'Comb'('ConsCall','SetRBT2.RBSEmpty',[]),'Var'(11)]),'Comb'('ConsCall','SetRBT2.RBS',['Comb'('ConsCall','SetRBT2.RBSBlack',[]),'Var'(2),'Var'(12),'Var'(4)])]),'Comb'('ConsCall','SetRBT2.RBS',['Var'(1),'Var'(2),'Comb'('ConsCall','SetRBT2.RBS',['Var'(5),'Var'(6),'Comb'('ConsCall','SetRBT2.RBSEmpty',[]),'Comb'('ConsCall','SetRBT2.RBS',['Var'(9),'Var'(10),'Var'(11),'Var'(12)])]),'Var'(4)])]))])),'Branch'('Pattern'('SetRBT2.RBS',[13,14,15,16]),'Case'('Flex','Var'(8),['Branch'('Pattern'('SetRBT2.RBSEmpty',[]),'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',&&,['Comb'('FuncCall',==,['Var'(5),'Comb'('ConsCall','SetRBT2.RBSRed',[])]),'Comb'('FuncCall',==,['Var'(13),'Comb'('ConsCall','SetRBT2.RBSRed',[])])]),'Comb'('ConsCall','SetRBT2.RBS',['Comb'('ConsCall','SetRBT2.RBSRed',[]),'Var'(6),'Comb'('ConsCall','SetRBT2.RBS',['Comb'('ConsCall','SetRBT2.RBSBlack',[]),'Var'(14),'Var'(15),'Var'(16)]),'Comb'('ConsCall','SetRBT2.RBS',['Comb'('ConsCall','SetRBT2.RBSBlack',[]),'Var'(2),'Comb'('ConsCall','SetRBT2.RBSEmpty',[]),'Var'(4)])]),'Comb'('ConsCall','SetRBT2.RBS',['Var'(1),'Var'(2),'Comb'('ConsCall','SetRBT2.RBS',['Var'(5),'Var'(6),'Comb'('ConsCall','SetRBT2.RBS',['Var'(13),'Var'(14),'Var'(15),'Var'(16)]),'Comb'('ConsCall','SetRBT2.RBSEmpty',[])]),'Var'(4)])])),'Branch'('Pattern'('SetRBT2.RBS',[17,18,19,20]),'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',&&,['Comb'('FuncCall',==,['Var'(5),'Comb'('ConsCall','SetRBT2.RBSRed',[])]),'Comb'('FuncCall',==,['Var'(13),'Comb'('ConsCall','SetRBT2.RBSRed',[])])]),'Comb'('ConsCall','SetRBT2.RBS',['Comb'('ConsCall','SetRBT2.RBSRed',[]),'Var'(6),'Comb'('ConsCall','SetRBT2.RBS',['Comb'('ConsCall','SetRBT2.RBSBlack',[]),'Var'(14),'Var'(15),'Var'(16)]),'Comb'('ConsCall','SetRBT2.RBS',['Comb'('ConsCall','SetRBT2.RBSBlack',[]),'Var'(2),'Comb'('ConsCall','SetRBT2.RBS',['Var'(17),'Var'(18),'Var'(19),'Var'(20)]),'Var'(4)])]),'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',&&,['Comb'('FuncCall',==,['Var'(5),'Comb'('ConsCall','SetRBT2.RBSRed',[])]),'Comb'('FuncCall',==,['Var'(17),'Comb'('ConsCall','SetRBT2.RBSRed',[])])]),'Comb'('ConsCall','SetRBT2.RBS',['Comb'('ConsCall','SetRBT2.RBSRed',[]),'Var'(18),'Comb'('ConsCall','SetRBT2.RBS',['Comb'('ConsCall','SetRBT2.RBSBlack',[]),'Var'(6),'Comb'('ConsCall','SetRBT2.RBS',['Var'(13),'Var'(14),'Var'(15),'Var'(16)]),'Var'(19)]),'Comb'('ConsCall','SetRBT2.RBS',['Comb'('ConsCall','SetRBT2.RBSBlack',[]),'Var'(2),'Var'(20),'Var'(4)])]),'Comb'('ConsCall','SetRBT2.RBS',['Var'(1),'Var'(2),'Comb'('ConsCall','SetRBT2.RBS',['Var'(5),'Var'(6),'Comb'('ConsCall','SetRBT2.RBS',['Var'(13),'Var'(14),'Var'(15),'Var'(16)]),'Comb'('ConsCall','SetRBT2.RBS',['Var'(17),'Var'(18),'Var'(19),'Var'(20)])]),'Var'(4)])])]))]))]))]))]))).
evaluation('SetRBT2.rbsBalanceR','Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'('SetRBT2.RBS',[1,2,3,4]),'Case'('Flex','Var'(4),['Branch'('Pattern'('SetRBT2.RBSEmpty',[]),'Comb'('ConsCall','SetRBT2.RBS',['Var'(1),'Var'(2),'Var'(3),'Comb'('ConsCall','SetRBT2.RBSEmpty',[])])),'Branch'('Pattern'('SetRBT2.RBS',[5,6,7,8]),'Case'('Flex','Var'(7),['Branch'('Pattern'('SetRBT2.RBSEmpty',[]),'Case'('Flex','Var'(8),['Branch'('Pattern'('SetRBT2.RBSEmpty',[]),'Comb'('ConsCall','SetRBT2.RBS',['Var'(1),'Var'(2),'Var'(3),'Comb'('ConsCall','SetRBT2.RBS',['Var'(5),'Var'(6),'Comb'('ConsCall','SetRBT2.RBSEmpty',[]),'Comb'('ConsCall','SetRBT2.RBSEmpty',[])])])),'Branch'('Pattern'('SetRBT2.RBS',[9,10,11,12]),'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',&&,['Comb'('FuncCall',==,['Var'(5),'Comb'('ConsCall','SetRBT2.RBSRed',[])]),'Comb'('FuncCall',==,['Var'(9),'Comb'('ConsCall','SetRBT2.RBSRed',[])])]),'Comb'('ConsCall','SetRBT2.RBS',['Comb'('ConsCall','SetRBT2.RBSRed',[]),'Var'(6),'Comb'('ConsCall','SetRBT2.RBS',['Comb'('ConsCall','SetRBT2.RBSBlack',[]),'Var'(2),'Var'(3),'Comb'('ConsCall','SetRBT2.RBSEmpty',[])]),'Comb'('ConsCall','SetRBT2.RBS',['Comb'('ConsCall','SetRBT2.RBSBlack',[]),'Var'(10),'Var'(11),'Var'(12)])]),'Comb'('ConsCall','SetRBT2.RBS',['Var'(1),'Var'(2),'Var'(3),'Comb'('ConsCall','SetRBT2.RBS',['Var'(5),'Var'(6),'Comb'('ConsCall','SetRBT2.RBSEmpty',[]),'Comb'('ConsCall','SetRBT2.RBS',['Var'(9),'Var'(10),'Var'(11),'Var'(12)])])])]))])),'Branch'('Pattern'('SetRBT2.RBS',[13,14,15,16]),'Case'('Flex','Var'(8),['Branch'('Pattern'('SetRBT2.RBSEmpty',[]),'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',&&,['Comb'('FuncCall',==,['Var'(5),'Comb'('ConsCall','SetRBT2.RBSRed',[])]),'Comb'('FuncCall',==,['Var'(13),'Comb'('ConsCall','SetRBT2.RBSRed',[])])]),'Comb'('ConsCall','SetRBT2.RBS',['Comb'('ConsCall','SetRBT2.RBSRed',[]),'Var'(14),'Comb'('ConsCall','SetRBT2.RBS',['Comb'('ConsCall','SetRBT2.RBSBlack',[]),'Var'(2),'Var'(3),'Var'(15)]),'Comb'('ConsCall','SetRBT2.RBS',['Comb'('ConsCall','SetRBT2.RBSBlack',[]),'Var'(6),'Var'(16),'Comb'('ConsCall','SetRBT2.RBSEmpty',[])])]),'Comb'('ConsCall','SetRBT2.RBS',['Var'(1),'Var'(2),'Var'(3),'Comb'('ConsCall','SetRBT2.RBS',['Var'(5),'Var'(6),'Comb'('ConsCall','SetRBT2.RBS',['Var'(13),'Var'(14),'Var'(15),'Var'(16)]),'Comb'('ConsCall','SetRBT2.RBSEmpty',[])])])])),'Branch'('Pattern'('SetRBT2.RBS',[17,18,19,20]),'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',&&,['Comb'('FuncCall',==,['Var'(5),'Comb'('ConsCall','SetRBT2.RBSRed',[])]),'Comb'('FuncCall',==,['Var'(13),'Comb'('ConsCall','SetRBT2.RBSRed',[])])]),'Comb'('ConsCall','SetRBT2.RBS',['Comb'('ConsCall','SetRBT2.RBSRed',[]),'Var'(14),'Comb'('ConsCall','SetRBT2.RBS',['Comb'('ConsCall','SetRBT2.RBSBlack',[]),'Var'(2),'Var'(3),'Var'(15)]),'Comb'('ConsCall','SetRBT2.RBS',['Comb'('ConsCall','SetRBT2.RBSBlack',[]),'Var'(6),'Var'(16),'Comb'('ConsCall','SetRBT2.RBS',['Var'(17),'Var'(18),'Var'(19),'Var'(20)])])]),'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',&&,['Comb'('FuncCall',==,['Var'(5),'Comb'('ConsCall','SetRBT2.RBSRed',[])]),'Comb'('FuncCall',==,['Var'(17),'Comb'('ConsCall','SetRBT2.RBSRed',[])])]),'Comb'('ConsCall','SetRBT2.RBS',['Comb'('ConsCall','SetRBT2.RBSRed',[]),'Var'(6),'Comb'('ConsCall','SetRBT2.RBS',['Comb'('ConsCall','SetRBT2.RBSBlack',[]),'Var'(2),'Var'(3),'Comb'('ConsCall','SetRBT2.RBS',['Var'(13),'Var'(14),'Var'(15),'Var'(16)])]),'Comb'('ConsCall','SetRBT2.RBS',['Comb'('ConsCall','SetRBT2.RBSBlack',[]),'Var'(18),'Var'(19),'Var'(20)])]),'Comb'('ConsCall','SetRBT2.RBS',['Var'(1),'Var'(2),'Var'(3),'Comb'('ConsCall','SetRBT2.RBS',['Var'(5),'Var'(6),'Comb'('ConsCall','SetRBT2.RBS',['Var'(13),'Var'(14),'Var'(15),'Var'(16)]),'Comb'('ConsCall','SetRBT2.RBS',['Var'(17),'Var'(18),'Var'(19),'Var'(20)])])])])]))]))]))]))]))).
evaluation('SetRBT2.ins_6383','Rule'([0,1,2],'Case'('Flex','Var'(2),['Branch'('Pattern'('SetRBT2.RBSEmpty',[]),'Comb'('ConsCall','SetRBT2.RBS',['Comb'('ConsCall','SetRBT2.RBSRed',[]),'Var'(0),'Comb'('ConsCall','SetRBT2.RBSEmpty',[]),'Comb'('ConsCall','SetRBT2.RBSEmpty',[])])),'Branch'('Pattern'('SetRBT2.RBS',[3,4,5,6]),'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',==,['Var'(0),'Var'(4)]),'Comb'('ConsCall','SetRBT2.RBS',['Var'(3),'Var'(4),'Var'(5),'Var'(6)]),'Comb'('FuncCall',if_then_else,['Apply'('Apply'('Var'(1),'Var'(0)),'Var'(4)),'Comb'('FuncCall','SetRBT2.rbsBalanceL',['Comb'('ConsCall','SetRBT2.RBS',['Var'(3),'Var'(4),'Comb'('FuncCall','SetRBT2.ins_6383',['Var'(0),'Var'(1),'Var'(5)]),'Var'(6)])]),'Comb'('FuncCall','SetRBT2.rbsBalanceR',['Comb'('ConsCall','SetRBT2.RBS',['Var'(3),'Var'(4),'Var'(5),'Comb'('FuncCall','SetRBT2.ins_6383',['Var'(0),'Var'(1),'Var'(6)])])])])]))]))).
evaluation('SetRBT2.setRBT2_lambda0_7386','Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'('SetRBT2.RBS',[1,2,3,4]),'Comb'('ConsCall','SetRBT2.RBS',['Comb'('ConsCall','SetRBT2.RBSBlack',[]),'Var'(2),'Var'(3),'Var'(4)]))]))).
evaluation('SetRBT2.ins_6398','Rule'([0,1,2],'Case'('Flex','Var'(2),['Branch'('Pattern'('SetRBT2.RBSEmpty',[]),'Comb'('ConsCall','SetRBT2.RBS',['Comb'('ConsCall','SetRBT2.RBSRed',[]),'Var'(0),'Comb'('ConsCall','SetRBT2.RBSEmpty',[]),'Comb'('ConsCall','SetRBT2.RBSEmpty',[])])),'Branch'('Pattern'('SetRBT2.RBS',[3,4,5,6]),'Comb'('FuncCall',if_then_else,['Apply'('Apply'('Var'(1),'Var'(0)),'Var'(4)),'Comb'('FuncCall','SetRBT2.rbsBalanceL',['Comb'('ConsCall','SetRBT2.RBS',['Var'(3),'Var'(4),'Comb'('FuncCall','SetRBT2.ins_6398',['Var'(0),'Var'(1),'Var'(5)]),'Var'(6)])]),'Comb'('FuncCall','SetRBT2.rbsBalanceR',['Comb'('ConsCall','SetRBT2.RBS',['Var'(3),'Var'(4),'Var'(5),'Comb'('FuncCall','SetRBT2.ins_6398',['Var'(0),'Var'(1),'Var'(6)])])])]))]))).
evaluation('SetRBT2.setRBT2_lambda1_7387','Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'('SetRBT2.RBS',[1,2,3,4]),'Comb'('ConsCall','SetRBT2.RBS',['Comb'('ConsCall','SetRBT2.RBSBlack',[]),'Var'(2),'Var'(3),'Var'(4)]))]))).
evaluation('SetRBT2.s2l_6409','Rule'([0,1],'Case'('Flex','Var'(0),['Branch'('Pattern'('SetRBT2.RBSEmpty',[]),'Var'(1)),'Branch'('Pattern'('SetRBT2.RBS',[2,3,4,5]),'Comb'('FuncCall','SetRBT2.s2l_6409',['Var'(4),'Comb'('ConsCall','.',['Var'(3),'Comb'('FuncCall','SetRBT2.s2l_6409',['Var'(5),'Var'(1)])])]))]))).
evaluation('SetRBT2.setRBT2_lambda3_7388','Rule'([0,1],'Comb'('FuncCall','SetRBT2.elemRBT',['Var'(1),'Var'(0)]))).
evaluation('SetRBT2.setRBT2_lambda2_7389','Rule'([0,1,2],'Case'('Flex','Var'(2),['Branch'('Pattern'('SetRBT2.SetRBT',[3,4]),'Comb'('FuncCall',foldr,['Comb'('PartCall','SetRBT2.insertRBT',[]),'Comb'('FuncCall','SetRBT2.emptySetRBT',['Var'(3)]),'Comb'('FuncCall',filter,['Comb'('PartCall','SetRBT2.setRBT2_lambda3_7388',['Var'(0)]),'Comb'('FuncCall','SetRBT2.setRBT2list',['Var'(1)])])]))]))).
evaluation('SetRBT2.setRBT2_lambda4_7390','Rule'([0,1,2,3,4],'Case'('Flex','Var'(4),['Branch'('Pattern'('SetRBT2.RBS',[5,6,7,8]),'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',/=,['Var'(0),'Comb'('ConsCall','SetRBT2.RBSBlack',[])]),'Comb'('ConsCall','SetRBT2.RBS',['Var'(0),'Var'(1),'Var'(2),'Var'(3)]),'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',==,['Var'(5),'Comb'('ConsCall','SetRBT2.RBSRed',[])]),'Comb'('ConsCall','SetRBT2.RBS',['Var'(5),'Var'(6),'Var'(7),'Var'(8)]),'Comb'('FuncCall','SetRBT2.rbsBalanceR',['Comb'('ConsCall','SetRBT2.RBS',['Var'(0),'Var'(1),'Var'(2),'Var'(3)])])])]))]))).
evaluation('TableRBT2.emptyTableRBT','Rule'([0],'Comb'('ConsCall','TableRBT2.TableRBT',['Var'(0),'Comb'('ConsCall','TableRBT2.RBTEmpty',[])]))).
evaluation('TableRBT2.lookupRBT','Rule'([0,1],'Case'('Flex','Var'(1),['Branch'('Pattern'('TableRBT2.TableRBT',[2,3]),'Comb'('FuncCall','TableRBT2.lookupRBTree',['Var'(2),'Var'(0),'Var'(3)]))]))).
evaluation('TableRBT2.lookupRBTree','Rule'([0,1,2],'Case'('Flex','Var'(2),['Branch'('Pattern'('TableRBT2.RBTEmpty',[]),'Comb'('ConsCall','Nothing',[])),'Branch'('Pattern'('TableRBT2.RBT',[3,4,5,6,7]),'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',==,['Var'(4),'Var'(1)]),'Comb'('ConsCall','Just',['Var'(5)]),'Comb'('FuncCall',if_then_else,['Apply'('Apply'('Var'(0),'Var'(1)),'Var'(4)),'Comb'('FuncCall','TableRBT2.lookupRBTree',['Var'(0),'Var'(1),'Var'(6)]),'Comb'('FuncCall','TableRBT2.lookupRBTree',['Var'(0),'Var'(1),'Var'(7)])])]))]))).
evaluation('TableRBT2.updateRBT','Rule'([0,1,2],'Case'('Flex','Var'(2),['Branch'('Pattern'('TableRBT2.TableRBT',[3,4]),'Comb'('FuncCall',$,['Comb'('PartCall','TableRBT2.TableRBT',['Var'(3)]),'Comb'('FuncCall','TableRBT2.updateRBTree',['Var'(3),'Var'(0),'Var'(1),'Var'(4)])]))]))).
evaluation('TableRBT2.updateRBTree','Rule'([0,1,2,3],'Comb'('FuncCall','TableRBT2.tableRBT2_lambda0_8750',['Comb'('FuncCall','TableRBT2.ins_7577',['Var'(1),'Var'(2),'Var'(0),'Var'(3)])]))).
evaluation('TableRBT2.tableRBT2list','Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'('TableRBT2.TableRBT',[1,2]),'Comb'('FuncCall','TableRBT2.t2l_7590',['Var'(2),'Comb'('ConsCall',[],[])]))]))).
evaluation('TableRBT2.rbtBalance','Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'('TableRBT2.RBTEmpty',[]),'Comb'('ConsCall','TableRBT2.RBTEmpty',[])),'Branch'('Pattern'('TableRBT2.RBT',[1,2,3,4,5]),'Comb'('FuncCall','TableRBT2.tableRBT2_lambda1_8751',['Var'(1),'Var'(2),'Var'(3),'Var'(4),'Var'(5),'Comb'('FuncCall','TableRBT2.rbtBalanceL',['Comb'('ConsCall','TableRBT2.RBT',['Var'(1),'Var'(2),'Var'(3),'Var'(4),'Var'(5)])])]))]))).
evaluation('TableRBT2.rbtBalanceL','Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'('TableRBT2.RBT',[1,2,3,4,5]),'Case'('Flex','Var'(4),['Branch'('Pattern'('TableRBT2.RBTEmpty',[]),'Comb'('ConsCall','TableRBT2.RBT',['Var'(1),'Var'(2),'Var'(3),'Comb'('ConsCall','TableRBT2.RBTEmpty',[]),'Var'(5)])),'Branch'('Pattern'('TableRBT2.RBT',[6,7,8,9,10]),'Case'('Flex','Var'(9),['Branch'('Pattern'('TableRBT2.RBTEmpty',[]),'Case'('Flex','Var'(10),['Branch'('Pattern'('TableRBT2.RBTEmpty',[]),'Comb'('ConsCall','TableRBT2.RBT',['Var'(1),'Var'(2),'Var'(3),'Comb'('ConsCall','TableRBT2.RBT',['Var'(6),'Var'(7),'Var'(8),'Comb'('ConsCall','TableRBT2.RBTEmpty',[]),'Comb'('ConsCall','TableRBT2.RBTEmpty',[])]),'Var'(5)])),'Branch'('Pattern'('TableRBT2.RBT',[11,12,13,14,15]),'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',&&,['Comb'('FuncCall',==,['Var'(6),'Comb'('ConsCall','TableRBT2.RBTRed',[])]),'Comb'('FuncCall',==,['Var'(11),'Comb'('ConsCall','TableRBT2.RBTRed',[])])]),'Comb'('ConsCall','TableRBT2.RBT',['Comb'('ConsCall','TableRBT2.RBTRed',[]),'Var'(12),'Var'(13),'Comb'('ConsCall','TableRBT2.RBT',['Comb'('ConsCall','TableRBT2.RBTBlack',[]),'Var'(7),'Var'(8),'Comb'('ConsCall','TableRBT2.RBTEmpty',[]),'Var'(14)]),'Comb'('ConsCall','TableRBT2.RBT',['Comb'('ConsCall','TableRBT2.RBTBlack',[]),'Var'(2),'Var'(3),'Var'(15),'Var'(5)])]),'Comb'('ConsCall','TableRBT2.RBT',['Var'(1),'Var'(2),'Var'(3),'Comb'('ConsCall','TableRBT2.RBT',['Var'(6),'Var'(7),'Var'(8),'Comb'('ConsCall','TableRBT2.RBTEmpty',[]),'Comb'('ConsCall','TableRBT2.RBT',['Var'(11),'Var'(12),'Var'(13),'Var'(14),'Var'(15)])]),'Var'(5)])]))])),'Branch'('Pattern'('TableRBT2.RBT',[16,17,18,19,20]),'Case'('Flex','Var'(10),['Branch'('Pattern'('TableRBT2.RBTEmpty',[]),'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',&&,['Comb'('FuncCall',==,['Var'(6),'Comb'('ConsCall','TableRBT2.RBTRed',[])]),'Comb'('FuncCall',==,['Var'(16),'Comb'('ConsCall','TableRBT2.RBTRed',[])])]),'Comb'('ConsCall','TableRBT2.RBT',['Comb'('ConsCall','TableRBT2.RBTRed',[]),'Var'(7),'Var'(8),'Comb'('ConsCall','TableRBT2.RBT',['Comb'('ConsCall','TableRBT2.RBTBlack',[]),'Var'(17),'Var'(18),'Var'(19),'Var'(20)]),'Comb'('ConsCall','TableRBT2.RBT',['Comb'('ConsCall','TableRBT2.RBTBlack',[]),'Var'(2),'Var'(3),'Comb'('ConsCall','TableRBT2.RBTEmpty',[]),'Var'(5)])]),'Comb'('ConsCall','TableRBT2.RBT',['Var'(1),'Var'(2),'Var'(3),'Comb'('ConsCall','TableRBT2.RBT',['Var'(6),'Var'(7),'Var'(8),'Comb'('ConsCall','TableRBT2.RBT',['Var'(16),'Var'(17),'Var'(18),'Var'(19),'Var'(20)]),'Comb'('ConsCall','TableRBT2.RBTEmpty',[])]),'Var'(5)])])),'Branch'('Pattern'('TableRBT2.RBT',[21,22,23,24,25]),'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',&&,['Comb'('FuncCall',==,['Var'(6),'Comb'('ConsCall','TableRBT2.RBTRed',[])]),'Comb'('FuncCall',==,['Var'(16),'Comb'('ConsCall','TableRBT2.RBTRed',[])])]),'Comb'('ConsCall','TableRBT2.RBT',['Comb'('ConsCall','TableRBT2.RBTRed',[]),'Var'(7),'Var'(8),'Comb'('ConsCall','TableRBT2.RBT',['Comb'('ConsCall','TableRBT2.RBTBlack',[]),'Var'(17),'Var'(18),'Var'(19),'Var'(20)]),'Comb'('ConsCall','TableRBT2.RBT',['Comb'('ConsCall','TableRBT2.RBTBlack',[]),'Var'(2),'Var'(3),'Comb'('ConsCall','TableRBT2.RBT',['Var'(21),'Var'(22),'Var'(23),'Var'(24),'Var'(25)]),'Var'(5)])]),'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',&&,['Comb'('FuncCall',==,['Var'(6),'Comb'('ConsCall','TableRBT2.RBTRed',[])]),'Comb'('FuncCall',==,['Var'(21),'Comb'('ConsCall','TableRBT2.RBTRed',[])])]),'Comb'('ConsCall','TableRBT2.RBT',['Comb'('ConsCall','TableRBT2.RBTRed',[]),'Var'(22),'Var'(23),'Comb'('ConsCall','TableRBT2.RBT',['Comb'('ConsCall','TableRBT2.RBTBlack',[]),'Var'(7),'Var'(8),'Comb'('ConsCall','TableRBT2.RBT',['Var'(16),'Var'(17),'Var'(18),'Var'(19),'Var'(20)]),'Var'(24)]),'Comb'('ConsCall','TableRBT2.RBT',['Comb'('ConsCall','TableRBT2.RBTBlack',[]),'Var'(2),'Var'(3),'Var'(25),'Var'(5)])]),'Comb'('ConsCall','TableRBT2.RBT',['Var'(1),'Var'(2),'Var'(3),'Comb'('ConsCall','TableRBT2.RBT',['Var'(6),'Var'(7),'Var'(8),'Comb'('ConsCall','TableRBT2.RBT',['Var'(16),'Var'(17),'Var'(18),'Var'(19),'Var'(20)]),'Comb'('ConsCall','TableRBT2.RBT',['Var'(21),'Var'(22),'Var'(23),'Var'(24),'Var'(25)])]),'Var'(5)])])]))]))]))]))]))).
evaluation('TableRBT2.rbtBalanceR','Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'('TableRBT2.RBT',[1,2,3,4,5]),'Case'('Flex','Var'(5),['Branch'('Pattern'('TableRBT2.RBTEmpty',[]),'Comb'('ConsCall','TableRBT2.RBT',['Var'(1),'Var'(2),'Var'(3),'Var'(4),'Comb'('ConsCall','TableRBT2.RBTEmpty',[])])),'Branch'('Pattern'('TableRBT2.RBT',[6,7,8,9,10]),'Case'('Flex','Var'(9),['Branch'('Pattern'('TableRBT2.RBTEmpty',[]),'Case'('Flex','Var'(10),['Branch'('Pattern'('TableRBT2.RBTEmpty',[]),'Comb'('ConsCall','TableRBT2.RBT',['Var'(1),'Var'(2),'Var'(3),'Var'(4),'Comb'('ConsCall','TableRBT2.RBT',['Var'(6),'Var'(7),'Var'(8),'Comb'('ConsCall','TableRBT2.RBTEmpty',[]),'Comb'('ConsCall','TableRBT2.RBTEmpty',[])])])),'Branch'('Pattern'('TableRBT2.RBT',[11,12,13,14,15]),'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',&&,['Comb'('FuncCall',==,['Var'(6),'Comb'('ConsCall','TableRBT2.RBTRed',[])]),'Comb'('FuncCall',==,['Var'(11),'Comb'('ConsCall','TableRBT2.RBTRed',[])])]),'Comb'('ConsCall','TableRBT2.RBT',['Comb'('ConsCall','TableRBT2.RBTRed',[]),'Var'(7),'Var'(8),'Comb'('ConsCall','TableRBT2.RBT',['Comb'('ConsCall','TableRBT2.RBTBlack',[]),'Var'(2),'Var'(3),'Var'(4),'Comb'('ConsCall','TableRBT2.RBTEmpty',[])]),'Comb'('ConsCall','TableRBT2.RBT',['Comb'('ConsCall','TableRBT2.RBTBlack',[]),'Var'(12),'Var'(13),'Var'(14),'Var'(15)])]),'Comb'('ConsCall','TableRBT2.RBT',['Var'(1),'Var'(2),'Var'(3),'Var'(4),'Comb'('ConsCall','TableRBT2.RBT',['Var'(6),'Var'(7),'Var'(8),'Comb'('ConsCall','TableRBT2.RBTEmpty',[]),'Comb'('ConsCall','TableRBT2.RBT',['Var'(11),'Var'(12),'Var'(13),'Var'(14),'Var'(15)])])])]))])),'Branch'('Pattern'('TableRBT2.RBT',[16,17,18,19,20]),'Case'('Flex','Var'(10),['Branch'('Pattern'('TableRBT2.RBTEmpty',[]),'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',&&,['Comb'('FuncCall',==,['Var'(6),'Comb'('ConsCall','TableRBT2.RBTRed',[])]),'Comb'('FuncCall',==,['Var'(16),'Comb'('ConsCall','TableRBT2.RBTRed',[])])]),'Comb'('ConsCall','TableRBT2.RBT',['Comb'('ConsCall','TableRBT2.RBTRed',[]),'Var'(17),'Var'(18),'Comb'('ConsCall','TableRBT2.RBT',['Comb'('ConsCall','TableRBT2.RBTBlack',[]),'Var'(2),'Var'(3),'Var'(4),'Var'(19)]),'Comb'('ConsCall','TableRBT2.RBT',['Comb'('ConsCall','TableRBT2.RBTBlack',[]),'Var'(7),'Var'(8),'Var'(20),'Comb'('ConsCall','TableRBT2.RBTEmpty',[])])]),'Comb'('ConsCall','TableRBT2.RBT',['Var'(1),'Var'(2),'Var'(3),'Var'(4),'Comb'('ConsCall','TableRBT2.RBT',['Var'(6),'Var'(7),'Var'(8),'Comb'('ConsCall','TableRBT2.RBT',['Var'(16),'Var'(17),'Var'(18),'Var'(19),'Var'(20)]),'Comb'('ConsCall','TableRBT2.RBTEmpty',[])])])])),'Branch'('Pattern'('TableRBT2.RBT',[21,22,23,24,25]),'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',&&,['Comb'('FuncCall',==,['Var'(6),'Comb'('ConsCall','TableRBT2.RBTRed',[])]),'Comb'('FuncCall',==,['Var'(16),'Comb'('ConsCall','TableRBT2.RBTRed',[])])]),'Comb'('ConsCall','TableRBT2.RBT',['Comb'('ConsCall','TableRBT2.RBTRed',[]),'Var'(17),'Var'(18),'Comb'('ConsCall','TableRBT2.RBT',['Comb'('ConsCall','TableRBT2.RBTBlack',[]),'Var'(2),'Var'(3),'Var'(4),'Var'(19)]),'Comb'('ConsCall','TableRBT2.RBT',['Comb'('ConsCall','TableRBT2.RBTBlack',[]),'Var'(7),'Var'(8),'Var'(20),'Comb'('ConsCall','TableRBT2.RBT',['Var'(21),'Var'(22),'Var'(23),'Var'(24),'Var'(25)])])]),'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',&&,['Comb'('FuncCall',==,['Var'(6),'Comb'('ConsCall','TableRBT2.RBTRed',[])]),'Comb'('FuncCall',==,['Var'(21),'Comb'('ConsCall','TableRBT2.RBTRed',[])])]),'Comb'('ConsCall','TableRBT2.RBT',['Comb'('ConsCall','TableRBT2.RBTRed',[]),'Var'(7),'Var'(8),'Comb'('ConsCall','TableRBT2.RBT',['Comb'('ConsCall','TableRBT2.RBTBlack',[]),'Var'(2),'Var'(3),'Var'(4),'Comb'('ConsCall','TableRBT2.RBT',['Var'(16),'Var'(17),'Var'(18),'Var'(19),'Var'(20)])]),'Comb'('ConsCall','TableRBT2.RBT',['Comb'('ConsCall','TableRBT2.RBTBlack',[]),'Var'(22),'Var'(23),'Var'(24),'Var'(25)])]),'Comb'('ConsCall','TableRBT2.RBT',['Var'(1),'Var'(2),'Var'(3),'Var'(4),'Comb'('ConsCall','TableRBT2.RBT',['Var'(6),'Var'(7),'Var'(8),'Comb'('ConsCall','TableRBT2.RBT',['Var'(16),'Var'(17),'Var'(18),'Var'(19),'Var'(20)]),'Comb'('ConsCall','TableRBT2.RBT',['Var'(21),'Var'(22),'Var'(23),'Var'(24),'Var'(25)])])])])]))]))]))]))]))).
evaluation('TableRBT2.ins_7577','Rule'([0,1,2,3],'Case'('Flex','Var'(3),['Branch'('Pattern'('TableRBT2.RBTEmpty',[]),'Comb'('ConsCall','TableRBT2.RBT',['Comb'('ConsCall','TableRBT2.RBTRed',[]),'Var'(0),'Var'(1),'Comb'('ConsCall','TableRBT2.RBTEmpty',[]),'Comb'('ConsCall','TableRBT2.RBTEmpty',[])])),'Branch'('Pattern'('TableRBT2.RBT',[4,5,6,7,8]),'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',==,['Var'(0),'Var'(5)]),'Comb'('ConsCall','TableRBT2.RBT',['Var'(4),'Var'(5),'Var'(1),'Var'(7),'Var'(8)]),'Comb'('FuncCall',if_then_else,['Apply'('Apply'('Var'(2),'Var'(0)),'Var'(5)),'Comb'('FuncCall','TableRBT2.rbtBalanceL',['Comb'('ConsCall','TableRBT2.RBT',['Var'(4),'Var'(5),'Var'(6),'Comb'('FuncCall','TableRBT2.ins_7577',['Var'(0),'Var'(1),'Var'(2),'Var'(7)]),'Var'(8)])]),'Comb'('FuncCall','TableRBT2.rbtBalanceR',['Comb'('ConsCall','TableRBT2.RBT',['Var'(4),'Var'(5),'Var'(6),'Var'(7),'Comb'('FuncCall','TableRBT2.ins_7577',['Var'(0),'Var'(1),'Var'(2),'Var'(8)])])])])]))]))).
evaluation('TableRBT2.tableRBT2_lambda0_8750','Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'('TableRBT2.RBT',[1,2,3,4,5]),'Comb'('ConsCall','TableRBT2.RBT',['Comb'('ConsCall','TableRBT2.RBTBlack',[]),'Var'(2),'Var'(3),'Var'(4),'Var'(5)]))]))).
evaluation('TableRBT2.t2l_7590','Rule'([0,1],'Case'('Flex','Var'(0),['Branch'('Pattern'('TableRBT2.RBTEmpty',[]),'Var'(1)),'Branch'('Pattern'('TableRBT2.RBT',[2,3,4,5,6]),'Comb'('FuncCall','TableRBT2.t2l_7590',['Var'(5),'Comb'('ConsCall','.',['Comb'('ConsCall','(,)',['Var'(3),'Var'(4)]),'Comb'('FuncCall','TableRBT2.t2l_7590',['Var'(6),'Var'(1)])])]))]))).
evaluation('TableRBT2.tableRBT2_lambda1_8751','Rule'([0,1,2,3,4,5],'Case'('Flex','Var'(5),['Branch'('Pattern'('TableRBT2.RBT',[6,7,8,9,10]),'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',/=,['Var'(0),'Comb'('ConsCall','TableRBT2.RBTBlack',[])]),'Comb'('ConsCall','TableRBT2.RBT',['Var'(0),'Var'(1),'Var'(2),'Var'(3),'Var'(4)]),'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',==,['Var'(6),'Comb'('ConsCall','TableRBT2.RBTRed',[])]),'Comb'('ConsCall','TableRBT2.RBT',['Var'(6),'Var'(7),'Var'(8),'Var'(9),'Var'(10)]),'Comb'('FuncCall','TableRBT2.rbtBalanceR',['Comb'('ConsCall','TableRBT2.RBT',['Var'(0),'Var'(1),'Var'(2),'Var'(3),'Var'(4)])])])]))]))).
evaluation('System.showDate','Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'('System.Date',[1,2,3,4,5,6]),'Comb'('FuncCall',++,['Comb'('FuncCall','System.digit2_2404',['Var'(2)]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(47)),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall',++,['Comb'('FuncCall','System.digit2_2404',['Var'(3)]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(47)),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall',++,['Comb'('FuncCall',show,['Var'(1)]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall',++,['Comb'('FuncCall','System.digit2_2404',['Var'(4)]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(58)),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall',++,['Comb'('FuncCall','System.digit2_2404',['Var'(5)]),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Lit'('Charc'(58)),'Comb'('ConsCall',[],[])]),'Comb'('FuncCall','System.digit2_2404',['Var'(6)])])])])])])])])])])]))]))).
evaluation('System.digit2_2404','Rule'([0],'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',<,['Var'(0),'Lit'('Intc'(10))]),'Comb'('ConsCall','.',['Lit'('Charc'(48)),'Comb'('ConsCall','.',['Comb'('FuncCall',chr,['Comb'('FuncCall',+,['Comb'('FuncCall',ord,['Lit'('Charc'(48))]),'Var'(0)])]),'Comb'('ConsCall',[],[])])]),'Comb'('FuncCall',show,['Var'(0)])]))).
evaluation('List.nub','Rule'([0],'Comb'('FuncCall','List.nubBy',['Comb'('PartCall',==,[]),'Var'(0)]))).
evaluation('List.nubBy','Rule'([0,1],'Case'('Flex','Var'(1),['Branch'('Pattern'([],[]),'Comb'('ConsCall',[],[])),'Branch'('Pattern'('.',[2,3]),'Comb'('ConsCall','.',['Var'(2),'Comb'('FuncCall','List.nubBy',['Var'(0),'Comb'('FuncCall',filter,['Comb'('PartCall','List.list_lambda0_3110',['Var'(0),'Var'(2)]),'Var'(3)])])]))]))).
evaluation('List.delete','Rule'([0,1],'Case'('Flex','Var'(1),['Branch'('Pattern'([],[]),'Comb'('ConsCall',[],[])),'Branch'('Pattern'('.',[2,3]),'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',==,['Var'(0),'Var'(2)]),'Var'(3),'Comb'('ConsCall','.',['Var'(2),'Comb'('FuncCall','List.delete',['Var'(0),'Var'(3)])])]))]))).
evaluation('List.union','Rule'([0,1],'Case'('Flex','Var'(0),['Branch'('Pattern'([],[]),'Var'(1)),'Branch'('Pattern'('.',[2,3]),'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',elem,['Var'(2),'Var'(1)]),'Comb'('FuncCall','List.union',['Var'(3),'Var'(1)]),'Comb'('ConsCall','.',['Var'(2),'Comb'('FuncCall','List.union',['Var'(3),'Var'(1)])])]))]))).
evaluation('List.intersect','Rule'([0,1],'Case'('Flex','Var'(0),['Branch'('Pattern'([],[]),'Comb'('ConsCall',[],[])),'Branch'('Pattern'('.',[2,3]),'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',elem,['Var'(2),'Var'(1)]),'Comb'('ConsCall','.',['Var'(2),'Comb'('FuncCall','List.intersect',['Var'(3),'Var'(1)])]),'Comb'('FuncCall','List.intersect',['Var'(3),'Var'(1)])]))]))).
evaluation('List.intersperse','Rule'([0,1],'Case'('Flex','Var'(1),['Branch'('Pattern'([],[]),'Comb'('ConsCall',[],[])),'Branch'('Pattern'('.',[2,3]),'Case'('Flex','Var'(3),['Branch'('Pattern'([],[]),'Comb'('ConsCall','.',['Var'(2),'Comb'('ConsCall',[],[])])),'Branch'('Pattern'('.',[4,5]),'Comb'('ConsCall','.',['Var'(2),'Comb'('ConsCall','.',['Var'(0),'Comb'('FuncCall','List.intersperse',['Var'(0),'Comb'('ConsCall','.',['Var'(4),'Var'(5)])])])]))]))]))).
evaluation('List.transpose','Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'([],[]),'Comb'('ConsCall',[],[])),'Branch'('Pattern'('.',[1,2]),'Case'('Flex','Var'(1),['Branch'('Pattern'([],[]),'Comb'('FuncCall','List.transpose',['Var'(2)])),'Branch'('Pattern'('.',[3,4]),'Comb'('ConsCall','.',['Comb'('ConsCall','.',['Var'(3),'Comb'('FuncCall',map,['Comb'('PartCall',head,[]),'Var'(2)])]),'Comb'('FuncCall','List.transpose',['Comb'('ConsCall','.',['Var'(4),'Comb'('FuncCall',map,['Comb'('PartCall',tail,[]),'Var'(2)])])])]))]))]))).
evaluation('List.partition','Rule'([0,1],'Comb'('FuncCall',foldr,['Comb'('PartCall','List.select_2741',['Var'(0)]),'Comb'('ConsCall','(,)',['Comb'('ConsCall',[],[]),'Comb'('ConsCall',[],[])]),'Var'(1)]))).
evaluation('List.group','Rule'([0],'Apply'('Comb'('PartCall','List.groupBy',['Comb'('PartCall',==,[])]),'Var'(0)))).
evaluation('List.groupBy','Rule'([0,1],'Case'('Flex','Var'(1),['Branch'('Pattern'([],[]),'Comb'('ConsCall',[],[])),'Branch'('Pattern'('.',[2,3]),'Comb'('FuncCall','List.list_lambda1_3111',['Var'(2),'Var'(0),'Comb'('FuncCall',span,['Apply'('Var'(0),'Var'(2)),'Var'(3)])]))]))).
evaluation('List.replace','Rule'([0,1,2],'Case'('Flex','Var'(2),['Branch'('Pattern'([],[]),'Comb'('ConsCall',[],[])),'Branch'('Pattern'('.',[3,4]),'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',==,['Var'(1),'Lit'('Intc'(0))]),'Comb'('ConsCall','.',['Var'(0),'Var'(4)]),'Comb'('ConsCall','.',['Var'(3),'Comb'('FuncCall','List.replace',['Var'(0),'Comb'('FuncCall',-,['Var'(1),'Lit'('Intc'(1))]),'Var'(4)])])]))]))).
evaluation('List.isPrefixOf','Rule'([0,1],'Case'('Flex','Var'(0),['Branch'('Pattern'([],[]),'Comb'('ConsCall','True',[])),'Branch'('Pattern'('.',[2,3]),'Case'('Flex','Var'(1),['Branch'('Pattern'([],[]),'Comb'('ConsCall','False',[])),'Branch'('Pattern'('.',[4,5]),'Comb'('FuncCall',&&,['Comb'('FuncCall',==,['Var'(2),'Var'(4)]),'Comb'('FuncCall','List.isPrefixOf',['Var'(3),'Var'(5)])]))]))]))).
evaluation('List.sortBy','Rule'([0,1],'Apply'('Comb'('PartCall',foldr,['Comb'('PartCall','List.insertBy',['Var'(0)]),'Comb'('ConsCall',[],[])]),'Var'(1)))).
evaluation('List.insertBy','Rule'([0,1,2],'Case'('Flex','Var'(2),['Branch'('Pattern'([],[]),'Comb'('ConsCall','.',['Var'(1),'Comb'('ConsCall',[],[])])),'Branch'('Pattern'('.',[3,4]),'Comb'('FuncCall',if_then_else,['Apply'('Apply'('Var'(0),'Var'(1)),'Var'(3)),'Comb'('ConsCall','.',['Var'(1),'Comb'('ConsCall','.',['Var'(3),'Var'(4)])]),'Comb'('ConsCall','.',['Var'(3),'Comb'('FuncCall','List.insertBy',['Var'(0),'Var'(1),'Var'(4)])])]))]))).
evaluation('List.last','Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'('.',[1,2]),'Case'('Flex','Var'(2),['Branch'('Pattern'([],[]),'Var'(1)),'Branch'('Pattern'('.',[3,4]),'Comb'('FuncCall','List.last',['Comb'('ConsCall','.',['Var'(3),'Var'(4)])]))]))]))).
evaluation('List.list_lambda0_3110','Rule'([0,1,2],'Comb'('FuncCall',not,['Apply'('Apply'('Var'(0),'Var'(1)),'Var'(2))]))).
evaluation('List.select_2741','Rule'([0,1,2],'Case'('Flex','Var'(2),['Branch'('Pattern'('(,)',[3,4]),'Comb'('FuncCall',if_then_else,['Apply'('Var'(0),'Var'(1)),'Comb'('ConsCall','(,)',['Comb'('ConsCall','.',['Var'(1),'Var'(3)]),'Var'(4)]),'Comb'('ConsCall','(,)',['Var'(3),'Comb'('ConsCall','.',['Var'(1),'Var'(4)])])]))]))).
evaluation('List.list_lambda1_3111','Rule'([0,1,2],'Case'('Flex','Var'(2),['Branch'('Pattern'('(,)',[3,4]),'Comb'('ConsCall','.',['Comb'('ConsCall','.',['Var'(0),'Var'(3)]),'Comb'('FuncCall','List.groupBy',['Var'(1),'Var'(4)])]))]))).
evaluation('Char.isUpper','Rule'([0],'Comb'('FuncCall',&&,['Comb'('FuncCall',>=,['Comb'('FuncCall',ord,['Var'(0)]),'Comb'('FuncCall',ord,['Lit'('Charc'(65))])]),'Comb'('FuncCall',<=,['Comb'('FuncCall',ord,['Var'(0)]),'Comb'('FuncCall',ord,['Lit'('Charc'(90))])])]))).
evaluation('Char.isLower','Rule'([0],'Comb'('FuncCall',&&,['Comb'('FuncCall',>=,['Comb'('FuncCall',ord,['Var'(0)]),'Comb'('FuncCall',ord,['Lit'('Charc'(97))])]),'Comb'('FuncCall',<=,['Comb'('FuncCall',ord,['Var'(0)]),'Comb'('FuncCall',ord,['Lit'('Charc'(122))])])]))).
evaluation('Char.isAlpha','Rule'([0],'Comb'('FuncCall','||',['Comb'('FuncCall','Char.isUpper',['Var'(0)]),'Comb'('FuncCall','Char.isLower',['Var'(0)])]))).
evaluation('Char.isDigit','Rule'([0],'Comb'('FuncCall',&&,['Comb'('FuncCall',<=,['Comb'('FuncCall',ord,['Lit'('Charc'(48))]),'Comb'('FuncCall',ord,['Var'(0)])]),'Comb'('FuncCall',<=,['Comb'('FuncCall',ord,['Var'(0)]),'Comb'('FuncCall',ord,['Lit'('Charc'(57))])])]))).
evaluation('Char.isAlphaNum','Rule'([0],'Comb'('FuncCall','||',['Comb'('FuncCall','Char.isAlpha',['Var'(0)]),'Comb'('FuncCall','Char.isDigit',['Var'(0)])]))).
evaluation('Char.isOctDigit','Rule'([0],'Comb'('FuncCall',&&,['Comb'('FuncCall',>=,['Comb'('FuncCall',ord,['Var'(0)]),'Comb'('FuncCall',ord,['Lit'('Charc'(48))])]),'Comb'('FuncCall',<=,['Comb'('FuncCall',ord,['Var'(0)]),'Comb'('FuncCall',ord,['Lit'('Charc'(55))])])]))).
evaluation('Char.isHexDigit','Rule'([0],'Comb'('FuncCall','||',['Comb'('FuncCall','Char.isDigit',['Var'(0)]),'Comb'('FuncCall','||',['Comb'('FuncCall',&&,['Comb'('FuncCall',>=,['Comb'('FuncCall',ord,['Var'(0)]),'Comb'('FuncCall',ord,['Lit'('Charc'(65))])]),'Comb'('FuncCall',<=,['Comb'('FuncCall',ord,['Var'(0)]),'Comb'('FuncCall',ord,['Lit'('Charc'(70))])])]),'Comb'('FuncCall',&&,['Comb'('FuncCall',>=,['Comb'('FuncCall',ord,['Var'(0)]),'Comb'('FuncCall',ord,['Lit'('Charc'(97))])]),'Comb'('FuncCall',<=,['Comb'('FuncCall',ord,['Var'(0)]),'Comb'('FuncCall',ord,['Lit'('Charc'(102))])])])])]))).
evaluation('Char.isSpace','Rule'([0],'Comb'('FuncCall','||',['Comb'('FuncCall',==,['Var'(0),'Lit'('Charc'(32))]),'Comb'('FuncCall','||',['Comb'('FuncCall',==,['Var'(0),'Lit'('Charc'(9))]),'Comb'('FuncCall','||',['Comb'('FuncCall',==,['Var'(0),'Lit'('Charc'(10))]),'Comb'('FuncCall','||',['Comb'('FuncCall',==,['Var'(0),'Lit'('Charc'(13))]),'Comb'('FuncCall',==,['Comb'('FuncCall',ord,['Var'(0)]),'Lit'('Intc'(12))])])])])]))).
evaluation('Char.toUpper','Rule'([0],'Comb'('FuncCall',if_then_else,['Comb'('FuncCall','Char.isLower',['Var'(0)]),'Comb'('FuncCall',chr,['Comb'('FuncCall',+,['Comb'('FuncCall',-,['Comb'('FuncCall',ord,['Var'(0)]),'Comb'('FuncCall',ord,['Lit'('Charc'(97))])]),'Comb'('FuncCall',ord,['Lit'('Charc'(65))])])]),'Var'(0)]))).
evaluation('Char.toLower','Rule'([0],'Comb'('FuncCall',if_then_else,['Comb'('FuncCall','Char.isUpper',['Var'(0)]),'Comb'('FuncCall',chr,['Comb'('FuncCall',+,['Comb'('FuncCall',-,['Comb'('FuncCall',ord,['Var'(0)]),'Comb'('FuncCall',ord,['Lit'('Charc'(65))])]),'Comb'('FuncCall',ord,['Lit'('Charc'(97))])])]),'Var'(0)]))).
evaluation('Char.digitToInt','Rule'([0],'Comb'('FuncCall',if_then_else,['Comb'('FuncCall','Char.isDigit',['Var'(0)]),'Comb'('FuncCall',-,['Comb'('FuncCall',ord,['Var'(0)]),'Comb'('FuncCall',ord,['Lit'('Charc'(48))])]),'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',&&,['Comb'('FuncCall',>=,['Comb'('FuncCall',ord,['Var'(0)]),'Comb'('FuncCall',ord,['Lit'('Charc'(65))])]),'Comb'('FuncCall',<=,['Comb'('FuncCall',ord,['Var'(0)]),'Comb'('FuncCall',ord,['Lit'('Charc'(70))])])]),'Comb'('FuncCall',+,['Comb'('FuncCall',-,['Comb'('FuncCall',ord,['Var'(0)]),'Comb'('FuncCall',ord,['Lit'('Charc'(65))])]),'Lit'('Intc'(10))]),'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',&&,['Comb'('FuncCall',>=,['Comb'('FuncCall',ord,['Var'(0)]),'Comb'('FuncCall',ord,['Lit'('Charc'(97))])]),'Comb'('FuncCall',<=,['Comb'('FuncCall',ord,['Var'(0)]),'Comb'('FuncCall',ord,['Lit'('Charc'(102))])])]),'Comb'('FuncCall',+,['Comb'('FuncCall',-,['Comb'('FuncCall',ord,['Var'(0)]),'Comb'('FuncCall',ord,['Lit'('Charc'(97))])]),'Lit'('Intc'(10))]),'Comb'('FuncCall',error,['Comb'('ConsCall','.',['Lit'('Charc'(67)),'Comb'('ConsCall','.',['Lit'('Charc'(104)),'Comb'('ConsCall','.',['Lit'('Charc'(97)),'Comb'('ConsCall','.',['Lit'('Charc'(114)),'Comb'('ConsCall','.',['Lit'('Charc'(46)),'Comb'('ConsCall','.',['Lit'('Charc'(100)),'Comb'('ConsCall','.',['Lit'('Charc'(105)),'Comb'('ConsCall','.',['Lit'('Charc'(103)),'Comb'('ConsCall','.',['Lit'('Charc'(105)),'Comb'('ConsCall','.',['Lit'('Charc'(116)),'Comb'('ConsCall','.',['Lit'('Charc'(84)),'Comb'('ConsCall','.',['Lit'('Charc'(111)),'Comb'('ConsCall','.',['Lit'('Charc'(73)),'Comb'('ConsCall','.',['Lit'('Charc'(110)),'Comb'('ConsCall','.',['Lit'('Charc'(116)),'Comb'('ConsCall','.',['Lit'('Charc'(58)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(97)),'Comb'('ConsCall','.',['Lit'('Charc'(114)),'Comb'('ConsCall','.',['Lit'('Charc'(103)),'Comb'('ConsCall','.',['Lit'('Charc'(117)),'Comb'('ConsCall','.',['Lit'('Charc'(109)),'Comb'('ConsCall','.',['Lit'('Charc'(101)),'Comb'('ConsCall','.',['Lit'('Charc'(110)),'Comb'('ConsCall','.',['Lit'('Charc'(116)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(105)),'Comb'('ConsCall','.',['Lit'('Charc'(115)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(110)),'Comb'('ConsCall','.',['Lit'('Charc'(111)),'Comb'('ConsCall','.',['Lit'('Charc'(116)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(97)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(100)),'Comb'('ConsCall','.',['Lit'('Charc'(105)),'Comb'('ConsCall','.',['Lit'('Charc'(103)),'Comb'('ConsCall','.',['Lit'('Charc'(105)),'Comb'('ConsCall','.',['Lit'('Charc'(116)),'Comb'('ConsCall',[],[])])])])])])])])])])])])])])])])])])])])])])])])])])])])])])])])])])])])])])])])])])])])]))).
evaluation('Char.intToDigit','Rule'([0],'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',&&,['Comb'('FuncCall',>=,['Var'(0),'Lit'('Intc'(0))]),'Comb'('FuncCall',<=,['Var'(0),'Lit'('Intc'(9))])]),'Comb'('FuncCall',chr,['Comb'('FuncCall',+,['Comb'('FuncCall',ord,['Lit'('Charc'(48))]),'Var'(0)])]),'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',&&,['Comb'('FuncCall',>=,['Var'(0),'Lit'('Intc'(10))]),'Comb'('FuncCall',<=,['Var'(0),'Lit'('Intc'(15))])]),'Comb'('FuncCall',chr,['Comb'('FuncCall',-,['Comb'('FuncCall',+,['Comb'('FuncCall',ord,['Lit'('Charc'(65))]),'Var'(0)]),'Lit'('Intc'(10))])]),'Comb'('FuncCall',error,['Comb'('ConsCall','.',['Lit'('Charc'(67)),'Comb'('ConsCall','.',['Lit'('Charc'(104)),'Comb'('ConsCall','.',['Lit'('Charc'(97)),'Comb'('ConsCall','.',['Lit'('Charc'(114)),'Comb'('ConsCall','.',['Lit'('Charc'(46)),'Comb'('ConsCall','.',['Lit'('Charc'(105)),'Comb'('ConsCall','.',['Lit'('Charc'(110)),'Comb'('ConsCall','.',['Lit'('Charc'(116)),'Comb'('ConsCall','.',['Lit'('Charc'(84)),'Comb'('ConsCall','.',['Lit'('Charc'(111)),'Comb'('ConsCall','.',['Lit'('Charc'(68)),'Comb'('ConsCall','.',['Lit'('Charc'(105)),'Comb'('ConsCall','.',['Lit'('Charc'(103)),'Comb'('ConsCall','.',['Lit'('Charc'(105)),'Comb'('ConsCall','.',['Lit'('Charc'(116)),'Comb'('ConsCall','.',['Lit'('Charc'(58)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(97)),'Comb'('ConsCall','.',['Lit'('Charc'(114)),'Comb'('ConsCall','.',['Lit'('Charc'(103)),'Comb'('ConsCall','.',['Lit'('Charc'(117)),'Comb'('ConsCall','.',['Lit'('Charc'(109)),'Comb'('ConsCall','.',['Lit'('Charc'(101)),'Comb'('ConsCall','.',['Lit'('Charc'(110)),'Comb'('ConsCall','.',['Lit'('Charc'(116)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(110)),'Comb'('ConsCall','.',['Lit'('Charc'(111)),'Comb'('ConsCall','.',['Lit'('Charc'(116)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(97)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(100)),'Comb'('ConsCall','.',['Lit'('Charc'(105)),'Comb'('ConsCall','.',['Lit'('Charc'(103)),'Comb'('ConsCall','.',['Lit'('Charc'(105)),'Comb'('ConsCall','.',['Lit'('Charc'(116)),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Comb'('ConsCall','.',['Lit'('Charc'(118)),'Comb'('ConsCall','.',['Lit'('Charc'(97)),'Comb'('ConsCall','.',['Lit'('Charc'(108)),'Comb'('ConsCall','.',['Lit'('Charc'(117)),'Comb'('ConsCall','.',['Lit'('Charc'(101)),'Comb'('ConsCall',[],[])])])])])])])])])])])])])])])])])])])])])])])])])])])])])])])])])])])])])])])])])])])])])])]))).




%%%%% Number of shared variables: 361
